(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

BeginPackage[
    "Genealogies`Genealogies`",{"Statistics`DiscreteDistributions`",
      "Statistics`ContinuousDistributions`","Statistics`DataManipulation`",
      "Statistics`DescriptiveStatistics`","Utilities`RandomNumbers`",
      "Utilities`SetManipulation`",
      "DiscreteMath`Combinatorica`",
      "Graphics`Colors`"}];









Node::usage=
    "Node[i,{info},{Node[j,\[Ellipsis]],Node[k,\[Ellipsis]]}] denotes a node \
in a branching tree.  This node is labelled by the integer i; information on \
it is given by {info}.  The node has descendant nodes labelled j, k.  A \
terminal node (a leaf) is denoted by Node[i,{info},{}].";





NodeFunction::usage=
    "NodeFunction is an option for CollapseGenealogy and MakeGenealogy which \
can be set to extract information about each node.";



ExtractGenealogy::usage=
    "ExtractGenealogy[g,i] gives the genealogy that descends from node i.  \
For an ancestral graph, ExtractGenealogy[{AncestralLineage[\[Ellipsis]]\
\[Ellipsis]},x] generates the genealogy corresponding to map position x. \
InformationFunction->f generates an information list f[i,x]. \
ExtractGenealogy[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] generates the \
set of genealogies, applying to segments demarcated by Junctions[g].  All \
parts of the genome must have a single common ancestor.";



DeleteGenealogy::usage=
    "DeleteGenealogy[g,i] deletes the genealogy that descends from node i.";



\!\(\(AddGenealogy::usage = \
\*"\"\<AddGenealogy[\!\(g\_1\),\!\(g\_2\),i,j,info] adds genealogy \!\(g\_2\) \
to genealogy \!\(g\_1\), immediately above existing node i of \!\(g\_1\).  \
The new node is labelled j.  The new node is labelled j, and carries \
information info.  If i=j, then \!\(g\_2\) is added to existing node i, and \
its information is unaltered.  Node i must be found once and only once within \
\!\(g\_1\).\>\"";\)\)



AddNode::usage=
    "AddNode[g,i,k,info] adds a new node k immediately above existing node i \
of g.  The new node carries information info.  AddNode[g,i,j,k,info] adds a \
new node k between nodes i and j of an unrooted genealogy.";



CondenseGenealogy::usage=
    "CondenseGenealogy[g] removes all nodes that have only one descendant. \
However, the root node is not affected. ";



Nodes::usage=
    "Nodes[g] lists all the nodes of the genealogy g, including the leaves. ";





InternalNodes::usage=
    "InternalNodes[g] lists the internal nodes of the genealogy g. ";



Leaves::usage=
    "Leaves[g] lists the terminal nodes of the genealogy g. For an ancestral \
graph, Leaves[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] gives those \
lineages which start at times when no other lineages end";



 CollapseGenealogy::usage=
    "CollapseGenealogy[genealogy] reduces the genealogy to a nested list.  \
Node\[Rule]False only lists the leaves. NodeFunction\[Rule]f extracts a \
nested list of the information associated with each node, by applying \
f[i,{info}] to the full set of information contained in the genealogy. Nested\
\[Rule]False does not preserve the nested structure.";



\!\(\(SizeOfGenealogyPlot::usage = \*"\"\<SizeOfGenealogyPlot[g] gives the \
minimum and maximum coordinates, held as the last element of the information \
lists in g, in the form {{\!\(x\_min\),\!\(y\_min\)},{\!\(x\_max\),\!\(y\_max\
\)}}.\>\"";\)\)



MakeGenealogyPlot::usage=
    "MakeGenealogyPlot[g] appends coordinates to the information lists; these \
are used by PlotGenealogy[].  The vertical coordinate is incremented in units \
of 1, and the vertical span equals the number of lineages, minus 1. ";



PlotGenealogy::usage=
    "PlotGenealogy[g] plots a genealogy.  \
PlotGenealogy[g,NodeFunction\[Rule]f] uses f[i,info] to derive the \
coordinates; this might represent coalescence time, for example.  By default, \
nodes & leaves are labelled.  NodeLabels\[Rule]None suppresses the labelling; \
NodeLabels\[Rule]f uses f[i,info] to derive labels.  \
MakeGenealogyPlot\[Rule]False requires that  the coordinates are held as the \
last element of the information list.  By default, these are generated by \
MakeGenealogyPlot[g].";



LeafOffset::usage=
    "LeafOffset is an option for PlotGenealogy which determines the position \
of leaf labels.";



NodeOffset::usage=
    "NodeOffset is an option for PlotGenealogy which determines the position \
of node labels.";



LeafLabels::usage=
    "LeafLabels\[Rule]f is an option for PlotGenealogy which uses f[i,info] \
to construct labels for the leaves; LeafLabels\[Rule]None suppresses labels.";



MostRecentCommonAncestor::usage=
    "MostRecentCommonAncestor[g,i,j] gives the most recent common ancestor of \
nodes i, j.  ";



Nested::usage=
    "Nested is an option for CollapseGenealogy which determines whether the \
nested structure is preserved. ";



\!\(\(ExtractInformation::usage = \*"\"\<ExtractInformation[g,i] gives the \
information associated with node i. ExtractInformation[g] gives a list of the \
information for all the nodes.  For an ancestral graph, \
ExtractInformation[{AncestralLineage[\[Ellipsis]]\[Ellipsis]},l] extracts the \
information associated with the lineage labelled by l.  Checks that there is \
only one such lineage. ExtractInformation[{AncestralLineage[\[Ellipsis]]\
\[Ellipsis]},{\!\(l\_1\),\[Ellipsis]}] extracts a list of such information. \
\>\"";\)\)



TransformInformation::usage=
    "TransformInformation[g,f] replaces the information list info by \
f[node,info].";



\!\(\(ListToGenealogy::usage = \*"\"\<ListToGenealogy[list] constructs a \
genealogy from a nested list of the form {label,{\!\(node\_1\),\!\(node\_2\),\
\[Ellipsis]}}.  Information on each node can be included using NodeFunction\
\[Rule]f, where f[label] gives a list of information for the node with that \
label.  ListToGenealogy[{{a,b},{c,d}},Node\[Rule]False] gives a genealogy \
relating objects {a,b,\[Ellipsis]}.  Internal nodes are unlabelled.\>\"";\)\)



OrderedNodes::usage=
    "OrderedNodes[g,f] gives a list of the nodes in the genealogy, in the \
order defined by f[ i,{info}].  OrderedNodes[g,f,Node\[Rule]True] only lists \
internal nodes.";



\!\(\(Ancestors::usage = \*"\"\<Ancestors[g,node] lists the ancestors of the \
node.  For an ancestral graph, Ancestors[{AncestralLineage[\[Ellipsis]],\
\[Ellipsis]},l] lists the immediate ancestors of lineage l.  MapPosition\
\[Rule]x restricts the list to ancestors at map position x.  AncestorList\
\[Rule]All gives a list of all ancestors, in  the form {\!\(l\_1\),{{\!\(d\_1\
\),{\[Ellipsis]}},{\!\(d\_2\),{\[Ellipsis]}}}}.  AncestorList\[Rule]Roots \
gives only the root ancestors.  \>\"";\)\)



\!\(\(Descendants::usage = \*"\"\<Descendants[g,node] lists the immediate \
descendants of the node.  Descendants[g,node,DescendantList\[Rule]All] lists \
all the descendants of the node. \
Descendants[g,node,DescendantList\[Rule]Leaves] lists only the descendant \
leaves of the node.  For an ancestral graph, Descendants[{AncestralLineage[\
\[Ellipsis]],\[Ellipsis]},l] lists the immediate descendants from lineage l.  \
MapPosition\[Rule]x restricts the list to descendants at map position x.  \
DescendantList\[Rule]All gives a list of all descendants, in  the form {\!\(l\
\_1\),{{\!\(d\_1\),{\[Ellipsis]}},{\!\(d\_2\),{\[Ellipsis]}}}}. \
DescendantList\[Rule]Leaves gives only the descendant leaves.\>\"";\)\)



DescendantList::usage=
    "DescendantList is an option for Descendants[]; may be set to Next, All \
or Leaves.";



UnrootedGenealogy::usage="UnrootedGenealogy[g] gives an unrooted genealogy.";



RootedGenealogy::usage="\!\(TextForm\`RootedGenealogy\)[g,i] roots an \
unrooted genealogy at node i";



SiblingList::usage=
    "SiblingList[g] lists all pairs of leaves which are directly related.";





GenealogyToFamily::usage=
    "GenealogyToFamily[g,f] gives a list of the family structures following \
successive coalescences. The function f[i,{info}] gives the ordering of the \
coalescence for node i.";



\!\(\(FamilyToGenealogy::usage = \
\*"\"\<FamilyToGenealogy[{a,b,c,\[Ellipsis]},S] gives a randomly constructed \
genealogy which satistfies the sequence of family structures S, and which \
relates {a,b,c,\[Ellipsis]}.  The terminal nodes are labelled by {a,b,c,\
\[Ellipsis]}, and the internal nodes are labelled by integers giving the \
order of the coalescence events. \
NodeLabels\[Rule]{\!\(label\_1\),\[Ellipsis]} allows an arbitrary list of \
labels for the internal nodes.  NodeInformation\[Rule]{\!\(info\_1\),\
\[Ellipsis]}, LeafInformation\[Rule]{\!\(info\_a\),\[Ellipsis]} allow \
arbitrary lists of information to be associated with the nodes and leaves.  \
With n items, there are n nodes, and so all the optional lists must have \
length n.\>\"";\)\)



\!\(\(\(\ \)\(LeafInformation::usage = \*"\"\<LeafInformation\[Rule]{\!\(info\
\_a\),\[Ellipsis]} is an option for FamilyToGenealogy[] which specifies \
information associated with each leaf.\>\"";\)\)\)



\!\(\(\(\ \)\(NodeInformation::usage = \*"\"\<NodeInformation\[Rule]{\!\(info\
\_1\),\[Ellipsis]} is an option for FamilyToGenealogy[] which specifies \
information associated with each internal node.  The number of such nodes is \
the same as the number of leaves; nodes are ordered by their \
timing.\>\"";\)\)\)



\!\(\(\(\ \)\(NodeLabels::usage = \*"\"\<NodeLabels\[Rule]{\!\(label\_1\),\
\[Ellipsis]} is an option for FamilyToGenealogy[] which specifies labels for \
each internal node.  The number of such nodes is the same as the number of \
leaves; nodes are ordered by their timing.  NodeLabels\[Rule]f is an option \
for PlotGenealogy which uses f[i,info] to construct labels for the nodes; \
NodeLabels\[Rule]None suppresses labels.\>\"";\)\)\)



\!\(\(GenealogyB::usage = \*"\"\<GenealogyB[j,i,k] is the coefficient of \
Exp[-\!\(\[Lambda]\_i\)t/2N] in the expression for \!\(P\_j\), the \
probability of j coalescences having occurred.\>\"";\)\)



CoalescenceDistribution::usage=
    "CoalescenceDistribution[j,k,t] is the probability of j coalescences \
having occurred among k lineages over t generations (scaled to 2N) ";



SimplifyFamilies::usage=
    "SimplifyFamilies replaces duplications such as {{3,1},{2,2},{1,2}} by \
{{3,1},{3,2}}";



FamilyProbability::usage=
    "FamilyProbability[S] gives the probability that the family structure S \
would be produced, given a certain number of coalescence events.";



NumberOfLineages::usage=
    "NumberOfLineages[g]  gives the total number of lineages (i.e., terminal \
nodes) involved in the genealogy g. NumberOfLineages[g,i] gives the number \
that descend from node i.  NumberOfLineages[S] can also be applied to a list \
of family sizes, S";



PairwiseIdentity::usage=
    "PairwiseIdentity[S] gives the mean pairwise identity, given the family \
structure S.";



AllSets::usage=
    "AllSets[j,k] lists all the family structures that could yield j families \
and k genes";



NewS::usage="NewS[S] gives a recursion for the family structures";



NumberOfFamilies::usage="NumberOfFamilies[S] gives the number of families";





CoalescenceTimes::usage=
    "CoalescenceTimes is an option for RandomGenealogy.  CoalescenceTimes\
\[Rule]Random uses RandomCoalescenceTimes[k]; otherwise a list of times must \
be supplied";



RandomCoalescenceTimes::usage=
    "RandomCoalescenceTimes[k] gives a list of random coalescence times, \
scaled to 2N generations. RandomCoalescenceTimes[n,k,R] generates a sequence \
of n coalescences and recombinations, starting with k lineages at t=0. The \
output is a list of n items of the form {t,k,j}, where t is the time of the \
event;k is the number of lineages after the event; and j is the location of \
the recombination event in the interval {0,R}. j=None indicates a \
coalescence.  RandomCoalescenceTimes[k,R] generates a single item, with rate \
k(k-1)/2 of coalescence and k R of recombination.";



NumberOfCoalescences::usage=
    "NumberOfCoalescences[k,T] gives a randomly sampled number of coalescence \
events that occur in T (scaled to 2N). NumberOfCoalescences[{t1,t2..},T] does \
the same, for a list of coalescence times. ";



TotalLength::usage=
    "TotalLength[{t1,t2,..}] is the total length of the tree, given the \
coalescence times.";



RandomFamilies::usage=
    "RandomFamilies[k] generates a list of the family sizes going back \
through time to the common ancestor of k genes.";



RandomPreviousFamily::usage=
    "RandomPreviousFamily[{1,1,2,3}] generates a random coalescence to give \
the previous family structure";



\!\(\(RandomGenealogy::usage = \*"\"\<RandomGenealogy[{\!\(leaf\_1\),\!\(leaf\
\_2\),\[Ellipsis]}] gives a random realisation of the coalescent process.  \
Terminal nodes are labelled {\!\(leaf\_1\),\!\(leaf\_2\),\[Ellipsis]}, and \
internal nodes are labelled by an integer, in the order in which they occur.  \
Each node carries its time, scaled to 2N generations.  MutationRate\[Rule]\
\[Theta] simulates infinite-sites mutation at a rate \[Theta]=4N\[Mu]; \
mutations are labelled by unique integers. NodeLabels\[Rule]{\!\(label\_1\),\
\[Ellipsis]} can be used to label internal nodes.   RandomGenealogy[{\!\(leaf\
\_1\),\!\(leaf\_2\)\[Ellipsis]},n,R] gives a random realisation of the \
coalescent process with recombination; there are n events. \
RandomGenealogy[{\!\(leaf\_1\),\!\(leaf\_2\)\[Ellipsis]},{{\!\(t\_1\),\!\(k\_\
1\),\!\(x\_1\)}\[Ellipsis]},R] gives a random realisation for a specific \
sequence of events, generated by RandomCoalescenceTimes[n,k,R]; this \
preserves null lineages, however.  DeleteNullLineages->True ignores null \
events; can only be used with the first form. PrintDetails\[Rule]True prints \
details of the construction.  MaxTime->t stops after time t.  Fixation->True \
stops when the whole genome is fixed.\>\"";\)\)



MutationRate::usage=
    "MutationRate\[Rule]\[Theta] is an option for RandomGenealogy[] which \
sets the scaled mutation rate \[Theta]=4N\[VeryThinSpace]\[Mu].  Default is \
MutationRate\[Rule]None.";



\!\(\(DeletedMutations::usage = \
\*"\"\<DeletedMutations[g,{\!\(T\_0\),\!\(T\_1\)}] lists those mutations that \
should be deleted because they occurred in time interval {\!\(T\_0\),\!\(T\_1\
\)}.  This list may be to some extent randomly generated. \>\"";\)\)



RandomBottleneckedGenealogy::usage=
    "RandomBottleneckedGenealogy[leaves,{T0,T1},\[Theta]] gives a random \
genealogy, with no mutations occurring in time interval {T0,T1}.";





MomentGeneratingFunction::usage=
    "MomentGeneratingFunction[g,\[Omega],\[Theta]] gives the generating \
function for the number of mutations along each branch of the genealogy, \
under the infinite sites model. \
MomentGeneratingFunction[{{a},{b},\[Ellipsis]},\[Omega],\[Theta]] gives the \
generating function for all tree topologies, in terms of variables \
\[Omega][S] which correspond to those mutations in branches ancestral to the \
set of leaves S. Stores results. ";





IncidenceMatrix::usage=
    IncidenceMatrix::usage<>
      "  For genealogies, IncidenceMatrix[g,nodelist] gives the matrix \
describing an ordering of coalescences defined by nodelist.  The last member \
of nodelist is the root node.  The elements of the matrix show whether a \
branch is present during the time for which there are 1\[LessEqual]i\
\[LessEqual]n lineages. Rows correspond to branches, in the order specified \
by nodelist. ";



\!\(\(MonteCarloProbability::usage = \
\*"\"\<MonteCarloProbability[g,nodelist,J,\[Theta],\!\(\(\[Theta]\^*\)\),ns] \
makes a Monte Carlo estimate of the probability of the genealogy g and the \
mutational configuration J, assuming that the coalescences are in the order \
specified by nodelist. A list of ns values is returned. \
MonteCarloProbability[g,J,\[Theta],\!\(\(\[Theta]\^*\)\),ns] makes no \
assumptions as to the order of events. Uses the arbitrary parameter \!\(\(\
\[Theta]\^*\)\) to make random partitions.  \!\(\(\[Theta]\^*\)\) must be a \
number, but \[Theta] can be symbolic.\>\"";\)\)



PossibleCoalescenceOrder::usage=
    "PossibleCoalescenceOrder[g] lists the possible orders in which \
coalescence events might occur; each is given by an ordered list of nodes.  \
Leaves are listed first, and the root node last.";



RandomCoalescenceOrder::usage=
    "RandomCoalescenceOrder[g] gives a random ordering of the possible \
coalescence events";



NumberOfPossibleCoalescences::usage=
    "NumberOfPossibleCoalescences[g,nodelist] gives the number of possible \
coalescences that could occur at each step. Only internal nodes are included. \
The order of coalescences is defined by nodelist";



NumberOfMutations::usage=
    "NumberOfMutations[g,node] gives the number of mutations that occurred on \
the branch leading down to the specified node. The set of mutations is given \
in the second element of the information for each node. ";



Mutations::usage=
    "Mutations[g] gives the set of mutations that occured on g.  \
Mutations[g,i] gives the mutations that arose on the branch leading down to \
node i.  By default, these are held in the second element of the information \
list.  NodeFunction\[Rule]f uses f[i,info] to extract the mutation list.";



MutationOrigin::usage=
    "MutationOrigin[g,k] gives the first node at which mutation k appears.   \
By default, the mutations are held in the second element of the information \
list, and the coalescence time as the first element.  NodeFunction\[Rule]f \
uses f[i,info] to return {time,mutations}.";



MutationInterval::usage=
    "MutationInterval[g,k] gives the time interval in which mutation k arose. \
 By default, the mutations are held in the second element of the information \
list, and the coalescence time as the first element.  NodeFunction\[Rule]f \
uses f[i,info] to return {time,mutations}.";



ExactProbability::usage=
    "ExactProbability[g,\[Theta]] gives the probability of this genealogy, \
given a scaled mutation rate \[Theta]=4N\[VeryThinSpace]\[Mu]. By default, \
the number of mutations is deduced from a list of unique mutations held in \
the second element of the information list.  NodeFunction\[Rule]f uses \
f[i,info] to find the number of mutations. Uses MomentGeneratingFunction[], \
and so is intractable for large numbers of mutations and for large \
genealogies.  ExactProbability[S,\[Theta]] uses the generating function over \
all topologies to find the net probability of the configuration of mutations \
represented by the matrix S.";



\!\(\(GenealogyToMatrix::usage = \*"\"\<GenealogyToMatrix[g] gives a matrix \
whose rows specify which mutations are found in which leaf of the genealogy. \
The genealogy can be unrooted. By default, the list of mutations is taken \
from the second element of the information list.  NodeFunction\[Rule]f uses \
f[i,info] to specify the mutations in each node.  \
MutationLabels->{\!\(m\_1\),\[Ellipsis]} specifies the names of the \
mutations; by default, the list is the set of mutations found in g.\>\"";\)\)



\!\(\(MatrixToGenealogy::usage = \*"\"\<MatrixToGenealogy[S,{\!\(leaf\_1\), \
\!\(leaf\_2\),\[Ellipsis]},{\!\(\[Mu]\_1\),\[Ellipsis]}] constructs a \
genealogy from the matrix S.  The leaves are labelled by {\!\(leaf\_1\), \
\[Ellipsis]} and the mutations by {\!\(\[Mu]\_1\),\[Ellipsis]}; internal \
nodes are labelled by unique integers.  Unrooted->True yields an unrooted \
genealogy; no assumption is made as to which allele is ancestral and which \
derived.\>\"";\)\)



\!\(\(MatrixToList::usage = \*"\"\<MatrixToList[S] converts a matrix \
representation to a list of the mutations held by each leaf.  By default, \
mutations are numbered 1,2\[Ellipsis].  MutationLabels\[Rule]{\!\(m\_1\),\
\[Ellipsis]} uses the specified labels.\>\"";\)\)



\!\(\(FindNode::usage = \*"\"\<FindNode[g,{\!\(m\_1\),\[Ellipsis]},newNode] \
finds from where in the genealogy g a leaf carrying mutations {\!\(m\_1\),\
\[Ellipsis]} descends.  If no node or branch matches, returns $Failed. If the \
leaf joins the branch above node i, returns \
{i,newNode,{\!\(m\_1\),\[Ellipsis]}}, where newNode is a new node label, \
distinct from any other in g. The last element lists the mutations carried at \
the new node.  If the leaf joins at node i, returns {i,i,{\!\(m\_1\),\
\[Ellipsis]}}, where the last element lists the mutations carried at node i.  \
  The new leaf MUST contain all the mutations in the root node of g, and g \
must carry at least one mutation on each branch, except for branches loeading \
down to leaves.\>\"";\)\)



MutationLabels::usage=
    "MutationLabels is an option for MatrixToList[] which labels the \
mutations.";



\!\(\(ListToMatrix::usage = \*"\"\<ListToMatrix[{{1,2,3},{4},\[Ellipsis]}] \
converts a list of mutations present at each node into a matrix \
representation.  MutationLabels\[Rule]{\!\(m\_1\),\[Ellipsis]} gives the \
columns in the specified order.\>\"";\)\)



GriffithsTavare::usage=
    "GriffithsTavare[S,\[Theta]] uses the Griffiths-Tavare algorithm to find \
the probability of a configuration of mutations defined by the matrix S.";



MonteCarloGriffithsTavare::usage=
    "MonteCarloGriffithsTavare[S,\[Theta]] uses the Monte-Carlo \
Griffiths-Tavare algorithm to find the probability of a configuration of \
mutations defined by the matrix S.";



ValidMatrixQ::usage=
    "ValidMatrixQ[S] determines whether a matrix of mutations, S, is \
compatible with a genealogy. The i'th row of S is a list of {1,0,\[Ellipsis]} \
representing the set of mutations present in the i'th leaf. \
Unrooted\[Rule]True does not assume that a '1' represents a new mutation: 0, \
1 just represent two alternative alleles. ValidMatrixQ[{0,1\[Ellipsis]},{1,0,\
\[Ellipsis]}] tests a particular pair of mutations.";



Unrooted::usage=
    "Unrooted is an option for ValidMatrixQ which specifies that the \
genealogy is unrooted - i.e., no assumption is made about which allele is \
ancestral";



SwapStates::usage=
    "SwapStates[s,S] swaps the states of mutations listed in the matrix S, \
according to the specification s.  The matrix S has dimensions # leaves\
\[Times]# mutations, and s is a vector of length equal to the # of mutations. \
 Both consist of 0 or 1.";



MissingCombination::usage=
    "MissingCombination[S] tabulates the missing combinations for each pair \
of mutations listed in S.  Each element contains {} if there are less than 3 \
combinations for that pair.  If there are 4 combinations, the matrix is \
invalid, and an error message is returned.  If there are three combinations, \
the missing combination is returned; swaps represented by this combination \
are not allowed.  Stores results.";



PossibleRootings::usage=
    "PossibleRootings[S] lists all valid ways of rooting the mutations listed \
in S. Returns a list, in which each row {0,1,\[Ellipsis]} indicates whether \
an allele `1` is to be taken as ancestral (1) or derived (0). \
PossibleRootings[{{Null,0,1,Null\[Ellipsis]},\[Ellipsis]},S] eliminates \
indeterminate mutations, indicated by Null, until the solution is found.";



\!\(\(AddMutation::usage = \*"\"\<AddMutation[n,m,g] adds the mutations m to \
node n; m can be one mutation,or a list of mutations. \
AddMutation[{\!\(n\_1\),\!\(n\_2\),\[Ellipsis]},{\!\(m\_1\),\!\(m\_2\),\
\[Ellipsis]},g] adds to a list of nodes. Mutations are held as the second \
element of the information list.  \>\"";\)\)



CondenseMatrix::usage=
    "CondenseMatrix[S] reduces the matrix S to the minimum informative size. \
Columns depicting mutations with the same distribution across leaves, \
mutations fixed across the whole set, or present in only one leaf, are \
removed.  Unrooted->True also removes one of each pair of complementary \
mutations (e.g. {0,0,1,1} and {1,1,0,0}).";





AncestralLineage::usage="\!\(TraditionalForm\`\(TraditionalForm\`\
AncestralLineage[l, {t0, t1}, {{a, b}, {}, {c, d}, {c}}, {r1, r2, r3, R}, \
info]\)\) represents one lineage in an ancestral graph.  It gives the name of \
the lineage, l; the timespan, {t0,t1}; the leaves which descend from the \
various segments, {{a,b},{},{c,d},{c}}; and the rightmost positions of each \
segment, {r1,r2,r3,R}.  The genome spans {0,R}.";



AncestralGraphPattern::usage=
    "AncestralGraphPattern is matched by a list \
{AncestralLineage[\[Ellipsis]]...}, representing an ancestral graph. No \
detailed checks are made that this is a valid graph, however.";



AncestralLineagePattern::usage=
    "AncestralLineagePattern is matched by an AncestralLineage[\[Ellipsis]]";



ExtractLabel::usage=
    "ExtractLabel is a rule which replaces AncestralLineage[l,\[Ellipsis]] by \
its label, l.";



\!\(\(CoalesceLineages::usage = \*"\"\<CoalesceLineages[AncestralLineage[l1,\
\[Ellipsis]],AncestralLineage[l2,\[Ellipsis]],l12,t] gives a lineage l12 \
which is ancestral to l1, l2, generated by a coalescence event at time t.  By \
default, corresponding elements of information lists are put into a set; \
InformationFunction\[Rule]f generates a new information list \
f[\!\(i\_1\),\!\(i\_2\)]\>\"";\)\)



InformationFunction::usage=
    "InformationFunction->f is an option for functions dealing with ancestral \
graphs, which specifies how the information associated with each lineage \
should be handled.";



RecombineLineage::usage=
    "RecombineLineage[AncestralLineage[l,\[Ellipsis]],{lL,lR},x,t] generates \
two recombinant lineages, with breakpoint at map position x, and labelled lL, \
lR. By default, the information lists are duplicated; InformationFunction\
\[Rule]{fL,fR} generates a pair of information lists {fL[i],fR[i]}.";



Junctions::usage=
    "Junctions[AncestralLineage[\[Ellipsis]]] lists the junctions present in \
the lineage.  Junctions[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists all \
the junctions present in the ancestral graph. ";



MapLength::usage=
    "MapLength[AncestralLineage[\[Ellipsis]]] or MapLength[{AncestralLineage[\
\[Ellipsis]]\[Ellipsis]}] gives the map length, R. ";



LineagesPresent::usage=
    "LineagesPresent[{AncestralLineage[\[Ellipsis]],\[Ellipsis]},t] gives the \
set of lineages present at time t. LineagesPresent[{AncestralLineage[\
\[Ellipsis]],\[Ellipsis]}] lists all lineages";



RecombinantLineages::usage=
    "RecombinantLineages[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] gives \
lineages which start at the same time as a sister lineage";



CoalescentLineages::usage=
    "CoalescentLineages[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] gives \
lineages which start at the same time as two other lineages end";



RootLineages::usage=
    "RootLineages[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] gives lineages \
which end when no other lineages begin.";



\!\(\(ExtractLineage::usage = \*"\"\<ExtractLineage[{AncestralLineage[\
\[Ellipsis]]\[Ellipsis]},l] extracts the lineage labelled by l. Checks that \
there is only one such lineage. ExtractLineage[{AncestralLineage[\[Ellipsis]]\
\[Ellipsis]},{\!\(l\_1\),\[Ellipsis]}] extracts a list of lineages. \>\"";\)\)



ExtractLineagesEndingAtT::usage=
    "ExtractLineagesEndingAtT[{AncestralLineage[\[Ellipsis]]\[Ellipsis]},t] \
extracts those lineages which end at time t.  These are either root lineages, \
with no ancestors, or are generated by a coalescence or recombination.  \
Checks that these are present in the appropriate numbers.";



ExtractLineagesStartingAtT::usage=
    "ExtractLineagesStartingAtT[{AncestralLineage[\[Ellipsis]]\[Ellipsis]},t] \
extracts those lineages which start at time t.  These are either leaves, with \
no descendants, or are generated by a coalescence or recombination.  Checks \
that these are present in the appropriate numbers.";



TimesOfEvents::usage=
    "TimesOfEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists all the \
times at which lineages begin or end.";



AllEvents::usage=
    "AllEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists all events \
at which lineages begin or end, in the form {t,descendants,ancestors,map \
position}. (The last element is set if there has been a recombination event; \
otherwise it is None).";



\!\(\(CoalescenceEvents::usage = \*"\"\<CoalescenceEvents[{AncestralLineage[\
\[Ellipsis]]\[Ellipsis]}] lists events at which lineages {\!\(l\_1\),\
\[Ellipsis]} coalesce into lineage \!\(l\_p\), in the form \
{t,{\!\(l\_1\),\!\(l\_2\)},\!\(l\_P\)}.\>\"";\)\)



NullLineages::usage=
    "NullLineages[g] lists those lineages which contain no material ancestral \
to the sample.";



\!\(\(RecombinationEvents::usage = \
\*"\"\<RecombinationEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists \
events at which a lineages \!\(l\_1\) splits into two lineage {\!\(l\_L\), \!\
\(l\_R\)} in the form {t,{\!\(l\_p\)},{\!\(l\_L\),\!\(l\_R\)},r}.\>\"";\)\)



\!\(\(NullRecombinationEvents::usage = \
\*"\"\<NullRecombinationEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] \
lists events at which a lineages \!\(l\_1\) splits into two lineages \
{\!\(l\_L\), \!\(l\_R\)}, but where one of these is null.  These have the \
form {t,{\!\(l\_p\)},{\!\(l\_L\),\!\(l\_R\)},R}.\>\"";\)\)



LeafEvents::usage=
    "LeafEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists events at \
which a lineages becomes extinct.";



RootEvents::usage=
    "RootEvents[{AncestralLineage[\[Ellipsis]]\[Ellipsis]}] lists events at \
which an ancestral lineage begins.";



TimespanOfLineage::usage=
    "TimespanOfLineage[{AncestralLineage[\[Ellipsis]]\[Ellipsis]},l] gives \
the start and end times,{t0,t1}, of lineage l.";



MapPosition::usage=
    "MapPosition\[Rule]x is an option for Descendants which specifies that \
only descendants at map position x are counted.";



AddDescendants::usage="AddDescendants[g,{l}] returns {l,Descendants[g,l]}.";



AncestorList::usage=
    "AncestorList is an option for Ancestors; it may be set to Previous, All \
or Roots";



AddAncestors::usage="AddAncestors[g,{l}] returns {l,Ancestors[g,l]}.";



DeleteNullLineages::usage=
    "DeleteNullLineages[g] deletes ancestral lineages that have no \
descedants.  DeleteNullLineages is also an option for AddRecombinantLineages \
which specifies whether lineages carrying no material ancestral to thhe \
sample are to be included.";



AddRecombinantLineages::usage=
    "AddRecombinantLineages[g,l,{lL,lR},x,t] terminates lineage l, and adds \
two recombinant lineages {lL,lR} to the list g. DeleteNullLineages->True \
ignores null recombination events.";



AddCoalescentLineage::usage=
    "AddCoalescentLineage[g,{l1,l2},lC,t] terminates lineages {l1,l2} at t, \
and adds a coalescent lineage lC to the list g.";



PrintDetails::usage="PrintDetails is an option for RandomGenealogy";



Segments::usage=
    "Segments[AncestralLineage[\[Ellipsis]],l] gives the blocks ancestral to \
l present within the lineage.  Segments[{AncestralLineage[\[Ellipsis]]\
\[Ellipsis]},l] applies to several lineages";



PlotSegments::usage=
    "PlotSegments[AncestralLineage[\[Ellipsis]],leaf,y] gives a Graphics[] \
object depicting the segments ancestral to the leaf; drawn at height y.  \
SegmentStyle\[Rule]{Blue,\[Ellipsis]} and BackgroundStyle\[Rule]{Yellow,\
\[Ellipsis]} set the style of the lines.  PlotSegments[{AncestralLineage[\
\[Ellipsis]]\[Ellipsis]},leaf,{y0,y1}] plots a series of lineages spanning \
{y0,y1}; JunctionStyle specifies vertical lines depicting the junctions. ";



BackgroundStyle::usage=
    "BackgroundStyle is an option for PlotSegments which sets the style of \
non-ancestral parts of the chromosome; default {Yellow}";



SegmentStyle::usage=
    "SegmentStyle is an option for PlotSegments which sets the style of \
ancestral parts of the chromosome; default {Blue}";



JunctionStyle::usage=
    "JunctionStyle is an option for PlotSegments which sets the style of \
vertical lines depicting junctions; default {Black}";



TimespanOfJunction::usage=
    "TimespanOfJunction[{AncestralLineage[\[Ellipsis]]\[Ellipsis]},j] finds \
the first and last occurrence of j. ";



FixedQ::usage=
    "FixedQ[AncestralLineage[\[Ellipsis]],lvs] tests whether this ancestral \
lineage only contains segments ancestral to the entire set lvs.  Can also \
apply to an ancestral graph";



MaxTime::usage=
    "MaxTime is an option for RandomGenealogy which specifies the maximum \
time to run the coalescent with recombination.";



Fixation::usage=
    "Fixation is an option for RandomGenealogy which specifies that the \
coalescent with recombination stops at fixation";





\!\(\(MRCA::usage = \*"\"\<MRCA[g,{\!\(node\_1\),\[Ellipsis]}] gives the most \
recent common ancestor of the list of nodes.\>\"";\)\)



\!\(\(PairwiseDivergence::usage = \*"\"\<PairwiseDivergence[g] lists the time \
to MRCA of all pairs of leaves.  PairwiseDivergence[g,{\!\(node\_1\),\!\(node\
\_2\)}] gives the time to the MRCA of these nodes.\>\"";\)\)



\!\(\(PairwiseDifference::usage = \*"\"\<PairwiseDifference[g] lists the \
number of sites which differ between randomly chosen pairs.  \
PairwiseDifference[g,{\!\(node\_1\),\!\(node\_2\)}] gives the mutations which \
differ between the nodes.\>\"";\)\)



MeanPairwiseDivergence::usage=
    "MeanPairwiseDivergence[g] gives the mean time back to a common ancestor \
between two genes.";



ExtractCoalescenceTimes::usage=
    "ExtractCoalescenceTimes[g] extracts a list of the coalescence times.";



LengthOfGenealogy::usage=
    "LengthOfGenealogy[g] gives the total length of the genealogy.";



DepthOfGenealogy::usage=
    "DepthOfGenealogy[g] gives the time to the last common ancestor.";



\!\(\(PairwiseDivergencePlot::usage = \*"\"\<PairwiseDivergencePlot[g,{Dmax,\
\[Delta]}] plots the distribution of pairwise divergence as a histogram, on \
the range {0,Dmax}.  PairwiseDivergencePlot[{\!\(g\_1\),\[Ellipsis]},{Dmax,\
\[Delta]}] plots the overall distribution for a set of replicate genealogies.\
\>\"";\)\)



\!\(\(PairwiseDifferencePlot::usage = \*"\"\<PairwiseDifferencePlot[g,{Dmax,\
\[Delta]}] plots the distribution of pairwise difference as a histogram, on \
the range {0,Dmax}.  PairwiseDifferencePlot[{\!\(g\_1\),\[Ellipsis]},{Dmax,\
\[Delta]}] plots the overall distribution for a set of replicate genealogies.\
\>\"";\)\)



\!\(\(BlockSizes::usage = \*"\"\<BlockSizes[AncestralLineage[l,{\!\(t\_0\),\!\
\(t\_1\)},{{},{\[Ellipsis]},\[Ellipsis]},{\!\(r\_1\),\[Ellipsis],R},{\
\[Ellipsis]}]] returns the sizes of blocks with different descendants. \
BlockSizes[g] applies to a whole ancestral graph.\>\"";\)\)



Begin["Genealogies`Genealogies`Private`"];

<<"Utilities`SetManipulation`";





Options[CollapseGenealogy]={Node\[Rule]True,NodeFunction\[Rule](#1&),
      Nested\[Rule]True};

CollapseGenealogy[g_Node,opts___Rule]:=
    Module[{ff=NodeFunction/.{opts}/.Options[CollapseGenealogy]},
      If[Nested/.{opts}/.Options[CollapseGenealogy],
If[Node/.{opts}/.Options[CollapseGenealogy],
          g//.{Node[i_,s_List,{m___Node}]:>{ff[i,s],{m}}}/.{{i_,{}}:>i},
		g//.{Node[i_,s_List,{m__Node}]:>{m},Node[i_,s_List,{}]:>ff[i,s]}],
If[Node/.{opts}/.Options[CollapseGenealogy],
				Extract[{g},#]&/@Position[{g},Node[i_,s_List,{m___Node}]],
	Extract[{g},#]&/@Position[{g},Node[i_,s_List,{}]]]//.Node[i_,
              s_List,{m___Node}]:>ff[i,s]]];

CollapseGenealogy[{g__Node},opts___Rule]:=
    Module[{ff=NodeFunction/.{opts}/.Options[CollapseGenealogy]},
      If[Node/.{opts}/.Options[CollapseGenealogy],
				{g}/.Node[i_,s_List,_List]:>ff[i,s],
	       Cases[{g}, Node[_,_,{_}]]/.Node[i_,s_List,{_}]:>ff[i,s]]];



Nodes[g_Node]:=
    Extract[{g},#]\[LeftDoubleBracket]1\[RightDoubleBracket]&/@
      Position[{g},Node[_,_List,{___Node}]];

Nodes[{g___Node}]:=	{g}/.Node[i_,_List,_List]:>i;



InternalNodes[g_Node]:=
    Extract[{g},#]\[LeftDoubleBracket]1\[RightDoubleBracket]&/@
      Position[{g},Node[_,_List,{m__Node}]];

InternalNodes[{g___Node}]:=Complement[Nodes[{g}],Leaves[{g}]];



Leaves[g_Node]:=
    Extract[{g},#]\[LeftDoubleBracket]1\[RightDoubleBracket]&/@
      Position[{g},Node[i_,s_List,{}]];

Leaves[{g___Node}]:=Cases[{g}, Node[_,_List,{_}]]/.Node[i_,_List,{_}]:>i;



ExtractInformation[g_Node,i_]:=Module[{ps=Position[g,Node[i,_List,_List]]},
		Switch[Length[ps],
			1,Extract[g,Append[ps\[LeftDoubleBracket]1\[RightDoubleBracket],2]],
			0,Print[i," does not appear in ",g];,
			_,Print[i," appears more than once in ",g]]];

ExtractInformation[g_Node]:=ExtractInformation[g,#]&/@Nodes[g];

ExtractInformation[{___Node,Node[i_,info_List,_List],___Node},i_]:=info;

ExtractInformation[{g__Node}]:=ExtractInformation[{g},#]&/@Nodes[{g}];



TransformInformation[g_Node,f_]:=
    g//.{Node[i_,si_List,{nn___Node}]:>
            NodeTemp[i,f[i,si],{nn}]}/.{NodeTemp\[Rule]Node};

TransformInformation[{g__Node},
      f_]:={g}//.{Node[i_,si_List,{nn___}]:>
            NodeTemp[i,f[i,si],{nn}]}/.{NodeTemp\[Rule]Node};



DeleteGenealogy[g_Node,i_]:=Module[{ps=Position[g,Node[i,_List,_List]]},
		Switch[Length[ps],
			1,Delete[g,ps\[LeftDoubleBracket]1\[RightDoubleBracket]],
			0,Print[i," does not appear in ",g];,
			_,Print[i," appears more than once in ",g]]];



CondenseGenealogy[g_Node]:=
    g//.{Node[p_,pi_List,{m1___Node,Node[x_,y_List,{z_Node}],m2___Node}]:>
          Node[p,pi,{m1,z,m2}]};



ExtractGenealogy[g_Node,i_]:=Module[{ps=Position[g,Node[i,_List,_List]]},
		Switch[Length[ps],
			1,If[ps\[LeftDoubleBracket]1\[RightDoubleBracket]=={},g,
          Extract[g,ps\[LeftDoubleBracket]1\[RightDoubleBracket]]],
			0,Print[i," does not appear in ",g];,
			_,Print[i," appears more than once in ",g]]];



AddGenealogy[g1_Node,g2_Node,nn_,nn_]:=
    g1/.{Node[nn,s1_List,{n1___}]:>Node[nn,s1,{n1,g2}]};
AddGenealogy[g1_Node,g2_Node,nn_,nn_,info_]:=AddGenealogy[g1,g2,nn,nn];

AddGenealogy[g1_Node,g2_Node,i_,nn_,info_]:=
    g1/.{Node[i,s1_List,n1_List]:>Node[nn,info,{Node[i,s1,n1],g2}]};

AddGenealogy[{g1__Node},{g2__Node},i1_,
      i2_]:={g1,g2}/.{Node[i1,inf1_,{a___}]:>Node[i1,inf1,{a,i2}],
          Node[i2,inf2_,{a___}]:>Node[i2,inf2,{a,i1}]}//Sort;



AddNode[g_Node,i_,k_,info_] :=
	
    g/.Node[i,si_,{m___Node}]:>Node[k,info,{Node[i,si,{m}]}];

AddNode[{g__Node},i_,j_,k_,
      info_] :=
{g,
        Node[k,info,{i,j}]}/.{Node[i,si_,{m___Node}]:>Node[i,si,{m,k}],
        Node[j,sj_,{m___Node}]:>Node[j,sj,{m,k}]};



Options[ListToGenealogy]={Node\[Rule]True,NodeFunction\[Rule]({}&)};

ListToGenealogy[s_List,opts___Rule]:=
    Module[{ff=NodeFunction/.{opts}/.Options[ListToGenealogy]},
		If[Node/.{opts}/.Options[ListToGenealogy],
			s//.{List[i_,{m___}]:>
                    Node[i/.List->ListTemp,(ff[i]/.List->ListTemp),
                      ListTemp[m]]},
		s//.{m___}:>Node[ListTemp[],ListTemp[],ListTemp[m]]]/.{ListTemp->
                List}//.{Node[i_,
                z_List,{x___,m_?((FreeQ[#,Node]&&FreeQ[#,NodeTemp])&),y___}]:>
              Node[i,z,{x,NodeTemp[m,ff[m],{}],y}]}/.NodeTemp->Node];



Options[OrderedNodes]={Node\[Rule]False};

OrderedNodes[g_Node,f_,opts___Rule] :=
	
    Module[{tt=CollapseGenealogy[g,NodeFunction\[Rule]f],
        nn=CollapseGenealogy[g],leaves},
		If[Node/.{opts}/.Options[OrderedNodes],
		  leaves=CollapseGenealogy[g,Node\[Rule]False];
		  Select[OrderedNodes[g,f],(FreeQ[leaves, #])&],
		Join@@(Extract[nn,#]&/@Position[tt, #]&/@(Sort[Union[tt//Flatten]]))]];





Ancestors[g_Node,i_]:=
    g/.Node[i,{___},{Node___}]:>{None}//.Node[
            j_,{___},{___,{None,k___},___}]:>{None,j,k}/.{None,j___}:>{j};



Options[Descendants]={DescendantList\[Rule]Next};

Descendants[g_Node,i_,opts___Rule]:=
	
    Module[{dl=DescendantList/.{opts}/.Options[Descendants],tt,dd,ddn},
		Switch[dl,
		  Next,
		    Last[ExtractGenealogy[g,i]]/.Node[j_,_List,_List]:>j,
		  All,
		    tt=dd=Descendants[g,i];
         While[Length[dd]>0,
				  ddn={};Scan[(ddn=Join[ddn,Descendants[g,#]])&,dd];
				  dd=ddn;
				  tt=Join[tt,dd]];tt,
		  Leaves,
		    Intersection[Descendants[g,i,DescendantList\[Rule]All],Leaves[g]],
		  _,
		    Print[dl," is not a valid setting for DescendantList"];
			$Failed]];

Descendants[{g__Node},i_]:=
    Cases[{g},Node[i,_List,_List]]/.{{Node[_,_List,s_List]}:>s};



MostRecentCommonAncestor[g_Node,i_,j_] :=
    First[Intersection[Ancestors[g,i],Ancestors[g,j]]];



UnrootedGenealogy[g_Node]:=Module[{aa,dd},
		(aa=Ancestors[g,#\[LeftDoubleBracket]1\[RightDoubleBracket]];
            dd=Descendants[g,#\[LeftDoubleBracket]1\[RightDoubleBracket]];
	Node[#\[LeftDoubleBracket]1\[RightDoubleBracket],#\[LeftDoubleBracket]2\
\[RightDoubleBracket],If[aa==={},dd,Append[dd,Last[aa]]]])&/@
        Sort[CollapseGenealogy[g,Nested\[Rule]False,
            NodeFunction\[Rule]({#1,#2}&)]]];



RootedGenealogy[{g__Node},k_]:=
    Node[k,ExtractInformation[{g},k],
        List/@Descendants[{g},k]]//.{Node[i_,si_List,{m__List}]:>
						
          Node[i,si,
            Node[#\[LeftDoubleBracket]1\[RightDoubleBracket],
                  ExtractInformation[{g},#\[LeftDoubleBracket]1\
\[RightDoubleBracket]],
						List/@
                    DeleteCases[
                      Descendants[{g},#\[LeftDoubleBracket]1\
\[RightDoubleBracket]],i]]&/@{m}]};



SiblingList[g_Node] :=Module[{
			leaves=Leaves[g],
			nodes=InternalNodes[g],
			dl,ff,ss,i,j,n},
		n=Length[leaves];
		dl=Descendants[g,#]&/@nodes;
	 ff[{x_,y_}]:=Or@@((MemberQ[#, x]&&MemberQ[#, y])&/@dl);
	  ss=Flatten[
          Table[{leaves\[LeftDoubleBracket]i\[RightDoubleBracket],
              leaves\[LeftDoubleBracket]j\[RightDoubleBracket]},{i,2,
              Length[leaves]},{j,i-1}],1];
	  Select[ss,ff]];





SizeOfGenealogyPlot[g_Node]:=
    Module[{ei=Transpose[Last/@ExtractInformation[g]]},
		{Min/@ei,Max/@ei}];



MakeGenealogyPlot[ Node[i_,si_,{}]]:=Node[i,Append[si,{0,0}],{}];

MakeGenealogyPlot[Node[i_,si_List,{nn__Node}]]:=
	
    Module[{k=Length[{nn}],j,gl=MakeGenealogyPlot/@{nn},xl,xt,al,ngl},
		sl=SizeOfGenealogyPlot/@gl;
		xl=(#\[LeftDoubleBracket]2,1\[RightDoubleBracket]-#\[LeftDoubleBracket]1,
                  1\[RightDoubleBracket])&/@sl;
		al=Range[0,k]+FoldList[Plus,0,xl];
		ngl=Table[
          TransformInformation[
            gl\[LeftDoubleBracket]
              j\[RightDoubleBracket],(ReplacePart[#2,{#2\[LeftDoubleBracket]-\
1,1\[RightDoubleBracket]+
                      al\[LeftDoubleBracket]
                        j\[RightDoubleBracket],#2\[LeftDoubleBracket]-1,
                      2\[RightDoubleBracket]},-1]&)],{j,k}];
      Node[i,Append[si,{(Last[al]-1)/2,1+Max[(#/.{{_,_},{_,y_}}:>y)&/@sl]}],
        ngl]];



Options[PlotGenealogy]={NodeFunction\[Rule](#2\[LeftDoubleBracket]-1\
\[RightDoubleBracket]&),NodeLabels\[Rule](#1&),LeafLabels\[Rule](#1&),
      MakeGenealogyPlot\[Rule]True,LeafOffset\[Rule]{0,-0.2},
      NodeOffset\[Rule]{-0.2,0.2}};

PlotGenealogy[gg_Node,opts___Rule]:=
    Module[{nf=NodeFunction/.{opts}/.Options[PlotGenealogy],nlab,llab,
		   lv=Leaves[gg],nl=Nodes[gg],
			 dl,ll,j,gl,nlF,llF,g,
			 lo=LeafOffset/.{opts}/.Options[PlotGenealogy],
			 no=NodeOffset/.{opts}/.Options[PlotGenealogy]},
		g=If[MakeGenealogyPlot/.{opts}/.Options[PlotGenealogy],
          MakeGenealogyPlot[gg],gg];
		nlF=NodeLabels/.{opts}/.Options[PlotGenealogy];
		llF=LeafLabels/.{opts}/.Options[PlotGenealogy];
		nl=Complement[nl,lv];dl=(Descendants[g,#]&/@nl);
	  ll=Flatten[
          Table[{nl\[LeftDoubleBracket]j\[RightDoubleBracket],#}&/@
              dl\[LeftDoubleBracket]j\[RightDoubleBracket],{j,Length[dl]}],
          1];
	  gl=Line[{nf[#\[LeftDoubleBracket]1\[RightDoubleBracket],
                  ExtractInformation[
                    g,#\[LeftDoubleBracket]1\[RightDoubleBracket]]],
                nf[#\[LeftDoubleBracket]1\[RightDoubleBracket],
                  ExtractInformation[
                    g,#\[LeftDoubleBracket]2\[RightDoubleBracket]]]}]&/@ll;
	  nlab=ExtractInformation[g,#]&/@nl;
		nlab=If[nlF===None,
				{},
			MapThread[Text,{MapThread[nlF,{nl,nlab}],
						((nf[#,ExtractInformation[g,#]]+no)&/@nl)}]];
     llab=ExtractInformation[g,#]&/@lv;
		 llab=If[llF===None,
				{},
			MapThread[Text,{MapThread[llF,{lv,llab}],
						((nf[#,ExtractInformation[g,#]]+lo)&/@lv)}]];
Graphics[Join[gl,nlab,llab],
        PlotRange\[Rule](Transpose[SizeOfGenealogyPlot[g]]+{{-1,1},{-1,1}})]];







GenealogyToFamily[g_Node,f_]:=
    Module[{no=OrderedNodes[g,f],leaves=CollapseGenealogy[g,Node\[Rule]False],
        ng,fl},
		no=Select[no,(FreeQ[leaves, #])&];
		ng=g//.Node[i_,s_List,m_List]:>
              NodeTemp[i,{NumberOfLineages[g,i]},m]/.NodeTemp->Node;
		fl=FoldList[(#1/.Node[#2,x_,m_List]:>Node[#2,x,{}])&,ng,no];
		Flatten[CollapseGenealogy[#,Node->False,NodeFunction->(#2&)]]&/@fl];



Options[FamilyToGenealogy]={NodeInformation\[Rule]None,
      LeafInformation\[Rule]None,NodeLabels\[Rule]None};

FamilyToGenealogy[ls_,sf_,opts___Rule]:=
    Module[{ss,ds,ts,j,k,n=Length[sf],nl,ni,li},
		ni=NodeInformation/.{opts}/.Options[FamilyToGenealogy];
	  nl=NodeLabels/.{opts}/.Options[FamilyToGenealogy];
		li=LeafInformation/.{opts}/.Options[FamilyToGenealogy];
      If[nl==None,nl=Range[n]];
			If[ni==None,ni={}&/@nl];If[li==None,li={}&/@nl];
		ss=Node[nl\[LeftDoubleBracket]-1\[RightDoubleBracket],
          ni\[LeftDoubleBracket]-1\[RightDoubleBracket],
          MapThread[Node[#1,#2,{}]&,{ls,li}]];
		Do[
			ds=Frequencies[
            TakeAway[sf\[LeftDoubleBracket]j\[RightDoubleBracket],
              ExactIntersection[sf\[LeftDoubleBracket]j\[RightDoubleBracket],
                sf\[LeftDoubleBracket]j+1\[RightDoubleBracket]]]];
			ts=Flatten[
            Table[RandomSet[ds\[LeftDoubleBracket]k,1\[RightDoubleBracket],
                Select[ss\[LeftDoubleBracket]3\[RightDoubleBracket],(\
NumberOfLineages[#]==ds\[LeftDoubleBracket]k,2\[RightDoubleBracket])&]],
					{k,Length[ds]}],1];
			ss=Node[nl\[LeftDoubleBracket]-1\[RightDoubleBracket],
            ni\[LeftDoubleBracket]-1\[RightDoubleBracket],
            Append[TakeAway[ss\[LeftDoubleBracket]3\[RightDoubleBracket],ts],
              Node[nl\[LeftDoubleBracket]j\[RightDoubleBracket],
                ni\[LeftDoubleBracket]j\[RightDoubleBracket],ts]]],
			{j,n-1}];
		ss];



\!\(\(GenealogyB[k_, k_, k_] := \(GenealogyB[k, k, k] = 1\);\)\n
  \(GenealogyB[j_, i_, k_] := \(GenealogyB[j, i, k] = 
        If[i < j, 
          0, \n\t\t\tIf[
            i == j, \(-\(\[Sum]\+\(ii = j + 1\)\%k GenealogyB[j, ii, 
                  k]\)\), \(\(j \((j + 1)\)\)\/\(j \((j - 1)\) - 
                    i \((i - 1)\)\)\) GenealogyB[j + 1, i, k]]]\);\)\)



CoalescenceDistribution[j_,k_,t_]:=
    Module[{i},Sum[GenealogyB[j,i,k]Exp[-i(i-1)t/2],{i,j,k}] ];



SimplifyFamilies={{x___List,{n1a_,a_},y___List,{n2a_,a_},z___List}:>
        Sort[{x,{n1a+n2a,a},y,z}]};



FamilyProbability[{x__Integer}]:=FamilyProbability[Frequencies[{x}]];
FamilyProbability[{{_,1}}]:=1;

\!\(\(FamilyProbability[
        s_List] := \(FamilyProbability[s /. SimplifyFamilies] = 
        Module[{ss, i, \[Alpha], l, j, tl, tr, ni, mi, nm, ns, n1, 
            n2}, \n\t\tss = s /. SimplifyFamilies; l = Length[ss]; 
          j = NumberOfFamilies[
              ss]; \n\t\t\tSum[\((tl = Take[ss, i - 1]; \n\t\t\t\tni = 
                ss\[LeftDoubleBracket]i, 2\[RightDoubleBracket]; \t
              mi = ss\[LeftDoubleBracket]i, 1\[RightDoubleBracket]; 
              nm = {mi - 1, ni}; \n\t\t\t\ttr = Take[ss, \(-\((l - i)\)\)]; 
              If[mi > 1, 
                tr = Prepend[tr, \ nm]]; \n\t\t\tSum[\((ns = 
                    Join[tl, {{1, \[Alpha]}, {1, ni - \[Alpha]}}, tr] //. 
                      SimplifyFamilies; \n\t\t\t\t\tn1 = 
                    ns /. {___, {x_, \[Alpha]}, ___} -> 
                        x; \t\n\t\t\t\t\t\t\tn2 = 
                    ns /. {___, {x_, ni - \[Alpha]}, ___} -> 
                        x; \n\t\t\t\t\t\tIf[\[Alpha] == 
                        ni - \[Alpha], \(n1 \((n1 - 1)\)\)\/\(j \((j + \
1)\)\), \(n1\ n2\)\/\(j \((j + 1)\)\)] FamilyProbability[ns])\), {\[Alpha], 
                  1, ni - 1}])\), {i, 1, l}]]\);\)\)



NumberOfLineages[{s__Integer}]:=NumberOfLineages[Frequencies[{s}]];
NumberOfLineages[{s___Integer}]:=Plus@@((Times@@#)&/@{s});
NumberOfLineages[g_Node]:=Length[Position[g,Node[_,_List,{}]]];
NumberOfLineages[g_Node,i_]:=
    Length[Position[ExtractGenealogy[g,i],Node[_,_List,{}]]];
NumberOfLineages[{g__Node}]:=Count[{g},Node[_,_,{_}]];
NumberOfLineages[{g__Node},_]:=NumberOfLineages[{g}];



\!\(\(PairwiseIdentity[{s__Integer}] := 
      PairwiseIdentity[Frequencies[{s}]];\)\n
  \(PairwiseIdentity[s__List] := 
      Module[{i, k = NumberOfLineages[s]}, \n
        Sum[s\[LeftDoubleBracket]i, 1\[RightDoubleBracket] s\
\[LeftDoubleBracket]i, 2\[RightDoubleBracket] \((s\[LeftDoubleBracket]i, 2\
\[RightDoubleBracket] - 1)\), {i, 1, Length[s]}]\/\(k \((k - 1)\)\)];\)\)



AllSets[1]={{{1,1}}};
AllSets[k_Integer]:=AllSets[k]=
			Union[Sort/@Flatten[NewS/@AllSets[k-1],1]];

AllSets[1,1]={{{1,1}}};
AllSets[j_Integer,k_Integer]:=AllSets[j,k]=
			If[(j==0)||(k==0),{},
        Union[Sort/@
            Flatten[Join[NewS[#,same]&/@AllSets[j,k-1],
                NewS[#,diff]&/@AllSets[j-1,k-1]],1]]];



NewS[s_,same]:=Module[{i,l=Length[s],tl,tr,ni,mi},
	Table[(tl=Take[s,i-1];
				ni=s\[LeftDoubleBracket]i,2\[RightDoubleBracket];	
          mi=s\[LeftDoubleBracket]i,1\[RightDoubleBracket];nm={mi-1,ni};
				tr=Take[s,-(l-i)];If[mi>1,tr=Prepend[tr, nm]];
		Join[tl,{{1,ni+1}},tr]//.SimplifyFamilies),{i,1,l}]];
NewS[s_,diff]:={Prepend[s,{1,1}]//.SimplifyFamilies};
NewS[s_]:=Join[NewS[s,diff],NewS[s,same]];



NumberOfFamilies[{s__Integer}]:=NumberOfFamilies[Frequencies[{s}]];
NumberOfFamilies[
      s__List]:=(Plus@@s)\[LeftDoubleBracket]1\[RightDoubleBracket];





\!\(\(RandomCoalescenceTimes[k0_] := 
      Module[{k = k0 + 1}, 
        Drop[FoldList[Plus, 0, 
            Table[k -= 1; 
              Random[ExponentialDistribution[\(k \((k - 1)\)\)\/2]], {k0 - 
                  1}]], 1]];\)\)



NumberOfCoalescences[k_Integer,T_]:=
    NumberOfCoalescences[RandomCoalescenceTimes[k],T];

NumberOfCoalescences[tl_List,T_]:=Length[Select[tl,(#<T)&]];



TotalLength[tl_List]:=Plus@@tl+Last[tl];



RandomFamilies[k_Integer]:=NestList[RandomPreviousFamily,Array[1&,k],k-1];



RandomPreviousFamily[{k_Integer}]:={k};
RandomPreviousFamily[n_List]:=Module[{rp,k=Length[n],n2},
		rp=RandomSet[2,k];
      n2=n\[LeftDoubleBracket]
          rp\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket];
      Sort[ReplacePart[Delete[n,rp\[LeftDoubleBracket]2\[RightDoubleBracket]],
          n2+n\[LeftDoubleBracket]
              rp\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RightDoubleBracket],rp\[LeftDoubleBracket]1\[RightDoubleBracket]]]];



Options[RandomGenealogy]={NodeLabels\[Rule]None,MutationRate\[Rule]None,
      CoalescenceTimes\[Rule]Random};

RandomGenealogy[ls_,opts___Rule]:=
	
    Module[{n=Length[ls],nl,li,ni,mu,\[Mu]T,rt,rg,nm=0,j,\[Lambda]},
		rt=CoalescenceTimes/.{opts}/.Options[RandomGenealogy];
                   If[rt===Random,rt=RandomCoalescenceTimes[n]];
      		nl=NodeLabels/.{opts}/.Options[RandomGenealogy];
      		mu=MutationRate/.{opts}/.Options[RandomGenealogy];
      		li=If[mu===None,Array[{0}&,n],Array[{0,\[Mu]T}&,n]];
      		ni=If[mu===None,(List/@rt),{#,\[Mu]T}&/@rt];
      		rg=
        FamilyToGenealogy[ls,RandomFamilies[n],NodeLabels\[Rule]nl,
          NodeInformation\[Rule]ni,LeafInformation\[Rule]li];
      	If[mu===None,
        			rg,
        		  
        rg\[LeftDoubleBracket]2\[RightDoubleBracket]={rt\[LeftDoubleBracket]-\
1\[RightDoubleBracket],{}};
        			
        rg//.{Node[
                i1_,{t1_,\[Mu]_List},{a___,Node[i2_,{t2_,\[Mu]T},{m___}],
                  b___}]:>
              						(\[Lambda]=mu(t1-t2)/2;
                							
                j=If[\[Lambda]==0,0,Random[PoissonDistribution[\[Lambda]]]];
                							nm=nm+j;
                Node[i1,{t1,\[Mu]},{a,
                    Node[i2,{t2,Sort[Join[\[Mu],Range[nm-j+1,nm]]]},{m}],
                    b}])}]];



DeletedMutations[g_Node,{T0_,T1_}]:=Module[{tt={},ii,mi},
		(mi=MutationInterval[g,#];
			ii=IntervalIntersection[Interval[{T0,T1}],Interval[mi]];
	   If[Not[ii===Interval[]],
              If[(Max[mi]-Min[mi])Random[]<(Max[ii]-Min[ii]),
                AppendTo[tt,#]]])&/@Mutations[g];
	tt];



RandomBottleneckedGenealogy[lv_,{T0_,T1_},\[Theta]_]:=
	
    Module[{g=RandomGenealogy[lv,MutationRate\[Rule]\[Theta]] ,dl},
	   dl=DeletedMutations[g,{T0,T1}];
		TransformInformation[g,
        ReplacePart[#2,
            Complement[#2\[LeftDoubleBracket]2\[RightDoubleBracket],dl],2]&]];





MomentGeneratingFunction[
      Node[i_,_List,{Node[a_,s_List,{nn__Node}]}],\[Omega]_,\[Theta]_]:=
	
    MomentGeneratingFunction[Node[a,s,{nn}],\[Omega],\[Theta]];

\!\(\(MomentGeneratingFunction[
        Node[i_, _List, {Node[a_, _List, {}], 
            Node[b_, _List, {}]}], \[Omega]_, \[Theta]_] := \n\t
      1\/\(1 + \[Theta] \((1 - \((\[Omega][a] + \[Omega][b])\)/2)\)\);\)\)

\!\(\(MomentGeneratingFunction[g_Node, \[Omega]_, \[Theta]_] := 
      Module[{\n\t\t\tleaves = 
            Leaves[g], \n\t\tn, \[Lambda], \[Phi]}, \n\t\tn = 
          Length[leaves]; \[Lambda] = \(n\/2\) \((\[Theta] + n - 
                1)\); \[Phi] = \[Theta]\/\(n \((\[Theta] + n - 1)\)\); \n\t\t\
\t1\/\(\[Lambda] \((1 - \[Phi] \((Plus @@ \((\[Omega] /@ \
leaves)\))\))\)\)*\((Plus @@ \((\(\((MomentGeneratingFunction[
                        g /. {Node[x_, 
                                y_, {Node[#\[LeftDoubleBracket]1\
\[RightDoubleBracket], _, {}], 
                                  Node[#\[LeftDoubleBracket]2\
\[RightDoubleBracket], _, {}]}] :> Node[x, y, {}], 
                            Node[x_, 
                                y_, {Node[#\[LeftDoubleBracket]2\
\[RightDoubleBracket], _, {}], 
                                  Node[#\[LeftDoubleBracket]1\
\[RightDoubleBracket], _, {}]}] :> 
                              Node[x, y, {}]}, \[Omega], \[Theta]])\) &\) /@ 
                  SiblingList[g])\))\)];\)\)

\!\(\(MomentGeneratingFunction[{g__List}, \[Omega]_, \[Theta]_] := \
\(MomentGeneratingFunction[{g}, \[Omega], \[Theta]] = 
        Module[{\n\t\tn = Length[{g}], \[Lambda], \[Phi], ng, gl, i, 
            j}, \n\t\tIf[n == 1, 
            1, \[Lambda] = \(n\/2\) \((\[Theta] + n - 
                    1)\); \[Phi] = \[Theta]\/\(n \((\[Theta] + n - 1)\)\); \n\
\ \ \ \ gl = Flatten[
                Table[Sort[{{g}\[LeftDoubleBracket]
                        i\[RightDoubleBracket], {g}\[LeftDoubleBracket]
                        j\[RightDoubleBracket]}], {i, 2, n}, {j, i - 1}], 
                1]; \n\t\t\(1\/\(\[Lambda] \((1 - \[Phi] \((Plus @@ \((\(\
\[Omega][Sort[#]] &\) /@ {g})\))\))\)\)\) 
              Plus @@ \((\(\((ng = {g} /. {{x___, #\[LeftDoubleBracket]1\
\[RightDoubleBracket], y___, #\[LeftDoubleBracket]2\[RightDoubleBracket], 
                                  z___} :> 
                                Sort[{x, 
                                    Join[#\[LeftDoubleBracket]1\
\[RightDoubleBracket], #\[LeftDoubleBracket]2\[RightDoubleBracket]], y, 
                                    z}], {x___, #\[LeftDoubleBracket]2\
\[RightDoubleBracket], y___, #\[LeftDoubleBracket]1\[RightDoubleBracket], 
                                  z___} :> 
                                Sort[{x, 
                                    Join[#\[LeftDoubleBracket]1\
\[RightDoubleBracket], #\[LeftDoubleBracket]2\[RightDoubleBracket]], y, z}]}; 
                        MomentGeneratingFunction[
                          ng, \[Omega], \[Theta]])\) &\) /@ gl)\)]]\);\)\)





PossibleCoalescenceOrder[
      Node[i_,_,{Node[a_,_,{}],Node[b_,_,{}]}]]:={Append[Sort[{a,b}],i]};

PossibleCoalescenceOrder[Node[i_,_,{Node[a_,s_,{nn__Node}]}]]:=
    Append[#,i]&/@PossibleCoalescenceOrder[Node[a,s,{nn}]];

PossibleCoalescenceOrder[g_Node]:=
	Module[{sl=SiblingList[g],tl={},lv,j},
		Do[tl=Join[tl,
            Join[sl\[LeftDoubleBracket]j\[RightDoubleBracket],#]&/@
              PossibleCoalescenceOrder[
                g/.{Node[i_,
                        s_,{Node[
                            sl\[LeftDoubleBracket]j,
                              1\[RightDoubleBracket],_,{}],
                          Node[sl\[LeftDoubleBracket]j,
                              2\[RightDoubleBracket],_,{}]}]:>Node[i,s,{}],
                    Node[i_,
                        s_,{Node[
                            sl\[LeftDoubleBracket]j,
                              2\[RightDoubleBracket],_,{}],
                          Node[sl\[LeftDoubleBracket]j,
                              1\[RightDoubleBracket],_,{}]}]:>
                      Node[i,s,{}]}]],{j,Length[sl]}];lv=Sort[Leaves[g]];
		Join[lv,TakeAway[#,lv]]&/@tl];



RandomCoalescenceOrder[Node[i_,_,{Node[a_,_,{}],Node[b_,_,{}]}]]:=
    Append[Sort[{a,b}],i];

RandomCoalescenceOrder[Node[i_,_,{Node[a_,s_,{nn__Node}]}]]:=
    Append[RandomCoalescenceOrder[Node[a,s,{nn}]],i];

RandomCoalescenceOrder[g_Node]:=
	Module[{sl=SiblingList[g],lv,j,tl},
		j=Random[Integer,{1,Length[sl]}];
		tl=Join[sl\[LeftDoubleBracket]j\[RightDoubleBracket],
          RandomCoalescenceOrder[
            g/.{Node[i_,
                    s_,{Node[
                        sl\[LeftDoubleBracket]j,1\[RightDoubleBracket],_,{}],
                      Node[sl\[LeftDoubleBracket]j,
                          2\[RightDoubleBracket],_,{}]}]:>Node[i,s,{}],
                Node[i_,
                    s_,{Node[
                        sl\[LeftDoubleBracket]j,2\[RightDoubleBracket],_,{}],
                      Node[sl\[LeftDoubleBracket]j,
                          1\[RightDoubleBracket],_,{}]}]:>Node[i,s,{}]}]];
      lv=Sort[Leaves[g]];
		Join[lv,TakeAway[tl,lv]]];



NumberOfPossibleCoalescences[g_Node,nl_]:=Module[{lv=Leaves[g],ng=g,tt={}},
       Scan[(AppendTo[tt,Length[SiblingList[ng]]];
			ng=ng/.Node[#,s_,{___}]:>Node[#,s,{}])&,TakeAway[nl,lv]];tt];



Unprotect[IncidenceMatrix];

IncidenceMatrix[g_Node,nl_List] :=Module[{
			leaves=Leaves[g],
			n=NumberOfLineages[g],S={If[FreeQ[g, Node[#,_,{}]],0,1]&/@nl},x,i},
		 Do[PrependTo[S,First[S]];
	         S\[LeftDoubleBracket]1,i\[RightDoubleBracket]=1;
        x=(Position[nl,#]\[LeftDoubleBracket]1,1\[RightDoubleBracket]&/@
              Descendants[g,nl\[LeftDoubleBracket]i\[RightDoubleBracket]]);
			    S\[LeftDoubleBracket]1,
            x\[LeftDoubleBracket]1\[RightDoubleBracket]\[RightDoubleBracket]=
          0;S\[LeftDoubleBracket]1,
              x\[LeftDoubleBracket]2\[RightDoubleBracket]\[RightDoubleBracket]\
=0;,{i,n+1,2n-1}];
Transpose[S]];

Protect[IncidenceMatrix];



MonteCarloProbability[Node[i_,_,{g_Node}],nl_List,J_List,\[Theta]_,\[Phi]_,
      ns_Integer] :=
	
    Module[{ps=Position[nl,i]\[LeftDoubleBracket]1,1\[RightDoubleBracket]},
		MonteCarloProbability[g,Delete[nl,ps],Delete[ J,ps],\[Theta],\[Phi],ns]];

\!\(\(MonteCarloProbability[g_Node, nl_List, J_List, \[Theta]_, \[Theta]1_, 
        ns_Integer]\  := 
      Module[{n = NumberOfLineages[g], S = IncidenceMatrix[g, nl], i, 
          j, \[Phi]v, \[Phi]v1, \[Phi], \[Phi]1, \[Lambda], 
          Jt}, \n\t\t\[Phi] = 
          Table[\[Theta]\/\(i \((\[Theta] + i - 1)\)\), {i, 1, 
              n}]; \[Phi]v = \(\((# . \[Phi]1)\) &\) /@ S; \n\t\t\[Phi]1 = 
          Table[\[Theta]1\/\(i \((\[Theta]1 + i - 1)\)\), {i, 1, 
              n}]; \[Phi]v1 = \(\((# . \[Phi]1)\) &\) /@ 
            S; \n\t\t\[Lambda] = \[Product]\+\(i = 2\)\%n\((i\/2\ \((\[Theta] \
+ i - 1)\))\); \n\ \((Times @@ MapThread[Power, {\[Phi]v, J}]\/\(\[Lambda] \
\((Times @@ \((Factorial /@ J)\)\ )\)\))\)*
          Table[\n\t\t\t\tJt = 
              Plus @@ MapThread[
                  RandomMultinomial[#3, \(#1  \[Phi]1\)\/#2] &, {S, \[Phi]v1, 
                    J}]; \n\t\t\t\tTimes @@ 
              MapThread[\((\(#1!\) \((#2\/#3)\)\^#1)\) &, {Jt, \[Phi], \
\[Phi]1}], {ns}]];\)\)





MonteCarloProbability[g_Node,J_List,\[Theta]_,\[Theta]1_,ns_Integer] :=
	
    Module[{nl=RandomCoalescenceOrder[g]},
		MonteCarloProbability[g,nl,J,\[Theta],\[Theta]1,
          ns]*(Times@@Drop[NumberOfPossibleCoalescences[g,nl],-1])];



Options[NumberOfMutations]={NodeFunction\[Rule](#2\[LeftDoubleBracket]2\
\[RightDoubleBracket]&)};

NumberOfMutations[g_Node,i_,opts___Rule]:=
	
    Module[{a=Ancestors[g,i],	
        nf=NodeFunction/.{opts}/.Options[NumberOfMutations]},
		If[a==={},
			0,
			Length[
				Complement[
					nf[i,ExtractInformation[g,i]],
					nf[Last[a],ExtractInformation[g,Last[a]]]]]]];



Options[Mutations]={NodeFunction\[Rule](#2\[LeftDoubleBracket]2\
\[RightDoubleBracket]&)};

Mutations[g_Node,opts___Rule]:=
  Module[{nf=NodeFunction/.{opts}/.Options[Mutations]},
		Union[Flatten[
        CollapseGenealogy[g,
            NodeFunction\[Rule]
              nf]\[LeftDoubleBracket]2\[RightDoubleBracket]]]]

Mutations[g_Node,i_,opts___Rule]:=
  Module[{nf=NodeFunction/.{opts}/.Options[Mutations],an=Ancestors[g,i]},
		Complement[nf[i,ExtractInformation[g,i]],
      If[an==={},{},nf[Last[an],ExtractInformation[g,Last[an ]]]]]]



Options[MutationOrigin]={NodeFunction\[Rule](Take[#2,2]&)};

MutationOrigin[g_Node,k_,opts___Rule] :=
    Module[{ll,nf=NodeFunction/.{opts}/.Options[MutationOrigin]},
		ll=CollapseGenealogy[g,
          NodeFunction\[Rule](If[
                  MemberQ[nf[#1,#2]\[LeftDoubleBracket]2\[RightDoubleBracket],
                    k],{nf[#1,#2]\[LeftDoubleBracket]1\[RightDoubleBracket],#\
1},{-\[Infinity],#1}]&),Nested\[Rule]False];
		ll=First[
          Sort[ll,(#1\[LeftDoubleBracket]1\[RightDoubleBracket]>#2\
\[LeftDoubleBracket]1\[RightDoubleBracket])&]];
		If[ll\[LeftDoubleBracket]1\[RightDoubleBracket]===-\[Infinity],$Failed,
        ll\[LeftDoubleBracket]2\[RightDoubleBracket]]];



Options[MutationInterval]={NodeFunction\[Rule](Take[#2,2]&)};

MutationInterval[g_Node,k_,opts___Rule]:=
    Module[{nn=MutationOrigin[g,k,opts],an,t0,t1,
        nf=NodeFunction/.{opts}/.Options[MutationInterval]},
	If[nn===$Failed,$Failed,
			t0=nf[nn,
              ExtractInformation[g,
                nn]]\[LeftDoubleBracket]1\[RightDoubleBracket];
			an=Ancestors[g,nn];
			If[an==={},{t0,\[Infinity]},
			t1=nf[Last[an],
                ExtractInformation[g,
                  Last[an]]]\[LeftDoubleBracket]1\[RightDoubleBracket];
			{t0,t1}]]];



Options[ExactProbability]={NodeFunction\[Rule](#2\[LeftDoubleBracket]2\
\[RightDoubleBracket]&)};

\!\(\(ExactProbability[g_Node, \[Theta]_, opts___Rule] := 
      Module[{\[Omega], mgf, 
          jl, \n\t\t\tnl = 
            Nodes[g], \n\t\t\tnf = \(NodeFunction /. {opts}\) /. 
              Options[ExactProbability]}, \n\t\tmgf = 
          MomentGeneratingFunction[
            g, \[Omega], \[Theta]]; \n\t\ \ jl = \(NumberOfMutations[
                g, #] &\) /@ nl; \n\t\ \ jl = 
          Reverse /@ 
            Sort[Transpose[{jl, \[Omega] /@ nl}]]; \n\t\tScan[\((mgf = 
                D[mgf, #]\/\(#\[LeftDoubleBracket]2\[RightDoubleBracket]!\) /. \
#\[LeftDoubleBracket]1\[RightDoubleBracket] \[Rule] 0)\) &, jl]; 
        mgf // Factor];\)\)

\!\(\(ExactProbability[S_List, \[Theta]_] := 
      Module[\n\t\t{\[Omega], \[Nu], mgf, jl, rl, ll, nl = Length[S], 
          nm = Length[
              S\[LeftDoubleBracket]1\[RightDoubleBracket]], \n\t\t\tff = 
            Frequencies[Transpose[S]]}, \n\t\tll = 
          List /@ Range[nl]; \n\t\t\ \ mgf = 
          MomentGeneratingFunction[ll, \[Omega], \[Theta]]; \n\t\t\ If[
            0 == \((Plus @@ \(Plus @@ S\))\), \n\t\t\t\ \ mgf /. \[Omega][_] :> 
                0, \n\t\t\t\ \ \ jl = \(ff /. \n\t\t\t\t\t{i_Integer, 
                      s_List} :> {i, \[Nu] @@ \((\(Extract[ll, #] &\) /@ 
                            Position[s, 1])\)}\) /. \[Nu][a__List] :> \[Nu][
                    Flatten[{a}]]; \n\t\t\ \ \ jl = Reverse /@ Sort[jl]; 
            rl = jl /. {{\[Nu][
                        a_], _} :> \((\[Omega][a] -> \[Nu][
                          a])\)}; \n\t\t\ \ \ \ mgf = \ \(mgf /. 
                  rl\) /. \[Omega][_] :> 
                  0; \n\t\ \ \ \ \ Scan[\((mgf = 
                    D[mgf, #]\/\(#\[LeftDoubleBracket]2\[RightDoubleBracket]!\
\) /. #\[LeftDoubleBracket]1\[RightDoubleBracket] \[Rule] 0)\) &, jl]; mgf] // 
          Factor];\)\)



Options[GenealogyToMatrix]={NodeFunction\[Rule](#2\[LeftDoubleBracket]2\
\[RightDoubleBracket]&)};

GenealogyToMatrix[g:Node[_,_List,_List]|{Node[_,_List,_List]...},opts___Rule]:=
    ListToMatrix[
      CollapseGenealogy[g,Nested\[Rule]False,Node\[Rule]False,
        NodeFunction\[Rule](NodeFunction/.{opts}/.Options[
                GenealogyToMatrix])],opts];



Options[MatrixToGenealogy]={Unrooted\[Rule]False};

MatrixToGenealogy[S_List,ll_List,ml_List,opts___Rule]:=
    
    If[ValidMatrixQ[S,opts],
      If[Unrooted/.{opts}/.Options[MatrixToGenealogy],
        MatrixToUnrootedGenealogy[S,ll,ml],
        MatrixToRootedGenealogy[S,ll,ml]],
      Message[MatrixToGenealogy::invalidMatrix,S];$Failed];

MatrixToRootedGenealogy[S_List,ll_List,ml_List]:=
    Module[{nl=Length[S],j,g,rtn,sharedMutations,nodeCount,
        lS=MatrixToList[S,MutationLabels\[Rule]ml]},
	sharedMutations=Extract[ml,#]&/@Position[Transpose[S],{(1)..}];
	nodeCount=2;
	g=Node[1,{0,
            sharedMutations},{Node[
              ll\[LeftDoubleBracket]1\[RightDoubleBracket],{0,
                lS\[LeftDoubleBracket]1\[RightDoubleBracket]},{}]}];
	Do[rtn=FindNode[g,lS\[LeftDoubleBracket]j\[RightDoubleBracket],nodeCount];
			  If[rtn===$Failed,
				g=$Failed;Break[],
				If[!(rtn\[LeftDoubleBracket]1\[RightDoubleBracket]===
                  rtn\[LeftDoubleBracket]2\[RightDoubleBracket]),
            nodeCount+=1];
				 g=AddGenealogy[g,
              Node[ll\[LeftDoubleBracket]j\[RightDoubleBracket],{0,
                  lS\[LeftDoubleBracket]j\[RightDoubleBracket]},{}],
              rtn\[LeftDoubleBracket]1\[RightDoubleBracket],
              rtn\[LeftDoubleBracket]2\[RightDoubleBracket],{0,
                rtn\[LeftDoubleBracket]3\[RightDoubleBracket]}]],
			{j,2,nl}];
		g];

MatrixToGenealogy::invalidMatrix=
    "The matrix `1` is not consistent with any genealogy";

MatrixToGenealogy::multipleSplit=
    "Mutation `1` appears to split the genealogy at several nodes.  The list \
of possible nodes, and the current genealogy are `2`, `3`";

MatrixToUnrootedGenealogy[S_List,ll_List,ml_List]:=
    
    Module[{nl,mlist,j,nleaves=Length[S],
        nmutns=Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]],rs,rs2,vms,
        nn=1,ms1,ms2,mm},
      nl=Append[Node[#,{0,{}},{1}]&/@ll,Node[nn,{0,{}},ll]];
      mlist=MatrixToList[S,MutationLabels\[Rule]ml];
      llist=MatrixToList[Transpose[S],MutationLabels\[Rule]ll];
      vms=
        ml\[LeftDoubleBracket]#\[RightDoubleBracket]&/@
          Select[Range[nmutns],
            Length[llist\[LeftDoubleBracket]#\[RightDoubleBracket]]>1&];
      nl=AddMutation[1,vms,AddMutation[ll,mlist,nl]];
      Do[If[
          1<Length[llist\[LeftDoubleBracket]j\[RightDoubleBracket]]<
            nleaves-1,
          (*Print["Doing mutation",j];*)
          
          nds=Cases[nl,
              Node[_,{_,{___,
                    ml\[LeftDoubleBracket]
                      j\[RightDoubleBracket],___}},{_,_,__}]];
          (*Print["nds=",nds];*)
          
          rs=nds/.{Node[nd_,_,
                    rs_]\[RuleDelayed](rs2=
                      Select[rs,
                        MemberQ[
                            ExtractInformation[
                                nl,#]\[LeftDoubleBracket]2\
\[RightDoubleBracket],ml\[LeftDoubleBracket]j\[RightDoubleBracket]]&];
                    {nd,rs2,Complement[rs,rs2]})};
          (*Print["rs=",rs];*)
          
          rs=Select[
              rs,(1<Length[#\[LeftDoubleBracket]2\[RightDoubleBracket]]&&
                    1<Length[#\[LeftDoubleBracket]3\[RightDoubleBracket]])&];
          (*Print["rs=",rs];*)
          
          If[Length[rs]>1,
            Message[MatrixToGenealogy::multipleSplit,
              ml\[LeftDoubleBracket]j\[RightDoubleBracket],rs,nl]];
          If[Length[rs]>0,
            (rs=First[rs];
              (*Print["Split at ",rs];*)
              nn+=1;
              mm=ExtractInformation[nl,
                    rs\[LeftDoubleBracket]1\[RightDoubleBracket]]\
\[LeftDoubleBracket]2\[RightDoubleBracket];
              
              nl=nl/.Node[
                      rs\[LeftDoubleBracket]1\[RightDoubleBracket],_,_]\
\[RuleDelayed](ms1=Union[Flatten[
                            ExtractInformation[
                                    nl,#]\[LeftDoubleBracket]2\
\[RightDoubleBracket]&/@rs\[LeftDoubleBracket]2\[RightDoubleBracket]]];
                      
                      Node[rs\[LeftDoubleBracket]1\[RightDoubleBracket],{0,
                          Intersection[ms1,mm]},
                        Append[rs\[LeftDoubleBracket]2\[RightDoubleBracket],
                          nn]]);
              
              AppendTo[nl,
                ms2=Union[
                    Flatten[
                      ExtractInformation[
                              nl,#]\[LeftDoubleBracket]2\[RightDoubleBracket]&\
/@rs\[LeftDoubleBracket]3\[RightDoubleBracket]]];
                
                Node[nn,{0,Intersection[ms2,mm]},
                  Append[rs\[LeftDoubleBracket]3\[RightDoubleBracket],
                    rs\[LeftDoubleBracket]1\[RightDoubleBracket]]]];
              ((nl=
                        nl/.Node[#,x_,y_]\[RuleDelayed]Node[#,x,
                              y/.rs\[LeftDoubleBracket]1\[RightDoubleBracket]\
\[RuleDelayed]nn])&/@rs\[LeftDoubleBracket]3\[RightDoubleBracket]);)]],
        {j,Length[ml]}];
      nl];



FindNode[g_Node,leafMutations_List,newNode_]:=
	
    Module[{nd=g\[LeftDoubleBracket]1\[RightDoubleBracket],
        oldNd=g\[LeftDoubleBracket]1\[RightDoubleBracket],desc,nodeMutations,
        descendantMutations,sharedMutations,lsm,ps,rtn={}},
		While[rtn==={},
		  desc=Descendants[g,nd];
       nodeMutations=
          ExtractInformation[g,nd]\[LeftDoubleBracket]2\[RightDoubleBracket];
       descendantMutations=
          Complement[#,
                nodeMutations]&/@(ExtractInformation[
                      g,#]\[LeftDoubleBracket]2\[RightDoubleBracket]&/@desc);
       sharedMutations=Intersection[#,leafMutations]&/@descendantMutations;
      lsm=Length/@sharedMutations;
      If[Complement[nodeMutations,leafMutations]==={},
	     If[Max[lsm]==0,
	        rtn={nd,nd,nodeMutations},
	        If[Max[lsm]!=Plus@@lsm,
		          If[Max[lsm]==-\[Infinity],
							rtn={nd,newNode,Intersection[leafMutations,nodeMutations]},
							Print["New leaf",leafMutations,
                  "contains mutations from several branches:",lsm];
		         rtn=$Failed],
		         
              ps=Position[lsm,Max[lsm]]\[LeftDoubleBracket]1,
                  1\[RightDoubleBracket];
		        
              If[Complement[
                    descendantMutations\[LeftDoubleBracket]
                      ps\[RightDoubleBracket],leafMutations]==={},
			          nd=desc\[LeftDoubleBracket]ps\[RightDoubleBracket],
			         
                rtn={desc\[LeftDoubleBracket]ps\[RightDoubleBracket],newNode,
                    Join[nodeMutations,
                      Intersection[leafMutations,
                        descendantMutations\[LeftDoubleBracket]
                          ps\[RightDoubleBracket]]]}]]],
	Print["New leaf",leafMutations,"does not contain all mutations in node ",
            nd];
	rtn=$Failed]];
	rtn];





Options[MatrixToList]={MutationLabels\[Rule]Automatic};

MatrixToList[S_List,opts___Rule] :=
    Module[{i,nl=Length[S],
        nm=Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]],ml},
			ml=MutationLabels/.{opts}/.Options[MatrixToList];
		  If[ml===Automatic,ml=Range[nm]];
		  Table[
        Extract[ml,#]&/@
          Position[S\[LeftDoubleBracket]i\[RightDoubleBracket],1],{i,nl}]];



Options[ListToMatrix]={MutationLabels\[Rule]Automatic};

ListToMatrix[z_List,opts___Rule] :=
	
    Module[{i,nl=Length[z],zl=Union[Flatten[z]]},
			ml=MutationLabels/.{opts}/.Options[MatrixToList];
		  If[ml===Automatic,ml=zl];
		  Table[
        If[MemberQ[z\[LeftDoubleBracket]i\[RightDoubleBracket],#],1,0]&/@
          ml,{i,nl}]];



GriffithsTavare[{},\[Theta]_]:=GriffithsTavareFailed[{}];

\!\(\(GriffithsTavare[{g1_List, 
          g2_List}, \[Theta]_] := \n\t\(GriffithsTavare[{g1, 
            g2}, \[Theta]] = \n\t\tModule[{a1 = 
              Plus @@ \((g1 \((1 - g2)\))\), 
            a2 = Plus @@ \((g2 \((1 - g1)\))\)}, \n\t\tBinomial[a1 + a2, 
              a1] \(\((\[Theta]\/\(2 \((1 + \[Theta])\)\))\)\^\(a1 + a2\)\) 
            1\/\(1 + \[Theta]\)]\);\)\)

\!\(\(GriffithsTavare[S_List, \[Theta]_] := 
      If[OrderedQ[S] && 
          OrderedQ[Transpose[S]], \n\t\tGriffithsTavare[
            S, \[Theta]] = \n\t\t\tModule[{\[Lambda], ps, 
              dt, \n\t\t\t\t\tff = 
                DeleteCases[Frequencies[S], {1, _}], \n\t\t\t\t\tn = 
                Length[S], 
              nm = Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]], 
              mutationTerms, coalescenceTerms}, \n\t\t\t\tps = 
              Position[Plus @@ S, 1]; \n\t\t\t\tmutationTerms = 
              If[Length[ps] == 0, 
                0, \n\t\t\t\t\t\tIf[
                  nm == 1, \n\t\t\t\t\t\t\tGriffithsTavare[
                    S /. {1 -> 0}, \[Theta]], \n\t\t\t\t\t\t\tdt = 
                    Union[\(Transpose[
                            Delete[
                              Transpose[
                                S], #\[LeftDoubleBracket]1\
\[RightDoubleBracket]]] &\) /@ 
                        ps]; \n\t\t\t\t\t\t\ \ Plus @@ \
\((\(GriffithsTavare[#, \[Theta]] &\) /@ 
                        dt)\)]]; \n\t\t\t\tcoalescenceTerms = 
              If[ff === {}, \n\t\t\t\t\t\t0, \n\t\t\t\t\t\tff = 
                  Transpose[ff]; \n\t\t\t\t\t\tIf[
                  Max[First[ff]] \[LessEqual] 
                    1, \n\t\t\t\t\t\t\t0, \n\t\t\t\t\t\t\tPlus @@ 
                    MapThread[\(\(#1 \((#1 - 1)\)\)\/2\) 
                          GriffithsTavare[
                            Delete[
                              S, \(Position[S, #2]\)\[LeftDoubleBracket]1, 
                                1\[RightDoubleBracket]], \[Theta]] &, 
                      ff]]]; \[Lambda] = \(n\/2\) \((\[Theta] + n - 
                    1)\); \(1\/\[Lambda]\) \((\(\[Theta]\/2\) mutationTerms + 
                    coalescenceTerms)\) // Factor], 
        GriffithsTavare[Transpose[Sort[Transpose[Sort[S]]]], \[Theta]]];\)\)



\!\(\(MonteCarloGriffithsTavare[
        S_List, \[Theta]_, \[Phi]_] := \n\t\t\tModule[{pr = 1, nS = S, n, ps, 
          J, K, nm = 
            Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]]}, \n\t\t\t\
While[\(! nS === {{0}}\), \n\t\ \ \ \ \ \ \ \ \ st = Transpose[nS]; 
          ust = Union[st]; \n\t\ \ \ \ \ \ \ \ \ ps = 
            Position[Plus @@ Transpose[ust], 1]; \n\t\ \ \ \ \ \ \ \ \ J = 
            Length[ps]; \n\t\ \ \ \ \ \ \ \ \ ff = 
            DeleteCases[Frequencies[nS], {1, _}]; \n\t\ \ \ \ \ \ \ \ \ K = 
            If[ff === {}, 0, 
              fft = Transpose[ff]; \n\t\ \ \ \ \ \ \ \ \ \ \ \ If[
                Max[First[fft]] \[LessEqual] 
                  1, \n\t\t\t\t\t\t\ \ \t0, \n\t\t\t\t\ \ \ \ \ \ \ \ \ \ fft\
\[LeftDoubleBracket]1\[RightDoubleBracket] . \((fft\[LeftDoubleBracket]1\
\[RightDoubleBracket] - 1)\)/2]]; \n\t\t\ \ \ \ \ \ \ n = 
            Length[nS]; \n\t\ \ \ \ \ \ \ \ \  (*\(Print[nS // MatrixForm, 
                Tab, {n, J, K}, Tab, pr];\)*) \n\t\t\tnS = 
            If[Random[] < \(J\ \[Phi]\)\/\(J\ \[Phi] + 2  K\), \n\t\t\ \ \ \ \
\ \ \ If[Length[nS\[LeftDoubleBracket]1\[RightDoubleBracket]] == 
                  1, \n\t\t\t\t\ \ \ \ \ \ \ \ \ \ nS /. {1 \[Rule] 
                      0}, \n\t\t\t\t\ \ \ \ \ \ \ \ \ \ rj = 
                  ps\[LeftDoubleBracket]Random[Integer, {1, J}], 
                    1\[RightDoubleBracket]; \n\t\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ Transpose[Delete[
                    st, \(Position[st, 
                        ust\[LeftDoubleBracket]
                          rj\[RightDoubleBracket]]\)\[LeftDoubleBracket]1, 
                      1\[RightDoubleBracket]]]], \n\t\ \ \ \ \ \ \ \ \ \ rk = 
                RandomList[
                  1, \(fft\[LeftDoubleBracket]1\[RightDoubleBracket] \((fft\
\[LeftDoubleBracket]1\[RightDoubleBracket] - 1)\)\)\/\(2  K\)]; \n\ \ \ \ \ \ \
\ \ \ \ \ \ Delete[
                nS, \(Position[nS, 
                    fft\[LeftDoubleBracket]2, 
                      1\[RightDoubleBracket]]\)\[LeftDoubleBracket]1, 
                  1\[RightDoubleBracket]]]; \n\ \ \ \ \ \ \ \ \ \ \ \ \ \ pr *= \
\((J\ \[Phi] + 2  K)\)\/\(n \((\[Theta] + n - 1)\)\)]; 
        pr \((\[Theta]\/\[Phi])\)\^nm];\)\)

MonteCarloGriffithsTavare[S_List,\[Theta]_]:=
    MonteCarloGriffithsTavare[S,\[Theta],\[Theta]];



ValidMatrixQ::notTensor=
    "ValidMatrixQ[`1`] should have as an argument a tensor of rank 2, \
containing 0 or 1";

Options[ValidMatrixQ]={Unrooted\[Rule] False};

ValidMatrixQ[S:{{(0|1)...}...},opts___Rule]:=Module[{tS},
      If[MatrixQ[S],
        If[Dimensions[S]\[LeftDoubleBracket]-1\[RightDoubleBracket]<2,
          True,
          tS=Union[Transpose[S]];
          If[Unrooted/.{opts}/.Options[ValidMatrixQ],
            
            Max[ValidMatrixQ[0,0][tS]ValidMatrixQ[1,0][tS]ValidMatrixQ[0,1][
                    tS]ValidMatrixQ[1,1][tS]]\[Equal]0,
            
            Max[ValidMatrixQ[1,0][tS]ValidMatrixQ[0,1][tS]ValidMatrixQ[1,1][
                    tS]]\[Equal]0]],
        Message[ValidMatrixQ::notTensor,S]]];

ValidMatrixQ[1,1]=Compile[{{tS,_Integer,2}},
      1-(Times@@Transpose[1-Outer[Times,tS,tS,1],{3,2,1}])];
ValidMatrixQ[0,1]=Compile[{{tS,_Integer,2}},
      1-(Times@@Transpose[1-Outer[Times,1-tS,tS,1],{3,2,1}])];
ValidMatrixQ[1,0]=Compile[{{tS,_Integer,2}},
      1-(Times@@Transpose[1-Outer[Times,tS,1-tS,1],{3,2,1}])];
ValidMatrixQ[0,0]=Compile[{{tS,_Integer,2}},
      1-(Times@@Transpose[1-Outer[Times,1-tS,1-tS,1],{3,2,1}])];



SwapStates[s:{(0|1)...},S:{{(0|1)...}...}]:=(s+#(1-2s))&/@S;



MissingCombination::invalidMatrix=
    "The matrix is not consistent with any genealogy: `1`";

MissingCombination[S:{{(0|1)...}...}]:=MissingCombination[S]=
      Module[{ut,tS=Transpose[S]},
        Outer[(ut=Union[Transpose[{##}]];
              Switch[Length[ut],
                4,Message[MissingCombination::invalidMatrix,S];$Failed,
                3,Complement[{{0,0},{0,1},{1,0},{1,1}},ut]//First,
                _,{}])&,tS,tS,1]];



PossibleRootings[x_?((ListQ[#]&&FreeQ[#, Null])&),S:{{(0|1|Null)...}...}]:=x;
PossibleRootings[{a___List,{c___,Null,d___},b___List},S:{{(0|1|Null)...}...}]:=

        Module[{i,\[Alpha],\[Beta],nl=Length[S],
        nm=Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]],
        tS=Transpose[S],miss,ut,j=Length[{c}]+1,cd={c,Null,d},t0,t1,t0Q=True,
        t1Q=True},
      miss=
        Transpose[MissingCombination[S]]\[LeftDoubleBracket]
          j\[RightDoubleBracket];
      t0=Table[If[\[Alpha]\[Equal]j,
            0,
            Switch[cd\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket],
              Null,
              Switch[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket],
                {0,0},1,
                {1,0},0,
                _,Null],
              0,
              If[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket]\[Equal]\
{0,0},t0Q=False];0,
              1,
              If[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket]\[Equal]\
{1,0},t0Q=False];1]],{\[Alpha],nm}];
      t1=Table[If[\[Alpha]\[Equal]j,
            1,
            Switch[cd\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket],
              Null,
              Switch[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket],
                {0,1},1,
                {1,1},0,
                _,Null],
              0,
              If[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket]\[Equal]\
{0,1},t1Q=False];0,
              1,
              If[miss\[LeftDoubleBracket]\[Alpha]\[RightDoubleBracket]\[Equal]\
{1,1},t1Q=False];1]],{\[Alpha],nm}];
      If[t0Q,If[t1Q,{a,t0,t1,b},{a,t0,b}],If[t1Q,{a,t1,b},{a,b}]]];

PossibleRootings[S:{{(0|1|Null)...}...}]:=
    FixedPoint[
      PossibleRootings[#,S]&,{Array[
          Null&,{Length[S\[LeftDoubleBracket]1\[RightDoubleBracket]]}]}];



AddMutation::invalidLists=
    "The lists of nodes `1` and of mutations `2` are not compatible.";

AddMutation[n_?(Not[ListQ[#]]&),m_?(Not[ListQ[#]]&),
    g:(Node[_,_List,{___Node}]|{Node[_,_List,_List]...})]:=
  
  g/.Node[n,{x_,y_List,z___},d_List]\[RuleDelayed]Node[n,{x,Append[y,m],z},d];
AddMutation[n_?(Not[ListQ[#]]&),m_List,
    g:(Node[_,_List,{___Node}]|{Node[_,_List,_List]...})]:=
  
  g/.Node[n,{x_,y_List,z___},d_List]\[RuleDelayed]Node[n,{x,Join[y,m],z},d];

AddMutation[n_List,m_List,
      g:(Node[_,_List,{___Node}]|{Node[_,_List,_List]...})]:=
    
    If[Length[n]\[Equal]Length[m],
      Fold[
        AddMutation[#2\[LeftDoubleBracket]1\[RightDoubleBracket],#2\
\[LeftDoubleBracket]2\[RightDoubleBracket],#1]&,g,Transpose[{n,m}]],
      Message[AddMutation::invalidLists,n,m]];



Options[CondenseMatrix]={Unrooted\[Rule]False};

CondenseMatrix::notMatrix="`1` is not a matrix";

CondenseMatrix[S:{{(0|1)...}...},opts___Rule]:=If[MatrixQ[S],
      Module[{tSR},
        If[Unrooted/.{opts}/.Options[CondenseMatrix],
          
          tSR=DeleteCases[
              Union[Transpose[S]],{0 ...}|{1 ...}|{0 ... ,1,0 ...}|{1 ... ,0,
                  1 ...}];
          
          Transpose[
            Union[tSR/.{x:{(0|1)...}\[RuleDelayed]First[Sort[{x,1-x}]]}]],
          
          Transpose[
            DeleteCases[
              Union[Transpose[S]],{0 ...}|{1 ...}|{0 ... ,1,0 ...}]]]],
      Message[CondenseMatrix::notMatrix,S]];





AncestralGraphPattern={AncestralLineagePattern...};



AncestralLineagePattern=AncestralLineage[_,{_,_},_List,_List,{___List}];



Junctions[AncestralLineage[_,{_,_},_List,j_List,_List]]:=Drop[j,-1];
Junctions[g:AncestralGraphPattern]:=Union[Flatten[Junctions/@g]];



MapLength::mixedLengths="The map lengths `1` differ among lineages";

MapLength[AncestralLineage[_,{_,_},_List,j_List,_List]]:=Last[j];
MapLength[g:AncestralGraphPattern]:=
    Module[{ml=Union[MapLength/@g]},
      If[Length[ml]>1,
        Message[MapLength::mixedLengths,ml]];
      ml\[LeftDoubleBracket]1\[RightDoubleBracket]];



TimesOfEvents[g:AncestralGraphPattern]:=
    Union[Flatten[
        g/.AncestralLineage[_,{t0_,t1_},_List,_List,_List]\[RuleDelayed]{t0,
              t1}]];



AllEvents::badJunctions=
    "The junctions at the recombination event at t=`1` in graph `2` do not \
change by 1.";

AllEvents::badRelationship=
    "The event at t=`1` in graph `2` does not have the right form.";

AllEvents[g:AncestralGraphPattern]:=AllEvents[g]=Module[{cs,ce,jj},
        (cs=Cases[g,AncestralLineage[_,{#,_},_List,_List,_List]];
              ce=Cases[g,AncestralLineage[_,{_,#},_List,_List,_List]];
              Switch[Length/@{ce,cs},
                {0,_}|{_,0}|{2,1},
                {#,ce/.ExtractLabel,cs/.ExtractLabel,None},
                {1,2},
                
                jj=TakeAway[
                    Join[cs\[LeftDoubleBracket]1,4\[RightDoubleBracket],
                      cs\[LeftDoubleBracket]2,4\[RightDoubleBracket]],
                    ce\[LeftDoubleBracket]1,4\[RightDoubleBracket]];
                (*If[\[InvisibleSpace]!(MatchQ[
                            jj,{x_,x_,
                              1}]||(Sort[{cs\[LeftDoubleBracket]1,
                                    3\[RightDoubleBracket],
                                  cs\[LeftDoubleBracket]2,
                                    3\[RightDoubleBracket]}]===
                              Sort[{{{}},
                                  ce\[LeftDoubleBracket]1,
                                    3\[RightDoubleBracket]}])),
                    Message[AllEvents::"badJunctions",#1,g]]*)(* 
                  too hard to do *)
                
                If[Not[{}===
                      Cases[Transpose[{cs\[LeftDoubleBracket]2,
                                4\[RightDoubleBracket],
                              cs\[LeftDoubleBracket]2,
                                3\[RightDoubleBracket]}],{jj\
\[LeftDoubleBracket]1\[RightDoubleBracket],_}]\[LeftDoubleBracket]1,
                        2\[RightDoubleBracket]],
                  cs=Reverse[cs]];
                {#,ce/.ExtractLabel,cs/.ExtractLabel,
                  jj\[LeftDoubleBracket]1\[RightDoubleBracket]},
                _,
                Message[AllEvents::badRelationship,#,g];
                {#,ce/.ExtractLabel,cs/.ExtractLabel,None}])&/@
          TimesOfEvents[g]];



CoalescenceEvents[g:AncestralGraphPattern]:=
    Cases[AllEvents[g],{_,{_,_},{_},_}];



RecombinationEvents[g:AncestralGraphPattern]:=
    RecombinationEvents[g]=Cases[AllEvents[g],{_,{_},{_,_},_}];



NullRecombinationEvents[g:AncestralGraphPattern]:=
    NullRecombinationEvents[g]=Cases[AllEvents[g],{_,{_},{_,_},MapLength[g]}];



LeafEvents[g:AncestralGraphPattern]:=
    LeafEvents[g]=Cases[AllEvents[g],{_,{},{__},_}];



RootEvents[g:AncestralGraphPattern]:=
    RootEvents[g]=Cases[AllEvents[g],{_,{__},{},_}];



Leaves::multipleLineages="Some leaves share the same label: `1`"; 

Leaves[g:AncestralGraphPattern]:=
    
    Module[{ss=
          Flatten[#\[LeftDoubleBracket]3\[RightDoubleBracket]&/@
              LeafEvents[g]],uss,res},
      uss=Union[ss];res=TakeAway[ss,uss]==={};
      If[Not[res],Message[Leaves::multipleLineages,g]];
      uss];



LineagesPresent[g:AncestralGraphPattern,t_]:=
    
    Select[g,(#\[LeftDoubleBracket]2,1\[RightDoubleBracket]\[LessEqual]
              t<#\[LeftDoubleBracket]2,
                2\[RightDoubleBracket])&]/.ExtractLabel;
LineagesPresent[g:AncestralGraphPattern]:=
    g/.ExtractLabel;



RecombinantLineages::multipleLineages=
    "Some recombinant lineages share the same label: `1`"; 

RecombinantLineages[g:AncestralGraphPattern]:=
    
    Module[{ss=
          Flatten[#\[LeftDoubleBracket]3\[RightDoubleBracket]&/@
              RecombinationEvents[g]],uss,dss},
      uss=Union[ss];dss=ss\[Backslash]uss;
      If[Not[dss==={}],Message[RecombinantLineages::multipleLineages,g]];
      uss];



CoalescentLineages::multipleLineages=
    "Some coalescent lineages share the same label: `1`"; 

CoalescentLineages[g:AncestralGraphPattern]:=
    
    Module[{ss=
          Flatten[#\[LeftDoubleBracket]3\[RightDoubleBracket]&/@
              CoalescenceEvents[g]],uss,dss},
      uss=Union[ss];dss=ss\[Backslash]uss;
      If[Not[dss==={}],Message[CoalescentLineages::multipleLineages,g]];
      uss];



RootLineages::multipleLineages=
    "Some root lineages share the same label: `1`"; 

RootLineages[g:AncestralGraphPattern]:=
    
    Module[{ss=
          Flatten[(#\[LeftDoubleBracket]2\[RightDoubleBracket])&/@
              RootEvents[g]],uss,res},
      uss=Union[ss];ss\[Backslash]uss==={};
      If[Not[res],Message[RootLineages::multipleLineages,g]];
      uss];



NullLineages[g:AncestralGraphPattern]:=
    NullLineages[g]=
      Cases[g,AncestralLineage[_,{_,_},{{}},{MapLength[g]},_List]];



TimespanOfLineage[g:AncestralGraphPattern,l_]:=
    ExtractLineage[g,l]\[LeftDoubleBracket]2\[RightDoubleBracket];



TimespanOfJunction[ag:AncestralGraphPattern,j_]:=Module[{cc},
      cc=Cases[ag,AncestralLineage[_,{_,_},_,{___,j,___},_]];
      {First[Sort[cc/.AncestralLineage[_,{t0_,_},_,_,_]\[RuleDelayed]t0]],
        Last[Sort[cc/.AncestralLineage[_,{_,t1_},_,_,_]\[RuleDelayed]t1]]}];



ExtractLabel={AncestralLineage[l_,{_,_},_List,_List,_List]\[RuleDelayed]l};



ExtractInformation[g:AncestralGraphPattern,l_]:=Last[ExtractLineage[g,l]];



ExtractLineage::notPresent="Lineage `1` is not present in the graph `2`";

ExtractLineage::multipleLineages=
    "Lineage `1` occurs more than once in the graph `2`";

ExtractLineage[g:AncestralGraphPattern,l_List]:=Map[ExtractLineage[g,#]&,l,1];

ExtractLineage[g:AncestralGraphPattern,l_?(Not[ListQ[#]]&)]:=Module[{cs},
      cs=Cases[g,AncestralLineage[l,{_,_},_List,_List,_List]];
      Switch[Length[cs],
        0,Message[ExtractLineage::notPresent,l,g];{},
        1,cs\[LeftDoubleBracket]1\[RightDoubleBracket],
        _,Message[ExtractLineage::multipleLineages,l,g];cs]];



ExtractLineagesEndingAtT[g:AncestralGraphPattern,t_]:=Module[{cs},
      cs=Cases[g,AncestralLineage[_,{_,t},_List,_List,_List]]/.ExtractLabel];



ExtractLineagesStartingAtT[g:AncestralGraphPattern,t_]:=Module[{cs},
      cs=Cases[g,AncestralLineage[_,{t,_},_List,_List,_List]]/.ExtractLabel];



ExtractGenealogy::multipleRoots=
    "Some of the leaves `1` have more than one ancestral lineage at map \
position `3`: `2`";

ExtractGenealogy[g:AncestralGraphPattern,x_]:=
    
    Module[{ng=g,ds,ll=Leaves[g],rl},
      rl=Union[
          Ancestors[g,#,AncestorList\[Rule]Roots,MapPosition\[Rule]x]&/@ll];
      If[Length[rl]\[Equal]1,
        ds=
          Descendants[g,rl\[LeftDoubleBracket]1\[RightDoubleBracket],
            MapPosition\[Rule]x,DescendantList\[Rule]All];
        ds=
          ds//.{a___,{l_?(Not[MemberQ[ll, #]]&),{}},b___}\[RuleDelayed]{a,b};
        ListToGenealogy[ds,
          NodeFunction\[Rule]({First[TimespanOfLineage[g,#]]}&)],
        Message[ExtractGenealogy::multipleRoots,ll,rl,x];$Failed]];

(* This is an old piece of code which is in some ways more efficient*)
(*
  
  ExtractGenealogy[g:AncestralGraphPattern,x_]:=
      
      Module[{ng=g,ds,ll=Leaves[g],rl},
        rl=Union[Flatten[Ancestors[g,#,AncestorList\[Rule]Roots]]]&/@ll;
        If[And@@(Length[#]\[Equal]1&/@rl),
          
          ds=RecombinationEvents[g]/.{_,_,{aL_,aR_},j_}\[RuleDelayed]
                If[x<j,aR,aL];
          (ng=DeleteCases[ng,AncestralLineage[#,{_,_},_List,_List,_List]])&/@
            ds;
          ng,
          Message[ExtractGenealogy::multipleRoots,ll,rl];$Failed]];
  *)

\!\(\(ExtractGenealogy[g : AncestralGraphPattern] := 
      Module[{js = 
            Junctions[g]}, \[IndentingNewLine]\(ExtractGenealogy[
              g, #] &\) /@ \(\(Prepend[js, 0] + Append[js, 1]\)\/2\)];\)\)







Options[Descendants]=Append[Options[Descendants],MapPosition\[Rule]None];

Descendants::multipleLineages="Several events occur at `1`; `2`";

Descendants[g:AncestralGraphPattern,l_,opts___Rule]:=
    
    Module[{t0,desc,f,dl=DescendantList/.{opts}/.Options[Descendants],mp,cs,
        re},
      Switch[dl,
        Next,
        mp=MapPosition/.{opts}/.Options[Descendants];
        t0=TimespanOfLineage[g,l]//First;
        cs=
          Cases[g,AncestralLineage[_,{_,
                  t0},_List,_List,_List]]/.ExtractLabel;
        If[mp===None,
          cs,
          re=Cases[AllEvents[g],{t0,_,_,_}];
          
          If[Length[re]\[NotEqual]1,
            Message[Descendants::multipleLineages,t0,g]];
          If[re\[LeftDoubleBracket]1,-1\[RightDoubleBracket]===None,
            cs,
            
            If[(mp<re\[LeftDoubleBracket]1,-1\[RightDoubleBracket]&&
                    re\[LeftDoubleBracket]1,3,1\[RightDoubleBracket]===
                      l)||(mp\[GreaterEqual]
                      re\[LeftDoubleBracket]1,-1\[RightDoubleBracket]&&
                    re\[LeftDoubleBracket]1,3,2\[RightDoubleBracket]===l),
              cs,{}]]],
        All,
        First[FixedPoint[Map[AddDescendants[g,#,opts]&,#,{-2}]&, {l}]],
        Leaves,
        First[{l}//.{{x__?(Not[ListQ[#]]&)}\[RuleDelayed]((dd=
                          Descendants[g,#,DescendantList\[Rule]Next,opts];
                        If[dd==={},#,dd])&/@{x})}]]];



AddDescendants[g:AncestralGraphPattern,{},___Rule]:={};
AddDescendants[g:AncestralGraphPattern,{x__?(Not[ListQ[#]]&)},
      opts___Rule]:=
    {#,
          Descendants[g,#,DescendantList\[Rule]Next,opts]}&/@{x};



Options[Ancestors]={AncestorList\[Rule]Previous,MapPosition\[Rule]None};

Ancestors::multipleLineages="Several events occur at `1`; `2`";

Ancestors[g:AncestralGraphPattern,l_,opts___Rule]:=
    
    Module[{t0,anc,f,al=AncestorList/.{opts}/.Options[Ancestors],mp,cs,re},
      Switch[al,
        Previous,
        mp=MapPosition/.{opts}/.Options[Ancestors];
        t0=TimespanOfLineage[g,l]//Last;
        cs=
          Cases[g,AncestralLineage[_,{t0,_},_List,_List,_List]]/.ExtractLabel;\

        If[mp===None,
          cs,
          re=Cases[AllEvents[g],{t0,_,_,_}];
          
          If[Length[re]\[NotEqual]1,
            Message[Ancestors::multipleLineages,t0,g]];
          If[re\[LeftDoubleBracket]1,-1\[RightDoubleBracket]===None,
            cs,
            
            If[mp<re\[LeftDoubleBracket]1,-1\[RightDoubleBracket],{re\
\[LeftDoubleBracket]1,3,1\[RightDoubleBracket]},{re\[LeftDoubleBracket]1,3,
                  2\[RightDoubleBracket]}]]],
        All,
        First[FixedPoint[Map[AddAncestors[g,#,opts]&,#,{-2}]&, {l}]],
        Roots,
        First[{l}//.{{x__?(Not[ListQ[#]]&)}\[RuleDelayed](y=
                    Union[Flatten[((dd=
                                  Ancestors[g,#,AncestorList\[Rule]Previous,
                                    opts];If[dd==={},#,dd])&/@{x})]];(*Print[
                        y];*)y)}]]];

















































































AddAncestors[g:AncestralGraphPattern,{},___Rule]:={};
AddAncestors[g:AncestralGraphPattern,{x__?(Not[ListQ[#]]&)},
      opts___Rule]:=
    {#,
          Ancestors[g,#,AncestorList\[Rule]Previous,opts]}&/@{x};



Options[CoalesceLineages]={InformationFunction\[Rule](Transpose[{##}]&)};

CoalesceLineages::badInfoLists=
    "The information lists associated with the two lineages have different \
lengths.";

CoalesceLineages[
      AncestralLineage[_,{_,_},s1_List,j1_List,i1:{___List}],
      AncestralLineage[_,{_,_},s2_List,j2_List,i2:{___List}],l12_,t12_,
      opts___Rule]:=
    
    Module[{if=InformationFunction/.{opts}/.Options[CoalesceLineages],jsl},
      If[Length[i1]\[NotEqual]Length[i2],
        Message[CoalesceLineages::badInfoLists,i1,i2];$Failed,
        jsl=
          Transpose[
            Sort[Join[Replace[Transpose[{j1,s1}],{j_,s_}\[Rule]{j,s,Null},1],
                Replace[Transpose[{j2,s2}],{j_,s_}\[Rule]{j,Null,s},1]]]];
        jsl=
          Drop[Transpose[
              jsl//.{a___,Null,x_?(Not[#===Null]&),b___}\[Rule]{a,x,x,
                    b}],-1];
        jsl=Replace[jsl,{j_,ss1_,ss2_}\[Rule]{j,Union[Join[ss1,ss2]]},1];
        jsl=
          jsl//.{a___,{j_?(Not[ListQ[#]]&),s__},{j_?(Not[ListQ[#]]&),__},
                b___}\[Rule]{a,{j,s},b};
        jsl=
          jsl//.{a___,{_?(Not[ListQ[#]]&),s__},{jj2_?(Not[ListQ[#]]&),s__},
                b___}\[Rule]{a,{jj2,s},b};
        jsl=Transpose[jsl];
        AncestralLineage[l12,{t12,\[Infinity]},
          Sort/@jsl\[LeftDoubleBracket]2\[RightDoubleBracket],
          jsl\[LeftDoubleBracket]1\[RightDoubleBracket],if[i1,i2]]]];



Options[RecombineLineage]={InformationFunction\[Rule]{Identity,Identity}};

RecombineLineage[AncestralLineage[_,{_,_},s_List,j_List,i_List],{lL_,lR_},x_,
      t_,opts___Rule]:=
    
    Module[{if=InformationFunction/.{opts}/.Options[RecombineLineage],jsl,jsL,
        jsR,jsRR},
      jsl=Transpose[{j,s}];
      jsRR=Select[jsl,(#\[LeftDoubleBracket]1\[RightDoubleBracket]>x)&];
      If[jsRR\[LeftDoubleBracket]1,2\[RightDoubleBracket]==={},
        jsR=Transpose[jsRR];
        jsL=
          Transpose[
            Join[Select[
                jsl,(#\[LeftDoubleBracket]1\[RightDoubleBracket]\[LessEqual]
                      x)&],{{jsR\[LeftDoubleBracket]1,-1\[RightDoubleBracket],\
{}}}]],
        jsR=Transpose[Prepend[jsRR,{x,{}}]];
        jsL=
          Transpose[
            Join[Select[
                jsl,(#\[LeftDoubleBracket]1\[RightDoubleBracket]\[LessEqual]
                      x)&],{{x,
                  jsR\[LeftDoubleBracket]2,
                    2\[RightDoubleBracket]},{jsR\[LeftDoubleBracket]1,-1\
\[RightDoubleBracket],{}}}]]];
      {AncestralLineage[lL,{t,\[Infinity]},
          Sort/@jsL\[LeftDoubleBracket]2\[RightDoubleBracket],
          jsL\[LeftDoubleBracket]1\[RightDoubleBracket],
          if\[LeftDoubleBracket]1\[RightDoubleBracket][i]],
        AncestralLineage[lR,{t,\[Infinity]},
          Sort/@jsR\[LeftDoubleBracket]2\[RightDoubleBracket],
          jsR\[LeftDoubleBracket]1\[RightDoubleBracket],
          if\[LeftDoubleBracket]2\[RightDoubleBracket][i]]}];







Options[AddRecombinantLineages]={DeleteNullLineages\[Rule]False};

AddRecombinantLineages[g:AncestralGraphPattern,l_,{lL_,lR_},x_,t_,
      opts___Rule]:=
    
    Module[{rl=RecombineLineage[ExtractLineage[g,l],{lL,lR},x,t]},
      If[(DeleteNullLineages/.{opts}/.Options[
                AddRecombinantLineages])&&(rl\[LeftDoubleBracket]1,
                  3\[RightDoubleBracket]==={{}}||
              rl\[LeftDoubleBracket]2,3\[RightDoubleBracket]==={{}}),
        g,
        Join[
          g/.AncestralLineage[l,{t0_,_},s_,j_,i_]\[RuleDelayed]
              AncestralLineage[l,{t0,t},s,j,i],rl]]];



AddCoalescentLineage[g:AncestralGraphPattern,{l1_,l2_},lC_,t_]:=
    Module[{cl=
          CoalesceLineages[ExtractLineage[g,l1],ExtractLineage[g,l2],lC,t]},
      Append[g/.AncestralLineage[ll:l1|l2,{t0_,_},s_,j_,i_]\[RuleDelayed]
            AncestralLineage[ll,{t0,t},s,j,i],cl]];



\!\(\(RandomCoalescenceTimes[k_Integer, R_] := 
      Module[{t, \[Lambda] = \(k \((k - 1)\)\)\/2 + 
              k\ R}, \[IndentingNewLine]t = 
          Random[ExponentialDistribution[\[Lambda]]]; \[IndentingNewLine]If[
          Random[] < k\ R/\[Lambda], \[IndentingNewLine]{t, k + 1, 
            Random[UniformDistribution[0, \ R]]}, \[IndentingNewLine]{t, 
            k - 1, None}]];\)\)

RandomCoalescenceTimes[n_Integer,k_Integer,R_]:=
    Drop[FoldList[#2+{#1\[LeftDoubleBracket]1\[RightDoubleBracket],0,0}&,{0,0,
          0},
        Drop[
          NestList[
            RandomCoalescenceTimes[#\[LeftDoubleBracket]2\[RightDoubleBracket]\
,R]&,{0,k,0},n],1]],1];



Options[RandomGenealogy]=
    Join[Options[RandomGenealogy],{PrintDetails\[Rule]False,
        MaxTime\[Rule]\[Infinity],Fixation\[Rule]False}];

RandomGenealogy::badRec=
    "Attempt to add recombinant lineages derived from `1` to `2` failed.";
RandomGenealogy::oneRec=
    "Only one recombinant lineages derived from `1` added to `2`: error.";

RandomGenealogy[ll_List,n_Integer,R_,opts___Rule]:=
    
    Module[{rct,g1=g0=AncestralLineage[#,{0,\[Infinity]},{{#}},{R},{}]&/@ll,
        k=0,lvs=ll,nl,t=0,cl,
        pd=PrintDetails/.{opts}/.Options[RandomGenealogy],
        tm=MaxTime/.{opts}/.Options[RandomGenealogy],
        fix=Fixation/.{opts}/.Options[RandomGenealogy]},
      While[k\[LessEqual]n\[And]t<tm\[And]If[fix,
            Not[FixedQ[ExtractLineage[g0,#]&/@lvs,ll]],
            True],
        (k+=1;
          rct=RandomCoalescenceTimes[Length[lvs],R];
          t+=rct\[LeftDoubleBracket]1\[RightDoubleBracket];
          If[pd,Print[rct]];
          If[Last[rct]===None,
            nl=RandomSet[2,lvs];
            If[pd,Print["Coalescing ",nl,"; current lineages ",lvs]];
            g1=AddCoalescentLineage[g0,nl,k+1,t];
            lvs=TakeAway[lvs,nl];lvs=Append[lvs,k+1];k+=1,
            nl=RandomSet[1,lvs]\[LeftDoubleBracket]1\[RightDoubleBracket];
            If[pd,Print["Recombining ",nl,"; current lineages ",lvs]];
            
            g1=AddRecombinantLineages[g0,nl,{k+1,k+2},
                rct\[LeftDoubleBracket]3\[RightDoubleBracket],t,opts];
            (*If[pd,Print[g0,Tab,g1]];*)
            
            Switch[Length[g1]-Length[g0],
              0,Null,
              1,Message[RandomGenealogy::oneRec,nl,g1];
              lvs=TakeAway[lvs,{nl}];lvs=Join[lvs,{k+1}];k+=1,
              2,
              lvs=TakeAway[lvs,{nl}];lvs=Join[lvs,{k+1,k+2}];k+=2,
              _,Message[RandomGenealogy::badRec,nl,g1]]];
          If[pd,
            cl=ExtractLineage[g1,#]&/@lvs;
            Print["Current lineages =",cl," fixed? ",FixedQ[cl,ll]]];g0=g1)];
      g1];

RandomGenealogy[ll_List,rct:{{_,_Integer,_}...},R_,opts___Rule]:=
    
    Module[{g1,g0=AncestralLineage[#,{0,\[Infinity]},{{#}},{R},{}]&/@ll,k=0,
        lvs=ll,nl,pd=PrintDetails/.{opts}/.Options[RandomGenealogy]},
      (If[pd,Print[#]];
            If[Last[#]===None,
              nl=RandomSet[2,lvs];
              If[pd,Print["Coalescing ",nl,"; current lineages ",lvs]];
              
              g1=AddCoalescentLineage[g0,nl,
                  k+1,#\[LeftDoubleBracket]1\[RightDoubleBracket]];
              lvs=TakeAway[lvs,nl];lvs=Append[lvs,k+1];k+=1,
              nl=RandomSet[1,lvs]\[LeftDoubleBracket]1\[RightDoubleBracket];
              If[pd,Print["Recombining ",nl,"; current lineages ",lvs]];
              
              g1=AddRecombinantLineages[g0,
                  nl,{k+1,
                    k+2},#\[LeftDoubleBracket]3\[RightDoubleBracket],#\
\[LeftDoubleBracket]1\[RightDoubleBracket]];
              Switch[Length[g1]-Length[g0],
                1,lvs=TakeAway[lvs,{nl}];lvs=Join[lvs,{k+1}];k+=1,
                2,lvs=TakeAway[lvs,{nl}];lvs=Join[lvs,{k+1,k+2}];k+=2,
                _,Message[RandomGenealogy::badRec,nl,g1]]];
            If[pd,Print["G=",g1]];g0=g1)&/@rct;
      g1];



Segments[al:AncestralLineagePattern,l_]:=
    Module[{xx=al/.AncestralLineage[_,{_,_},s_,j_,_]:>{s,j},yy},
      yy=Replace[
            Transpose[
              xx],{{___?(FreeQ[#,l]&)}\[RuleDelayed]{},{___?(FreeQ[#,l]&),
                  l,___?(FreeQ[#,l]&)}\[RuleDelayed]{l}},{2}]//.{a___,{s_List,
                x0_},{s_List,x1_},b___}\[RuleDelayed]{a,{s,x1},b};
      yy=(yy//.
            {{b___,{{},x0_},
                  {{___,l,___},x1_},c___}\[RuleDelayed]{b,{x0,x1},c},
              {b___,{{},_}}\[RuleDelayed]{b},
              {{{___,l,___},x0_},b___}\[RuleDelayed]{{0,x0},b}})];

Segments[al:AncestralGraphPattern,l_]:=Segments[#,l]&/@al;



Options[PlotSegments]={JunctionStyle\[Rule]{Black},SegmentStyle\[Rule]{Blue},
      BackgroundStyle\[Rule]{Yellow}};

PlotSegments[al:AncestralLineagePattern,l_,y_,opts___Rule]:=
    
    Module[{segs=Segments[al,l],yy,
        bs=BackgroundStyle/.{opts}/.Options[PlotSegments],
        ss=SegmentStyle/.{opts}/.Options[PlotSegments]},
      yy=bs\[Vee]{Line[{{0,y},{MapLength[al],y}}]}\[Vee]ss\[Vee]
          {Replace[segs,{x0_,x1_}\[RuleDelayed]Line[{{x0,y},{x1,y}}],1]};
      Graphics[yy]];

\!\(\(PlotSegments[al : AncestralGraphPattern, l_, {y0_, y1_}, 
        opts___Rule] := \[IndentingNewLine]Module[{segs = Segments[al, l], 
          yy, \[IndentingNewLine]jj = Junctions[al], y, k, 
          nl = Length[
              al], \[IndentingNewLine]bs = \(BackgroundStyle /. {opts}\) /. 
              Options[PlotSegments], \[IndentingNewLine]js = \(JunctionStyle /. \
{opts}\) /. Options[
                PlotSegments], \[IndentingNewLine]ss = \(SegmentStyle /. \
{opts}\) /. Options[PlotSegments]}, \[IndentingNewLine]yy = 
          js\[Vee]Replace[jj, x_ \[RuleDelayed] Line[{{x, y0}, {x, y1}}], 
              1]\[Vee]bs\[Vee]Table[
              Line[{{0, y}, {MapLength[al], y}}], {y, y0, 
                y1, \(y1 - y0\)\/Max[1, nl - 1]}]\[Vee]Table[
              ss\[Vee]Replace[
                  segs[\([k]\)], {x0_, 
                      x1_} \[RuleDelayed] {Line[{{x0, \(y0 \((nl - k)\) + y1 \
\((k - 1)\)\)\/Max[1, nl - 1]}, {x1, \(y0 \((nl - k)\) + y1 \((k - \
1)\)\)\/Max[1, nl - 1]}}]}, 1], {k, nl}]; \[IndentingNewLine]Graphics[
          yy]];\)\)



FixedQ[AncestralLineage[_,_List,s_List,_List,_List],
      lvs_List]:=(Complement[Sort/@s,{{},Sort[lvs]}]==={});
FixedQ[ag:AncestralGraphPattern,lvs_List]:=And@@(FixedQ[#,lvs]&/@ag);





MRCA[g_Node,{}]:={};
MRCA[g_Node,{(x_)..}]:=x;
MRCA[g_Node,nl_List]:=Module[{al=Ancestors[g,#]&/@nl},
      Last[TakeAway[First[al],Complement[First[al],Intersection@@al]]]];



PairwiseDivergence[g_Node,nl_List]:=First[ExtractInformation[g,MRCA[g,nl]]];
PairwiseDivergence[g_Node]:=
    PairwiseDivergence[g,#]&/@
      Union[Sort/@
          DeleteCases[Flatten[Outer[List,Leaves[g],Leaves[g]],1],{a_,a_}]];



PairwiseDifference[g_Node,nl_List]:=
    Module[{ml=
          ExtractInformation[g,#]\[LeftDoubleBracket]2\[RightDoubleBracket]&/@
            nl},
      Complement[Union@@ml,Intersection@@ml]];
PairwiseDifference[g_Node]:=
    Length[PairwiseDifference[g,#]]&/@
      Union[Sort/@
          DeleteCases[Flatten[Outer[List,Leaves[g],Leaves[g]],1],{a_,a_}]];



MeanPairwiseDivergence[g_Node]:=Mean[PairwiseDivergence[g]];



ExtractCoalescenceTimes[g_Node]:=Union[First/@ExtractInformation[g]];



LengthOfGenealogy[g_Node]:=Module[{ct=ExtractCoalescenceTimes[g]},
      Last[ct]+Plus@@ct];



DepthOfGenealogy[g_Node]:=Last[ExtractCoalescenceTimes[g]];



\!\(\(PairwiseDivergencePlot[gl : {__Node}, {dm_, d_}, 
        opts___Rule] := \[IndentingNewLine]Module[{bc = 
            Plus @@ \((\(BinCounts[PairwiseDivergence[#], {0, dm, d}] &\) /@ 
                  gl)\)}, \[IndentingNewLine]ListPlot[
          Transpose[{Range[d\/2, dm - d\/2, d], bc}], 
          opts]];\)\[IndentingNewLine]
  \(PairwiseDivergencePlot[g_Node, {dm_, d_}, 
        opts___Rule] := \[IndentingNewLine]PairwiseDivergencePlot[{g}, {dm, 
          d}, opts];\)\)



\!\(\(PairwiseDifferencePlot[gl : {__Node}, {dm_, d_}, 
        opts___Rule] := \[IndentingNewLine]Module[{bc = 
            Plus @@ \((\(BinCounts[PairwiseDifference[#], {0, dm, d}] &\) /@ 
                  gl)\)}, \[IndentingNewLine]ListPlot[
          Transpose[{Range[d\/2, dm - d\/2, d], bc}], 
          opts]];\)\[IndentingNewLine]
  \(PairwiseDifferencePlot[g_Node, {dm_, d_}, 
        opts___Rule] := \[IndentingNewLine]PairwiseDifferencePlot[{g}, {dm, 
          d}, opts];\)\)



DeleteNullLineages[g:AncestralGraphPattern]:=
    DeleteCases[g,AncestralLineage[_,{_,_},{{}},{_},_List]];



BlockSizes[AncestralLineage[_,{_,_},{{}},_List,_List]]:=0;
BlockSizes[AncestralLineage[_,{_,_},_List,r_List,_List]]:=
    r-Prepend[Drop[r,-1],0];
BlockSizes[g:AncestralGraphPattern]:=BlockSizes/@g;



End[];
EndPackage[];