(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Multilocus`DataManipulation`",
	{"Utilities`SetManipulation`",
			"Statistics`DescriptiveStatistics`",
    "Statistics`MultiDescriptiveStatistics`"}]







HaploidTypes::usage=
    "HaploidTypes[{{a1,b1,..},{a2,b2,..}..}] lists all possible haploid \
genotypes, based on the set of alleles {a1,b1,..} at locus 1, etc.  \
HaploidTypes[{{a,b,..},n}] lists all possible genotypes, assuming the same \
set of alleles at n loci.  HaploidTypes[n] assumes n loci, with two alleles \
labelled {0,1}. HaploidTypes[n,SortByClass\[Rule]True] lists haplotypes \
ordered by the # of '1' alleles.";



SortByClass::usage=
    "SortByClass is an option for HaploidTypes[] and Diploid Types[] which \
determines the order of the genotypes.";



DiploidTypes::usage=
    "DiploidTypes[{{a1,b1,..},{a2,b2,..}..}] lists all possible diploid \
genotypes, based on the set of alleles {a1,b1,..} at locus 1, etc.  \
DiploidTypes[{a,b,..},n] lists all possible genotypes, assuming the same set \
of alleles at n loci.  DiploidTypes[n] assumes n loci, with two alleles \
labelled {0,1}.  DiploidTypes[n,SortByClass\[Rule]True] lists  diploid \
genotypes ordered by the # of '1' alleles.";



PossibleGenotypes::usage=
    "PossibleGenotypes[{{a,A},{b,B},{c,c}}] lists all the diploid genotypes \
compatible with the observed genotype, {{{a,b,c},{A,B,c}},\[Ellipsis]}. The \
default is to list both {{a,b,c},{A,B,c}} and {{A,B,c},{a,b,c}}; \
ListEquivalentGenotypes->True only lists one of these two complementary \
genotypes"; 



HaploidSubsets::usage=
    "HaploidSubsets[S] gives all the haploid subsets based on loci listed in \
S. Stores results.";



DiploidSubsets::usage=
    "DiploidSubsets[S] gives all the diploid subsets based on loci listed in \
S. Stores results.";



ListEquivalentGenotypes::usage="ListEquivalentGenotypes is an option for PossibleGenotypes[g]; if true, lists both equivalent genotypes (h1,h2} and {h2,h1}.";



ObservableGenotype::usage="ObservableGenotype[{{a,b,\[Ellipsis]},{A,B,\
\[Ellipsis]}}] gives the diploid genotype that would be observed if \!\(\*
StyleBox[\"cis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"and\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"trans\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"could\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"not\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"be\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"distinguished\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Plain\"]\)";



Data::usage=
    "Data[site] is a structure which denotes an array containing data on \
site; by default, it is a list of diploid genotypes written in the form \
{{0,0},{0,1},{1,1},..}";



\[EmptySet]::usage="\[EmptySet] denotes missing data";



ConvertData::usage=
    "ConvertData[{{0,1,-1,2},\[Ellipsis]}}] converts data on biallelic loci \
into the more general form, {{{0,0},{0,1},\[EmptySet],{1,1}},\[Ellipsis]}.  \
ConvertData[{{0,1,-1,2},\[Ellipsis]}},{1,2,2,2,\[Ellipsis]}] allows for \
different ploidy across loci; gives  {{{0},{0,1},\[EmptySet],{1,1}},\
\[Ellipsis]}";



NumberOfIndividuals::usage=
    "NumberOfIndividuals[site] gives the number of individualsin site.";



LocusNames::usage="LocusNames[site] gives the names of the loci at the site";

Ploidy::usage="Ploidy[site] gives the ploidy of the various loci in the site"

NumberOfGenes::usage=
    "NumberOfGenes[site] gives the number of genes sampled from the site, \
allowing for variation in ploidy";

NumberOfLoci::usage="NumberOfLoci[site] gives the number of loci.";



SelectLoci::usage=
    "SelectLoci[newsite,oldsite,loci] names a new dataset which is derived as \
a subset of the old one. Loci can be specified by number ({5,1,3}, say) or by \
name ({'mtDNA','Adh'), say), provided that LocusNames[oldsite] is defined. \
SelectLoci[data,{5,1,3}] forms a new dataset which contains the chosen loci, \
specified by number.";



SelectIndividuals::usage=
    "SelectIndividuals[newsite,oldsite,inds] names a new dataset which is \
derived as a subset of the old one. Individuals are specified by number \
({5,1,3}, say).";



MissingData::usage=
    "MissingData is an option for GenotypeFrequency and AlleleFrequencyTable \
that specifies that missing data,\[EmptySet], are interpreted as homozygous \
null alleles";



NullAllele::usage=
    "NullAllele\[Rule]\[Nu] is anmoption for GenotypeFrequency and \
AlleleFrequencyTable which specifies that \[Nu] represents a null allele.  \
This must be listed in the allele list for the relevant loci, and the same \
symbol must be used for all loci";



GenotypeFrequency::usage=
    "GenotypeFrequency[d,alleleList,pList]  lists the diploid genotype \
frequency for each locus, given the allele frequencies p. The allele names \
are listed in the second argument. GenotypeFrequency[d,alleleList,p1,p2] \
allows there to be different pools for the two parents (as in an F1 hybrid or \
backcross) NullAllele\[Rule]\[Nu]  specifies that allele \[Nu] is a null \
allele; null heterozygotes appear as homozygotes, and null homozygotes appear \
as missing data.  MissingData\[Rule]True allows missing data to be \
interpreted as null homozygotes and used in estimation; otherwise they are \
ignored";



\!\(\(AlleleFrequency::usage = \
\*"\"\<AlleleFrequency[locus,allele,alleleList,pList] gives the frequency of \
the given allele. Missing data are represented by \[EmptySet] and return a \
frequency of \[EmptySet]. \
AlleleFrequency[{\!\(a\_1\),\[Ellipsis]},alleleList,pList] lists the \
frequencies of all the alleles. (These are assumed to be at successive \
loci,so that {\!\(a\_1\),\[Ellipsis]} is a haploid genotype).\>\"";\)\)



AlleleFrequencyTable::usage=
    "AlleleFrequencyTable[site,alleles] gives a table of allele frequencies \
for the site.  NullAlleles\[Rule]\[Nu] allows for the presence of null \
alleles, labelled \[Nu].  The same symbol must be used for nulls at all loci. \
 MissingData->True specifies that \[EmptySet] is interpreted as a null \
homozygote.  Otherwise, missing data are ignored.";



NumberOfIndividualsTable::usage=
    "NumberOfIndividualsTable[site] gives a table of the number of \
individuals with data for each locus";



NumberOfGenesTable::usage=
    "NumberOfGenesTable[site] gives a table of the number of genes with data \
for each locus";



ReducedData::usage=
    "ReducedData[site,alleles,Detail->True] lists the number of observations \
of each diploid type for that site, together with that type. \
ReducedData[site,alleles] just lists the counts, in the same order as \
DiploidTypes[].";

Detail::usage=
    "Detail is an option for ReducedData which lists counts and types, rather \
than just counts";



AlleleFrequencyMean::usage=
    "AlleleFrequencyMean[site,alleles] gives the mean allele frequency.  \
There must be the same number of alleles per locus.";



NetCovariance::usage=
    "NetCovariance[site] gives the net covariance between each locus and the \
others";



RandomFamily::usage=
    "RandomFamily[p] gives a haploid offspring from the diploid parent p.  \
RandomFamily[p1,p2] gives a random diploid offspring from a cross between \
diploid genotypes p1, p2.  RandomFamily[p1,p2,n] generates n such offspring.  \
Linkage\[Rule]{r12,r23,\[Ellipsis]} allows for linkage.  SegregationRatio\
\[Rule]{0.6,0.7,\[Ellipsis]} allows for a biased segregation at each locus; \
the proportion of alleles derived from the first genome in the diploid is \
given.";



\!\(\(SegregationRatio::usage = \*"\"\<SegregationRatio is an option for \
RandomFamily that specifies the probability that the allele from the first \
genome in the diploid is transmitted.  SegregationRatio\[Rule]{0.6,0.7,\
\[Ellipsis]} specifies different ratios for each locus.  SegregationRatio\
\[Rule]{{0.6,0.7,\[Ellipsis]},{0.8,\[Ellipsis]}} allows different ratios in \
the two parents. SegregationRatio\[Rule]\!\(1\/2\), the default, specifies \
the same ratio at all loci.\>\"";\)\)



\!\(\(Linkage::usage = \*"\"\<Linkage\[Rule]{\!\(r\_\(1, \\\\\\\ \(\(\\\\\\\\\
\)\(\\\\\\\ \)\(2\)\)\)\),\!\(r\_\(2, \\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \
\)\(\\\\\\\\\\\\\\\\ \(\(\\\\\\\\\)\(\\\\\\\ \)\) 3\)\)\)\),\[Ellipsis]} is \
an option for Gametes[], GameteTable[] and RandomFamily[] which specifies the \
recombination rates in each interval; assumes no interference and a linear \
map.  The default Linkage\[Rule]False gives unlinked loci. \>\"";\)\)



\!\(\(NetRecombination::usage = \
\*"\"\<NetRecombination[{\!\(r\_1\),\!\(r\_2\),\!\(r\_3\),\[Ellipsis]}] gives \
the net recombination rate across a linear genetic map\>\"";\)\)



ParentalGenotypes::usage=
    "ParentalGenotypes[{{0,0,1,1,\[Ellipsis]},\[Ellipsis]}] returns a list of \
the joint parental genotypes inferred from a list of segregations.  Assumes \
two alleles per locus, with genotypes represented by 0,1, 2.  Missing data \
can be represented by \[EmptySet].";



GenotypeFrequencyTable::usage="\!\(TraditionalForm\`GenotypeFrequencyTable\)[\
site,alleles] lists the diploid genotype frequencies, locus by locus";



\!\(\(GenotypeProbability::usage = \*"\"\<GenotypeProbability[o,p] is the \
chance that haploid offspring o would be produced by diploid parent p. \
GenotypeProbability[o,\!\(p\_1\),\!\(p\_2\)] is the chance that diploid \
offspring o would be produced by diploid parents \!\(p\_1\),\!\(p\_2\).  \
Options Linkage and SegregationRatio can be used, as in RandomFamily[]. \
ObservableGenotype\[Rule]True sums over all full diploid offspring genotypes \
compatible with the observed genotype o. \>\"";\)\)



Begin["Multilocus`DataManipulation`Private`"];

Off[General::spell1,General::spell];



Options[HaploidTypes]={SortByClass\[Rule]False};

HaploidTypes[{},___]:={};

HaploidTypes[g_List,opts___]:=
    HaploidTypes[g,opts]=If[SortByClass/.{opts}/.Options[HaploidTypes],
			Sort[HaploidTypes[g],
          Module[{p1=Plus@@#1,p2=Plus@@#2},
              If[p1<p2,True,If[p1>p2,False,OrderedQ[{#1,#2}]]]]&],
			Flatten[Apply[Outer,Prepend[g,List]],Length[g]-1]];

HaploidTypes[{g_List,n_Integer},opts___]:=
    HaploidTypes[{g,n},opts]=HaploidTypes[Table[g,{n}],opts];

HaploidTypes[n_Integer,opts___]:=
    HaploidTypes[n,opts]=HaploidTypes[{{0,1},n},opts];



Options[DiploidTypes]={SortByClass\[Rule]False};

DiploidTypes[{},___]={};
DiploidTypes[{s_List},opts___]:=
    DiploidTypes[{s},opts]=If[SortByClass/.{opts}/.Options[DiploidTypes],
			Sort[DiploidTypes[{s}],
          Module[{p1=Plus@@Plus@@#1,p2=Plus@@Plus@@#2},
              If[p1<p2,True,If[p1>p2,False,OrderedQ[{#1,#2}]]]]&],
			Module[{fs,j,k},
          
          fs=Flatten[
              Table[{Sort[{s\[LeftDoubleBracket]j\[RightDoubleBracket],
                      s\[LeftDoubleBracket]k\[RightDoubleBracket]}]},{j,
                  Length[s]},{k,j}],1]]];
DiploidTypes[{s_List,t__List},opts___]:=DiploidTypes[{s,t},opts]=
      		If[SortByClass/.{opts}/.Options[DiploidTypes],
        		 
        Sort[DiploidTypes[{s,t}],
          Module[{p1=Plus@@Plus@@#1,p2=Plus@@Plus@@#2},
              If[p1<p2,True,If[p1>p2,False,OrderedQ[{#1,#2}]]]]&],
        			Flatten[Outer[Join,DiploidTypes[{s}],DiploidTypes[{t}],1],1]];

DiploidTypes[{s_List,n_Integer},opts___]:=DiploidTypes[s,n,opts]=
		DiploidTypes[Table[s,{n}],opts];

DiploidTypes[n_Integer,opts___]:=DiploidTypes[n,opts]=
		DiploidTypes[{{0,1},n},opts];



\!\(\(DiploidSubsets[S_List] := \(DiploidSubsets[S] = 
        HaploidSubsets[Join[S, \(\((\(#\^*\))\) &\) /@ S]]\);\)\)



HaploidSubsets[S_List]:=HaploidSubsets[S]=Subsets[S,2,Length[S]];



Options[PossibleGenotypes]={ListEquivalentGenotypes\[Rule]True};

PossibleGenotypes[g:{{_,_}...},opts___Rule]:=
    Module[{ps},
      ps=Outer[List,##]&@@Replace[g,{x_,x_}\[Rule]{x},1];
      ps=Flatten[ps,Depth[ps]-3];
      ps={#,Flatten[MapThread[TakeAway[#1,{#2}]&,{g,#}]]}&/@ps;
      If[ListEquivalentGenotypes/.{opts}/.Options[PossibleGenotypes],
        ps,(Sort/@ps)//Union]];



ObservableGenotype[{h1_List,h2_List}]:=Sort/@Transpose[{h1,h2}];



NumberOfIndividuals[s_]:=Length[Data[s]];



NumberOfLoci[s_]:=
    If[NumberOfIndividuals[s]==0,Indeterminate,
      Length[Data[s]\[LeftDoubleBracket]1\[RightDoubleBracket]]];



NumberOfIndividualsTable[s_]:=
    Length[DeleteCases[#,\[EmptySet]]]&/@Transpose[Data[s]];



NumberOfGenesTable[s_]:=
    Length[Flatten[DeleteCases[#,\[EmptySet]]]]&/@Transpose[Data[s]];



NumberOfGenes[s_]:=NumberOfIndividuals[s](Plus@@Ploidy[s]);



Ploidy::baddata="Data for a locus at site `1` are invalid or missing: `2`";

Ploidy[s_]:=Module[{pl,x},
    pl=Transpose[(If[#===\[EmptySet],\[EmptySet],Length[#]]&/@#)&/@Data[s]];
    (x=DeleteCases[#,\[EmptySet]]/.{a_Integer..}\[Rule]a;
          If[MatchQ[x,_List],Message[Ploidy::baddata,s,x];\[EmptySet],x])&/@
      pl];



SelectLoci::badspec=
    "Specification `1` for loci does not match locus names `2` for site `3`";

SelectLoci[ns_,os_,x_]:=
    Module[{xx,
        lns=(Head[LocusNames[os]]===List)},
       If[MatchQ[x,{___Integer}],
        xx=x,
        xx=Flatten[Position[LocusNames[os], #]&/@x];
        If[(Length[xx]\[NotEqual]Length[x])||(!MatchQ[xx,{___Integer}]),
          Message[SelectLoci::badspec,x,LocusNames[os],os]]];
      (Data[ns]=SelectLoci[Data[os],xx];
        If[lns,
          LocusNames[ns]=
            LocusNames[os]\[LeftDoubleBracket]xx\[RightDoubleBracket]]);];

SelectLoci[d_,x:{___Integer}]:=
    Transpose[Transpose[d]\[LeftDoubleBracket]x\[RightDoubleBracket]];

SelectIndividuals[ns_,os_,x:{___Integer}]:=
    Module[{
        lns=(Head[LocusNames[os]]===List)},
       (Data[ns]=Data[os]\[LeftDoubleBracket]x\[RightDoubleBracket];
          If[lns,LocusNames[ns]=LocusNames[os]]);];



Options[GenotypeFrequency]={MissingData\[Rule]False,NullAllele\[Rule]None};

GenotypeFrequency[l_Integer,\[EmptySet],al:{_List...},p1_List,p2_List,
      opts___Rule]:=
    
    Module[{na=NullAllele/.{opts}/.Options[GenotypeFrequency],
        md=MissingData/.{opts}/.Options[GenotypeFrequency]},
      If[na===None,
        \[EmptySet],
        If[MemberQ[al\[LeftDoubleBracket]l\[RightDoubleBracket],na]\[And]md,
          AlleleFrequency[l,na,al,p1]AlleleFrequency[l,na,al,p2],
          \[EmptySet]]]];

GenotypeFrequency[l_Integer,{a_,a_},al:{_List...},p1_List,p2_List,
      opts___Rule]:=
    
    Module[{na=NullAllele/.{opts}/.Options[GenotypeFrequency],
        md=MissingData/.{opts}/.Options[GenotypeFrequency],pn1,pn2},
      If[MemberQ[al\[LeftDoubleBracket]l\[RightDoubleBracket],na],
        pn1=AlleleFrequency[l,na,al,p1];pn2=AlleleFrequency[l,na,al,p2];
        (AlleleFrequency[l,a,al,p1]AlleleFrequency[l,a,al,p2]+
              AlleleFrequency[l,a,al,p1]pn2+AlleleFrequency[l,a,al,p2]pn1)/
          If[MemberQ[al\[LeftDoubleBracket]l\[RightDoubleBracket],
                na]\[And]!md,1-pn1*pn2,1],
        AlleleFrequency[l,a,al,p1]AlleleFrequency[l,a,al,p2]]];
GenotypeFrequency[l_Integer,{a1_,a2_},al:{_List...},p1_List,p2_List,
      opts___Rule]:=
    Module[{na=NullAllele/.{opts}/.Options[GenotypeFrequency],
        md=MissingData/.{opts}/.Options[GenotypeFrequency],pn1,pn2},
      If[MemberQ[al\[LeftDoubleBracket]l\[RightDoubleBracket],na],
        pn1=AlleleFrequency[l,na,al,p1];pn2=AlleleFrequency[l,na,al,p2]];
      (AlleleFrequency[l,a1,al,p1]AlleleFrequency[l,a2,al,p2]+
            AlleleFrequency[l,a1,al,p2]AlleleFrequency[l,a2,al,p1])/
        If[MemberQ[al\[LeftDoubleBracket]l\[RightDoubleBracket],na]\[And]!md,
          1-pn1*pn2,1]];

GenotypeFrequency[dg:{({_,_}|\[EmptySet])...},al:{_List...},p1_List,p2_List,
      opts___Rule]:=
    
    MapIndexed[
      GenotypeFrequency[#2\[LeftDoubleBracket]1\[RightDoubleBracket],#1,al,p1,
          p2,opts]&,dg];

GenotypeFrequency[dg:{({_,_}|\[EmptySet])...},{as_List,n_Integer},p1_List,
      p2_List,opts___Rule]:=
		GenotypeFrequency[dg,Table[as,{n}],p1,p2,opts];

GenotypeFrequency[dg:{({_,_}|\[EmptySet])...},n_Integer,p1_List,p2_List,
      opts___Rule]:=
	GenotypeFrequency[dg,{{0,1},n},p1,p2,opts];

GenotypeFrequency[dg:{({_,_}|\[EmptySet])...},as_,pl_List,opts___Rule]:=
	
    GenotypeFrequency[dg,as,pl,pl,opts];



AlleleFrequency::badAllele="`1` is not an allele of locus `2`";

AlleleFrequency[l_Integer,a_,al:{_List...},pl_List]:=
    Module[{pos=Position[al\[LeftDoubleBracket]l\[RightDoubleBracket],a]},
      If[a===\[EmptySet],
        \[EmptySet],
        If[pos==={},
          Message[AlleleFrequency::badAllele,a,l];Indeterminate,
          
          Extract[pl\[LeftDoubleBracket]l\[RightDoubleBracket],
            pos\[LeftDoubleBracket]1\[RightDoubleBracket]]]]];

AlleleFrequency[a_List,al:{_List...},pl_List]:=
    MapIndexed[
      AlleleFrequency[#2\[LeftDoubleBracket]1\[RightDoubleBracket],#1,al,pl]&,
      a];

AlleleFrequency[l_Integer,a_,{as_List,n_Integer},pl_List]:=
		
    AlleleFrequency[l,a,Table[as,{n}],pl];

AlleleFrequency[l_Integer,a_,n_Integer,pl_List]:=
	
    AlleleFrequencyTable[l,a,{{0,1},n},pl];

AlleleFrequency[a_List,{as_List,n_Integer},pl_List]:=
		
    AlleleFrequency[a,Table[as,{n}],pl];

AlleleFrequency[a_List,n_Integer,pl_List]:=
	
    AlleleFrequencyTable[a,{{0,1},n},pl];



Options[AlleleFrequencyTable]={NullAllele\[Rule]None,MissingData\[Rule]False};

AlleleFrequencyTable::badNull=
    "Missing allele `1` is present more than once in allele list `2` for \
locus `3`";

AlleleFrequencyTable[s_,{as_List,n_Integer},opts___Rule]:=
		
    AlleleFrequencyTable[s,Table[as,{n}],opts];

AlleleFrequencyTable[s_,n_Integer,opts___Rule]:=
	
    AlleleFrequencyTable[s,{{0,1},n},opts];

Options[AlleleFrequencyTable]={NullAllele\[Rule]None,MissingData\[Rule]False};

AlleleFrequencyTable::badNull=
    "Missing allele `1` is present more than once in allele list `2` for \
locus `3`";

AlleleFrequencyTable[s_,{as_List,n_Integer},opts___Rule]:=
		
    AlleleFrequencyTable[s,Table[as,{n}],opts];

AlleleFrequencyTable[s_,n_Integer,opts___Rule]:=
	
    AlleleFrequencyTable[s,{{0,1},n},opts];

\!\(\(AlleleFrequencyTable[s_, al : {_List ... }, 
        opts___Rule] := \(AlleleFrequencyTable[s, as, opts] = 
        Module[{j, k, td = Transpose[Data[s]], pp, gt, ngt, nm, dt, homs, ff, 
            ntot = 2\ NumberOfIndividuals[s], pna, px, pl, 
            na = \(NullAllele /. {opts}\) /. Options[AlleleFrequencyTable], 
            md = \(MissingData /. {opts}\) /. 
                Options[AlleleFrequencyTable]}, \[IndentingNewLine]ngt = 
            NumberOfGenesTable[s]; \[IndentingNewLine]pp = 
            Table[If[
                ngt\[LeftDoubleBracket]j\[RightDoubleBracket] \[Equal] 0, 
                Indeterminate, 
                Count[Flatten[
                      DeleteCases[
                        td\[LeftDoubleBracket]
                          j\[RightDoubleBracket], \[EmptySet]]], 
                    al\[LeftDoubleBracket]j, k\[RightDoubleBracket]]/
                  ngt\[LeftDoubleBracket]j\[RightDoubleBracket]], {j, 
                NumberOfLoci[s]}, {k, 
                Length[al\[LeftDoubleBracket]
                    j\[RightDoubleBracket]]}]; \[IndentingNewLine]If[
            na === None, \[IndentingNewLine]pp, \[IndentingNewLine]dt = \
\(DiploidTypes[{#}] &\) /@ al; \[IndentingNewLine]gt = 
              GenotypeFrequencyTable[s, al]; \[IndentingNewLine]Table[
              np = Position[al\[LeftDoubleBracket]j\[RightDoubleBracket], 
                  na]; \ \[IndentingNewLine]If[
                Length[np] > 1, \[IndentingNewLine]Message[
                  AlleleFrequencyTable::badNull, na, al, j]; \ Indeterminate, 
                If[Length[np] \[Equal] 0, 
                  pp\[LeftDoubleBracket]j\[RightDoubleBracket], 
                  pna = np\[LeftDoubleBracket]1, 1\[RightDoubleBracket]; \ 
                  px = Delete[pp\[LeftDoubleBracket]j\[RightDoubleBracket], 
                      pna]; \ homs = 
                    Delete[\(ngt\[LeftDoubleBracket]j\[RightDoubleBracket]*
                            Extract[
                              gt\[LeftDoubleBracket]
                                j\[RightDoubleBracket], #] &\) /@ 
                        Position[
                          dt\[LeftDoubleBracket]j\[RightDoubleBracket], {{a_, 
                              a_}}], pna]; \[IndentingNewLine]\ 
                  If[md, \[IndentingNewLine]nm = 
                      ntot - ngt\[LeftDoubleBracket]
                          j\[RightDoubleBracket]; \
\[IndentingNewLine]ff[{p_List, 
                          pn_}] := \[IndentingNewLine]1\/ntot\ {px*
                              ngt\[LeftDoubleBracket]j\[RightDoubleBracket] - 
                            homs*pn\/\(p + 2\ pn\), 
                          nm + homs . \(pn\/\(p + 
                                    2\ pn\)\)}, \
\[IndentingNewLine]ff[{p_List, 
                          pn_}] := \[IndentingNewLine]\((1 - pn\^2)\) {px - 
                            
                            homs\/ngt\[LeftDoubleBracket]j\
\[RightDoubleBracket]*pn\/\(p + 2\ pn\), 
                          pn\^2\/\(1 - pn\^2\) + \(homs\/ngt\
\[LeftDoubleBracket]j\[RightDoubleBracket]\) . \(pn\/\(p + 2\ pn\)\)}]; \ 
                  pl = NestWhile[
                      ff, {px\ \((1 - 0.001)\), 
                        0.001}, \((Abs[#1\[LeftDoubleBracket]2\
\[RightDoubleBracket] - #2\[LeftDoubleBracket]2\[RightDoubleBracket]] > 
                              10\^\(-9\) \[And] \ 
                            0.999 > #2\[LeftDoubleBracket]2\
\[RightDoubleBracket] > 10\^\(-8\))\) &, 2]; \ 
                  Insert[pl\[LeftDoubleBracket]1\[RightDoubleBracket], 
                    pl\[LeftDoubleBracket]2\[RightDoubleBracket], pna]]], {j, 
                NumberOfLoci[s]}]]]\);\)\)

AlleleFrequencyTable[s_,{as_List,n_Integer},opts___Rule]:=
    AlleleFrequencyTable[s,Table[as,{n}],opts];

AlleleFrequencyTable[s_,n_Integer,opts___Rule]:=
    AlleleFrequencyTable[s,{{0,1},n},opts];



Options[ReducedData]:={Detail->False};

ReducedData[s_,as_,opts___]:=
    Module[{dd=Data[s],dt=DiploidTypes[as]},
      If[Detail/.{opts}/.Options[ReducedData],
			{Count[dd,#],#}&/@dt,
			Count[dd,#]&/@dt]];



ConvertData[{a__List}]:=ConvertData/@{a};
ConvertData[{a___}]:=
	{a}/.{0\[Rule]{0,0},1\[Rule]{0,1},
        2\[Rule]{1,1},-1\[Rule]\[EmptySet]};

ConvertData[{a__List},pl_List]:=ConvertData[#,pl]&/@{a};
ConvertData[{a___},pl_List]:=Module[{j},
	Table[If[pl\[LeftDoubleBracket]j\[RightDoubleBracket]==2,
				{a}\[LeftDoubleBracket]j\[RightDoubleBracket]/.{0\[Rule]{0,0},
              1\[Rule]{0,1},2\[Rule]{1,1},-1\[Rule]\[EmptySet]},
				{a}\[LeftDoubleBracket]j\[RightDoubleBracket]/.{0\[Rule]{0},
              1\[Rule]{1}}],{j,Length[{a}]}]];



AlleleFrequencyMean[s_,as_]:=
    If[NumberOfIndividuals[s]==0,
      Indeterminate,(#.NumberOfGenesTable[s])&/@
          Transpose[AlleleFrequencyTable[s,as]]/Plus@@NumberOfGenesTable[s]];



\!\(\(NetCovariance[s_] := 
      Module[{i, j, k, ss, dsdt, ds, sds, ff}, \n\t
        ds = \((Data[
                s] /. {{i_?NumberQ, j_?NumberQ} :> i + j, {i_?NumberQ} :> 
                  i, \[EmptySet] \[Rule] 0})\)\t; \n\tsds = Plus @@ ds; \n\t
        dsdt = Table[
            If[\(NumberOfGenesTable[s]\)\[LeftDoubleBracket]
                  j\[RightDoubleBracket] == 0, Indeterminate, 
              sds\[LeftDoubleBracket]j\[RightDoubleBracket]\/\(\
NumberOfGenesTable[s]\)\[LeftDoubleBracket]j\[RightDoubleBracket]], {j, 
              NumberOfLoci[s]}]; \n\tff = \(\((# - dsdt)\) &\) /@ ds; \n\t
        Table[\((ss = 0; 
            Sum[If[\((\(Data[s]\)\[LeftDoubleBracket]i, 
                          j\[RightDoubleBracket] === \[EmptySet])\) || \
\((\(Data[s]\)\[LeftDoubleBracket]i, 
                          k\[RightDoubleBracket] === \[EmptySet])\), 0, 
                  ss += 1; 
                  ff\[LeftDoubleBracket]i, j\[RightDoubleBracket] 
                    ff\[LeftDoubleBracket]i, k\[RightDoubleBracket]], {i, 
                  NumberOfIndividuals[s]}]/ss)\), {k, NumberOfLoci[s]}, {j, 
            NumberOfLoci[s]}]];\)\)



Options[RandomFamily]={Linkage\[Rule]False,SegregationRatio\[Rule]False};

RandomFamily[p__List,n_Integer,opts___Rule] :=Table[RandomFamily[p,opts],{n}];

RandomFamily[p1_List,p2_List] :={RandomFamily[p1],RandomFamily[p2]};

RandomFamily[p1_List,p2_List,
      opts__Rule] :={RandomFamily[p1,
        opts/.{(Linkage\[Rule]{x_List,y_List})\[RuleDelayed](Linkage\[Rule]
                  x),(SegregationRatio\[Rule]{x_List,
                    y_List})\[RuleDelayed](SegregationRatio\[Rule]x)}],
      RandomFamily[p2,
        opts/.{(Linkage\[Rule]{x_List,y_List})\[RuleDelayed](Linkage\[Rule]
                  y),(SegregationRatio\[Rule]{x_List,
                    y_List})\[RuleDelayed](SegregationRatio\[Rule]y)}]};

\!\(\(RandomFamily[{h1_List, h2_List}, 
        opts___Rule]\  := \[IndentingNewLine]Module[{\[IndentingNewLine]rl = \
\(Linkage /. {opts}\) /. Options[RandomFamily], 
          sr = \(SegregationRatio /. {opts}\) /. 
              Options[RandomFamily], \[IndentingNewLine]x, y, 
          tss = Transpose[{h1, h2}], j}, \[IndentingNewLine]If[
          rl === False, \[IndentingNewLine]If[sr === False, 
            sr = Table[
                1\/2, {Length[
                    h1]}]]; \[IndentingNewLine]MapThread[\((#1\
\[LeftDoubleBracket]If[Random[] < #2, 1, 
                    2]\[RightDoubleBracket])\) &, {Transpose[{h1, h2}], 
              sr}], \[IndentingNewLine]x = Random[Integer, {1, 2}]; 
          y = {tss\[LeftDoubleBracket]1, 
                x\[RightDoubleBracket]}; \[IndentingNewLine]Do[
            If[Random[] < rl\[LeftDoubleBracket]j\[RightDoubleBracket], 
              x = If[x \[Equal] 1, 2, 1]]; 
            AppendTo[y, 
              tss\[LeftDoubleBracket]j + 1, x\[RightDoubleBracket]], {j, 
              Length[rl]}]; y]];\)\)



Options[GenotypeProbability]={Linkage\[Rule]False,
      SegregationRatio\[Rule]False,ObservableGenotype\[Rule]False};

\!\(\(GenotypeProbability[o_List, {h1_List, h2_List}, 
        opts___Rule] := \[IndentingNewLine]Module[{\[IndentingNewLine]rl = \
\(Linkage /. {opts}\) /. Options[GenotypeProbability], 
          sr = \(SegregationRatio /. {opts}\) /. 
              Options[GenotypeProbability], z, rr, xx}, \[IndentingNewLine]If[
          rl === False, \[IndentingNewLine]If[sr === False, 
            sr = Table[1\/2, {Length[h1]}]]; \[IndentingNewLine]Times @@ 
            MapThread[\((Plus @@ \((Position[#2, #1] /. {{1} \[Rule] #3, {2} \
\[Rule] 1 - #3})\))\) &, {o, {h1, h2} // Transpose, 
                sr}], \[IndentingNewLine]z = 
            Transpose[{Transpose[{h1, h2}], o, 
                Append[rl, \[Pi]]}]; \[IndentingNewLine]If[
            And @@ \((\(MemberQ[#\[LeftDoubleBracket]1\[RightDoubleBracket], \
#\[LeftDoubleBracket]2\[RightDoubleBracket]] &\) /@ 
                  z)\), \[IndentingNewLine]z = \(\(z //. {a___, {{y1_, z1_}, 
                          o1_, r1x_}, {{x_, x_}, x_, rx2_}, {{y2_, z2_}, o2_, 
                          r2_}, b___} \[RuleDelayed] {a, {{y1, z1}, o1, 
                          NetRecombination[{r1x, rx2}]}, {{y2, z2}, o2, r2}, 
                        b}\) /. {a___, {{x_, x_}, x_, 
                        rx_}} \[RuleDelayed] {a}\) /. {{{x_, x_}, x_, rx_}, 
                    b___} \[RuleDelayed] {b}; \[IndentingNewLine]rr = 
              Transpose[
                z /. {{{x_, y_}, x_, r_} \[RuleDelayed] {1, r}, {{x_, y_}, 
                        y_, r_} \[RuleDelayed] {2, 
                        r}}]; \[IndentingNewLine]xx = 
              Abs[rr\[LeftDoubleBracket]1\[RightDoubleBracket] - 
                  RotateLeft[
                    rr\[LeftDoubleBracket]1\[RightDoubleBracket]]]; \
\[IndentingNewLine]Times @@ 
              Drop[Transpose[{xx, 
                      rr\[LeftDoubleBracket]2\[RightDoubleBracket]}] /. {{1, 
                        r_} \[RuleDelayed] r, {0, r_} \[RuleDelayed] 
                      1 - r}, \(-1\)], \[IndentingNewLine]0]]];\)\)

GenotypeProbability[{h1_List,h2_List},p1_List,p2_List]:=
    
    GenotypeProbability[h1,p1]GenotypeProbability[h2,p2];

GenotypeProbability[{h1_List,h2_List},p1_List,p2_List,opts__Rule]:=
    
    If[ObservableGenotype/.{opts}/.Options[GenotypeProbability],
      Module[{j,
          ps=PossibleGenotypes[o],
          nopts=DeleteCases[opts,ObservableGenotype\[Rule]True]},
        Sum[
          GenotypeProbability[
                ps\[LeftDoubleBracket]
                  j\[RightDoubleBracket],#\[LeftDoubleBracket]1\
\[RightDoubleBracket],#\[LeftDoubleBracket]2\[RightDoubleBracket],nopts]&/@
            parents,{j,Length[ps]}]],
      GenotypeProbability[h1,p1,
          opts/.{(Linkage\[Rule]{x_List,y_List})\[RuleDelayed](Linkage\[Rule]
                    x),(SegregationRatio\[Rule]{x_List,
                      y_List})\[RuleDelayed](SegregationRatio\[Rule]
                    x)}]GenotypeProbability[h2,p2,
          opts/.{(Linkage\[Rule]{x_List,y_List})\[RuleDelayed](Linkage\[Rule]
                    y),(SegregationRatio\[Rule]{x_List,
                      y_List})\[RuleDelayed](SegregationRatio\[Rule]y)}]];

GenotypeProbability[g:{{_,_}...},p1_List,p2_List,opts1___Rule,
      ObservableGenotype\[Rule]True,opts2___Rule]:=
    
    Plus@@(GenotypeProbability[#,p1,p2,opts1,opts2]&/@PossibleGenotypes[g]);



NetRecombination[{}]:=0;
NetRecombination[{r___,s_}]:=s+NetRecombination[{r}](1-2s);



GenotypeFrequencyTable[s_,a_]:=Module[{f},
    f[d_,aa_]:=(Count[d,#]&/@(DiploidTypes[{aa}]/.{c_List}\[Rule]c));
    MapThread[f,{Transpose[Data[s]],a}]/NumberOfIndividualsTable[s]];



ParentalGenotypes[{}]:=\[EmptySet];
ParentalGenotypes[f:{(0|1|2|\[EmptySet])..}]:=
    DeleteCases[
        Union[f],\[EmptySet]]/.{{0}\[Rule]{0,0},{1}\[Rule]{0,2},{2}\[Rule]{2,
            2},{0,1,2}\[Rule]{1,1},{0,2}\[Rule]{1,1}};
ParentalGenotypes[f:{___List}]:=ParentalGenotypes/@Transpose[f];



On[General::spell1,General::spell];

End[];


EndPackage[];