(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

BeginPackage["Utilities`Calculus`"];





\!\(\(FourierNormalised::usage = \*"\"\<FourierNormalised[f,\!\(x\_max\),n] \
gives the Fourier transform of the function f, as an interpolation function \
on the range |\[Omega]|<\!\(\(\[Pi]\\\\\\\ \((n\\\\\\\  - \\\\\\\ 1\()\^2\)\)\
\)\/\(2\\\\\\\ \\\\\\\ n\\\\\\\ x\_max\)\).  Uses the numerical function \
Fourier.  Assumes FourierOverallConstant\[Rule]1/\!\(\@\(2\\\\\\\ \\\\\\\ \
\[Pi]\)\).\>\"";\)\)



\!\(\(InverseFourierNormalised::usage = \
\*"\"\<InverseFourierNormalised[f,\!\(\[Omega]\_max\),n] gives the inverse \
Fourier transform of the function f, as an interpolation function on the \
range |x|<\!\(\(\[Pi]\\\\\\\ \((n\\\\\\\  - \\\\\\\ 1\()\^2\)\)\)\/\(2\\\\\\\ \
\\\\\\\ n\\\\\\\ \[Omega]\_max\)\).  Uses the numerical function \
InverseFourier.  Assumes FourierOverallConstant\[Rule]1/\!\(\@\(2\\\\\\\ \\\\\
\\\ \[Pi]\)\).\>\"";\)\)



\!\(\(FourierNormalisedTable::usage = \*"\"\<FourierNormalisedTable[{\!\(f\_1\
\),\[Ellipsis],\!\(f\_n\)},\!\(x\_max\)] gives the Fourier transform of the \
function f, as a list on the range |\[Omega]|<\!\(\(\[Pi]\\\\\\\ \((n\\\\\\\  \
- \\\\\\\ 1\()\^2\)\)\)\/\(2\\\\\\\ \\\\\\\ n\\\\\\\ x\_max\)\).  Uses the \
numerical function Fourier.  Assumes FourierOverallConstant\[Rule]1/\!\(\@\(2\
\\\\\\\ \\\\\\\ \[Pi]\)\).\>\"";\)\)



\!\(\(InverseFourierNormalisedTable::usage = \
\*"\"\<InverseFourierNormalisedTable[{\!\(f\_1\),\[Ellipsis],\!\(f\_n\)},\!\(\
\[Omega]\_max\)] gives the inverse Fourier transform of the function f, as a \
list on the range |x|<\!\(\(\[Pi]\\\\\\\ \((n\\\\\\\  - \\\\\\\ 1\()\^2\)\)\)\
\/\(2\\\\\\\ \\\\\\\ n\\\\\\\ \[Omega]\_max\)\).  Uses the numerical function \
InverseFourier.  Assumes FourierOverallConstant\[Rule]1/\!\(\@\(2\\\\\\\ \\\\\
\\\ \[Pi]\)\).\>\"";\)\)



\!\(\(TransformedRange::usage = \*"\"\<TransformedRange[X,n] gives the \
maximum value \!\(\[Omega]\_max\)=\!\(\(\[Pi]\\\\\\\ \((n\\\\\\\  - \\\\\\\ 1\
\()\^2\)\)\)\/\(2\\\\\\\ \\\\\\\ n\\\\\\\ \[Omega]\_max\)\); used by \
FourierNormalised and InverseFourierNormalised\>\"";\)\)



\!\(\(ImVector::usage = \*"\"\<ImVector[n] stores the vector \!\(\
\[ExponentialE]\^\(I\[VeryThinSpace]\[Pi]\\\\\\\ \((1\\\\\\\  - \\\\\\\ \
1/n)\)\\\\\\\ \((#\\\\\\\  - \\\\\\\ 1)\)\)\), which is used by \
FourierNormalised[]\>\"";\)\)



Begin["Utilities`Calculus`Private`"];



\!\(\(TransformedRange[X_, 
        n_Integer] := \(\[Pi] \((n - 1)\)\^2\)\/\(2  n\ X\);\)\)



\!\(\(FourierNormalised[f_, X_, n_Integer] := 
      Module[{W = TransformedRange[X, n]}, \n\t
        Interpolation[
          Transpose[{Range[\(-W\), 
                W, \(\[Pi] \((n - 1)\)\)\/\(\(\ \)\(n\ X\)\)], 
              FourierNormalisedTable[
                f /@ Range[\(-X\), X, \(2  X\)\/\(n - 1\)], X]}]]];\)\)



\!\(\(InverseFourierNormalised[f_, W_, n_Integer] := 
      Module[{X = TransformedRange[W, n]}, \n\t\tInterpolation[
          Transpose[{Range[\(-X\), 
                X, \(\[Pi] \((n - 1)\)\)\/\(\(\ \)\(n\ W\)\)], 
              InverseFourierNormalisedTable[
                f /@ Range[\(-W\), W, \(2  W\)\/\(n - 1\)], W]}]]];\)\)



\!\(\(FourierNormalisedTable[f_List, X_] := 
      Module[{n = 
            Length[f]}, \n\t\(\(2  
                  X\)\/\((n - 
                    1)\)\) \(\@\(n\/\(2  \[Pi]\)\)\) \(\[ExponentialE]\^\(I\
\[VeryThinSpace]\[Pi]\ \((n - 1)\)\^2/\((2  n)\)\)\) 
            Fourier[f\/ImVector[n]]\/ImVector[n] // Chop];\)\)



\!\(\(InverseFourierNormalisedTable[f_List, W_] := 
      Module[{n = 
            Length[f]}, \n\t\t\(\(2  
                  W\)\/\((n - 
                    1)\)\) \(\@\(n\/\(2  \[Pi]\)\)\) \
\(\[ExponentialE]\^\(\(-I\)\[VeryThinSpace]\[Pi]\ \((n - 1)\)\^2/\((2  
                        n)\)\)\) ImVector[n] InverseFourier[f\ ImVector[n]] // 
          Chop];\)\)



\!\(\(ImVector[n_Integer] := \(ImVector[n] = 
        N[Exp[I\[VeryThinSpace]\[Pi]\ \((1 - 1\/n)\) Range[0, n - 1]]]\);\)\)



End[];


EndPackage[];