(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

BeginPackage["Utilities`RandomNumbers`",{"Statistics`DescriptiveStatistics`",
	     "Statistics`Common`DistributionsCommon`",
      "Statistics`DiscreteDistributions`","Statistics`DataManipulation`",
      "Statistics`ContinuousDistributions`"}];





RandomSet::usage=
    "RandomSet[j,k] gives a random (ordered) set of j distinct integers in \
the range {1,k}.  (j\[LessEqual]k). RandomSet[{j1,j2,..},k] splits k into \
random sets of the specified size. RandomSet[j,{a,b,..}] gives j randomly \
chosen elements from the set {a,b,..}.   RandomSet[{j1,j2,..},{a,b,..}] \
splits {a,b,..} into random sets of the specified size; these are NOT sorted. \
 To sort them, use Sort[Sort/@#]&";

RandomSetCompiled::usage=
    "RandomSetCompiled[j,n] chooses j distinct integers from the set n.";



Muddle::usage="Muddle[{a,b,c,..}] gives a random reordering of the list";



Subdivide::usage=
    "Subdivide[{a,b,..},{1,2,3,..}] splits the list into subsets of the \
specified length.  BEWARE: the lengths must match.";



\!\(\(RandomCum::usage = \*"\"\<RandomCum[CDF[#]&,j0] generates a random \
number from the distribution whose cumulative distribution is given by \
CDF[j],  defined as the probability of going from 0 to j inclusive.  j0 is an \
initial guess.  Range is 0 to \[Infinity]. RandomCum[CDF[#]&,j0,x] generates \
the integer appropriate to \
x.RandomCum[{\!\(F\_0\),\!\(F\_1\),\[Ellipsis]},j0] is a faster version which \
uses a precalculated tableof the CDF.\>\"";\)\)



\!\(\(RandomMultinomial::usage = \*"\"\<RandomMultinomial[n,{\!\(p\_1\),\
\[Ellipsis]}] gives a list of random integers drawn from the multinomial. \
RandomMultinomial[{J,K,\[Ellipsis]},{\!\(n\_1\),\!\(n\_2\),\[Ellipsis]}] \
gives a list of numbers sampled without replacement from an urn with {J,K,\
\[Ellipsis]} of each kind.  Sampling is assumed to be exhaustive, so that the \
total number in the urn equals the total sample size \
\!\(\[Sum]\+i\)\!\(n\_i\).The probability of each configuration is given by \
MultinomialSamplingProbability[{{\!\(j\_1\),\[Ellipsis]},{\!\(k\_1\),\
\[Ellipsis]},\[Ellipsis]}].  Compiled\[Rule]True is faster.\>\"";\)\)



RandomList::usage=
    "RandomList[k,{p1,p2,...,pn}] returns k integers with probability \
{p1,p2,...,pn}. RandomList[k,{p1,p2,...,pn},{s1,s2,..}] returns a list of the \
elements s1. Compiled\[Rule]True uses compiled code.  Replace->False samples \
without replacement.";



RandomListCompiled::usage=
    "RandomListCompiled[k,{p1,p2,...,pn}] returns k integers with probability \
{p1,p2,...,pn}, using compiled code, and sampling without replacement.";



RandomListCompiledReplace::usage=
    "RandomListCompiledReplace[k,{p1,p2,...,pn}] returns k integers with \
probability {p1,p2,...,pn}, using compiled code, and sampling with \
replacement.";



\!\(\(LogLikelihoodTest::usage = \*"\"\<LogLikelihoodTest[obs,exp] gives \
log(L) for the comparison of observed and expected.  obs and exp can be any \
lists with coresponding structure.  Compiled\[Rule]True is a compiled \
version.  LogLikelihoodTest[{{\!\(obs\_\(1, 1\)\),\[Ellipsis]}\[Ellipsis]}] \
gives a test for associations between rows & columns.\>\"";\)\)



\!\(\(NegativeHypergeometricDistribution::usage = \
\*"\"\<NegativeHypergeometricDistribution[n,p,\[Alpha]] gives the \
distribution obtained by binomial sampling from an underlying Beta \
distribution with mean p and variance \
\!\(\(p\[VeryThinSpace]q\)\/\(\[Alpha]\\\\\\\ \(+\(\(\\\\\)\(\\\ \
\)\(1\)\)\)\)\).\>\"";\)\)



\!\(\(\(\ \)\(NegativeBinomialLogLikelihood::usage = \
\*"\"\<NegativeBinomialLogLikelihood[{\!\(n\_1\),\[Ellipsis]},{\!\(n\&_\),c}] \
gives the log likelihood that the list of numbers {\!\(n\_1\),\[Ellipsis]} \
are drawn from a negative binomial with mean \!\(n\&_\) and variance/mean \
ratio c.    Compiled->True is a compiled version.  \
NegativeBinomialLogLikelihood[{\!\(n\&_\),c}] gives the normalisation \
constant required for c<1. Normalised\[Rule]False omits normalisation; this \
may give errors for c<1 but is substantially \
faster.NegativeBinomialLogLikelihood[{{\!\(n\_1\),\[Ellipsis]}\[Ellipsis]},{{\
\!\(\[Alpha]\_1\),\!\(\[Beta]\_1\)}\[Ellipsis]},{\!\(n\&_\),c}] gives the \
log. likelihood for a multiplicative model, in which the parameters in  \
sample k are {\!\(\[Alpha]\_k\)\!\(n\&_\),\!\(\[Beta]\_k\)c}. \>\"";\)\(\ \
\)\)\)



\!\(\(\(NegativeBinomialLogLikelihoodCompiled::usage = \
\*"\"\<NegativeBinomialLogLikelihoodCompiled[{\!\(n\_1\)\[Ellipsis]},\!\(n\&_\
\),c] is a compiled version of NegativeBinomialLogLikelihood[]\>\"";\)\(\ \
\)\)\)



\!\(\(NegativeBinomialMLE::usage = \*"\"\<NegativeBinomialMLE[{\!\(n\_1\),\
\[Ellipsis]}] gives the MLE and log likelihood, {L,{\!\(n\&_\),c}}, given \
that the list of numbers {\!\(n\_1\),\[Ellipsis]} are drawn from a negative \
binomial with mean \!\(n\&_\) and variance/mean ratio c. \
NegativeBinomialMLE[{\!\(n\_1\),\[Ellipsis]},{None,c}] fixes c at some \
definite value; similarly for \!\(n\&_\). \>\"";\)\)



Normalised::usage=
    "Normalised is an option for NegativeBinomialLogLikelihood which \
determines whether the result is normalised to sum to 1 for c<1.";



FullOutput::usage=
    "FullOutput is an option for NegativeBinomialMLE and GaussianMLE which \
specifies that output should be in the form {L,pars} rather than {pars}.";



\!\(\(GaussianLogLikelihood::usage = \*"\"\<GaussianLogLikelihood[{\!\(x\_1\)\
\[Ellipsis]},{\[Mu],\!\(\[Sigma]\^2\)}] gives the log likelihood for the \
sample, ignoring constants. \[Mu],\!\(\[Sigma]\^2\) are the mean and variance \
of the \!\(x\_i\). \
GaussianLogLikelihood[{{\!\(x\_1\)\[Ellipsis]}\[Ellipsis]},{{\!\(\[Alpha]\_1\)\
,\!\(\[Beta]\_1\)}\[Ellipsis]},{\[Mu],\!\(\[Sigma]\^2\)}] does the same for \
an additive/multiplicative model, in which mean and variance in each sample \
are \[Mu]+\!\(\[Alpha]\_k\), \!\(\[Sigma]\^2\)\!\(\[Beta]\_k\).  Compiled\
\[Rule]True is a compiled version.\>\"";\)\)



\!\(\(GaussianMLE::usage = \*"\"\<GaussianMLE[{\!\(x\_1\),\[Ellipsis]}] gives \
estimates of the mean and variance of the population from which the \
\!\(x\_i\) were sampled.  GaussianMLE[{{\!\(x\_\(1, 1\)\),\[Ellipsis]},\
\[Ellipsis]},{{\!\(\[Alpha]\_1\),\!\(\[Beta]\_1\)},\[Ellipsis]}] does the \
same for an additive/multiplicative model, in which the mean and variance in \
each sample are \[Mu]+\!\(\[Alpha]\_k\), \!\(\[Sigma]\^2\)\!\(\[Beta]\_k\).  \
Compiled\[Rule]True is a compiled version.  FullOutput\[Rule]False suppresses \
output of the log likelihood, and just returns {\[Mu], \
\!\(\[Sigma]\^2\)}.\>\"";\)\)



\!\(\(\(\ \)\(MultinomialSamplingProbability::usage = \
\*"\"\<MultinomialSamplingProbability[{{\!\(j\_1\),\!\(k\_1\)\[Ellipsis]},\
\[Ellipsis]}] gives the probability of sampling without replacement a set of \
numbers {{\!\(j\_1\),\!\(k\_1\)\[Ellipsis]},\[Ellipsis]} from an urn \
containing {\!\(\[Sum]\_i\)\!\(j\_i\),\!\(\[Sum]\_i\)\!\(k\_i\)\[Ellipsis]} \
of each kind.\>\"";\)\)\)



Begin["Utilities`RandomNumbers`Private`"];

<<Statistics`ContinuousDistributions`;



RandomSet[j_Integer,s_List]:=Extract[s,List/@RandomSet[j,Length[s]]];
RandomSet[j_Integer,k_Integer]:=RandomSetCompiled[j,k];



RandomSet[{x__Integer},k_Integer]:=RandomSet[{x},Range[k]];
RandomSet[{x__Integer},s_List]:=Subdivide[Muddle[s],{x}];

RandomSetCompiled=Compile[{{j,_Integer},{n,_Integer}},
      Module[{aa=Range[n],na=n,ns={},k,new},
        If[j>n\[Or]j<0,Message[RandomSet::tooBig]];
        If[j\[LessEqual]Quotient[n,2],
          
          Sort[Table[(k=Random[Integer,{1,na}];na-=1;
                new=aa\[LeftDoubleBracket]k\[RightDoubleBracket];
                aa=Delete[aa,k];new),{j}]],
          Sort[Complement[Range[n],
              
              Table[(k=Random[Integer,{1,na}];na-=1;
                  new=aa\[LeftDoubleBracket]k\[RightDoubleBracket];
                  aa=Delete[aa,k];new),{n-j}]]]]],
      {{ns,_Integer,1},{na,_Integer},{k,_Integer},{new,_Integer},{aa,_Integer,
          1}}];

RandomSet::tooBig=
    "The number of distinct elements chosen must be no greater than the size \
of the set.";



Muddle[s_List]:=Sort[s,(Random[]<1/2)&];



Subdivide::lengthMismatch=
    "Length of set `1` does not match that requested,  `2`";

Subdivide[s_List,{j_Integer,k__Integer}]:=
    Join[{Take[s,j]},Subdivide[Drop[s,j],{k}]];
Subdivide[s_List,{k_Integer}]:=
    If[k==Length[s],{s},Message[Subdivide::lengthMismatch,s,k];s];



RandomCum[f_,j0_]:=RandomCum[f,j0,Random[]];
RandomCum[f_?(!ListQ[#]&),jj0_,x_]:=
    Module[{z,j,j0,ff},
             j0=Round[Max[1,jj0]];
       z={{-1,0},{j0,f[j0]}};
      While[z[[2,2]]<x,z[[2]]={2z[[2,1]],f[2z[[2,1]]]}];
      		While[z[[2,1]]-z[[1,1]]>1,
        			j=Round[(z[[2,1]]+z[[1,1]])/2];ff=f[j];
        			z[[If[ff<x,1,2]]]={j,ff}];
      	z[[2,1]]];

RandomCum[f_List,jj0_Integer,x_]:=RandomCumCompiled[f,jj0,x];

RandomCumCompiled=Compile[{{f,_Real,1},{jj0,_Integer},{x,_Real}},
      Module[{z,j,j0,ff,n=Length[f]-1},
               j0=Max[Min[n,jj0],1];
         z={{-1,0},{j0,f\[LeftDoubleBracket]j0+1\[RightDoubleBracket]}};
        While[z[[2,2]]<x,
          z[[2]]={2z[[2,1]],
              f\[LeftDoubleBracket]Min[2Round[z[[2,1]]],
                    n]+1\[RightDoubleBracket]}];
        		While[z[[2,1]]-z[[1,1]]>1,
          j=Min[Round[(z[[2,1]]+z[[1,1]])/2],n];
          ff=f\[LeftDoubleBracket]j+1\[RightDoubleBracket];
          			z[[If[ff<x,1,2]]]={j,ff}];
        	Round[z[[2,1]]]],
      {{z,_Real,2},{n,_Integer},{j,_Integer},{j0,_Integer},{ff,_Real}}];



Options[RandomMultinomial]={Compiled\[Rule]False};

\!\(\(RandomMultinomial[n_Integer, {_}] := {n};\)\n
  \(RandomMultinomial[n_Integer, {p_, r__}] := \n\t\t\t\tIf[p == 1, 
        Prepend[Table[0, {Length[{r}]}], 
          n], \[IndentingNewLine]Module[{np = 
              If[n < 10000, \[IndentingNewLine]Random[
                  BinomialDistribution[n, 
                    p]], \[IndentingNewLine]RandomCum[\[IndentingNewLine]CDF[
                      BinomialDistribution[n, N[p]], #] &, 
                  n\ p]]}, \[IndentingNewLine]Prepend[
            RandomMultinomial[n - np, {r}\/\(1 - p\)], np]]];\)\)

RandomMultinomial[{},{},___Rule]:={};
RandomMultinomial[{j_Integer},n:{__Integer},___Rule]:=List/@n;
RandomMultinomial[jk:{__Integer},{n1_Integer},___Rule]:={jk};
RandomMultinomial[jk:{__Integer},{n1_Integer,n2__Integer},opts___Rule]:=
    
    If[Compiled/.{opts}/.Options[RandomMultinomial],
      RandomMultinomialCompiled[jk,{n1,n2}],
      Module[{ss={},jj,nr=n1,nt=Plus@@jk,i=1,ljk=Length[jk]},
        While[i<ljk,
          
          jj=If[jk\[LeftDoubleBracket]i\[RightDoubleBracket]\[Equal]0,0,
              Random[HypergeometricDistribution[nr,
                  jk\[LeftDoubleBracket]i\[RightDoubleBracket],nt]]];
          nt-=jk\[LeftDoubleBracket]i\[RightDoubleBracket];i+=1;nr-=jj;
          AppendTo[ss,jj]];
        AppendTo[ss,nr];
        Prepend[RandomMultinomial[jk-ss,{n2}],ss]]];

RandomMultinomialCompiled=Compile[{{jk,_Integer,1},{nn,_Integer,1}},
      Module[{ljk=Length[jk],lnn=Length[nn],ss,n1=First[nn],nt=Plus@@nn,i,
          jj},
        If[lnn\[Equal]1,
          {jk},
          ss=Table[
              
              jj=If[jk\[LeftDoubleBracket]i\[RightDoubleBracket]\[Equal]0,0,
                  RandomHyperGeometricDistribution[n1,
                    jk\[LeftDoubleBracket]i\[RightDoubleBracket],nt]];
              nt=nt-jk\[LeftDoubleBracket]i\[RightDoubleBracket];n1=n1-jj;
              jj,
              {i,ljk}];
          Prepend[RandomMultinomialCompiled[jk-ss,Drop[nn,1]],ss]]],
      {{RandomMultinomialCompiled[_,_],_Integer,
          2},{RandomHyperGeometricDistribution[_,_,_],_Integer},{n1,_Integer},\
{nr,_Integer},{nt,_Integer},{jj,_Integer},{ss,_Integer,
          1},{i,_Integer},{ljk,_Integer}}];

RandomHyperGeometricDistribution[i_,j_,k_]:=
    Random[HypergeometricDistribution[i,j,k]];



Options[RandomList]={Compiled\[Rule]False,Replace->True};

RandomList::tooMany=
    "`1` cannot be sampled without replacement from the list `2`";

\!\(\(RandomList[k_Integer, p_List, opts___Rule] := \n\t
      If[\(Replace /. {opts}\) /. 
          Options[RandomList], \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
            Options[RandomList], \n\t\tRandomListCompiledReplace[k, 
            p], \[IndentingNewLine]Module[{cp = FoldList[Plus, 0, p], rr}, \n
            Table[\((rr = 
                  Random[]; \(Position[Sort[Append[cp, \ rr]], rr]\)[\([1, 
                      1]\)] - 1)\), {k}]]], \[IndentingNewLine]If[
          k > Length[p], \[IndentingNewLine]Message[RandomList::tooMany, k, 
            p]; Range[
            Length[p]], \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
              Options[RandomList], \n\t\tRandomListCompiled[k, 
              p], \[IndentingNewLine]Module[{pr = p, 
                rk}, \[IndentingNewLine]Table[
                rk = First[RandomList[1, pr]]; \[IndentingNewLine]pr = 
                  ReplacePart[pr, 0, rk]\/\(1 - pr\[LeftDoubleBracket]rk\
\[RightDoubleBracket]\); rk, {k}]\[IndentingNewLine]]]]];\)\)

RandomList[k_Integer,p_List,s_List,opts___Rule]:=
    Map[s\[LeftDoubleBracket]#\[RightDoubleBracket]&,RandomList[k,p,opts]];

RandomListCompiledReplace=Compile[{{k,_Integer},{p,_Real,1}},
	Module[{cp,rr},
       cp=FoldList[Plus,0,p];
			Table[(rr=Random[];Position[Sort[Append[cp, rr]],rr][[1,1]]-1),{k}]],
		{{cp,_Real,1},{rr,_Real}}];

\!\(\(RandomListCompiled = 
      Compile[{{k, _Integer}, {p, _Real, 1}}, \n\t
        Module[{pr = p, 
            rk}, \[IndentingNewLine]Table[\((rk = 
                First[RandomListCompiledReplace[1, 
                    pr]]; \[IndentingNewLine]pr = 
                ReplacePart[pr, 0, rk]\/\(1 - pr\[LeftDoubleBracket]rk\
\[RightDoubleBracket]\); rk)\), \[IndentingNewLine]{k}]], \n\t\t{{pr, _Real, 
            1}, {rk, _Integer}, {RandomListCompiledReplace[_, _], _Integer, 
            1}}];\)\)



Options[LogLikelihoodTest]={Compiled\[Rule]False};

\!\(\(LogLikelihoodTest[o_?NumberQ, e_?NumberQ] = 
      If[o \[Equal] 0, 0, o*Log[o/e]];\)\[IndentingNewLine]
  \(LogLikelihoodTest[obs_List, exp_List, 
        opts___Rule] := \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
          Options[LogLikelihoodTest], \
\[IndentingNewLine]LogLikelihoodTestCompiled[obs // Flatten, 
          exp // Flatten], \[IndentingNewLine]Plus @@ 
          MapThread[
            LogLikelihoodTest, {obs // Flatten, 
              exp // Flatten}]];\)\[IndentingNewLine]
  \(LogLikelihoodTest[obs : {{___?NumberQ} ... }, 
        opts___Rule] := \[IndentingNewLine]Module[{m1 = Plus @@ obs, 
          m2 = Plus @@ Transpose[obs]}, \[IndentingNewLine]LogLikelihoodTest[
          Flatten[obs], Flatten[Outer[Times, m2, m1]\/Plus @@ m1], opts]];\)\)

LogLikelihoodTestCompiled=Compile[{{obs,_Integer,1},{exp,_Real,1}},
      Module[{j},
        Sum[
          If[obs\[LeftDoubleBracket]j\[RightDoubleBracket]\[Equal]0,0,
            obs\[LeftDoubleBracket]j\[RightDoubleBracket]*
              Log[obs\[LeftDoubleBracket]j\[RightDoubleBracket]/
                  exp\[LeftDoubleBracket]j\[RightDoubleBracket]]],{j,
            Length[obs]}]]];



NegativeHypergeometricDistribution/:
    Domain[NegativeHypergeometricDistribution[n_,p_,\[Alpha]_] ]:=Range[0,n];

\!\(\(NegativeHypergeometricDistribution /: 
      PDF[NegativeHypergeometricDistribution[n_, p_, \[Alpha]_]\ , 
        i_] := \(\(Pochhammer[\[Alpha]\ p, \ i] 
              Pochhammer[\[Alpha] \((1 - p)\), \ 
                n - i]\)\/Pochhammer[\[Alpha], \ n]\) Binomial[n, i];\)\)

\!\(\(NegativeHypergeometricDistribution /: 
      CDF[NegativeHypergeometricDistribution[n_, p_, \[Alpha]_]\ , i_] := 
      Module[{j, 
          t = Pochhammer[\[Alpha] \((1 - p)\), \ n]\/Pochhammer[\[Alpha], \ \
n]}, \n\tt + 
          Sum[t = t \(\((\[Alpha]\ p + j - 1)\)\/\((\[Alpha] \((1 - p)\) + 
                        n - j)\)\) \((n - j + 1)\)\/j, {j, 1, i}]];\)\)

NegativeHypergeometricDistribution/:
    Quantile[NegativeHypergeometricDistribution[n_Integer,p_,\[Alpha]_] ,q_]:=
    Module[{i,s},
		If[q\[LessEqual]0,0,
        If[q\[GreaterEqual]1,n,
          If[q<CDF[NegativeHypergeometricDistribution[n,p,\[Alpha]],
                Quotient[n,2]],
				i=0;s=0;
					While[s+=PDF[NegativeHypergeometricDistribution[n,p,\[Alpha]],i];s<q,
						i+=1];i,
						i=n;s=1;
				While[s-=PDF[NegativeHypergeometricDistribution[n,p,\[Alpha]],i];
              s\[GreaterEqual]q,
						i-=1];i]] ]];

NegativeHypergeometricDistribution/:
    Mean[NegativeHypergeometricDistribution[n_,p_,\[Alpha]_]]:=
    n\[VeryThinSpace]p;

\!\(\(NegativeHypergeometricDistribution /: 
      Variance[NegativeHypergeometricDistribution[n_, p_, \[Alpha]_]] := 
      n\ p \((1 - p)\) \((n + \[Alpha])\)\/\((1 + \[Alpha])\);\)\)

\!\(\(NegativeHypergeometricDistribution /: 
      StandardDeviation[
        NegativeHypergeometricDistribution[n_, 
          p_, \[Alpha]_]] := \@\(n\ p \((1 - p)\) \((n + \[Alpha])\)\/\((1 + \
\[Alpha])\)\);\)\)

\!\(\(NegativeHypergeometricDistribution /: 
      Skewness[NegativeHypergeometricDistribution[n_, p_, \[Alpha]_]\ ] := 
      n\ p \((1 - p)\) \((1 - 
            2  p)\) \(\(\((n + \[Alpha])\) \((2  
                      n + \[Alpha])\)\)\/\(\((1 + \[Alpha])\) \((2 + \
\[Alpha])\)\)\)/
          StandardDeviation[
              NegativeHypergeometricDistribution[n, p, \[Alpha]]]^3;\)\)

\!\(\(NegativeHypergeometricDistribution /: 
      Kurtosis[NegativeHypergeometricDistribution[n_, p_, \[Alpha]_]] := 
      n\ p \((1 - 
            p)\) \((\(\((n + \[Alpha])\)\/\(\((1 + \[Alpha])\)\ \((2 + \
\[Alpha])\)\ \((3 + \[Alpha])\)\)\) \((\((6 
                         n\^2 + \((6  n - 
                            1\ )\) \[Alpha] + \ \[Alpha]\^2)\) - \((18 
                           n\^2 - 3  n \((n - 6)\)\ \[Alpha]\  - 
                        3 \((n - 2)\)\ \[Alpha]\^2)\)\ p \((1 - p)\))\))\)/
          Variance[NegativeHypergeometricDistribution[n, p, \[Alpha]]]^2;\)\)

NegativeHypergeometricDistribution/:
    KurtosisExcess[NegativeHypergeometricDistribution[n_,p_,\[Alpha]_] ]:=
    Kurtosis[NegativeHypergeometricDistribution[n,p,\[Alpha]]]-3;

NegativeHypergeometricDistribution/:
    ExpectedValue[f_,NegativeHypergeometricDistribution[n_,p_,\[Alpha]_] ]:=
    Module[{i},
      Sum[f[i]PDF[NegativeHypergeometricDistribution[n,p,\[Alpha]],i],{i,0,
          n}]];

NegativeHypergeometricDistribution/:
    ExpectedValue[f_,NegativeHypergeometricDistribution[n_,p_,\[Alpha]_],x_ ]:=
    Module[{i},
      Sum[(f/.x->i)PDF[NegativeHypergeometricDistribution[n,p,\[Alpha]],i],{i,
            0,n}]//Together];

NegativeHypergeometricDistribution/:
    CharacteristicFunction[
      NegativeHypergeometricDistribution[n_,p_,\[Alpha]_],
      t_ ]:=(Gamma[\[Alpha]] Gamma[
            n+\[Alpha]-p \[Alpha]] HypergeometricPFQ[{-n,
              p \[Alpha]},{1-n-\[Alpha]+p \[Alpha]},
            Exp[I t]])/(Gamma[(1-p) \[Alpha]] Gamma[n+\[Alpha]]);

NegativeHypergeometricDistribution/:
    Random[NegativeHypergeometricDistribution[n_,p_,\[Alpha]_] ]:=
    Random[BinomialDistribution[n,
        Random[BetaDistribution[\[Alpha] p,\[Alpha](1-p)]]]];

NegativeHypergeometricDistribution/:
    RandomArray[NegativeHypergeometricDistribution[n_,p_,\[Alpha]_] ,
      dims_List]:=
    Array[Random[NegativeHypergeometricDistribution[n,p,\[Alpha]]]&,dims];





Options[NegativeBinomialLogLikelihood]={Compiled\[Rule]False,
      Normalised\[Rule]True};

\!\(\(NegativeBinomialLogLikelihood[n : {___Integer}, {nb_, c_}, 
        opts___Rule] := 
      Module[{mx, K, Kl, nbObs, \[IndentingNewLine]bc, rng, 
          nflg = \(Normalised /. {opts}\) /. 
              Options[NegativeBinomialLogLikelihood], 
          cflg = \(Compiled /. {opts}\) /. 
              Options[NegativeBinomialLogLikelihood]}, \[IndentingNewLine]If[
          cflg, \[IndentingNewLine]If[
            nflg, \[IndentingNewLine]\
NegativeBinomialLogLikelihoodNormalisedCompiled[n, nb, c], 
            NegativeBinomialLogLikelihoodCompiled[n, nb, 
              c]], \[IndentingNewLine]mx = Max[n]; K = Length[n]; 
          nbObs = Plus @@ n\/K; \[IndentingNewLine]\[IndentingNewLine]rng = 
            Range[mx]; 
          bc = \(Count[n, #] &\) /@ rng; \[IndentingNewLine]Kl = 
            Drop[Reverse[
                FoldList[Plus, 0, 
                  Reverse[bc]]], \(-1\)]; \[IndentingNewLine]If[
            nflg, \[IndentingNewLine]If[
              c \[Equal] 
                1, \[IndentingNewLine]K \((nbObs\ Log[nb] - 
                      nb)\) - \[IndentingNewLine]Kl . 
                  Log[rng], \[IndentingNewLine]If[\((c < 
                      1)\) && \((mx \[GreaterEqual] 
                      1 + nb\/\(1 - c\))\), \[IndentingNewLine]\(-\[Infinity]\
\), \[IndentingNewLine]\(-K\) \((nb\/\(c - 1\) + nbObs)\)\[VeryThinSpace]Log[
                      c] + Kl . 
                    Log[\((c - 
                            1)\) + \(nb + 1 - c\)\/rng] - \
\[IndentingNewLine]K*
                    NegativeBinomialLogLikelihood[{nb, c}, 
                      opts]]], \[IndentingNewLine]\(-K\) \((nb\/\(c - 1\) + 
                    nbObs)\)\[VeryThinSpace]Log[c] + 
              Kl . Log[\((c - 1)\) + \(nb + 1 - c\)\/rng]]]];\)\)

\!\(\(NegativeBinomialLogLikelihood[{nb_, c_}, opts___Rule] := 
      Module[{k}, \[IndentingNewLine]Chop[
          If[c < 1, \[IndentingNewLine]k = Ceiling[nb\/\(1 - c\)]; 
            Log[1 - \((\((c - 1)\)\^\(k + 1\)\ c\^\(\(-\(nb\/\(c - 1\)\)\) - \
k - 1\)\ \ Pochhammer[nb\/\(c - 1\), k + 1]\ Hypergeometric2F1Regularized[1, 
                      1 + k + nb\/\(c - 1\), 2 + k, \(c - 1\)\/c])\)], 
            0]]];\)\)

\!\(\(NegativeBinomialLogLikelihoodNormalisedCompiled = \
\[IndentingNewLine]Compile[{{n, _Integer, 
            1}, {nb, _Real}, {c, _Real}}, \[IndentingNewLine]Module[{mx = 
              Max[n], rng, K = Length[n], nbObs, bc, 
            Kl}, \[IndentingNewLine]rng = Range[mx]; 
          nbObs = Plus @@ n\/K; \[IndentingNewLine]bc = \(Count[n, #] &\) /@ 
              rng; \[IndentingNewLine]Kl = 
            Drop[Reverse[
                FoldList[Plus, 0, 
                  Reverse[bc]]], \(-1\)]; \[IndentingNewLine]If[
            c \[Equal] 1, \[IndentingNewLine]K \((nbObs\ Log[nb] - nb)\) - 
              Kl . Log[
                  rng], \[IndentingNewLine]If[\((c < 
                    1)\) && \((mx \[GreaterEqual] 
                    1 + nb\/\(1 - c\))\), \[IndentingNewLine]\(-10\^8. \), \
\[IndentingNewLine]\(-K\) \((nb\/\(c - 1\) + nbObs)\)\[VeryThinSpace]Log[c] + 
                Kl . Log[\((c - 
                          1)\) + \(nb + 1 - c\)\/rng] - \[IndentingNewLine]K*
                  NegativeBinomialLogLikelihood[{nb, 
                      c}]]]], \
\[IndentingNewLine]{{NegativeBinomialLogLikelihood[{_, _}], _Real}}];\)\)

\!\(\(NegativeBinomialLogLikelihoodCompiled = \[IndentingNewLine]Compile[{{n, \
_Integer, 1}, {nb, _Real}, {c, _Real}}, \[IndentingNewLine]Module[{mx = 
              Max[n], rng, K = Length[n], nbObs, bc, 
            Kl}, \[IndentingNewLine]rng = Range[mx]; 
          nbObs = Plus @@ n\/K; \[IndentingNewLine]bc = \(Count[n, #] &\) /@ 
              rng; \[IndentingNewLine]Kl = 
            Drop[Reverse[
                FoldList[Plus, 0, 
                  Reverse[bc]]], \(-1\)]; \[IndentingNewLine]If[
            c \[Equal] 1, \[IndentingNewLine]K \((nbObs\ Log[nb] - nb)\) - 
              Kl . Log[
                  rng], \[IndentingNewLine]If[\((c < 
                    1)\) && \((mx \[GreaterEqual] 
                    1 + nb\/\(1 - c\))\), \[IndentingNewLine]\(-10\^8. \), \
\[IndentingNewLine]\(-K\) \((nb\/\(c - 1\) + nbObs)\)\[VeryThinSpace]Log[c] + 
                Kl . Log[\((c - 
                          1)\) + \(nb + 1 - c\)\/rng]]]], \
\[IndentingNewLine]{}];\)\)

NegativeBinomialLogLikelihood[n:{___List},ab:{{_,_}...},nbc:{_,_},
      opts___Rule]:=
    Module[{nn,nl,mxl},
      If[Compiled/.{opts}/.Options[NegativeBinomialLogLikelihood],
        nl=Length/@n;mxl=Max[nl];
        nn=If[Min[nl]<mxl,PadRight[#, mxl,-1]&/@n,n];
        If[Normalised/.{opts}/.Options[NegativeBinomialLogLikelihood],
          NegativeBinomialLogLikelihoodNMC[nn,ab,nbc],
          NegativeBinomialLogLikelihoodMC[nn,ab,nbc]],
        Plus@@
          MapThread[NegativeBinomialLogLikelihood[#1,nbc #2,opts]&,{n,ab}]]];

NegativeBinomialLogLikelihoodMC=
    Compile[{{n,_Integer,2},{ab,_Real,2},{nbc,_Real,1}},
      Module[{k,nk=Length[n]},
        Sum[
          NegativeBinomialLogLikelihoodCompiled[
            DeleteCases[n\[LeftDoubleBracket]k\[RightDoubleBracket],-1],
            nbc\[LeftDoubleBracket]1\[RightDoubleBracket]*
              ab\[LeftDoubleBracket]k,1\[RightDoubleBracket],
            nbc\[LeftDoubleBracket]2\[RightDoubleBracket]*
              ab\[LeftDoubleBracket]k,2\[RightDoubleBracket]],{k,nk}]],
      {{NegativeBinomialLogLikelihoodCompiled[_,_,_],_Real},{DeleteCases[_,_],\
_Integer,1}}];

NegativeBinomialLogLikelihoodNMC=
    Compile[{{n,_Integer,2},{ab,_Real,2},{nbc,_Real,1}},
      Module[{k,nk=Length[n]},
        Sum[
          NegativeBinomialLogLikelihoodNormalisedCompiled[
            DeleteCases[n\[LeftDoubleBracket]k\[RightDoubleBracket],-1],
            nbc\[LeftDoubleBracket]1\[RightDoubleBracket]*
              ab\[LeftDoubleBracket]k,1\[RightDoubleBracket],
            nbc\[LeftDoubleBracket]2\[RightDoubleBracket]*
              ab\[LeftDoubleBracket]k,2\[RightDoubleBracket]],{k,nk}]],
      {{NegativeBinomialLogLikelihoodNormalisedCompiled[_,_,_],_Real},{\
DeleteCases[_,_],_Integer,1}}];



Options[NegativeBinomialMLE]={FullOutput\[Rule]True};

NegativeBinomialMLE[n:{___Integer},{None,None},opts___Rule]:=
    
    NegativeBinomialMLE[n,{Mean[n],None},opts];

NegativeBinomialMLE[n:{___Integer},opts___Rule]:=
    
    NegativeBinomialMLE[n,{None,None},opts];

NegativeBinomialMLE[n:{___Integer},{nb_?NumberQ,c_?NumberQ},opts___Rule]:=
   
     If[FullOutput/.{opts}/.Options[NegativeBinomialMLE],
      {NegativeBinomialLogLikelihood[n,{nb,c},opts],{nb,c}},
      {nb,c}];

\!\(\(NegativeBinomialMLE[n : {___Integer}, {None, c_?NumberQ}, opts___Rule] := 
      Module[{mx = Max[n], K = Length[n], Kl, 
          nbObs = Mean[n], \[IndentingNewLine]bc, nb, 
          nbmle}, \[IndentingNewLine]bc = 
          BinCounts[n, {0, mx, 1}]; \[IndentingNewLine]Kl = 
          Drop[Reverse[
              FoldList[Plus, 0, 
                Reverse[bc]]], \(-1\)]; \[IndentingNewLine]nbmle = 
          If[c \[Equal] 1, \[IndentingNewLine]nbObs, \[IndentingNewLine]nb /. 
              FindRoot[
                Log[c]\/\(c - 1\) - \(1\/K\) \((Kl . \(1\/\(\((c - 1)\) 
                                Range[0, mx - 1] + nb\)\))\), {nb, 
                  nbObs}]]; \[IndentingNewLine]If[\(FullOutput /. {opts}\) /. 
            Options[NegativeBinomialMLE], \
\[IndentingNewLine]{NegativeBinomialLogLikelihood[n, {nbmle, c}, 
              opts], {nbmle, c}}, \[IndentingNewLine]{nbmle, c}]];\)\)

\!\(\(NegativeBinomialMLE[n : {___Integer}, {nb_?NumberQ, None}, 
        opts___Rule] := 
      Module[{mx = Max[n], K = Length[n], Kl, 
          nbObs = Mean[n], \[IndentingNewLine]bc, c, 
          cmle}, \[IndentingNewLine]bc = 
          BinCounts[n, {0, mx, 1}]; \[IndentingNewLine]Kl = 
          Drop[Reverse[
              FoldList[Plus, 0, 
                Reverse[bc]]], \(-1\)]; \[IndentingNewLine]cmle = 
          c /. FindRoot[
              Log[c]\/\((c - 1)\)\^2 - \((nb - nbObs)\)\/\(c \((c - 1)\)\ \
nb\) - \(1\/\(K \((c - 1)\)\)\) \((Kl . \(1\/\(\((c - 1)\) Range[0, mx - 1] + 
                            nb\)\))\), {c, 
                Variance[n]\/nbObs}]; \[IndentingNewLine]If[\(FullOutput /. \
{opts}\) /. Options[
              NegativeBinomialMLE], \
\[IndentingNewLine]{NegativeBinomialLogLikelihood[n, {nb, cmle}, opts], {nb, 
              cmle}}, \[IndentingNewLine]{nb, cmle}]];\)\)



Options[GaussianLogLikelihood]={Compiled\[Rule]False};

\!\(\(GaussianLogLikelihood[data : {___?NumberQ}, {m_, v_}, opts___Rule] := 
      If[\(Compiled /. {opts}\) /. 
          Options[GaussianLogLikelihood], \
\[IndentingNewLine]GaussianLogLikelihoodCompiled[data, m, 
          v], \[IndentingNewLine]Module[{n = Length[data], sm = Plus @@ data, 
            dm}, \[IndentingNewLine]dm = 
            data - sm\/n; \(-\(n\/2\)\) \((Log[
                  v] + \(1\/v\) \((\((m - sm\/n)\)\^2 + 
                      dm . dm\/\(n - 1\))\))\)]];\)\)

\!\(\(GaussianLogLikelihoodCompiled = 
      Compile[{{d, _Real, 1}, {m, _Real}, {v, _Real}}, 
        Module[{n = Length[d], sm = Plus @@ d, dm}, \[IndentingNewLine]dm = 
            d - sm\/n; \(-\(n\/2\)\) \((Log[
                  v] + \(1\/v\) \((\((m - sm\/n)\)\^2 + 
                      dm . dm\/\(n - 1\))\))\)]];\)\)

GaussianLogLikelihood[data:{___List},ab:{{_,_}...},{m_,v_},opts___Rule]:=
    
    Plus@@MapThread[
        GaussianLogLikelihood[#1,{m+#2\[LeftDoubleBracket]1\
\[RightDoubleBracket],v #2\[LeftDoubleBracket]2\[RightDoubleBracket]},
            opts]&,{data,ab}];



Options[GaussianMLE]={Compiled\[Rule]False,FullOutput\[Rule]True};

GaussianMLE[data:{___?NumberQ},opts___Rule]:=
    GaussianMLE[data,{None,None},opts];

\!\(\(GaussianMLE[data : {___?NumberQ}, {None, None}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, n, sm, 
          dm}, \[IndentingNewLine]pars = 
          If[\(Compiled /. {opts}\) /. 
              Options[GaussianMLE], \[IndentingNewLine]GaussianMLECompiled[
              data], \[IndentingNewLine]\[IndentingNewLine]n = Length[data]; 
            sm = Plus @@ data\/n; 
            dm = data - sm; {sm, 
              dm . dm\/\(n - 1\)}]; \[IndentingNewLine]If[\(FullOutput /. \
{opts}\) /. Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

\!\(\(GaussianMLE[data : {___?NumberQ}, {m_?NumberQ, None}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, n, sm, 
          dm}, \[IndentingNewLine]pars = 
          If[\(Compiled /. {opts}\) /. 
              Options[GaussianMLE], \
\[IndentingNewLine]GaussianMLEVarianceCompiled[data, 
              m], \[IndentingNewLine]dm = data - m; {m, 
              dm . dm\/Length[data]}]; \[IndentingNewLine]If[\(FullOutput /. \
{opts}\) /. Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

\!\(\(GaussianMLE[data : {___?NumberQ}, {None, v_?NumberQ}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, n, sm, 
          dm}, \[IndentingNewLine]pars = 
          If[\(Compiled /. {opts}\) /. 
              Options[GaussianMLE], \
\[IndentingNewLine]GaussianMLEMeanCompiled[data, 
              v], \[IndentingNewLine]{Plus @@ data\/Length[data], 
              v}]; \[IndentingNewLine]If[\(FullOutput /. {opts}\) /. 
            Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

GaussianMLE[data:{___?NumberQ},{m_?NumberQ,v_?NumberQ},opts___Rule]:=
    
    If[FullOutput/.{opts}/.Options[GaussianMLE],
      {GaussianLogLikelihood[data,{m,v},opts],{m,v}},
      {m,v}];

\!\(\(GaussianMLECompiled = 
      Compile[{{d, _Real, 1}}, \[IndentingNewLine]Module[{n = Length[d], 
            sm = Plus @@ d, dm}, \[IndentingNewLine]dm = d - sm\/n; {sm\/n, 
            dm . dm\/\(n - 1\)}]];\)\)

\!\(\(GaussianMLEMeanCompiled = 
      Compile[{{d, _Real, 
            1}, {v, _Real}}, \[IndentingNewLine]{Plus @@ d\/Length[d], 
          v}];\)\)

\!\(\(GaussianMLEVarianceCompiled = 
      Compile[{{d, _Real, 
            1}, {m, _Real}}, \[IndentingNewLine]Module[{dm = 
              d - m}, \[IndentingNewLine]{m, dm . dm\/Length[d]}]];\)\)

GaussianMLE[data:{___List},ab:{{_?NumberQ,_?NumberQ}...},opts___Rule]:=
    
    GaussianMLE[data,ab,{None,None},opts];

\!\(\(GaussianMLE[data : {___List}, ab : {{_, _} ... }, {None, None}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, pd, 
          n = Length /@ data, mxn, nt, mn, tab, mu, ss, nee, 
          dm}, \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
            Options[GaussianMLE], \[IndentingNewLine]\((mxn = 
              Max[n]; \[IndentingNewLine]pd = 
              If[Min[n] < mxn, \(PadRight[#, mxn, 0] &\) /@ data, 
                data]; \[IndentingNewLine]pars = 
              GaussianMLEModelCompiled[pd, ab, 
                n])\), \[IndentingNewLine]\((tab = 
              Transpose[ab]; \[IndentingNewLine]nt = Plus @@ n; 
            mn = \(\((Plus @@ #)\) &\) /@ data\/n; \[IndentingNewLine]\(nee = 
                  n . \(1\/tab\[LeftDoubleBracket]2\[RightDoubleBracket]\); 
                mu = n . \((\(mn - tab\[LeftDoubleBracket]1\
\[RightDoubleBracket]\)\/tab\[LeftDoubleBracket]2\[RightDoubleBracket])\)/
                    nee; dm = 
                  data - mn;\)\[IndentingNewLine]ss = \(\((# . #)\) &\) /@ dm\
\/\(n - 1\); \[IndentingNewLine]pars = {mu, \(1\/nt\) \((n . \(\((\((mn - tab\
\[LeftDoubleBracket]1\[RightDoubleBracket])\)\^2 + 
                                ss)\)\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket]\))\) - \(mu\^2\) 
                    nee\/nt})\)]; \[IndentingNewLine]If[\(FullOutput /. \
{opts}\) /. Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, ab, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

\!\(\(GaussianMLE[data : {___List}, ab : {{_, _} ... }, {m_?NumberQ, None}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, pd, 
          n = Length /@ data, mxn, nt, mn, tab, mu, ss, nee, 
          dm}, \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
            Options[GaussianMLE], \[IndentingNewLine]mxn = 
            Max[n]; \[IndentingNewLine]pd = 
            If[Min[n] < mxn, \(PadRight[#, mxn, 0] &\) /@ data, 
              data]; \[IndentingNewLine]pars = 
            GaussianMLEModelVarianceCompiled[pd, ab, n, 
              m], \[IndentingNewLine]tab = 
            Transpose[ab]; \[IndentingNewLine]\((dm = 
              data - m - 
                tab\[LeftDoubleBracket]1\[RightDoubleBracket]; \
\[IndentingNewLine]pars = {m, \(1\/Plus @@ 
                        n\) \((\(1\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket]\) . \((\(\((# . #)\) &\) /@ 
                          dm)\))\)})\)]; \[IndentingNewLine]If[\(FullOutput /. \
{opts}\) /. Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, ab, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

\!\(\(GaussianMLE[data : {___List}, ab : {{_, _} ... }, {None, v_?NumberQ}, 
        opts___Rule] := \[IndentingNewLine]Module[{pars, pd, 
          n = Length /@ data, mxn, nt, mn, tab, mu, ss, nee, 
          dm}, \[IndentingNewLine]If[\(Compiled /. {opts}\) /. 
            Options[GaussianMLE], \[IndentingNewLine]mxn = 
            Max[n]; \[IndentingNewLine]pd = 
            If[Min[n] < mxn, \(PadRight[#, mxn, 0] &\) /@ data, 
              data]; \[IndentingNewLine]pars = 
            GaussianMLEModelMeanCompiled[pd, ab, n, 
              v], \[IndentingNewLine]tab = 
            Transpose[
              ab]; \[IndentingNewLine]\((mn = \(\((Plus @@ #)\) &\) /@ \
data\/n; \[IndentingNewLine]pars = {n . \((\(mn - tab\[LeftDoubleBracket]1\
\[RightDoubleBracket]\)\/tab\[LeftDoubleBracket]2\[RightDoubleBracket])\)/\((\
n . \(1\/tab\[LeftDoubleBracket]2\[RightDoubleBracket]\))\), 
                v})\)]; \[IndentingNewLine]If[\(FullOutput /. {opts}\) /. 
            Options[GaussianMLE], \[IndentingNewLine]{GaussianLogLikelihood[
              data, ab, pars, opts], pars}, \[IndentingNewLine]pars]];\)\)

GaussianMLE[data:{___List},ab:{{_,_}...},{m_?NumberQ,v_?NumberQ},opts___Rule]:=

        If[FullOutput/.{opts}/.Options[GaussianMLE],
      {GaussianLogLikelihood[data,ab,{m,v},opts],{m,v}},
      {m,v}];

\!\(\(GaussianMLEModelCompiled = 
      Compile[{{d, _Real, 2}, {ab, _Real, 2}, {n, _Integer, 
            1}}, \[IndentingNewLine]Module[{nt = Plus @@ n, mn, 
            tab = Transpose[ab], mu, ss, nee, ssn, 
            nn = n - 
                1}, \[IndentingNewLine]mn = \(\((Plus @@ #)\) &\) /@ d\/n; \
\[IndentingNewLine]nee = 
            n . \(1\/tab\[LeftDoubleBracket]2\[RightDoubleBracket]\); 
          mu = n . \((\(mn - \
tab\[LeftDoubleBracket]1\[RightDoubleBracket]\)\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket])\)/
              nee; \[IndentingNewLine]ss = \((\(\((# . #)\) &\) /@ d)\) - 
              n\ \ mn\^2; 
          ssn = ss\/nn; \[IndentingNewLine]{mu, \(1\/nt\) \((n . \(\((\((mn - \
tab\[LeftDoubleBracket]1\[RightDoubleBracket])\)\^2 + 
                            ssn)\)\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket]\))\) - \(mu\^2\) nee\/nt}]];\)\)

\!\(\(GaussianMLEModelMeanCompiled = 
      Compile[{{d, _Real, 2}, {ab, _Real, 2}, {n, _Integer, 
            1}, {v, _Real}}, \[IndentingNewLine]Module[{mn = \(\((Plus @@ \
#)\) &\) /@ d\/n, 
            tab = Transpose[
                ab]}, \[IndentingNewLine]{n . \((\(mn - tab\
\[LeftDoubleBracket]1\[RightDoubleBracket]\)\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket])\)/\((n . \(1\/tab\[LeftDoubleBracket]2\
\[RightDoubleBracket]\))\), v}]];\)\)

\!\(\(GaussianMLEModelVarianceCompiled = 
      Compile[{{d, _Real, 2}, {ab, _Real, 2}, {n, _Integer, 
            1}, {m, _Real}}, \[IndentingNewLine]Module[{tab = Transpose[ab], 
            dm}, \[IndentingNewLine]dm = 
            d - m - tab\[LeftDoubleBracket]1\[RightDoubleBracket]; \
\[IndentingNewLine]{m, \(1\/Plus @@ 
                    n\) \((\(1\/tab\[LeftDoubleBracket]2\[RightDoubleBracket]\
\) . \((\(\((# . #)\) &\) /@ dm)\))\)}]];\)\)



\!\(\(MultinomialSamplingProbability[s : {{___} ... }] := 
      Times @@ \((\(\((Multinomial @@ #)\) &\) /@ s)\)\/Multinomial @@ \
\((Plus @@ s)\);\)\)



End[];
EndPackage[];