(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     54894,       1204]*)
(*NotebookOutlinePosition[     56451,       1250]*)
(*  CellTagsIndexPosition[     56269,       1241]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["PlotSegments", "SubsubsectionIcon"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {
            RowBox[{"PlotSegments", "[", 
              RowBox[{\({AncestralLineage[\[Ellipsis]], \[Ellipsis]}\), ",", 
                StyleBox["leaf",
                  FontSlant->"Italic"], ",", \({y\_0, y\_1}\)}], "]"}], 
            RowBox[{
            "gives", " ", "a", " ", "graphics", " ", "object", " ", "which", 
              " ", "represents", " ", "the", " ", "material", " ", 
              "ancestral", " ", "to", " ", 
              StyleBox["leaf",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], "in", 
              StyleBox[" ",
                FontSlant->"Italic"], "each", " ", "lineage"}]}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"PlotSegments"],

Cell[TextData[{
  "This shows all 49 segments in ",
  StyleBox["ng",
    FontSlant->"Italic"],
  ", starting with the leaf ",
  Cell[BoxData[
      \(TraditionalForm\`a\)]],
  " at the bottom.  Material ancestral to ",
  StyleBox["a",
    FontSlant->"Italic"],
  " is in blue, and non-ancestral material in yellow.  Junction boundaries \
are plotted as vertical lines."
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotSegments[ng, a, {0, 1}]];\)\)], "Input",
  CellLabel->"In[19]:=  (18:54:57 on 5/12/02)"],

Cell[GraphicsData["PICT", "\<\
0kX00P0_0;<1CP0A0_l<0?ooool0;`000080005>0000/`000000000N00402P02
02l0/`5>0200[P2@00H0T00P0:h0Y@060:D0802^0;/01P2k0200[P3a00H0l@0P
0:h110060@@0802^0A401P4A01[ooooo0000802^03H0[P560200Z`0f0:/1AP0P
0:L0=P2W0DH0802T03H0Y0560200X00f0:01AP0P09d0=P2M0DH0802I03H0V@56
0200UP0f09H1AP0P0980=P2B0DH0802?03H0S`560200R`0f08/1AP0P08P0=P28
0DH0802403H0Q0560200P@0f0841AP0P07d0=P1m0DH0801j03H0NP560200MP0f
07H1AP0P07<0=P1c0DH0801_03H0K`560200K00f06`1AP0P06P0=P1X0DH0801U
03H0I@560200H@0f0641AP0P05d0=P1M0DH0801J03H0FP560200EP0f05H1AP0P
05<0=P1C0DH0801?03H0C`560200C00f04`1AP0P04P0=P180DH0801503H0A@56
0200@@0f0441AP0P03h0=P0n0DH0800j03H0>P560200=`0f03L1AP0P03<0=P0c
0DH0800`03H0<0560200;00f02`1AP0P02T0=P0Y0DH0800U03H09@5602008P0f
0281AP0P01h0=P0N0DH0800K03H06`5602005`0f01L1AP0P01@0=P0D0DH0800@
03H0405602003@0f00d1AP0P00T0=P090DH0800603H01P5601X00000ool0802^
03H0[P560200Z`0f0:/14@0R0:L14CD00280Y00fK`008P2P0:E/000R09T14CD0
0280TP4A=@008P2?03IJ000R08/0T1D00280R04A=@008P2403I_000R0840=Vl0
0280P@4A=@008P1j0:E/000R07H0YEl00280L`443@008P1_0:EO000R06`0=Vl0
0280J04A=@008P1Q0:EO000R05d0=Vl00280FP443@008P1F0@@=000R04l0YAH0
0280C02kB@008P180A4e000R044110d00280>P4A=@008P0g03I_000R03L0^dT0
0280<`2U5P008P0c0@@=000R0300=Vl00280<02k=P008P0/0?4C000R02T0YAH0
02809@443@008P0R0?4P000R01@0YAH002803@2U5P008P0=0A4e003o\>"], "Graphics",
  CellLabel->"From In[19]:=  (18:54:57 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{287.938, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[TextData[{
  "Lineages are shown in the order they appear in the list, which in this \
case is the order in which they were generated.  The x axis runs from 0 to R, \
and the y axis from ",
  Cell[BoxData[
      \(TraditionalForm\`y\_0\ to\ \(\(y\_1\)\(.\)\)\)]]
}], "Text"],

Cell["This shows just those root lineages present at t=2:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
        PlotSegments[\(ExtractLineage[ng, #] &\) /@ LineagesPresent[ng, 2], 
          a, {0, 1}]];\)\)], "Input",
  CellLabel->"In[36]:=  (18:59:11 on 5/12/02)"],

Cell[GraphicsData["PICT", "\<\
0=h00P0_0;<1C`0A0_l<0?ooool0;`000080005?0000/`000000000N00402P02
02l0/`5?0200[P2U00H0Y@0P0:h0^`060;/0802^0?401P3a0200[P4A00H14@0J
ooooo`000200[P0f0:h1AP0P0980=P2B0DH0801f03H0MP560200FP0f05X1AP0P
03h0=P0n0DH0800R03H08P5602001P0f00H1AP0J00000?oo0280[P0fK`008P2^
0;/f000R0980lB000280?P2U5P008P0n0A4e003o\>"], "Graphics",
  CellLabel->"From In[36]:=  (18:59:11 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[TextData[{
  "LineagesPresent[ng,2] lists the labels of the lineages present, and \
ExtractLineage[ng,#]&/@ extracts the full list of lineages.  There are 4 null \
lineages, 5 blocks, and 4 lineages carrying material ancestral to ",
  StyleBox["a.",
    FontSlant->"Italic"]
}], "Text"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(SegmentStyle \[Rule] {Blue, 
                Thickness[
                  0.05]}\), \(sets\ the\ style\ of\ the\ ancestral\ \
segments\)},
          {\(BackgroundStyle -> {Yellow}\), \(sets\ the\ style\ of\ the\ non \
- ancestral\ material\)},
          {\(JunctionStyle -> {Black, 
                Dashing[0.01, 
                  0.01]}\), \(sets\ the\ style\ of\ the\ vertical\ lines\ \
depicting\ junctions\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->{"SegmentStyle", "BackgroundStyle", "JunctionStyle"}],

Cell["\<\
This generates a random genealogy with 3 leaves {a, b, c}, and 30 \
events; R=2:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ng3 = RandomGenealogy[{a, b, c}, 30, 2]\)], "Input",
  CellLabel->"In[37]:=  (19:06:09 on 5/12/02)"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\(AncestralLineage[
          a, {0, 0.08022194990581664`}, {{a}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          b, {0, 0.07693209618982745`}, {{b}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          c, {0, 0.14388597475863063`}, {{c}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          1, {0.07693209618982745`, 
            0.45196928336400893`}, {{b}, {}}, {0.031539970801442684`, 
            2}, {}]\), 
        ",", \(AncestralLineage[
          2, {0.07693209618982745`, 
            0.08022194990581664`}, {{}, {b}}, {0.031539970801442684`, 
            2}, {}]\), 
        ",", \(AncestralLineage[
          3, {0.08022194990581664`, 
            0.23345968419635083`}, {{a}, {a, b}}, {0.031539970801442684`, 
            2}, {}]\), 
        ",", \(AncestralLineage[
          4, {0.14388597475863063`, 
            0.3222906930739391`}, {{c}, {}}, {0.1959555703693053`, 2}, {}]\), 
        ",", \(AncestralLineage[
          5, {0.14388597475863063`, 
            0.38899192854037634`}, {{}, {c}}, {0.1959555703693053`, 2}, {}]\),
         ",", \(AncestralLineage[
          6, {0.23345968419635083`, 
            0.3956420558947829`}, {{a}, {a, b}, {}}, {0.031539970801442684`, 
            0.7368922787802568`, 2}, {}]\), 
        ",", \(AncestralLineage[
          7, {0.23345968419635083`, 
            0.37613947099060485`}, {{}, {a, b}}, {0.7368922787802568`, 
            2}, {}]\), 
        ",", \(AncestralLineage[
          8, {0.3222906930739391`, 
            0.5376317467422345`}, {{c}, {}}, {0.1959555703693053`, 2}, {}]\), 
        ",", \(AncestralLineage[
          9, {0.3222906930739391`, 0.4003117503624485`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          10, {0.37613947099060485`, 
            0.38899192854037634`}, {{}, {a, b}, {}}, {0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          11, {0.37613947099060485`, 
            0.3956420558947829`}, {{}, {a, b}}, {1.8445547970363083`, 
            2}, {}]\), 
        ",", \(AncestralLineage[
          12, {0.38899192854037634`, 
            0.4003117503624485`}, {{}, {c}, {c, a, 
              b}, {c}}, {0.1959555703693053`, 0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          13, {0.3956420558947829`, 
            0.5376317467422345`}, {{a}, {a, b}, {}, {a, 
              b}}, {0.031539970801442684`, 0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          14, {0.4003117503624485`, 
            0.4214520468286324`}, {{}, {c}, {c, a, 
              b}, {c}}, {0.1959555703693053`, 0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          15, {0.4214520468286324`, 
            0.45196928336400893`}, {{}, {c}, {c, a, 
              b}, {}}, {0.1959555703693053`, 0.7368922787802568`, 
            1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          16, {0.4214520468286324`, 
            0.7198733786812553`}, {{}, {c, a, b}, {c}}, {1.1596149831529554`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          17, {0.45196928336400893`, 
            0.5141197393465927`}, {{b}, {}, {c}, {c, a, 
              b}, {}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.7368922787802568`, 1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          18, {0.5141197393465927`, 
            0.5988936880191291`}, {{b}, {}, {c}, {}}, {0.031539970801442684`, 
            0.1959555703693053`, 0.4833638988523762`, 2}, {}]\), 
        ",", \(AncestralLineage[
          19, {0.5141197393465927`, 
            0.5326113895189726`}, {{}, {c}, {c, a, 
              b}, {}}, {0.4833638988523762`, 0.7368922787802568`, 
            1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          20, {0.5326113895189726`, 
            0.5461069624859071`}, {{}, {c}, {c, a, 
              b}, {}}, {0.4833638988523762`, 0.7368922787802568`, 
            1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          21, {0.5326113895189726`, 0.6388869704786799`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          22, {0.5376317467422345`, 
            0.5794096617930142`}, {{c, a}, {c, a, b}, {a, b}, {}, {a, 
              b}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.7368922787802568`, 1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          23, {0.5461069624859071`, 
            0.5988936880191291`}, {{}, {c}, {c, a, 
              b}, {}}, {0.4833638988523762`, 0.7368922787802568`, 
            1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          24, {0.5461069624859071`, 0.5794096617930142`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          25, {0.5794096617930142`, 
            1.7647965962820553`}, {{c, a}, {c, a, b}, {a, b}, {}, {a, 
              b}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.7368922787802568`, 1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          26, {0.5988936880191291`, 
            0.7198733786812553`}, {{b}, {}, {c}, {c, a, 
              b}, {}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.7368922787802568`, 1.1596149831529554`, 2}, {}]\), 
        ",", \(AncestralLineage[
          27, {0.6388869704786799`, 0.7829853088362446`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          28, {0.6388869704786799`, 0.945682982752103`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          29, {0.7198733786812553`, 
            1.0719710480823774`}, {{b}, {}, {c}, {c, a, 
              b}, {c}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.7368922787802568`, 1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          30, {0.7829853088362446`, 0.945682982752103`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          31, {0.7829853088362446`, 1.0794631469723346`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          32, {0.945682982752103`, 1.0794631469723346`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          33, {1.0719710480823774`, 
            1.1234934881596421`}, {{b}, {}, {c}, {}}, {0.031539970801442684`, 
            0.1959555703693053`, 0.6955430538836705`, 2}, {}]\), 
        ",", \(AncestralLineage[
          34, {1.0719710480823774`, 
            1.7369955658684648`}, {{}, {c}, {c, a, 
              b}, {c}}, {0.6955430538836705`, 0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          35, {1.0794631469723346`, 1.1234934881596421`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          36, {1.1234934881596421`, 
            1.5777943031026653`}, {{b}, {}, {c}, {}}, {0.031539970801442684`, 
            0.1959555703693053`, 0.6955430538836705`, 2}, {}]\), 
        ",", \(AncestralLineage[
          37, {1.5777943031026653`, 
            1.8072857872595656`}, {{b}, {}, {c}, {}}, {0.031539970801442684`, 
            0.1959555703693053`, 0.6955430538836705`, 2}, {}]\), 
        ",", \(AncestralLineage[
          38, {1.5777943031026653`, 1.6398905819990055`}, {{}}, {2}, {}]\), 
        ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"39", ",", 
            RowBox[{"{", 
              RowBox[{"1.6398905819990055`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{}}\), ",", \({2}\),
             ",", \({}\)}], "]"}], 
        ",", \(AncestralLineage[
          40, {1.6398905819990055`, 1.7369955658684648`}, {{}}, {2}, {}]\), 
        ",", \(AncestralLineage[
          41, {1.7369955658684648`, 
            1.7647965962820553`}, {{}, {c}, {c, a, 
              b}, {c}}, {0.6955430538836705`, 0.7368922787802568`, 
            1.8445547970363083`, 2}, {}]\), 
        ",", \(AncestralLineage[
          42, {1.7647965962820553`, 
            1.7710292896701125`}, {{c, a}, {c, a, b}, {a, b}, {a, b, c}, {c, 
              a, b}, {a, b, c}}, {0.031539970801442684`, 0.1959555703693053`, 
            0.6955430538836705`, 0.7368922787802568`, 1.8445547970363083`, 
            2}, {}]\), ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"43", ",", 
            RowBox[{"{", 
              RowBox[{"1.7710292896701125`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], 
            ",", \({{c, a}, {c, a, b}, {a, b}, {}}\), 
            ",", \({0.031539970801442684`, 0.1959555703693053`, 
              0.5285659088121535`, 2}\), ",", \({}\)}], "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"44", ",", 
            RowBox[{"{", 
              RowBox[{"1.7710292896701125`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], 
            ",", \({{}, {a, b}, {a, b, c}, {c, a, b}, {a, b, c}}\), 
            ",", \({0.5285659088121535`, 0.6955430538836705`, 
              0.7368922787802568`, 1.8445547970363083`, 2}\), ",", \({}\)}], 
          "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"45", ",", 
            RowBox[{"{", 
              RowBox[{"1.8072857872595656`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{b}, {}, {c}, {}}\),
             ",", \({0.031539970801442684`, 0.1959555703693053`, 
              0.6955430538836705`, 2}\), ",", \({}\)}], "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"46", ",", 
            RowBox[{"{", 
              RowBox[{"1.8072857872595656`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{}}\), ",", \({2}\),
             ",", \({}\)}], "]"}]}], "}"}]], "Output",
  CellLabel->"Out[37]=  (19:06:09 on 5/12/02)"]
}, Closed]],

Cell["This shows all 49 lineages, from bottom to top:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotSegments[ng3, a, {0, 1}], 
        PlotSegments[ng3, b, {0.005, 1.005}, SegmentStyle -> {Red}], 
        PlotSegments[ng3, c, {0.01, 1.01}, 
          SegmentStyle -> {Green}]];\)\)], "Input",
  CellLabel->"In[66]:=  (19:17:38 on 5/12/02)"],

Cell[GraphicsData["PICT", "\<\
2X@00P0_0Il2c@0A0_l<0?ooool0;`00008000;=0001W`000000000N00402P02
02l1W`;=0201U@1900l0B@0P0ID0O@0?07d0806E0=T03`3I0201U@3W00l0i`0P
0ID1700?0A`0806E0BT03`4Y0201U@6`00l1/00P0ID2RP0?0XX06_ooool0000P
0ID0?`6E0[/0806<03l1S0:k0201Q00o0H@2^`0P0G`0?`5l0[/0805d03l1M0:k
0201K00o0F`2^`0P0F@0?`5T0[/0805L03l1G0:k0201E00o0E@2^`0P0D`0?`5<
0[/0805303l1@`:k0201>`0o0C/2^`0P0C<0?`4c0[/0804[03l1:`:k02018`0o
0B<2^`0P0A/0?`4K0[/0804C03l14`:k02012`0o0@/2^`0P0@<0?`430[/0803j
03l0nP:k0200lP0o0?82^`0P0>X0?`3Z0[/0803R03l0hP:k0200fP0o0=X2^`0P
0=80?`3B0[/0803:03l0bP:k0200`P0o0<82^`0P0;X0?`2j0[/0802a03l0/@:k
0200Z@0o0:T2^`0P0:40?`2Q0[/0802I03l0V@:k0200T@0o0942^`0P08T0?`29
0[/0802103l0P@:k0200N@0o07T2^`0P0740?`1a0[/0801X03l0J0:k0200H00o
0602^`0P05P0?`1H0[/0801@03l0D0:k0200B00o04P2^`0P0400?`100[/0800h
03l0>0:k0200<00o0302^`0P02P0?`0X0[/0800O03l07`:k02005`0o01L2^`0P
00l0?`0?0[/06P00003oo`0P0ID0?`6E0[/0805/03l1K0:k0201E00o0E@1:@0P
0D`1:@5<0[/0804c0BT1<`::0281:`::<@00804S0BT18`::02016`0o0A/1:@0R
0A/2RS4002014`4Y0A<2RP0P0@/1:@4;0K0080430K010`::0200nP4Y0?X1/00P
0>X1:@3Z0K00803R0BT0hP6`0200dP0o0=81:@0R0=82RS400200bP4Y0<X1/00P
0;X0?`2j0BT08P2j0XXa000P0;41:@2a0K00802I0BT0V@::0200L@4Y0742RP0P
03P1:@0h0XX0800`03l0<0:k0200:00o02P0i`0P01l0i`0O0[/06P000000000P
0I<0B@0=04T0806C07d03@1m0201T`3I00d0f@0P0I<0i`0=0>L0806C0A`03@4L
0201T`4Y00d1:@0P0I<1/00=0K00806C0XX03@::01[ooooo0000806C03l1T`:k
0201RP0o0HX2^`0P0H80?`620[/0805j03l1NP:k0201LP0o0G82^`0P0FX0?`5Z
0[/0805R03l1HP:k0201FP0o0EX2^`0P0E80?`5B0[/0805:03l1BP:k0201@@0o
0D42^`0P0CT0?`4i0[/0804a03l1<@:k0201:@0o0BT2^`0P0B40?`4Q0[/0804I
03l16@:k02014@0o0A42^`0P0@T0?`490[/0804103l10@:k0200n00o0?P2^`0P
0?00?`3`0[/0803X03l0j0:k0200h00o0>02^`0P0=P0?`3H0[/0803@03l0d0:k
0200b00o0<P2^`0P0<00?`300[/0802h03l0^0:k0200[`0o0:l2^`0P0:L0?`2W
0[/0802O03l0W`:k0200U`0o09L2^`0P08l0?`2?0[/0802703l0Q`:k0200O`0o
07l2^`0P07L0?`1g0[/0801_03l0K`:k0200IP0o06H2^`0P05h0?`1N0[/0801F
03l0EP:k0200CP0o04h2^`0P04H0?`160[/0800n03l0?P:k0200=P0o03H2^`0P
02h0?`0^0[/0800V03l09P:k02007P0o01h2^`0P01D0?`0E0[/0800=03l03@:k
01[oo`000000806:03l1RP:k0281NP0o2P00805b04T1LP:k0201JP190FX2^`0P
0E80B@5B0BT0805:0BT1BP:k0201<@4Y0C42RP0R0BT2RS4002018@4Y0B42RP0P
0AT0B@4I0BT08P4I0XXa000P0A41:@4A0XX080490BT12@6`02010@6`0@42RP0R
0?P0?`X00200n04Y0?P1/00R0?00?`X00200j04Y0>P1/00P0>01:@3P0K00803@
04T0d04Y0280d0::<@0080380BT0b06`0200^0190;P1:@0R0;P2RS400280[`0o
2P00802_0BT0[`6`0280U`0o2P00802G0BT0U`::0280M`0o2P00801_0BT0K`::
0280GP0o2P008P1F03l:000P03H1:@0f0XX0800^04T0;P:k02009P1902H0i`0P
01h0i`0N0[/08P0E03l:000J000000000201T@1900/0B@0P0I40O@0;07d0806A
0=T02`3I0201T@3W00/0i`0P0I41700;0A`0806A0BT02`4Y0201T@6`00/1/00P
0I42RP0;0XX06_ooool0000P0I40?`6A0[/0806903l1R@:k0201P00o0H02^`0P
0GP0?`5h0[/0805`03l1L0:k0201J00o0FP2^`0P0F00?`5P0[/0805H03l1F0:k
0201D00o0E02^`0P0DP0?`580[/0805003l1@0:k0201=`0o0CL2^`0P0Bl0?`4_
0[/0804W03l19`:k02017`0o0Al2^`0P0AL0?`4G0[/0804?03l13`:k02011`0o
0@L2^`0P0?l0?`3o0[/0803g03l0m`:k0200kP0o0>h2^`0P0>H0?`3V0[/0803N
03l0gP:k0200eP0o0=H2^`0P0<h0?`3>0[/0803603l0aP:k0200_P0o0;h2^`0P
0;H0?`2f0[/0802^03l0[P:k0200Y@0o0:D2^`0P09d0?`2M0[/0802E03l0U@:k
0200S@0o08d2^`0P08D0?`250[/0801m03l0O@:k0200M@0o07D2^`0P06d0?`1]
0[/0801U03l0I@:k0200G00o05`2^`0P05@0?`1D0[/0801<03l0C0:k0200A00o
04@2^`0P03`0?`0l0[/0800d03l0=0:k0200;00o02`2^`0P02@0?`0T0[/0800L
03l070:k02004`0o01<2^`0P00/0?`0;0[/06P00ool0000P0H00?`600[/08P5P
03ln000P0EP0O@5H0[/08P5003ln000P0Al0O@4O0[/0804?07d13`:k02011`1m
0@L1/00P0?l1/03o0[/0803g07d0m`6`0280kP1mG000803V0=T0iP6`0200gP3I
0=h1/00R0<h0?ch00200aP3I0<H1/00R0;H0?ch00200[P1m0:h1/00P09D0O@2E
0[/0801e07d0M@4L0200K@4L06d2^`0P05`0O@1L0A`0801D07d0E04L0200=04L
03@2^`0R02`0?ch00200;04L02`2^`0R02@0?ch00200704L01`2^`0P01<0O@0C
0A`0o`\>"], "Graphics",
  CellLabel->"From In[66]:=  (19:17:38 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{670, 413.875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[TextData[{
  "Three graphics objects are generated, for material ancestral to each of \
the three leaves.  They are displaced slightly, using different ",
  Cell[BoxData[
      \(TraditionalForm\`{y\_0, \ y\_1}\)]],
  ", and coloured differently using SegmentStyle."
}], "Text"],

Cell[TextData[{
  "Note:  ",
  StyleBox["Graphics`Colors` is loaded to define the colours.",
    FontWeight->"Plain"]
}], "Text",
  FontWeight->"Bold"],

Cell["This extracts the five lineages present at the end (t=2):", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ng3End = \(ExtractLineage[ng3, #] &\) /@ 
        LineagesPresent[ng3, 2]\)], "Input",
  CellLabel->"In[53]:=  (19:11:35 on 5/12/02)"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"39", ",", 
            RowBox[{"{", 
              RowBox[{"1.6398905819990055`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{}}\), ",", \({2}\),
             ",", \({}\)}], "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"43", ",", 
            RowBox[{"{", 
              RowBox[{"1.7710292896701125`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], 
            ",", \({{c, a}, {c, a, b}, {a, b}, {}}\), 
            ",", \({0.031539970801442684`, 0.1959555703693053`, 
              0.5285659088121535`, 2}\), ",", \({}\)}], "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"44", ",", 
            RowBox[{"{", 
              RowBox[{"1.7710292896701125`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], 
            ",", \({{}, {a, b}, {a, b, c}, {c, a, b}, {a, b, c}}\), 
            ",", \({0.5285659088121535`, 0.6955430538836705`, 
              0.7368922787802568`, 1.8445547970363083`, 2}\), ",", \({}\)}], 
          "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"45", ",", 
            RowBox[{"{", 
              RowBox[{"1.8072857872595656`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{b}, {}, {c}, {}}\),
             ",", \({0.031539970801442684`, 0.1959555703693053`, 
              0.6955430538836705`, 2}\), ",", \({}\)}], "]"}], ",", 
        RowBox[{"AncestralLineage", "[", 
          RowBox[{"46", ",", 
            RowBox[{"{", 
              RowBox[{"1.8072857872595656`", ",", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]]}], "}"}], ",", \({{}}\), ",", \({2}\),
             ",", \({}\)}], "]"}]}], "}"}]], "Output",
  CellLabel->"Out[53]=  (19:11:35 on 5/12/02)"]
}, Closed]],

Cell["This shows just those lineages:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotSegments[ng3End, a, {0, 1}], 
        PlotSegments[ng3End, b, {0.02, 1.02}, SegmentStyle -> {Red}], 
        PlotSegments[ng3End, c, {0.04, 1.04}, 
          SegmentStyle -> {Green}]];\)\)], "Input",
  CellLabel->"In[55]:=  (19:12:10 on 5/12/02)"],

Cell[GraphicsData["PICT", "\<\
0PP00P0_0;<1C`0A0_l<0?ooool0;`000080005?0000/`000000000N00402P02
02l0/`5?0200[P0j00`0>P0P0:h0D00<0500802^07h0301n0200[P2D00`0U00P
0:h0VP0<09X0802^0C40304a01[ooooo0000802^03H0[P560200QP0f08H1AP0P
05d0=P1M0DH0800e03H0=@560200300f00`1AP0J00000?oo0280QP0fB000801M
07h0G@5601X000000000802[03X02@0j0200Z`1@00T0D00P0:/0OP0907h0802[
09@02@2D0200Z`2J00T0VP0P0:/1<@090C406_ooool0000P0:/0=P2[0DH08022
03H0PP560200FP0f05X1AP0P0340=P0a0DH0800903H02@5601[oo`0000008P22
03Y4000P05X0OP1J0DH08P0a03H4000J000000000200Z00j00H0>P0P0:P0D006
0500802X07h01P1n0200Z02D00H0U00P0:P0VP0609X0802X0C401P4a01[ooooo
0000802X03H0Z0560200O`0f07l1AP0P05L0=P1G0DH0800^03H0;P5602001P0f
00H1AP0J003oo`000280O`0f6P00801G09@0E`560280;P1@A000o`\>"], "Graphics",
  CellLabel->"From In[55]:=  (19:12:10 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell["\<\
TimesOfEvents[ng3] lists the times of all the events.  The set of \
figures shows the segments at each of these times (except the last, defined \
as t=\[Infinity]).  \
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\((ng3End = \(ExtractLineage[ng3, #] &\) /@ 
                LineagesPresent[ng3, #]; 
            yy = Length[ng3End]/4; \[IndentingNewLine]Show[
              PlotSegments[ng3End, 
                a, {0, 1}], \[IndentingNewLine]PlotSegments[ng3End, 
                b, {0.02, 1.02}, 
                SegmentStyle -> {Red}], \[IndentingNewLine]PlotSegments[
                ng3End, c, {0.04, 1.04}, 
                SegmentStyle -> {Green}], \[IndentingNewLine]AspectRatio -> 
                yy])\) &\) /@ Drop[TimesOfEvents[ng3], \(-1\)];\)\)], "Input",\

  CellLabel->"In[75]:=  (19:28:52 on 5/12/02)"],

Cell[CellGroupData[{

Cell[GraphicsData["PICT", "\<\
0>000P0_0=X1C`0A0_l<0?ooool0;`000080005?0000fP000000000N01[ooooo
00000@0:0080;`3J0Dl0803C03D0d`570200L@0e0741A`0P00h0=@0>0DL06P00
003oo`0P0=<0=@3C0DL06_ooool0000P0<l0=@3?0DL0801]03D0K@5702002`0e
00/1A`0Jool000000200K@0e06d1A`0Jooooo`000200c00e0<`1A`0P06T0=@1Y
0DL0800703D01`5701X00?oo0000800703D01`570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:52 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 216},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->1,
  AnimationCycleRepetitions->Infinity],

Cell[GraphicsData["PICT", "\<\
0C@00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0Jooooo`0002016P0e0AX1A`0P0<80=@320DL0801Z
03D0JP5702004`0e01<1A`0J00000?oo02016P0e0AX1A`0J000000000201500j
00h0>P0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@5702003P0e
00h1A`0Jool000000280I@0e1@00800>03X03P5701X000000000804?03X0200j
01[ooooo0000804?03D13`570200^00e0;P1A`0P0600=@1P0DL0800803D02057
01X00?oo0000802h03D0^0570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:53 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0AH00P0_0=X1C`0A0_l<0?ooool0;`000080005?0000fP000000000N00402P02
02l0fP5?0200d`0j00h0>P0Jooooo`000200d`0e0=<1A`0P0740=@1a0DL0800>
03D03P5701X00000ool0800>03D03P5701X000000000803?03X02`0j01[ooooo
0000803?03D0c`570200K@0e06d1A`0P00/0=@0;0DL06_oo0000000R06d0=@D0
02002`0j00/1A`0J000000000200c00j00L0>P0Jooooo`000200c00e0<`1A`0P
06T0=@1Y0DL0800703D01`5701X00?oo0000803<03D0c0570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:53 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 216},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0EX00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C05006_ooool0000P0AX0=@4J0DL08032
03D0`P570200JP0e06X1A`0P01<0=@0C0DL06P00003oo`0P0<80=@320DL06P00
0000000P0A@0>P0>03X0804D05003P1@01[ooooo0000804D03D150570200_@0e
0;d1A`0P06D0=@1U0DL0800>03D03P5701[oo`0000008P4D03D5000P0;d0>P2m
0DL06P000000000P0@l0>P0803X0804?0500201@01[ooooo0000804?03D13`57
0200^00e0;P1A`0P0600=@1P0DL0800803D0205701X00?oo00008P1P03DK000P
00P0D0080DL0o`\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:54 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0JH00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09X05`2J01[ooooo0000805P
03D1H05702013P0e0@h1A`0P0;`0=@2l0DL0801Y03D0J@5702005`0e01L1A`0J
00000?oo0280J@0eI@00800G09X05`5701X000000000805I03X04@0j0201F@1@
0140D00P0ET0VP0A09X06_ooool0000P0ET0=@5I0DL0804703D11`570200]@0e
0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P5I03D5000R06<0>V00
02004@2J0141A`0J000000000201D`0j00X0>P0P0E<0D00:0500805C09X02P2J
01[ooooo0000805C03D1D`5702010@0e0@41A`0P0:h0=@2^0DL0801L03D0G057
02002P0e00X1A`0J003oo`0002810@0e6`00802^0500[P570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:54 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0L@00P0_0K81C`0A0_l<0?ooool0;`000080005?0001/P000000000N00402P02
02l1/P5?0201YP0j01`0>P0P0JH0D00L0500806V09X0702J01[ooooo0000806V
03D1YP570201E`0e0EL1A`0P0@P0=@480DL0802i03D0^@570200J`0e06/1A`0P
01`0=@0L0DL06P00003oo`0R0@P0=FD00200^@2J0;T1A`0J000000000201WP0j
01@0>P0P0Ih0D00D0500806N09X0502J01[ooooo0000806N03D1WP570201C`0e
0Dl1A`0P0@00=@400DL0802b03D0/P570200H`0e06<1A`0P01@0=@0D0DL06_oo
0000000R0Ih0=@D00281000jH000802b09X0/P5701X000000000806F03X0300j
0201UP1@00`0D00P0IH0VP0<09X06_ooool0000P0IH0=@6F0DL0805703D1A`57
0200n@0e0?T1A`0P0:X0=@2Z0DL0801K03D0F`570200300e00`1A`0J003oo`00
0201A`1@0DL1A`0R05/0=A/00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:54 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 432},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0Q000P0_0OX1C`0A0_l<0?ooool0;`000080005?0001nP000000000N00402P02
02l1nP5?0201k00j0200>P0P0N`0D00P0500807/09X0802J0201k04a0201<@0J
ooooo`000201k00e0N`1A`0P0J00=@6P0DL0805C03D1D`5702011P0e0@H1A`0P
0;X0=@2j0DL0801]03D0K@570200800e0201A`0J00000?oo0281D`0eI@00801]
09X0K@4a0280804a5P006P000000000P0N<0>P0G03X0807S05005`1@0201h`2J
01L0VP0P0N<1<@0G0C406_ooool0000P0N<0=@7S0DL0806F03D1UP570201BP0e
0DX1A`0P0?d0=@3m0DL0802`03D0/0570200I00e06@1A`0P01L0=@0G0DL06_oo
0000000R0N<0=@D00281BP0jH000801T09X0I04a02805`4a5P006P000000000P
0MX0>P0>03X0807J05003P1@0201fP2J00h0VP0P0MX1<@0>0C406_ooool0000P
0MX0=@7J0DL0806=03D1S@570201@00e0D01A`0P0?@0=@3d0DL0802W03D0Y`57
0200FP0e05X1A`0P00h0=@0>0DL06P00ool0000P0Hd0D06=0DL08P3d03DK003o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:55 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 504},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0O800P0_0K81C`0A0_l<0?ooool0;`000080005?0001/P000000000N00402P02
02l1/P5?0201YP0j01`0>P0P0JH0D00L0500806V09X0702J0201YP4a01`1<@0J
ooooo`000201YP0e0JH1A`0P0EL0=@5G0DL0804803D120570200^@0e0;T1A`0P
06/0=@1[0DL0800L03D0705701X00000ool08P5G03EU000R06/1<AH00200702J
01`1<@0J000000000201WP0j01@0>P0P0Ih0D00D0500806N09X0502J0201WP4a
01@1<@0Jooooo`000201WP0e0Ih1A`0P0Dl0=@5?0DL0804003D100570200/P0e
0;81A`0P06<0=@1S0DL0800D03D0505701[oo`0000008P6N03D5000R0Dl0>V00
0280H`4a5P00800D09X0504a01X000000000806F03X0300j0201UP1@00`0D00P
0IH0VP0<09X0806F0C40304a01[ooooo0000806F03D1UP570201A`0e0DL1A`0P
0?T0=@3i0DL0802Z03D0ZP570200F`0e05/1A`0P00`0=@0<0DL06P00ool0000R
0?T0=A/00200301@00`1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:55 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 432},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0M@00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09X05`2J0201H04a01L1<@0J
ooooo`000201H00e0F01A`0P0@h0=@4>0DL0802l03D0_0570200J@0e06T1A`0P
01L0=@0G0DL06P00003oo`0P06T0VP1Y0C408P0G03EU000R01L1<AH001X00000
0000805I03X04@0j0201F@1@0140D00P0ET0VP0A09X0805I0C404@4a01[ooooo
0000805I03D1F@5702011`0e0@L1A`0P0;D0=@2e0DL0801S03D0H`5702004@0e
0141A`0Jool000000281F@0e1@00801S09X0H`4a02804@0jH0008P0A0C4F000J
000000000201D`0j00X0>P0P0E<0D00:0500805C09X02P2J0201D`4a00X1<@0J
ooooo`000201D`0e0E<1A`0P0@40=@410DL0802^03D0[P570200G00e05`1A`0P
00X0=@0:0DL06P00ool0000R0@40=A/00200G01@05`1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:56 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0KH00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09X04`2J02016P4a01<1<@0J
ooooo`0002016P0e0AX1A`0P0<80=@320DL0801Z03D0JP5702004`0e01<1A`0J
00000?oo0280JP0eI@008P1Z0C4F000P01<0VP0C0C406P000000000P0A@0>P0>
03X0804D05003P1@0201502J00h0VP0P0A@1<@0>0C406_ooool0000P0A@0=@4D
0DL0802m03D0_@570200I@0e06D1A`0P00h0=@0>0DL06_oo0000000R0A@0=@D0
0280I@0jH0008P1U0C4F000P00h0VP0>0C406P000000000P0@l0>P0803X0804?
0500201@02013`2J00P0VP0P0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h
03D0^0570200H00e0601A`0P00P0=@080DL06P00ool0000R0;P0=A/00200201@
00P1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:56 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0PH00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09X05`2J0201H03D01L0e00P
0F01<@0G0C406_ooool0000P0F00=@5P0DL0804>03D13P570200_00e0;`1A`0P
06T0=@1Y0DL0800G03D05`5701X00000ool08P2l03EU000R0;`1<AH00280J@2J
>P008P0G0=AM000J000000000201F@0j0140>P0P0ET0D00A0500805I09X04@2J
0201F@3D0140e00P0ET1<@0A0C406_ooool0000P0ET0=@5I0DL0804703D11`57
0200]@0e0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P5I03D5000R
0;D0>V000280]@4a5P008P1S09Xj000R0140e5d001X000000000805C03X02P0j
0201D`1@00X0D00P0E<0VP0:09X0805C0=@02P3D0201D`4a00X1<@0Jooooo`00
0201D`0e0E<1A`0P0@40=@410DL0802^03D0[P570200G00e05`1A`0P00X0=@0:
0DL06P00ool0000R0@40=A/00200G01@05`0e00R00X0e7<00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:57 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0NP00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09X04`2J02016P3D01<0e00P
0AX1<@0C0C406_ooool0000P0AX0=@4J0DL0803203D0`P570200JP0e06X1A`0P
01<0=@0C0DL06P00003oo`0R0<80=FD00280`P4a5P008P1Z0=AM000R01<0VSX0
01X000000000804D03X03P0j0201501@00h0D00P0A@0VP0>09X0804D0=@03P3D
0201504a00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@57
02003P0e00h1A`0Jool000000280_@0jH0008P2m0C4F000R06D0e5d002803P0e
1@008P0>09Xj000J0000000002013`0j00P0>P0P0@l0D0080500804?09X0202J
02013`3D00P0e00P0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h03D0^057
0200H00e0601A`0P00P0=@080DL06P00ool0000R0@l0=A/00280H03DL`008008
0500203D0?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:57 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0RX00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P07L05`1g0201H02J01L0VP0P
0F00e00G0=@0805P0C405`4a01[ooooo0000805P03D1H05702013P0e0@h1A`0P
0;`0=@2l0DL0801Y03D0J@5702005`0e01L1A`0J00000?oo02813P0eI@008P4>
0C4F000R0;`0e5d002805`2J>P006P000000000P0ET0>P0A03X0805I05004@1@
0201F@1g0140M`0P0ET0VP0A09X0805I0=@04@3D0201F@4a0141<@0Jooooo`00
0201F@0e0ET1A`0P0@L0=@470DL0802e03D0]@570200H`0e06<1A`0P0140=@0A
0DL06_oo0000000R0@L0>V0002811`4a5P008P2e0=AM000R06<0=@D002804@2J
>P006P000000000P0E<0>P0:03X0805C05002P1@0201D`1g00X0M`0P0E<0VP0:
09X0805C0=@02P3D0201D`4a00X1<@0Jooooo`000201D`0e0E<1A`0P0@40=@41
0DL0802^03D0[P570200G00e05`1A`0P00X0=@0:0DL06P00ool0000R0E<0=A/0
0280[P3DL`008P1L050W000R00X0Med00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:58 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0TP00P0_0K81C`0A0_l<0?ooool0;`000080005?0001/P000000000N00402P02
02l1/P5?0201YP0j01`0>P0P0JH0D00L0500806V07L0701g0201YP2J01`0VP0P
0JH0e00L0=@0806V0C40704a01[ooooo0000806V03D1YP570201E`0e0EL1A`0P
0@P0=@480DL0802i03D0^@570200J`0e06/1A`0P01`0=@0L0DL06P00003oo`0R
0EL0=FD00281E`4a5P008P480=AM000R06/0VSX001X000000000806N03X0500j
0201WP1@01@0D00P0Ih0M`0D07L0806N09X0502J0201WP3D01@0e00P0Ih1<@0D
0C406_ooool0000P0Ih0=@6N0DL0805?03D1C`570201000e0@01A`0P0;80=@2b
0DL0801S03D0H`570200500e01@1A`0Jool000000281C`0jH0008P5?0C4F000R
0@00e5d00280/P0e1@008P1S09Xj000J000000000201UP0j00`0>P0P0IH0D00<
0500806F07L0301g0201UP2J00`0VP0P0IH0e00<0=@0806F0C40304a01[ooooo
0000806F03D1UP570201A`0e0DL1A`0P0?T0=@3i0DL0802Z03D0ZP570200F`0e
05/1A`0P00`0=@0<0DL06P00ool0000R0IH0=A/00280n@3DL`008P2Z050W000R
05/0Med00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:58 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 432},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0RX00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P07L05`1g0201H02J01L0VP0P
0F00e00G0=@0805P0C405`4a01[ooooo0000805P03D1H05702013P0e0@h1A`0P
0;`0=@2l0DL0801Y03D0J@5702005`0e01L1A`0J00000?oo0281H03DG@008P2l
09Xj000R01L0=FD002805`4a5P006P000000000P0ET0>P0A03X0805I05004@1@
0201F@1g0140M`0P0ET0VP0A09X0805I0=@04@3D0201F@4a0141<@0Jooooo`00
0201F@0e0ET1A`0P0@L0=@470DL0802e03D0]@570200H`0e06<1A`0P0140=@0A
0DL06_oo0000000R0ET0e5d002811`0e1@008P2e09Xj000R0140>V0002804@4a
5P006P000000000P0E<0>P0:03X0805C05002P1@0201D`1g00X0M`0P0E<0VP0:
09X0805C0=@02P3D0201D`4a00X1<@0Jooooo`000201D`0e0E<1A`0P0@40=@41
0DL0802^03D0[P570200G00e05`1A`0P00X0=@0:0DL06P00ool0000R0E<0e7<0
02810@1@9`008P2^07MM000R00X0=A/00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:58 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0TP00P0_0K81C`0A0_l<0?ooool0;`000080005?0001/P000000000N00402P02
02l1/P5?0201YP0j01`0>P0P0JH0D00L0500806V07L0701g0201YP2J01`0VP0P
0JH0e00L0=@0806V0C40704a01[ooooo0000806V03D1YP570201E`0e0EL1A`0P
0@P0=@480DL0802i03D0^@570200J`0e06/1A`0P01`0=@0L0DL06P00003oo`0R
0JH0e5d00280^@0eI@008P2i0C4F000R06/0VSX001X000000000806N03X0500j
0201WP1@01@0D00P0Ih0M`0D07L0806N09X0502J0201WP3D01@0e00P0Ih1<@0D
0C406_ooool0000P0Ih0=@6N0DL0805?03D1C`570201000e0@01A`0P0;80=@2b
0DL0801S03D0H`570200500e01@1A`0Jool000000281WP3DG@008P5?03D5000R
0;80>V000280/P4a5P008P1S09Xj000J000000000201UP0j00`0>P0P0IH0D00<
0500806F07L0301g0201UP2J00`0VP0P0IH0e00<0=@0806F0C40304a01[ooooo
0000806F03D1UP570201A`0e0DL1A`0P0?T0=@3i0DL0802Z03D0ZP570200F`0e
05/1A`0P00`0=@0<0DL06P00ool0000R0IH0e7<00281A`1@9`008P2Z03DK000R
05/0Med00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:59 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 432},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0RX00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P07L05`1g0201H02J01L0VP0P
0F00e00G0=@0805P0C405`4a01[ooooo0000805P03D1H05702013P0e0@h1A`0P
0;`0=@2l0DL0801Y03D0J@5702005`0e01L1A`0J00000?oo0281H03DG@008P1Y
09Xj000R01L0=FD002805`4a5P006P000000000P0ET0>P0A03X0805I05004@1@
0201F@1g0140M`0P0ET0VP0A09X0805I0=@04@3D0201F@4a0141<@0Jooooo`00
0201F@0e0ET1A`0P0@L0=@470DL0802e03D0]@570200H`0e06<1A`0P0140=@0A
0DL06_oo0000000R0ET0e5d002811`0e1@008P1S09Xj000R0140>V0002804@4a
5P006P000000000P0E<0>P0:03X0805C05002P1@0201D`1g00X0M`0P0E<0VP0:
09X0805C0=@02P3D0201D`4a00X1<@0Jooooo`000201D`0e0E<1A`0P0@40=@41
0DL0802^03D0[P570200G00e05`1A`0P00X0=@0:0DL06P00ool0000R0E<0e7<0
02810@1@9`008P1L07MM000R00X0=A/00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:28:59 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0NP00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09X04`2J02016P3D01<0e00P
0AX1<@0C0C406_ooool0000P0AX0=@4J0DL0803203D0`P570200JP0e06X1A`0P
01<0=@0C0DL06P00003oo`0R0AX0e5d00280JP0eI@008P1Z0C4F000R01<0VSX0
01X000000000804D03X03P0j0201501@00h0D00P0A@0VP0>09X0804D0=@03P3D
0201504a00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@57
02003P0e00h1A`0Jool000000281503DG@008P1U03YP000R06D1<AH002803P0e
1@008P0>09Xj000J0000000002013`0j00P0>P0P0@l0D0080500804?09X0202J
02013`3D00P0e00P0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h03D0^057
0200H00e0601A`0P00P0=@080DL06P00ool0000R0@l0e7<00280H00e6`008008
0500203D0?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:00 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0PH00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09X05`2J0201H03D01L0e00P
0F01<@0G0C406_ooool0000P0F00=@5P0DL0804>03D13P570200_00e0;`1A`0P
06T0=@1Y0DL0800G03D05`5701X00000ool08P5P0=AM000R0@h0=FD002813P4a
5P008P2l09Xj000J000000000201F@0j0140>P0P0ET0D00A0500805I09X04@2J
0201F@3D0140e00P0ET1<@0A0C406_ooool0000P0ET0=@5I0DL0804703D11`57
0200]@0e0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P5I0=AM000R
0@L0>V0002811`4a5P008P2e03D5000R0;D0VSX001X000000000805C03X02P0j
0201D`1@00X0D00P0E<0VP0:09X0805C0=@02P3D0201D`4a00X1<@0Jooooo`00
0201D`0e0E<1A`0P0@40=@410DL0802^03D0[P570200G00e05`1A`0P00X0=@0:
0DL06P00ool0000R0E<0e7<002810@0e6`00802^0500[P3D0?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:00 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0KH00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09X04`2J02016P4a01<1<@0J
ooooo`0002016P0e0AX1A`0P0<80=@320DL0801Z03D0JP5702004`0e01<1A`0J
00000?oo02816P0eI@008P4J0C4F000P01<0VP0C0C406P000000000P0A@0>P0>
03X0804D05003P1@0201502J00h0VP0P0A@1<@0>0C406_ooool0000P0A@0=@4D
0DL0802m03D0_@570200I@0e06D1A`0P00h0=@0>0DL06_oo0000000R0A@0>V00
0281504a5P008P0>03D5000P00h0VP0>0C406P000000000P0@l0>P0803X0804?
0500201@02013`2J00P0VP0P0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h
03D0^0570200H00e0601A`0P00P0=@080DL06P00ool0000R0@l0=A/00200201@
00P1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:01 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0M@00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09X05`2J0201H04a01L1<@0J
ooooo`000201H00e0F01A`0P0@h0=@4>0DL0802l03D0_0570200J@0e06T1A`0P
01L0=@0G0DL06P00003oo`0R0F00=FD00281H04a5P00802l09X0_04a01X00000
0000805I03X04@0j0201F@1@0140D00P0ET0VP0A09X0805I0C404@4a01[ooooo
0000805I03D1F@5702011`0e0@L1A`0P0;D0=@2e0DL0801S03D0H`5702004@0e
0141A`0Jool000000281F@0jH0008P5I0C4F000R0;D0=@D00200]@2J0;D1<@0J
000000000201D`0j00X0>P0P0E<0D00:0500805C09X02P2J0201D`4a00X1<@0J
ooooo`000201D`0e0E<1A`0P0@40=@410DL0802^03D0[P570200G00e05`1A`0P
00X0=@0:0DL06P00ool0000R0E<0=A/00200[P1@0:h1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:01 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0KH00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09X04`2J02016P4a01<1<@0J
ooooo`0002016P0e0AX1A`0P0<80=@320DL0801Z03D0JP5702004`0e01<1A`0J
00000?oo02816P0eI@008P4J0C4F000P0<80VP320C406P000000000P0A@0>P0>
03X0804D05003P1@0201502J00h0VP0P0A@1<@0>0C406_ooool0000P0A@0=@4D
0DL0802m03D0_@570200I@0e06D1A`0P00h0=@0>0DL06_oo0000000R0A@0>V00
0281504a5P008P2m03D5000P0;d0VP2m0C406P000000000P0@l0>P0803X0804?
0500201@02013`2J00P0VP0P0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h
03D0^0570200H00e0601A`0P00P0=@080DL06P00ool0000R0@l0=A/00200^01@
0;P1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:01 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0OX00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09@05`2D0201H02J01L0VP0P
0F01<@0G0C406_ooool0000P0F00=@5P0DL0804>03D13P570200_00e0;`1A`0P
06T0=@1Y0DL0800G03D05`5701X00000ool08P5P03EU000R0F01<AH002005`2J
01L1<@0J000000000201F@0j0140>P0P0ET0D00A0500805I09@04@2D0201F@2J
0140VP0P0ET1<@0A0C406_ooool0000P0ET0=@5I0DL0804703D11`570200]@0e
0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P5I03YP000R0ET1<AH0
0280H`0e1@00800A09X04@4a01X000000000805C03X02P0j0201D`1@00X0D00P
0E<0U00:09@0805C09X02P2J0201D`4a00X1<@0Jooooo`000201D`0e0E<1A`0P
0@40=@410DL0802^03D0[P570200G00e05`1A`0P00X0=@0:0DL06P00ool0000R
0E<0=A/00280G01@A000800:09@02P570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:02 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0M`00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09@04`2D02016P2J01<0VP0P
0AX1<@0C0C406_ooool0000P0AX0=@4J0DL0803203D0`P570200JP0e06X1A`0P
01<0=@0C0DL06P00003oo`0R0AX0=FD002816P4a5P00801Z09X0JP4a01X00000
0000804D03X03P0j0201501@00h0D00P0A@0U00>09@0804D09X03P2J0201504a
00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@5702003P0e
00h1A`0Jool000000281500jH0008P4D0C4F000R0;d0=@D00200I@2J06D1<@0J
0000000002013`0j00P0>P0P0@l0D0080500804?09@0202D02013`2J00P0VP0P
0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h03D0^0570200H00e0601A`0P
00P0=@080DL06P00ool0000R0@l0=A/00280^01@A000801P09@0H0570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:02 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0Kh00P0_0=X1C`0A0_l<0?ooool0;`000080005?0000fP000000000N00402P02
02l0fP5?0200d`0j00h0>P0P0=<0D00>0500803C09@03P2D0200d`2J00h0VP0P
0=<1<@0>0C406_ooool0000P0=<0=@3C0DL0801a03D0L@5702003P0e00h1A`0J
00000?oo0280d`0eI@008P3C0C4F000P0740VP1a0C406P000000000P0<l0>P0;
03X0803?05002`1@0200c`2D00/0U00P0<l0VP0;09X0803?0C402`4a01[ooooo
0000803?03D0c`570200K@0e06d1A`0P00/0=@0;0DL06_oo0000000R0<l0>V00
0280c`4a5P00801]09X0K@4a02802`0e1@006P000000000P0<`0>P0703X0803<
05001`1@0200c02D00L0U00P0<`0VP0709X0803<0C401`4a01[ooooo0000803<
03D0c0570200J@0e06T1A`0P00L0=@070DL06P00ool0000R0<`0=A/00200J@2D
06T1A`0R00L0D4@00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:03 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 216},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0M`00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09@04`2D02016P2J01<0VP0P
0AX1<@0C0C406_ooool0000P0AX0=@4J0DL0803203D0`P570200JP0e06X1A`0P
01<0=@0C0DL06P00003oo`0R0AX0=FD002816P4a5P00803209X0`P4a01X00000
0000804D03X03P0j0201501@00h0D00P0A@0U00>09@0804D09X03P2J0201504a
00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@5702003P0e
00h1A`0Jool000000281500jH0008P4D0C4F000P0;d0VP2m0C408P1U03D5000J
0000000002013`0j00P0>P0P0@l0D0080500804?09@0202D02013`2J00P0VP0P
0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h03D0^0570200H00e0601A`0P
00P0=@080DL06P00ool0000R0@l0=A/00200^02D0;P1A`0R0600D4@00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:03 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0OX00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P09@05`2D0201H02J01L0VP0P
0F01<@0G0C406_ooool0000P0F00=@5P0DL0804>03D13P570200_00e0;`1A`0P
06T0=@1Y0DL0800G03D05`5701X00000ool08P5P03EU000R0F01<AH002013P2J
0@h1<@0J000000000201F@0j0140>P0P0ET0D00A0500805I09@04@2D0201F@2J
0140VP0P0ET1<@0A0C406_ooool0000P0ET0=@5I0DL0804703D11`570200]@0e
0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P5I03YP000R0ET1<AH0
02011`2J0@L1<@0R0;D0=@D001X000000000805C03X02P0j0201D`1@00X0D00P
0E<0U00:09@0805C09X02P2J0201D`4a00X1<@0Jooooo`000201D`0e0E<1A`0P
0@40=@410DL0802^03D0[P570200G00e05`1A`0P00X0=@0:0DL06P00ool0000R
0E<0=A/002010@2D0@41A`0R0:h0D4@00?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:04 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0M`00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J09@04`2D02016P2J01<0VP0P
0AX1<@0C0C406_ooool0000P0AX0=@4J0DL0803203D0`P570200JP0e06X1A`0P
01<0=@0C0DL06P00003oo`0R0AX0=FD002816P4a5P00800C09X04`4a01X00000
0000804D03X03P0j0201501@00h0D00P0A@0U00>09@0804D09X03P2J0201504a
00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U03D0I@5702003P0e
00h1A`0Jool000000281500jH0008P4D0C4F000R0;d0=@D002003P2J00h1<@0J
0000000002013`0j00P0>P0P0@l0D0080500804?09@0202D02013`2J00P0VP0P
0@l1<@080C406_ooool0000P0@l0=@4?0DL0802h03D0^0570200H00e0601A`0P
00P0=@080DL06P00ool0000R0@l0=A/00280^01@A000800809@020570?l\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:04 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0Ih00P0_0=X1C`0A0_l<0?ooool0;`000080005?0000fP000000000N00402P02
02l0fP5?0200d`0j00h0>P0P0=<0D00>0500803C09@03P2D0200d`2J00h0VP0P
0=<1<@0>0C406_ooool0000P0=<0=@3C0DL0801a03D0L@5702003P0e00h1A`0J
00000?oo02003P0e00h1A`0J000000000200c`0j00/0>P0P0<l0D00;0500803?
09@02`2D0200c`2J00/0VP0P0<l1<@0;0C406_ooool0000P0<l0=@3?0DL0801]
03D0K@5702002`0e00/1A`0Jool000000280c`0e1@00800;03X02`5701X00000
0000803<03X01`0j0200c01@00L0D00P0<`0U00709@0803<09X01`2J0200c04a
00L1<@0Jooooo`000200c00e0<`1A`0P06T0=@1Y0DL0800703D01`5701X00?oo
00008P3<0514000R00L0=A/002001`2D00L1A`3o\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:04 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 216},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0NX00P0_0B81C`0A0_l<0?ooool0;`000080005?00018P000000000N00402P02
02l18P5?02016P0j01<0>P0P0AX0D00C0500804J07h04`1n02016P2D01<0U00P
0AX0VP0C09X0804J0C404`4a01[ooooo0000804J03D16P570200`P0e0<81A`0P
06X0=@1Z0DL0800C03D04`5701X00000ool08P1Z03E9000P01<0OP0C0DL06P00
0000000P0A@0>P0>03X0804D05003P1@0201501n00h0OP0P0A@0U00>09@0804D
09X03P2J0201504a00h1<@0Jooooo`000201500e0A@1A`0P0;d0=@2m0DL0801U
03D0I@5702003P0e00h1A`0Jool000000281500e1@008P1U03Y4000P00h0OP0>
0DL06P000000000P0@l0>P0803X0804?0500201@02013`1n00P0OP0P0@l0U008
09@0804?09X0202J02013`4a00P1<@0Jooooo`0002013`0e0@l1A`0P0;P0=@2h
0DL0801P03D0H0570200200e00P1A`0J003oo`0002813`1@A0008P1P03DK000P
00P0U0080DL0o`\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:05 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->0,
  AnimationCycleRepetitions->0],

Cell[GraphicsData["PICT", "\<\
0PP00P0_0FX1C`0A0_l<0?ooool0;`000080005?0001JP000000000N00402P02
02l1JP5?0201H00j01L0>P0P0F00D00G0500805P07h05`1n0201H02D01L0U00P
0F00VP0G09X0805P0C405`4a01[ooooo0000805P03D1H05702013P0e0@h1A`0P
0;`0=@2l0DL0801Y03D0J@5702005`0e01L1A`0J00000?oo02813P0eB@00802l
07h0_05701X000000000805I03X04@0j0201F@1@0140D00P0ET0OP0A07h0805I
09@04@2D0201F@2J0140VP0P0ET1<@0A0C406_ooool0000P0ET0=@5I0DL08047
03D11`570200]@0e0;D1A`0P06<0=@1S0DL0800A03D04@5701[oo`0000008P47
03Y4000P0;D0OP2e0DL08P1S03D5000J000000000201D`0j00X0>P0P0E<0D00:
0500805C07h02P1n0201D`2D00X0U00P0E<0VP0:09X0805C0C402P4a01[ooooo
0000805C03D1D`5702010@0e0@41A`0P0:h0=@2^0DL0801L03D0G05702002P0e
00X1A`0J003oo`0002810@0e6`00802^09@0[P570280G01@A000o`\>"], "Graphics",
  CellLabel->"From In[75]:=  (19:29:05 on 5/12/02)",
  Evaluatable->False,
  ImageSize->{288, 360},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  AnimationCycleOffset->-30,
  AnimationCycleRepetitions->Infinity]
}, Closed]]
}, Open  ]],

Cell["\<\
By animating the set (double-click on it), one can see how \
recombination and coalescence changes the pattern of ancestry.  At each \
stage, the three complete leaf genomes are spread over varying numbers of \
ancestral genomes.  Eventually, there will be one common ancestor to all \
three leaves, over the whole genome; after that, they will have identical \
ancestry.  However, that has not happened by the end of this simulation (at \
t=1.807).\
\>", "Text"]
}, Closed]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{520, 626},
WindowMargins->{{137, Automatic}, {Automatic, 41}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "PlotSegments"->{
    Cell[1783, 53, 813, 18, 50, "DefinitionBox",
      CellTags->"PlotSegments"]},
  "SegmentStyle"->{
    Cell[6065, 160, 594, 13, 74, "DefinitionBox",
      CellTags->{"SegmentStyle", "BackgroundStyle", "JunctionStyle"}]},
  "BackgroundStyle"->{
    Cell[6065, 160, 594, 13, 74, "DefinitionBox",
      CellTags->{"SegmentStyle", "BackgroundStyle", "JunctionStyle"}]},
  "JunctionStyle"->{
    Cell[6065, 160, 594, 13, 74, "DefinitionBox",
      CellTags->{"SegmentStyle", "BackgroundStyle", "JunctionStyle"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"PlotSegments", 55731, 1225},
  {"SegmentStyle", 55834, 1228},
  {"BackgroundStyle", 55979, 1231},
  {"JunctionStyle", 56122, 1234}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 41, 0, 24, "SubsubsectionIcon"],
Cell[1783, 53, 813, 18, 50, "DefinitionBox",
  CellTags->"PlotSegments"],
Cell[2599, 73, 388, 12, 44, "MathCaption"],

Cell[CellGroupData[{
Cell[3012, 89, 119, 2, 27, "Input"],
Cell[3134, 93, 1514, 25, 184, 1339, 20, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[4663, 121, 279, 6, 36, "Text"],
Cell[4945, 129, 74, 0, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[5044, 133, 190, 4, 27, "Input"],
Cell[5237, 139, 519, 10, 184, 348, 5, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[5771, 152, 291, 6, 38, "Text"],
Cell[6065, 160, 594, 13, 74, "DefinitionBox",
  CellTags->{"SegmentStyle", "BackgroundStyle", "JunctionStyle"}],
Cell[6662, 175, 111, 3, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[6798, 182, 120, 2, 27, "Input"],
Cell[6921, 186, 10052, 205, 488, "Output"]
}, Closed]],
Cell[16988, 394, 70, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[17083, 398, 271, 5, 42, "Input"],
Cell[17357, 405, 3865, 62, 420, 3694, 57, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[21237, 470, 283, 6, 36, "Text"],
Cell[21523, 478, 151, 5, 24, "Text"],
Cell[21677, 485, 82, 1, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[21784, 490, 154, 3, 27, "Input"],
Cell[21941, 495, 2076, 44, 46, "Output"]
}, Closed]],
Cell[24032, 542, 54, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[24111, 546, 278, 5, 57, "Input"],
Cell[24392, 553, 923, 16, 184, 752, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False]
}, Open  ]],
Cell[25330, 572, 197, 4, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[25552, 580, 630, 12, 87, "Input"],

Cell[CellGroupData[{
Cell[26207, 596, 584, 12, 222, 351, 5, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[26794, 610, 691, 14, 294, 465, 7, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[27488, 626, 650, 13, 222, 424, 6, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[28141, 641, 743, 15, 294, 517, 8, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[28887, 658, 845, 16, 366, 619, 9, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[29735, 676, 886, 17, 438, 660, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[30624, 695, 988, 18, 510, 762, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[31615, 715, 948, 18, 438, 722, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[32566, 735, 907, 17, 366, 681, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[33476, 754, 867, 17, 294, 641, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[34346, 773, 975, 18, 366, 749, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[35324, 793, 935, 18, 294, 709, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[36262, 813, 1024, 19, 366, 798, 12, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[37289, 834, 1065, 20, 438, 839, 13, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[38357, 856, 1024, 19, 366, 798, 12, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[39384, 877, 1065, 20, 438, 839, 13, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[40452, 899, 1024, 19, 366, 798, 12, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[41479, 920, 935, 18, 294, 709, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[42417, 940, 975, 18, 366, 749, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[43395, 960, 867, 17, 294, 641, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[44265, 979, 907, 17, 366, 681, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[45175, 998, 867, 17, 294, 641, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[46045, 1017, 959, 18, 366, 733, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[47007, 1037, 918, 17, 294, 692, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[47928, 1056, 878, 17, 222, 652, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[48809, 1075, 918, 17, 294, 692, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[49730, 1094, 959, 18, 366, 733, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[50692, 1114, 918, 17, 294, 692, 10, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[51613, 1133, 834, 16, 222, 608, 9, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[52450, 1151, 938, 18, 294, 712, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False],
Cell[53391, 1171, 987, 18, 366, 752, 11, "GraphicsData", "PICT", "Graphics",
  Evaluatable->False]
}, Closed]]
}, Open  ]],
Cell[54405, 1193, 473, 8, 64, "Text"]
}, Closed]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

