(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    220258,       6254]*)
(*NotebookOutlinePosition[    222392,       6316]*)
(*  CellTagsIndexPosition[    222069,       6303]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Plotting genealogies", "SubsectionIcon"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(PlotGenealogy[
              g]\), \(\(plots\)\(\ \)\(a\)\(\ \)\(\(genealogy\)\(.\)\)\(\ \
\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"PlotGenealogy"],

Cell["\<\
PlotGenealogy[] generates a Graphics[] object depicting the \
genealogy, and labelling its nodes.  \
\>", "Text"],

Cell["This can be displayed using Show[]:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotGenealogy[tr]]; \)\)], "Input",
  CellLabel->"In[147]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .20601 m
.11111 .10301 L
s
.16667 .20601 m
.22222 .10301 L
s
.38889 .20601 m
.33333 .10301 L
s
.38889 .20601 m
.44444 .10301 L
s
.66667 .20601 m
.55556 .10301 L
s
.66667 .20601 m
.66667 .10301 L
s
.66667 .20601 m
.77778 .10301 L
s
.72222 .30902 m
.66667 .20601 L
s
.72222 .30902 m
.88889 .10301 L
s
.61111 .41202 m
.38889 .20601 L
s
.61111 .41202 m
.72222 .30902 L
s
.5 .51503 m
.16667 .20601 L
s
.5 .51503 m
.61111 .41202 L
s
gsave
.14444 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.36667 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.64444 .22661 -90.5625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
112.125000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.7 .32962 -98.3438 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
112.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
127.687500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.58889 .43262 -113.906 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
143.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
158.812500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.47778 .53563 -129.469 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
162.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
174.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
183.937500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
189.937500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -75 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[147]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0AOol01000Oomoogoo0`00
0goo0`000Woo00<007ooOol047oo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08
Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0B
Ool00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08
Ool00`00Oomoo`0?Ool00`00Oomoo`05Ool00`00Oomoo`03Ool01000Oomoo`0047oo00<007ooOol0
27oo00<007ooOol06Woo000JOol01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@0
00=oo`03001oogoo015oo`03001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D0
0003Ool007oo01=oo`03001oogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool0
0`00Oomoo`0?Ool00`00Oomoo`02Ool40002Ool40002Ool00`00Oomoo`0>Ool01000Oomoogoo0P00
00=oo`0000000Woo00<007ooOol06Woo000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Ao
o`05001oogooOol00003Ool01000Oomoo`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol0
1@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00
Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool01@00Oomoogoo00000goo00<007oo00000goo
00@007ooOol0011oo`05001oogooOol00002Ool01@00Oomoogoo000077oo000IOol00`00Oomoo`02
Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol03goo
00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo00<007ooOol00Woo00D007ooOomoo`00
00=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03001oogoo011oo`03001oogoo00=oo`03
001oogoo00Aoo`03001oogoo00eoo`03001oogoo009oo`07001oogooOol007oo00000goo00D007oo
Oomoo`0000ioo`03001oogoo009oo`04001oogoo0004Ool00`00Oomoo`0IOol001Yoo`03001oogoo
00Aoo`05001oogooOol0000DOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol0
0003Ool01000Oomoo`0057oo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo0000
0goo00@007ooOol001Aoo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00moo`05001oogoo
Ool00003Ool00`00Ool00003Ool01000Oomoo`0047oo00D007ooOomoo`00009oo`05001oogooOol0
000LOol001Yoo`03001oogoo009oo`<000=oo`03001oogoo019oo`04001oogooOol40003Ool00`00
Oomoo`0AOol00`00Oomoo`02Ool40002Ool00`00Oomoo`0BOol00`00Oomoo`02Ool40002Ool00`00
Oomoo`0BOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo00<007oo
Ool03goo00<007ooOol00Woo1@0000=oo`0000000`0000=oo`00Ool03goo00@007ooOomoo`@000=o
o`03001oogoo01Yoo`006goo00<007ooOol01Woo00<007ooOol057oo00@007ooOol000Eoo`03001o
ogoo01=oo`03001oogoo00Ioo`03001oogoo01Aoo`03001oogoo00Aoo`03001oo`0001Ioo`03001o
ogoo00Ioo`03001oogoo01Aoo`05001oogooOol00004Ool00`00Oomoo`0AOol00`00Oomoo`0<Ool0
0`00Oomoo`0@Ool01000Oomoo`001Goo00<007ooOol06goo000mOol20011Ool2000lOol3000jOol2
000SOol00?moob5oo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007oo
Ool07Goo0P007Woo00<007ooOol077oo0P007Woo00<007ooOol07goo000POol00`00Oomoo`0LOol0
0`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0OOol00`00Oomoo`0KOol00`00Oomoo`0KOol0
0`00Oomoo`0NOol00`00Oomoo`0OOol0025oo`03001oogoo01Yoo`03001oogoo01moo`03001oogoo
01]oo`03001oogoo025oo`03001oogoo01Yoo`03001oogoo01Yoo`03001oogoo01ioo`03001oogoo
021oo`008Goo00<007ooOol06Woo00<007ooOol07goo00<007ooOol06goo00<007ooOol08Woo00<0
07ooOol06Goo00<007ooOol06Goo00<007ooOol07Woo00<007ooOol08Goo000ROol00`00Oomoo`0H
Ool00`00Oomoo`0QOol00`00Oomoo`0IOol00`00Oomoo`0TOol00`00Oomoo`0HOol00`00Oomoo`0H
Ool00`00Oomoo`0NOol00`00Oomoo`0ROol0029oo`03001oogoo01Qoo`03001oogoo025oo`03001o
ogoo01Uoo`03001oogoo02Eoo`03001oogoo01Moo`03001oogoo01Moo`03001oogoo01ioo`03001o
ogoo02=oo`008goo00<007ooOol05Woo00<007ooOol08goo00<007ooOol05goo00<007ooOol09goo
00<007ooOol05Woo00<007ooOol05Woo00<007ooOol07goo00<007ooOol08goo000SOol00`00Oomo
o`0FOol00`00Oomoo`0SOol00`00Oomoo`0GOol00`00Oomoo`0XOol00`00Oomoo`0EOol00`00Oomo
o`0EOol00`00Oomoo`0OOol00`00Oomoo`0TOol002Aoo`03001oogoo01Aoo`03001oogoo02Eoo`03
001oogoo01Eoo`03001oogoo02Yoo`03001oogoo01Aoo`03001oogoo01Aoo`03001oogoo01moo`03
001oogoo02Eoo`009Goo00<007ooOol04goo00<007ooOol09Woo00<007ooOol04goo00<007ooOol0
;7oo00<007ooOol04goo00<007ooOol04goo00<007ooOol07goo00<007ooOol09Woo000UOol00`00
Oomoo`0BOol00`00Oomoo`0WOol00`00Oomoo`0COol00`00Oomoo`0]Ool00`00Oomoo`0BOol00`00
Oomoo`0BOol00`00Oomoo`0OOol00`00Oomoo`0WOol002Ioo`03001oogoo015oo`03001oogoo02Qo
o`03001oogoo015oo`03001oogoo02moo`03001oogoo015oo`03001oogoo015oo`03001oogoo021o
o`03001oogoo02Moo`009Woo00<007ooOol047oo00<007ooOol0:Goo00<007ooOol04Goo00<007oo
Ool0<7oo00<007ooOol047oo00<007ooOol047oo00<007ooOol087oo00<007ooOol0:7oo000WOol0
0`00Oomoo`0?Ool00`00Oomoo`0ZOol00`00Oomoo`0?Ool00`00Oomoo`0bOol00`00Oomoo`0?Ool0
0`00Oomoo`0?Ool00`00Oomoo`0POol00`00Oomoo`0YOol002Moo`03001oogoo00ioo`03001oogoo
02]oo`03001oogoo00moo`03001oogoo03=oo`03001oogoo00ioo`03001oogoo00ioo`03001oogoo
021oo`03001oogoo02Yoo`00:7oo00<007ooOol03Goo00<007ooOol0;7oo00<007ooOol03Goo00<0
07ooOol0=Goo0P003Woo00<007ooOol037oo0P008Woo00<007ooOol0:goo000XOol00`00Oomoo`0<
Ool00`00Oomoo`0]Ool00`00Oomoo`0=Ool00`00Oomoo`0gOol00`00Oomoo`0;Ool00`00Oomoo`0;
Ool00`00Oomoo`0ROol00`00Oomoo`0[Ool002Uoo`03001oogoo00]oo`03001oogoo02ioo`03001o
ogoo00]oo`03001oogoo03Uoo`03001oogoo00Yoo`03001oogoo00Yoo`03001oogoo029oo`03001o
ogoo02aoo`00:Goo00<007ooOol02Woo00<007ooOol0;goo00<007ooOol02goo00<007ooOol0>Woo
00<007ooOol02Goo00<007ooOol02Goo00<007ooOol08Woo00<007ooOol0;Goo000ZOol00`00Oomo
o`09Ool00`00Oomoo`0`Ool00`00Oomoo`09Ool00`00Oomoo`0lOol00`00Oomoo`08Ool00`00Oomo
o`08Ool00`00Oomoo`0ROol00`00Oomoo`0^Ool002Yoo`03001oogoo00Qoo`03001oogoo035oo`03
001oogoo00Uoo`03001oogoo03eoo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo029oo`03
001oogoo02moo`00:goo00<007ooOol01goo00<007ooOol0<Woo00<007ooOol01goo00<007ooOol0
?goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol08goo00<007ooOol0;goo000[Ool00`00
Oomoo`06Ool00`00Oomoo`0cOol00`00Oomoo`07Ool00`00Oomoo`10Ool00`00Oomoo`05Ool00`00
Oomoo`05Ool00`00Oomoo`0SOol00`00Oomoo`0`Ool002aoo`03001oogoo00Eoo`03001oogoo03Ao
o`03001oogoo00Eoo`03001oogoo049oo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo02=o
o`03001oogoo035oo`00;Goo00<007ooOol00goo00<007ooOol0=Woo00<007ooOol00goo00<007oo
Ool0A7oo00<007ooOol00goo00<007ooOol00goo00<007ooOol08goo00<007ooOol0<Woo000]Ool0
0`00Oomoo`03Ool00`00Oomoo`0fOol00`00Oomoo`03Ool00`00Oomoo`15Ool00`00Oomoo`02Ool0
0`00Oomoo`02Ool00`00Oomoo`0SOol00`00Oomoo`0cOol002ioo`05001oogooOol0000jOol01@00
Oomoogoo0000BGoo00D007ooOomoo`0000=oo`03001oogoo02Aoo`03001oogoo03=oo`00;Woo00D0
07ooOomoo`0003Yoo`05001oogooOol0001:Ool01000Oomoo`000Woo00<007ooOol097oo00<007oo
Ool0=7oo000_Ool00`00Ool0000lOol00`00Ool0001<Ool01@00Ool007oo00009Woo00<007ooOol0
=Goo000_Ool00`00Ool0000lOol00`00Ool0001=Ool3000VOol00`00Oomoo`0fOol0031oo`8003eo
o`8004ioo`03001oogoo02Aoo`03001oogoo03Moo`0077oo00<007ooOol04goo00@007ooOol002Io
o`03001oogoo019oo`05001oogooOol0000[Ool00`00Oomoo`0KOol00`00Oomoo`02Ool30003Ool3
0002Ool00`00Oomoo`0DOol00`00Oomoo`0gOol001]oo`03001oogoo00Qoo`03001oogoo00Yoo`04
001oogoo000TOol00`00Oomoo`08Ool00`00Oomoo`09Ool01@00Oomoogoo0000:Goo00<007ooOol0
27oo00<007ooOol037oo00<007ooOol00goo00<007ooOol017oo00<007ooOol00goo00@007ooOol0
01Aoo`03001oogoo03Qoo`006goo00@007ooOomoo`D0009oo`03001oogoo00Ioo`@00004Ool007oo
000TOol00`00Oomoo`02Ool30003Ool00`00Oomoo`07Ool500000goo001oo`0XOol00`00Oomoo`02
Ool40002Ool00`00Oomoo`05Ool40003Ool00`00Oomoo`03Ool01000Oomoogoo10000Woo10000Woo
00<007ooOol04Goo00<007ooOol0>Goo000KOol01@00Oomoogoo00000Woo00<007ooOol00Woo00<0
07ooOol01Goo00H007ooOomoo`00Ool2000TOol01@00Oomoogoo00000goo00D007ooOomoo`0000Mo
o`04001oogooOol200000goo001oo`0XOol01@00Oomoogoo00001goo00<007ooOol01Goo00<007oo
Ool017oo00<007ooOol00goo00<007oo00000goo00<007oo00000goo00@007ooOol0019oo`03001o
ogoo03Yoo`006Woo00<007ooOol00Woo100037oo00D007ooOomoo`00009oo`80029oo`03001oogoo
009oo`03001oogoo00eoo`09001oogooOol007oo001oo`0002Moo`03001oogoo009oo`D000]oo`03
001oogoo00Yoo`03001oo`0000=oo`03001oo`0000=oo`05001oogooOol0000AOol00`00Oomoo`0j
Ool001]oo`03001oogoo00Aoo`03001oogoo00Yoo`05001oogooOol00002Ool2000SOol01@00Oomo
ogoo00000goo00<007ooOol02Goo00D007ooOomoo`00009oo`03001oogoo02Moo`05001oogooOol0
0003Ool00`00Oomoo`09Ool00`00Oomoo`0;Ool20003Ool00`00Ool00003Ool01000Oomoo`004Goo
00<007ooOol0>goo000KOol00`00Oomoo`02Ool3000<Ool40003Ool00`00Ool0000ROol00`00Oomo
o`02Ool4000<Ool40002Ool2000XOol00`00Oomoo`02Ool3000;Ool4000<Ool600000goo00000003
00000goo001oo`0?Ool00`00Oomoo`0lOol001aoo`03001oogoo011oo`03001oogoo00=oo`05001o
ogooOol0000ROol00`00Oomoo`0DOol00`00Ool00002Ool00`00Oomoo`0VOol00`00Oomoo`0@Ool0
0`00Oomoo`0<Ool00`00Oomoo`09Ool00`00Oomoo`0>Ool00`00Oomoo`0mOol002ioo`8000Yoo`03
001oogoo03Eoo`8000Eoo`03001oogoo03Qoo`<000eoo`03001oogoo01Qoo`03001oogoo03ioo`00
>goo00<007ooOol0?7oo00<007ooOol0Agoo00<007ooOol067oo00<007ooOol0?Woo000lOol00`00
Oomoo`0lOol00`00Oomoo`17Ool00`00Oomoo`0FOol00`00Oomoo`0oOol003eoo`03001oogoo03ao
o`8004Moo`03001oogoo01Eoo`03001oogoo041oo`00?Woo0P00?Woo00<007ooOol0AGoo00<007oo
Ool04goo00<007ooOol0@Goo0010Ool00`00Oomoo`0lOol00`00Oomoo`14Ool00`00Oomoo`0BOol0
0`00Oomoo`12Ool0045oo`03001oogoo03aoo`03001oogoo04Aoo`03001oogoo015oo`03001oogoo
049oo`00@Woo00<007ooOol0?7oo00<007ooOol0A7oo00<007ooOol03goo00<007ooOol0@goo0013
Ool00`00Oomoo`0lOol00`00Oomoo`13Ool00`00Oomoo`0>Ool00`00Oomoo`14Ool004Aoo`03001o
ogoo03aoo`03001oogoo04=oo`03001oogoo00aoo`03001oogoo04Eoo`00AGoo00<007ooOol0?7oo
00<007ooOol0@Woo00<007ooOol02goo00<007ooOol0AWoo0016Ool00`00Oomoo`0lOol00`00Oomo
o`12Ool00`00Oomoo`0:Ool00`00Oomoo`16Ool004Moo`03001oogoo03aoo`03001oogoo045oo`03
001oogoo00Uoo`03001oogoo04Moo`00B7oo00<007ooOol0?7oo00<007ooOol0@Goo00<007ooOol0
1goo00<007ooOol0B7oo0019Ool00`00Oomoo`0lOol00`00Oomoo`10Ool00`00Oomoo`06Ool00`00
Oomoo`19Ool004Yoo`03001oogoo03aoo`80045oo`03001oogoo00Aoo`03001oogoo04Yoo`00Bgoo
0P00?Woo00<007ooOol0?goo00<007ooOol00goo00<007ooOol0BWoo001=Ool00`00Oomoo`0lOol0
0`00Oomoo`0nOol00`00Oomoo`02Ool00`00Oomoo`1;Ool004ioo`03001oogoo03aoo`03001oogoo
03ioo`04001oogoo001>Ool004moo`03001oogoo03aoo`03001oogoo03eoo`03001oo`0004moo`00
D7oo00<007ooOol0?7oo00<007ooOol0?7oo0P00D7oo001AOol00`00Oomoo`0lOol00`00Oomoo`0j
Ool00`00Oomoo`1@Ool0059oo`03001oogoo03aoo`03001oogoo01Eoo`03001oogoo021oo`<000=o
o`<0019oo`03001oogoo03Ioo`00Dgoo00<007ooOol0?7oo00<007ooOol04goo00<007ooOol027oo
00<007ooOol037oo00<007ooOol01Woo00D007ooOomoo`0000Eoo`04001oogoo000?Ool00`00Oomo
o`0eOol005Aoo`03001oogoo03aoo`03001oogoo019oo`03001oogoo009oo`@0009oo`03001oogoo
00Eoo`@000=oo`03001oogoo00Eoo`03001oo`0000<0009oo`@0009oo`03001oogoo00Ioo`800003
Ool00000009oo`03001oogoo03Eoo`00EGoo00<007ooOol0?7oo00<007ooOol04Goo00D007ooOomo
o`0000Moo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00=oo`03001oo`0000=oo`03001o
o`0000=oo`05001oogooOol00007Ool01000Oomoo`000goo00<007ooOol0=Goo001FOol00`00Oomo
o`0lOol2000@Ool00`00Oomoo`02Ool5000;Ool00`00Oomoo`09Ool01000Oomoo`000goo00<007oo
00000goo00<007ooOol02Goo00@007ooOol000Aoo`03001oogoo03Aoo`00Egoo00<007ooOol0?Goo
00<007ooOol03Woo00D007ooOomoo`0000=oo`03001oogoo00Uoo`03001oogoo00Qoo`05001oogoo
Ool00003Ool00`00Ool00003Ool00`00Oomoo`09Ool01000Oomoo`000goo00<007ooOol0=Goo001H
Ool00`00Oomoo`0mOol00`00Oomoo`0=Ool00`00Oomoo`02Ool3000;Ool40007Ool00`00Oomoo`03
Ool500000goo00000003000:Ool40003Ool00`00Oomoo`0eOol005Uoo`8003ioo`03001oogoo00eo
o`03001oogoo011oo`03001oogoo00Ioo`03001oogoo01Uoo`03001oogoo00=oo`03001oogoo03Io
o`00Fgoo00<007ooOol0?7oo00<007ooOol07goo0`001Goo00<007ooOol06Goo0P00?Woo001LOol0
0`00Oomoo`0lOol00`00Oomoo`0UOol00`00Oomoo`1JOol005eoo`03001oogoo03aoo`03001oogoo
02=oo`03001oogoo05]oo`00GWoo00<007ooOol0?7oo00<007ooOol08Goo00<007ooOol0G7oo001O
Ool00`00Oomoo`0lOol00`00Oomoo`0OOol00`00Oomoo`1MOol0061oo`03001oogoo03aoo`03001o
ogoo01aoo`80061oo`00HGoo00<007ooOol0?7oo00<007ooOol06Woo00<007ooOol0H7oo001ROol0
0`00Oomoo`0lOol00`00Oomoo`0HOol00`00Oomoo`1QOol006=oo`03001oogoo03aoo`8001Moo`03
001oogoo069oo`00I7oo00<007ooOol0?Goo00<007ooOol04goo00<007ooOol0Hgoo001UOol00`00
Oomoo`0mOol00`00Oomoo`0AOol00`00Oomoo`1TOol006Ioo`8003ioo`03001oogoo00moo`03001o
ogoo06Eoo`00J7oo00<007ooOol0?7oo00<007ooOol03Goo00<007ooOol0IWoo001YOol00`00Oomo
o`0lOol00`00Oomoo`0;Ool00`00Oomoo`1WOol006Yoo`03001oogoo03aoo`03001oogoo00Uoo`03
001oogoo06Qoo`00Jgoo00<007ooOol0?7oo00<007ooOol01goo00<007ooOol0JGoo001/Ool00`00
Oomoo`0lOol00`00Oomoo`05Ool00`00Oomoo`1ZOol006eoo`03001oogoo03aoo`03001oogoo00=o
o`03001oogoo06]oo`00KWoo00<007ooOol0?7oo00D007ooOomoo`0006ioo`00Kgoo00<007ooOol0
?7oo00<007oo0000Kgoo001`Ool00`00Oomoo`0kOol2001`Ool0075oo`03001oogoo00Ioo`03001o
ogoo031oo`03001oogoo00aoo`<000=oo`<0015oo`03001oogoo04Moo`00LWoo00<007ooOol017oo
00<007ooOol027oo00<007ooOol037oo00<007ooOol03Goo00<007ooOol01Woo00<007ooOol00goo
00<007ooOol02Woo00<007ooOol00goo00@007ooOol000ioo`03001oogoo04Ioo`00Lgoo00<007oo
Ool00goo00<007ooOol00Woo0`000goo00<007ooOol01Woo1@0000=oo`00Ool027oo10000Woo00<0
07ooOol01Goo10000goo00<007ooOol01goo10000Woo10000Woo00<007ooOol01Goo0P0000=oo`00
00000Woo00<007ooOol0AWoo001dOol20003Ool01@00Oomoogoo00000goo00D007ooOomoo`0000Io
o`05001oogooOol00003Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Ool0
0006Ool00`00Oomoo`05Ool01`00Oomoogoo001oo`0000=oo`05001oogooOol00006Ool01000Oomo
o`000goo00<007ooOol0AWoo001fOol00`00Ool00004Ool00`00Oomoo`0<Ool01@00Oomoogoo0000
2goo1@0027oo00@007ooOol000ioo`07001oogooOol007oo00000goo00<007ooOol027oo00@007oo
Ool000Aoo`03001oogoo04Eoo`00Mgoo00<007oo00000goo00D007ooOomoo`0000Yoo`05001oogoo
Ool0000;Ool01@00Oomoogoo00001goo00D007ooOomoo`0000ioo`07001oogooOol007oo00000goo
00<007ooOol027oo00@007ooOol000=oo`03001oogoo04Ioo`00N7oo0P0017oo10002goo100037oo
0`001goo00@007ooOomoo`@000eoo`D00003Ool0000000<000Uoo`@000=oo`03001oogoo04Ioo`00
NGoo0P005Goo00<007ooOol04goo00<007ooOol00goo00<007ooOol08Goo00<007ooOol00goo00<0
07ooOol0Agoo001jOol00`00Oomoo`0BOol2000DOol00`00Oomoo`04Ool3000POol2001?Ool007]o
o`03001oogoo02Eoo`8007]oo`00O7oo00<007ooOol08goo00<007ooOol0Ngoo001mOol00`00Oomo
o`0QOol00`00Oomoo`1lOol007ioo`03001oogoo01moo`03001oogoo07eoo`00Ogoo00<007ooOol0
7Goo00<007ooOol0OWoo0020Ool00`00Oomoo`0KOol00`00Oomoo`1oOol0085oo`8001Yoo`03001o
ogoo081oo`00Pgoo00<007ooOol05Woo00<007ooOol0PGoo0024Ool00`00Oomoo`0DOol00`00Oomo
o`22Ool008Eoo`03001oogoo015oo`8008Eoo`00QWoo00<007ooOol03goo00<007ooOol0QGoo0027
Ool00`00Oomoo`0=Ool00`00Oomoo`26Ool008Qoo`03001oogoo00]oo`03001oogoo08Moo`00RGoo
00<007ooOol02Goo00<007ooOol0R7oo002:Ool00`00Oomoo`07Ool00`00Oomoo`29Ool008]oo`03
001oogoo00Eoo`03001oogoo08Yoo`00S7oo00<007ooOol00goo00<007ooOol0Rgoo002=Ool01@00
Oomoogoo0000SWoo002>Ool00`00Ool0002?Ool008moo`03001oogoo08ioo`00ogoo8Goo001:Ool0
0`00Oomoo`1OOol30003Ool3000AOol00`00Oomoo`1GOol004Uoo`03001oogoo00Qoo`03001oogoo
00eoo`03001oogoo00aoo`03001oogoo00eoo`03001oogoo00aoo`03001oogoo00eoo`03001oogoo
00Yoo`03001oogoo00=oo`04001oogoo000>Ool00`00Oomoo`1FOol004Uoo`04001oogooOol50002
Ool00`00Oomoo`06Ool40003Ool00`00Oomoo`06Ool30003Ool00`00Oomoo`07Ool500000goo001o
o`07Ool40002Ool00`00Oomoo`06Ool40003Ool00`00Oomoo`07Ool40002Ool40002Ool00`00Oomo
o`05Ool200000goo00000002Ool00`00Oomoo`1FOol004Uoo`05001oogooOol00002Ool00`00Oomo
o`02Ool00`00Oomoo`05Ool01@00Oomoogoo00000goo00<007ooOol017oo00D007ooOomoo`0000=o
o`03001oogoo00Eoo`05001oogooOol00003Ool00`00Oomoo`04Ool00`00Oomoo`05Ool00`00Oomo
o`06Ool00`00Oomoo`04Ool00`00Oomoo`05Ool01`00Oomoogoo001oo`0000=oo`05001oogooOol0
0006Ool01000Oomoo`000goo00<007ooOol0EWoo0018Ool00`00Oomoo`02Ool4000<Ool01@00Oomo
ogoo00002Woo00<007ooOol03Goo00D007ooOomoo`0000Yoo`D000aoo`03001oogoo00aoo`07001o
ogooOol007oo00000goo00<007ooOol027oo00@007ooOol000Aoo`03001oogoo05Eoo`00BGoo00<0
07ooOol017oo00<007ooOol02Woo00D007ooOomoo`0000Yoo`05001oogooOol0000;Ool01@00Oomo
ogoo00002Woo00D007ooOomoo`0000aoo`03001oogoo00aoo`07001oogooOol007oo00000goo00<0
07ooOol027oo00@007ooOol000=oo`03001oogoo05Ioo`00BGoo00<007ooOol00Woo0`0037oo1000
37oo100037oo10002goo0`0037oo10003Goo1@0000=oo`0000000`002Goo10000goo00<007ooOol0
EWoo001:Ool00`00Oomoo`0@Ool00`00Oomoo`0POol00`00Oomoo`0IOol00`00Oomoo`0QOol00`00
Oomoo`03Ool00`00Oomoo`1GOol005aoo`80025oo`8001]oo`<0021oo`8005moo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5o
o`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(\(\ \)\(PlotGenealogy[g, 
              NodeLabels \[Rule] 
                None]\)\), \(suppresses\ the\ labelling\ of\ internal\ \
\(\(nodes\)\(.\)\)\)},
          {\(\(\ \)\(PlotGenealogy[g, 
              LeafLabels \[Rule] 
                None]\)\), \(suppresses\ the\ labelling\ of\ \
\(\(leaves\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->{"NodeLabels", "LeafLabels"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
      PlotGenealogy[tr, LeafLabels \[Rule] None, NodeLabels \[Rule] None]]; 
    \)\)], "Input",
  CellLabel->"In[148]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .20601 m
.11111 .10301 L
s
.16667 .20601 m
.22222 .10301 L
s
.38889 .20601 m
.33333 .10301 L
s
.38889 .20601 m
.44444 .10301 L
s
.66667 .20601 m
.55556 .10301 L
s
.66667 .20601 m
.66667 .10301 L
s
.66667 .20601 m
.77778 .10301 L
s
.72222 .30902 m
.66667 .20601 L
s
.72222 .30902 m
.88889 .10301 L
s
.61111 .41202 m
.38889 .20601 L
s
.61111 .41202 m
.72222 .30902 L
s
.5 .51503 m
.16667 .20601 L
s
.5 .51503 m
.61111 .41202 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[148]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0021oo`03001oogoo01aoo`03001o
ogoo01eoo`03001oogoo01eoo`03001oogoo01eoo`8001ioo`03001oogoo01aoo`8001ioo`03001o
ogoo01moo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007ooOol07goo
00<007ooOol06goo00<007ooOol06goo00<007ooOol07Woo00<007ooOol07goo000QOol00`00Oomo
o`0JOol00`00Oomoo`0OOol00`00Oomoo`0KOol00`00Oomoo`0QOol00`00Oomoo`0JOol00`00Oomo
o`0JOol00`00Oomoo`0NOol00`00Oomoo`0POol0025oo`03001oogoo01Yoo`03001oogoo01moo`03
001oogoo01]oo`03001oogoo029oo`03001oogoo01Uoo`03001oogoo01Uoo`03001oogoo01ioo`03
001oogoo025oo`008Woo00<007ooOol067oo00<007ooOol08Goo00<007ooOol06Goo00<007ooOol0
97oo00<007ooOol067oo00<007ooOol067oo00<007ooOol07Woo00<007ooOol08Woo000ROol00`00
Oomoo`0HOol00`00Oomoo`0QOol00`00Oomoo`0IOol00`00Oomoo`0UOol00`00Oomoo`0GOol00`00
Oomoo`0GOol00`00Oomoo`0NOol00`00Oomoo`0SOol002=oo`03001oogoo01Ioo`03001oogoo02=o
o`03001oogoo01Moo`03001oogoo02Moo`03001oogoo01Ioo`03001oogoo01Ioo`03001oogoo01mo
o`03001oogoo02=oo`008goo00<007ooOol05Woo00<007ooOol08goo00<007ooOol05goo00<007oo
Ool0:7oo00<007ooOol05Goo00<007ooOol05Goo00<007ooOol07goo00<007ooOol097oo000TOol0
0`00Oomoo`0DOol00`00Oomoo`0UOol00`00Oomoo`0EOol00`00Oomoo`0ZOol00`00Oomoo`0DOol0
0`00Oomoo`0DOol00`00Oomoo`0OOol00`00Oomoo`0UOol002Eoo`03001oogoo01=oo`03001oogoo
02Ioo`03001oogoo01=oo`03001oogoo02aoo`03001oogoo01=oo`03001oogoo01=oo`03001oogoo
01moo`03001oogoo02Ioo`009Goo00<007ooOol04Woo00<007ooOol09goo00<007ooOol04goo00<0
07ooOol0;Goo00<007ooOol04Woo00<007ooOol04Woo00<007ooOol07goo00<007ooOol09goo000V
Ool00`00Oomoo`0AOol00`00Oomoo`0XOol00`00Oomoo`0AOol00`00Oomoo`0_Ool00`00Oomoo`0A
Ool00`00Oomoo`0AOol00`00Oomoo`0POol00`00Oomoo`0WOol002Ioo`03001oogoo011oo`03001o
ogoo02Uoo`03001oogoo015oo`03001oogoo031oo`03001oogoo011oo`03001oogoo011oo`03001o
ogoo021oo`03001oogoo02Qoo`009goo00<007ooOol03goo00<007ooOol0:Woo00<007ooOol03goo
00<007ooOol0<Woo00<007ooOol03goo00<007ooOol03goo00<007ooOol087oo00<007ooOol0:Goo
000WOol00`00Oomoo`0>Ool00`00Oomoo`0[Ool00`00Oomoo`0?Ool00`00Oomoo`0cOol00`00Oomo
o`0>Ool00`00Oomoo`0>Ool00`00Oomoo`0POol00`00Oomoo`0ZOol002Qoo`03001oogoo00eoo`03
001oogoo02aoo`03001oogoo00eoo`03001oogoo03Eoo`8000ioo`03001oogoo00aoo`80029oo`03
001oogoo02]oo`00:7oo00<007ooOol037oo00<007ooOol0;Goo00<007ooOol03Goo00<007ooOol0
=goo00<007ooOol02goo00<007ooOol02goo00<007ooOol08Woo00<007ooOol0:goo000YOol00`00
Oomoo`0;Ool00`00Oomoo`0^Ool00`00Oomoo`0;Ool00`00Oomoo`0iOol00`00Oomoo`0:Ool00`00
Oomoo`0:Ool00`00Oomoo`0ROol00`00Oomoo`0/Ool002Uoo`03001oogoo00Yoo`03001oogoo02mo
o`03001oogoo00]oo`03001oogoo03Yoo`03001oogoo00Uoo`03001oogoo00Uoo`03001oogoo029o
o`03001oogoo02eoo`00:Woo00<007ooOol02Goo00<007ooOol0<7oo00<007ooOol02Goo00<007oo
Ool0?7oo00<007ooOol027oo00<007ooOol027oo00<007ooOol08Woo00<007ooOol0;Woo000ZOol0
0`00Oomoo`08Ool00`00Oomoo`0aOol00`00Oomoo`09Ool00`00Oomoo`0mOol00`00Oomoo`07Ool0
0`00Oomoo`07Ool00`00Oomoo`0ROol00`00Oomoo`0_Ool002]oo`03001oogoo00Moo`03001oogoo
039oo`03001oogoo00Moo`03001oogoo03moo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo
02=oo`03001oogoo02moo`00:goo00<007ooOol01Woo00<007ooOol0<goo00<007ooOol01goo00<0
07ooOol0@7oo00<007ooOol01Goo00<007ooOol01Goo00<007ooOol08goo00<007ooOol0<7oo000/
Ool00`00Oomoo`05Ool00`00Oomoo`0dOol00`00Oomoo`05Ool00`00Oomoo`12Ool00`00Oomoo`04
Ool00`00Oomoo`04Ool00`00Oomoo`0SOol00`00Oomoo`0aOol002eoo`03001oogoo00=oo`03001o
ogoo03Ioo`03001oogoo00=oo`03001oogoo04Aoo`03001oogoo00=oo`03001oogoo00=oo`03001o
ogoo02=oo`03001oogoo039oo`00;Goo00<007ooOol00goo00<007ooOol0=Woo00<007ooOol00goo
00<007ooOol0AGoo00<007ooOol00Woo00<007ooOol00Woo00<007ooOol08goo00<007ooOol0<goo
000^Ool01@00Oomoogoo0000>Woo00D007ooOomoo`0004Uoo`05001oogooOol00003Ool00`00Oomo
o`0TOol00`00Oomoo`0cOol002ioo`05001oogooOol0000jOol01@00Oomoogoo0000BWoo00@007oo
Ool0009oo`03001oogoo02Aoo`03001oogoo03Aoo`00;goo00<007oo0000?7oo00<007oo0000C7oo
00D007oo001oo`0002Ioo`03001oogoo03Eoo`00;goo00<007oo0000?7oo00<007oo0000CGoo0`00
9Woo00<007ooOol0=Woo000`Ool2000mOol2001>Ool00`00Oomoo`0TOol00`00Oomoo`0gOol0039o
o`03001oogoo03aoo`03001oogoo04]oo`03001oogoo02Aoo`03001oogoo03Moo`00<goo00<007oo
Ool0?7oo00<007ooOol0Bgoo00<007ooOol08Woo00<007ooOol0>7oo000dOol00`00Oomoo`0lOol0
0`00Oomoo`1:Ool00`00Oomoo`0QOol00`00Oomoo`0iOol003Eoo`03001oogoo03aoo`03001oogoo
04Yoo`03001oogoo01moo`03001oogoo03Yoo`00=Woo00<007ooOol0?7oo00<007ooOol0BGoo00<0
07ooOol07goo00<007ooOol0>Woo000gOol00`00Oomoo`0lOol00`00Oomoo`19Ool00`00Oomoo`0M
Ool00`00Oomoo`0kOol003Qoo`03001oogoo03aoo`03001oogoo04Uoo`03001oogoo01]oo`03001o
ogoo03aoo`00>Goo00<007ooOol0?7oo00<007ooOol0B7oo00<007ooOol06Woo00<007ooOol0?Goo
000jOol00`00Oomoo`0lOol00`00Oomoo`18Ool00`00Oomoo`0HOol00`00Oomoo`0nOol003]oo`03
001oogoo03aoo`03001oogoo04Moo`03001oogoo01Qoo`03001oogoo03ioo`00?7oo00<007ooOol0
?7oo00<007ooOol0Agoo00<007ooOol05Woo00<007ooOol0?goo000mOol00`00Oomoo`0lOol20017
Ool00`00Oomoo`0EOol00`00Oomoo`10Ool003ioo`8003ioo`03001oogoo04Eoo`03001oogoo01=o
o`03001oogoo045oo`00@7oo00<007ooOol0?7oo00<007ooOol0A7oo00<007ooOol04Woo00<007oo
Ool0@Woo0011Ool00`00Oomoo`0lOol00`00Oomoo`14Ool00`00Oomoo`0AOol00`00Oomoo`12Ool0
049oo`03001oogoo03aoo`03001oogoo04Aoo`03001oogoo00moo`03001oogoo04=oo`00@goo00<0
07ooOol0?7oo00<007ooOol0@goo00<007ooOol03Woo00<007ooOol0A7oo0014Ool00`00Oomoo`0l
Ool00`00Oomoo`13Ool00`00Oomoo`0<Ool00`00Oomoo`15Ool004Eoo`03001oogoo03aoo`03001o
ogoo049oo`03001oogoo00]oo`03001oogoo04Ioo`00AWoo00<007ooOol0?7oo00<007ooOol0@Woo
00<007ooOol02Woo00<007ooOol0AWoo0017Ool00`00Oomoo`0lOol00`00Oomoo`11Ool00`00Oomo
o`09Ool00`00Oomoo`17Ool004Qoo`03001oogoo03aoo`03001oogoo045oo`03001oogoo00Moo`03
001oogoo04Qoo`00BGoo00<007ooOol0?7oo00<007ooOol0@7oo00<007ooOol01Woo00<007ooOol0
BGoo001:Ool00`00Oomoo`0lOol20011Ool00`00Oomoo`04Ool00`00Oomoo`1:Ool004]oo`8003io
o`03001oogoo03moo`03001oogoo00=oo`03001oogoo04Yoo`00CGoo00<007ooOol0?7oo00<007oo
Ool0?Woo00<007ooOol00Woo00<007ooOol0Bgoo001>Ool00`00Oomoo`0lOol00`00Oomoo`0nOol0
1000Oomoo`00CWoo001?Ool00`00Oomoo`0lOol00`00Oomoo`0mOol00`00Ool0001?Ool0051oo`03
001oogoo03aoo`03001oogoo03aoo`80051oo`00DGoo00<007ooOol0?7oo00<007ooOol0>Woo00<0
07ooOol0D7oo001BOol00`00Oomoo`0lOol00`00Oomoo`0hOol00`00Oomoo`1AOol005=oo`03001o
ogoo03aoo`03001oogoo03Ioo`03001oogoo059oo`00E7oo00<007ooOol0?7oo00<007ooOol0=7oo
00<007ooOol0Dgoo001EOol00`00Oomoo`0lOol00`00Oomoo`0bOol00`00Oomoo`1DOol005Ioo`03
001oogoo03aoo`80035oo`03001oogoo05Eoo`00Egoo00<007ooOol0?Goo00<007ooOol0;Goo00<0
07ooOol0EWoo001HOol00`00Oomoo`0mOol00`00Oomoo`0[Ool00`00Oomoo`1GOol005Uoo`8003io
o`03001oogoo02Uoo`03001oogoo05Qoo`00Fgoo00<007ooOol0?7oo00<007ooOol09goo00<007oo
Ool0FGoo001LOol00`00Oomoo`0lOol00`00Oomoo`0UOol00`00Oomoo`1JOol005eoo`03001oogoo
03aoo`03001oogoo02=oo`03001oogoo05]oo`00GWoo00<007ooOol0?7oo00<007ooOol08Goo00<0
07ooOol0G7oo001OOol00`00Oomoo`0lOol00`00Oomoo`0OOol00`00Oomoo`1MOol0061oo`03001o
ogoo03aoo`03001oogoo01aoo`80061oo`00HGoo00<007ooOol0?7oo00<007ooOol06Woo00<007oo
Ool0H7oo001ROol00`00Oomoo`0lOol00`00Oomoo`0HOol00`00Oomoo`1QOol006=oo`03001oogoo
03aoo`8001Moo`03001oogoo069oo`00I7oo00<007ooOol0?Goo00<007ooOol04goo00<007ooOol0
Hgoo001UOol00`00Oomoo`0mOol00`00Oomoo`0AOol00`00Oomoo`1TOol006Ioo`8003ioo`03001o
ogoo00moo`03001oogoo06Eoo`00J7oo00<007ooOol0?7oo00<007ooOol03Goo00<007ooOol0IWoo
001YOol00`00Oomoo`0lOol00`00Oomoo`0;Ool00`00Oomoo`1WOol006Yoo`03001oogoo03aoo`03
001oogoo00Uoo`03001oogoo06Qoo`00Jgoo00<007ooOol0?7oo00<007ooOol01goo00<007ooOol0
JGoo001/Ool00`00Oomoo`0lOol00`00Oomoo`05Ool00`00Oomoo`1ZOol006eoo`03001oogoo03ao
o`03001oogoo00=oo`03001oogoo06]oo`00KWoo00<007ooOol0?7oo00D007ooOomoo`0006ioo`00
Kgoo00<007ooOol0?7oo00<007oo0000Kgoo001`Ool00`00Oomoo`0kOol2001`Ool0075oo`03001o
ogoo03Uoo`03001oogoo071oo`00LWoo00<007ooOol0=goo00<007ooOol0LGoo001cOol00`00Oomo
o`0eOol00`00Oomoo`1bOol007Aoo`8003Aoo`03001oogoo07=oo`00MWoo00<007ooOol0<7oo00<0
07ooOol0M7oo001gOol00`00Oomoo`0^Ool00`00Oomoo`1eOol007Qoo`03001oogoo02aoo`03001o
ogoo07Ioo`00NGoo00<007ooOol0:Woo00<007ooOol0Mgoo001jOol00`00Oomoo`0XOol00`00Oomo
o`1hOol007]oo`03001oogoo02Eoo`8007]oo`00O7oo00<007ooOol08goo00<007ooOol0Ngoo001m
Ool00`00Oomoo`0QOol00`00Oomoo`1lOol007ioo`03001oogoo01moo`03001oogoo07eoo`00Ogoo
00<007ooOol07Goo00<007ooOol0OWoo0020Ool00`00Oomoo`0KOol00`00Oomoo`1oOol0085oo`80
01Yoo`03001oogoo081oo`00Pgoo00<007ooOol05Woo00<007ooOol0PGoo0024Ool00`00Oomoo`0D
Ool00`00Oomoo`22Ool008Eoo`03001oogoo015oo`8008Eoo`00QWoo00<007ooOol03goo00<007oo
Ool0QGoo0027Ool00`00Oomoo`0=Ool00`00Oomoo`26Ool008Qoo`03001oogoo00]oo`03001oogoo
08Moo`00RGoo00<007ooOol02Goo00<007ooOol0R7oo002:Ool00`00Oomoo`07Ool00`00Oomoo`29
Ool008]oo`03001oogoo00Eoo`03001oogoo08Yoo`00S7oo00<007ooOol00goo00<007ooOol0Rgoo
002=Ool01@00Oomoogoo0000SWoo002>Ool00`00Ool0002?Ool008moo`03001oogoo08ioo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0
0?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0
0?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(\ PlotGenealogy[g, NodeLabels \[Rule] f]\), 
            \(uses\ f[i, info]\ to\ derive\ labels\ for\ internal\ 
              \(nodes . \)\)},
          {\(\ PlotGenealogy[g, LeafLabels \[Rule] f]\), 
            \(uses\ f[i, info]\ to\ derive\ labels\ for\ \(leaves . \)\)}
          }], TraditionalForm]]]], "DefinitionBox"],

Cell["This labels the internal nodes by their coalescence times:", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
      PlotGenealogy[tr, 
        NodeLabels \[Rule] 
          \((#2\[LeftDoubleBracket]1\[RightDoubleBracket]&)\)]]; \)\)], 
  "Input",
  CellLabel->"In[149]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .20601 m
.11111 .10301 L
s
.16667 .20601 m
.22222 .10301 L
s
.38889 .20601 m
.33333 .10301 L
s
.38889 .20601 m
.44444 .10301 L
s
.66667 .20601 m
.55556 .10301 L
s
.66667 .20601 m
.66667 .10301 L
s
.66667 .20601 m
.77778 .10301 L
s
.72222 .30902 m
.66667 .20601 L
s
.72222 .30902 m
.88889 .10301 L
s
.61111 .41202 m
.38889 .20601 L
s
.61111 .41202 m
.72222 .30902 L
s
.5 .51503 m
.16667 .20601 L
s
.5 .51503 m
.61111 .41202 L
s
[(0.4)] .14444 .22661 0 0 Mshowa
[(1)] .36667 .22661 0 0 Mshowa
[(1.5)] .64444 .22661 0 0 Mshowa
[(1.7)] .7 .32962 0 0 Mshowa
[(1.8)] .58889 .43262 0 0 Mshowa
[(2.3)] .47778 .53563 0 0 Mshowa
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -75 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[149]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0AOol01000Oomoogoo0`00
0goo0`000Woo00<007ooOol047oo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08
Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0B
Ool00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08
Ool00`00Oomoo`0?Ool00`00Oomoo`05Ool00`00Oomoo`03Ool01000Oomoo`0047oo00<007ooOol0
27oo00<007ooOol06Woo000JOol01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@0
00=oo`03001oogoo015oo`03001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D0
0003Ool007oo01=oo`03001oogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool0
0`00Oomoo`0?Ool00`00Oomoo`02Ool40002Ool40002Ool00`00Oomoo`0>Ool01000Oomoogoo0P00
00=oo`0000000Woo00<007ooOol06Woo000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Ao
o`05001oogooOol00003Ool01000Oomoo`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol0
1@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00
Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool01@00Oomoogoo00000goo00<007oo00000goo
00@007ooOol0011oo`05001oogooOol00002Ool01@00Oomoogoo000077oo000IOol00`00Oomoo`02
Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol03goo
00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo00<007ooOol00Woo00D007ooOomoo`00
00=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03001oogoo011oo`03001oogoo00=oo`03
001oogoo00Aoo`03001oogoo00eoo`03001oogoo009oo`07001oogooOol007oo00000goo00D007oo
Oomoo`0000ioo`03001oogoo009oo`04001oogoo0004Ool00`00Oomoo`0IOol001Yoo`03001oogoo
00Aoo`05001oogooOol0000DOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol0
0003Ool01000Oomoo`0057oo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo0000
0goo00@007ooOol001Aoo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00moo`05001oogoo
Ool00003Ool00`00Ool00003Ool01000Oomoo`0047oo00D007ooOomoo`00009oo`05001oogooOol0
000LOol001Yoo`03001oogoo009oo`<000=oo`03001oogoo019oo`04001oogooOol40003Ool00`00
Oomoo`0AOol00`00Oomoo`02Ool40002Ool00`00Oomoo`0BOol00`00Oomoo`02Ool40002Ool00`00
Oomoo`0BOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo00<007oo
Ool03goo00<007ooOol00Woo1@0000=oo`0000000`0000=oo`00Ool03goo00@007ooOomoo`@000=o
o`03001oogoo01Yoo`006goo00<007ooOol01Woo00<007ooOol057oo00@007ooOol000Eoo`03001o
ogoo01=oo`03001oogoo00Ioo`03001oogoo01Aoo`03001oogoo00Aoo`03001oo`0001Ioo`03001o
ogoo00Ioo`03001oogoo01Aoo`05001oogooOol00004Ool00`00Oomoo`0AOol00`00Oomoo`0<Ool0
0`00Oomoo`0@Ool01000Oomoo`001Goo00<007ooOol06goo000mOol20011Ool2000lOol3000jOol2
000SOol00?moob5oo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007oo
Ool07Goo0P007Woo00<007ooOol077oo0P007Woo00<007ooOol07goo000POol00`00Oomoo`0LOol0
0`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0OOol00`00Oomoo`0KOol00`00Oomoo`0KOol0
0`00Oomoo`0NOol00`00Oomoo`0OOol0025oo`03001oogoo01Yoo`03001oogoo01moo`03001oogoo
01]oo`03001oogoo025oo`03001oogoo01Yoo`03001oogoo01Yoo`03001oogoo01ioo`03001oogoo
021oo`008Goo00<007ooOol06Woo00<007ooOol07goo00<007ooOol06goo00<007ooOol08Woo00<0
07ooOol06Goo00<007ooOol06Goo00<007ooOol07Woo00<007ooOol08Goo000ROol00`00Oomoo`0H
Ool00`00Oomoo`0QOol00`00Oomoo`0IOol00`00Oomoo`0TOol00`00Oomoo`0HOol00`00Oomoo`0H
Ool00`00Oomoo`0NOol00`00Oomoo`0ROol0029oo`03001oogoo01Qoo`03001oogoo025oo`03001o
ogoo01Uoo`03001oogoo02Eoo`03001oogoo01Moo`03001oogoo01Moo`03001oogoo01ioo`03001o
ogoo02=oo`008goo00<007ooOol05Woo00<007ooOol08goo00<007ooOol05goo00<007ooOol09goo
00<007ooOol05Woo00<007ooOol05Woo00<007ooOol07goo00<007ooOol08goo000SOol00`00Oomo
o`0FOol00`00Oomoo`0SOol00`00Oomoo`0GOol00`00Oomoo`0XOol00`00Oomoo`0EOol00`00Oomo
o`0EOol00`00Oomoo`0OOol00`00Oomoo`0TOol002Aoo`03001oogoo01Aoo`03001oogoo02Eoo`03
001oogoo01Eoo`03001oogoo02Yoo`03001oogoo01Aoo`03001oogoo01Aoo`03001oogoo01moo`03
001oogoo02Eoo`009Goo00<007ooOol04goo00<007ooOol09Woo00<007ooOol04goo00<007ooOol0
;7oo00<007ooOol04goo00<007ooOol04goo00<007ooOol07goo00<007ooOol09Woo000UOol00`00
Oomoo`0BOol00`00Oomoo`0WOol00`00Oomoo`0COol00`00Oomoo`0]Ool00`00Oomoo`0BOol00`00
Oomoo`0BOol00`00Oomoo`0OOol00`00Oomoo`0WOol002Ioo`03001oogoo015oo`03001oogoo02Qo
o`03001oogoo015oo`03001oogoo02moo`03001oogoo015oo`03001oogoo015oo`03001oogoo021o
o`03001oogoo02Moo`009Woo00<007ooOol047oo00<007ooOol0:Goo00<007ooOol04Goo00<007oo
Ool0<7oo00<007ooOol047oo00<007ooOol047oo00<007ooOol087oo00<007ooOol0:7oo000WOol0
0`00Oomoo`0?Ool00`00Oomoo`0ZOol00`00Oomoo`0?Ool00`00Oomoo`0bOol00`00Oomoo`0?Ool0
0`00Oomoo`0?Ool00`00Oomoo`0POol00`00Oomoo`0YOol002Moo`03001oogoo00ioo`03001oogoo
02]oo`03001oogoo00moo`03001oogoo03=oo`03001oogoo00ioo`03001oogoo00ioo`03001oogoo
021oo`03001oogoo02Yoo`00:7oo00<007ooOol03Goo00<007ooOol0;7oo00<007ooOol03Goo00<0
07ooOol0=Goo0P003Woo00<007ooOol037oo0P008Woo00<007ooOol0:goo000XOol00`00Oomoo`0<
Ool00`00Oomoo`0]Ool00`00Oomoo`0=Ool00`00Oomoo`0gOol00`00Oomoo`0;Ool00`00Oomoo`0;
Ool00`00Oomoo`0ROol00`00Oomoo`0[Ool002Uoo`03001oogoo00]oo`03001oogoo02ioo`03001o
ogoo00]oo`03001oogoo03Uoo`03001oogoo00Yoo`03001oogoo00Yoo`03001oogoo029oo`03001o
ogoo02aoo`00:Goo00<007ooOol02Woo00<007ooOol0;goo00<007ooOol02goo00<007ooOol0>Woo
00<007ooOol02Goo00<007ooOol02Goo00<007ooOol08Woo00<007ooOol0;Goo000ZOol00`00Oomo
o`09Ool00`00Oomoo`0`Ool00`00Oomoo`09Ool00`00Oomoo`0lOol00`00Oomoo`08Ool00`00Oomo
o`08Ool00`00Oomoo`0ROol00`00Oomoo`0^Ool002Yoo`03001oogoo00Qoo`03001oogoo035oo`03
001oogoo00Uoo`03001oogoo03eoo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo029oo`03
001oogoo02moo`00:goo00<007ooOol01goo00<007ooOol0<Woo00<007ooOol01goo00<007ooOol0
?goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol08goo00<007ooOol0;goo000[Ool00`00
Oomoo`06Ool00`00Oomoo`0cOol00`00Oomoo`07Ool00`00Oomoo`10Ool00`00Oomoo`05Ool00`00
Oomoo`05Ool00`00Oomoo`0SOol00`00Oomoo`0`Ool002aoo`03001oogoo00Eoo`03001oogoo03Ao
o`03001oogoo00Eoo`03001oogoo049oo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo02=o
o`03001oogoo035oo`00;Goo00<007ooOol00goo00<007ooOol0=Woo00<007ooOol00goo00<007oo
Ool0A7oo00<007ooOol00goo00<007ooOol00goo00<007ooOol08goo00<007ooOol0<Woo000]Ool0
0`00Oomoo`03Ool00`00Oomoo`0fOol00`00Oomoo`03Ool00`00Oomoo`15Ool00`00Oomoo`02Ool0
0`00Oomoo`02Ool00`00Oomoo`0SOol00`00Oomoo`0cOol002ioo`05001oogooOol0000jOol01@00
Oomoogoo0000BGoo00D007ooOomoo`0000=oo`03001oogoo02Aoo`03001oogoo03=oo`00;Woo00D0
07ooOomoo`0003Yoo`05001oogooOol0001:Ool01000Oomoo`000Woo00<007ooOol097oo00<007oo
Ool0=7oo000_Ool00`00Ool0000lOol00`00Ool0001<Ool01@00Ool007oo00009Woo00<007ooOol0
=Goo000_Ool00`00Ool0000lOol00`00Ool0001=Ool3000VOol00`00Oomoo`0fOol0031oo`8003eo
o`8004ioo`03001oogoo02Aoo`03001oogoo03Moo`00<Woo00<007ooOol0?7oo00<007ooOol0Bgoo
00<007ooOol097oo00<007ooOol0=goo000cOol00`00Oomoo`0lOol00`00Oomoo`1;Ool00`00Oomo
o`0ROol00`00Oomoo`0hOol0029oo`8000Aoo`8000Aoo`<000=oo`03001oogoo031oo`<000Uoo`03
001oogoo03Yoo`<000Aoo`8000=oo`<00003Ool007oo029oo`03001oogoo03Uoo`008Goo00@007oo
Ool000=oo`8000Eoo`03001oogoo00=oo`03001oogoo031oo`03001oogoo00Uoo`03001oogoo03Yo
o`03001oogoo00=oo`8000Ioo`03001oo`00025oo`03001oogoo03Yoo`008Goo00@007ooOol000Qo
o`@000Eoo`03001oogoo02moo`03001oogoo00Yoo`03001oogoo03Uoo`03001oogoo00]oo`03001o
o`00025oo`03001oogoo03Yoo`008Goo00@007ooOol000Qoo`03001oo`0000Moo`03001oogoo02io
o`03001oogoo00]oo`03001oogoo03Qoo`03001oogoo00Qoo`<000=oo`03001oogoo01eoo`03001o
ogoo03]oo`008Goo00@007ooOol000Qoo`03001oo`0000Qoo`03001oogoo02eoo`03001oogoo00ao
o`03001oogoo03Moo`03001oogoo00Qoo`03001oogoo00Aoo`03001oogoo01]oo`03001oogoo03ao
o`008Woo0P002Woo0P002Goo00<007ooOol0:goo0P003goo00<007ooOol0=Goo0P002Woo10000goo
00<007ooOol06Woo00<007ooOol0?Goo000jOol00`00Oomoo`0lOol00`00Oomoo`18Ool00`00Oomo
o`0HOol00`00Oomoo`0nOol003]oo`03001oogoo03aoo`03001oogoo04Moo`03001oogoo01Qoo`03
001oogoo03ioo`00?7oo00<007ooOol0?7oo00<007ooOol0Agoo00<007ooOol05Woo00<007ooOol0
?goo000mOol00`00Oomoo`0lOol20017Ool00`00Oomoo`0EOol00`00Oomoo`10Ool003ioo`8003io
o`03001oogoo04Eoo`03001oogoo01=oo`03001oogoo045oo`00@7oo00<007ooOol0?7oo00<007oo
Ool0A7oo00<007ooOol04Woo00<007ooOol0@Woo0011Ool00`00Oomoo`0lOol00`00Oomoo`14Ool0
0`00Oomoo`0AOol00`00Oomoo`12Ool0049oo`03001oogoo03aoo`03001oogoo04Aoo`03001oogoo
00moo`03001oogoo04=oo`00@goo00<007ooOol0?7oo00<007ooOol0@goo00<007ooOol03Woo00<0
07ooOol0A7oo0014Ool00`00Oomoo`0lOol00`00Oomoo`13Ool00`00Oomoo`0<Ool00`00Oomoo`15
Ool004Eoo`03001oogoo03aoo`03001oogoo049oo`03001oogoo00]oo`03001oogoo04Ioo`00AWoo
00<007ooOol0?7oo00<007ooOol0@Woo00<007ooOol02Woo00<007ooOol0AWoo0017Ool00`00Oomo
o`0lOol00`00Oomoo`11Ool00`00Oomoo`09Ool00`00Oomoo`17Ool004Qoo`03001oogoo03aoo`03
001oogoo045oo`03001oogoo00Moo`03001oogoo04Qoo`00BGoo00<007ooOol0?7oo00<007ooOol0
@7oo00<007ooOol01Woo00<007ooOol0BGoo001:Ool00`00Oomoo`0lOol20011Ool00`00Oomoo`04
Ool00`00Oomoo`1:Ool004]oo`8003ioo`03001oogoo03moo`03001oogoo00=oo`03001oogoo04Yo
o`00CGoo00<007ooOol0?7oo00<007ooOol0?Woo00<007ooOol00Woo00<007ooOol0Bgoo001>Ool0
0`00Oomoo`0lOol00`00Oomoo`0nOol01000Oomoo`00CWoo001?Ool00`00Oomoo`0lOol00`00Oomo
o`0mOol00`00Ool0001?Ool0051oo`03001oogoo03aoo`03001oogoo03aoo`80051oo`00DGoo00<0
07ooOol0?7oo00<007ooOol0>Woo00<007ooOol0D7oo001BOol00`00Oomoo`0lOol00`00Oomoo`0h
Ool00`00Oomoo`1AOol005=oo`03001oogoo03aoo`03001oogoo03Ioo`03001oogoo059oo`00E7oo
00<007ooOol0?7oo00<007ooOol0:Woo0`0017oo0P0000Eoo`00Oomoo`00059oo`00EGoo00<007oo
Ool0?7oo00<007ooOol0:Woo00<007ooOol00goo0`000goo00<007ooOol0D7oo001FOol00`00Oomo
o`0lOol2000ZOol00`00Oomoo`04Ool00`00Oomoo`03Ool00`00Oomoo`1?Ool005Moo`03001oogoo
03eoo`03001oogoo02Moo`03001oogoo00=oo`03001oogoo00Aoo`03001oogoo04moo`00F7oo00<0
07ooOol0?Goo00<007ooOol09Woo00<007ooOol00Woo00<007ooOol01Woo00<007ooOol0CWoo001I
Ool2000nOol00`00Oomoo`0TOol20003Ool00`00Oomoo`04Ool4001@Ool005]oo`03001oogoo03ao
o`03001oogoo02Moo`03001oogoo05Uoo`00G7oo00<007ooOol0?7oo00<007ooOol09Goo00<007oo
Ool0FWoo001MOol00`00Oomoo`0lOol00`00Oomoo`0SOol00`00Oomoo`1KOol005ioo`03001oogoo
03aoo`03001oogoo025oo`03001oogoo05aoo`00Ggoo00<007ooOol0?7oo00<007ooOol07goo00<0
07ooOol0GGoo001POol00`00Oomoo`0lOol00`00Oomoo`0LOol2001POol0065oo`03001oogoo03ao
o`03001oogoo01Yoo`03001oogoo061oo`00HWoo00<007ooOol0?7oo00<007ooOol067oo00<007oo
Ool0HGoo001SOol00`00Oomoo`0lOol2000GOol00`00Oomoo`1ROol006Aoo`03001oogoo03eoo`03
001oogoo01=oo`03001oogoo06=oo`00IGoo00<007ooOol0?Goo00<007ooOol04Goo00<007ooOol0
I7oo001VOol2000nOol00`00Oomoo`0?Ool00`00Oomoo`1UOol006Qoo`03001oogoo03aoo`03001o
ogoo00eoo`03001oogoo06Ioo`00JGoo00<007ooOol0?7oo00<007ooOol02goo00<007ooOol0Igoo
001ZOol00`00Oomoo`0lOol00`00Oomoo`09Ool00`00Oomoo`1XOol006]oo`03001oogoo03aoo`03
001oogoo00Moo`03001oogoo06Uoo`00K7oo00<007ooOol0?7oo00<007ooOol01Goo00<007ooOol0
JWoo001]Ool00`00Oomoo`0lOol00`00Oomoo`03Ool00`00Oomoo`1[Ool006ioo`03001oogoo03ao
o`05001oogooOol0001^Ool006moo`03001oogoo03aoo`03001oo`0006moo`00L7oo00<007ooOol0
>goo0P00L7oo001aOol00`00Oomoo`0iOol00`00Oomoo`1`Ool0079oo`03001oogoo03Moo`03001o
ogoo075oo`00Lgoo00<007ooOol0:Woo0`0017oo0P000Woo00@007oo0000075oo`00M7oo0P00:goo
00<007ooOol00goo0P0000Aoo`00Ool0009oo`03001oogoo06ioo`00MWoo00<007ooOol0:7oo00<0
07ooOol01Goo00@007ooOol0009oo`03001oogoo06ioo`00Mgoo00<007ooOol09goo00<007ooOol0
17oo00<007ooOol00Woo0P00LGoo001hOol00`00Oomoo`0VOol00`00Oomoo`03Ool00`00Oomoo`02
Ool01000Oomoo`00L7oo001iOol00`00Oomoo`0TOol20004Ool00`00Oomoo`04Ool2001aOol007Yo
o`03001oogoo02Qoo`03001oogoo07Qoo`00Ngoo00<007ooOol09Goo0P00Ngoo001lOol00`00Oomo
o`0SOol00`00Oomoo`1kOol007eoo`03001oogoo025oo`03001oogoo07aoo`00OWoo00<007ooOol0
7goo00<007ooOol0OGoo001oOol00`00Oomoo`0MOol00`00Oomoo`1nOol0081oo`03001oogoo01]o
o`03001oogoo07moo`00PGoo0P006Woo00<007ooOol0P7oo0023Ool00`00Oomoo`0FOol00`00Oomo
o`21Ool008Aoo`03001oogoo01Aoo`03001oogoo089oo`00QGoo00<007ooOol04Goo0P00QGoo0026
Ool00`00Oomoo`0?Ool00`00Oomoo`25Ool008Moo`03001oogoo00eoo`03001oogoo08Ioo`00R7oo
00<007ooOol02goo00<007ooOol0Qgoo0029Ool00`00Oomoo`09Ool00`00Oomoo`28Ool008Yoo`03
001oogoo00Moo`03001oogoo08Uoo`00Rgoo00<007ooOol01Goo00<007ooOol0RWoo002<Ool00`00
Oomoo`03Ool00`00Oomoo`2;Ool008eoo`05001oogooOol0002>Ool008ioo`03001oo`0008moo`00
Sgoo00<007ooOol0SWoo003oOolQOol00?moob5oo`00ogoo8Goo0021Ool40003Ool20003Ool3002@
Ool0089oo`03001oogoo00=oo`8000Ioo`03001oogoo08eoo`00Pgoo00<007ooOol02Woo00<007oo
Ool0SGoo0024Ool00`00Oomoo`07Ool2002@Ool0085oo`04001oogoo000;Ool00`00Oomoo`2=Ool0
089oo`8000Uoo`<0091oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00001
\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(\(\ \)\(PlotGenealogy[g, 
              NodeFunction \[Rule] f]\)\), \(uses\ f[i, 
                info]\ to\ derive\ the\ coordinates; \ 
            the\ vertical\ coordinate\ might\ represent\ coalescence\ time, \ 
            for\ \(\(example\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->"NodeFunction"],

Cell["\<\
Here, the first element of the information list gives the \
coalescence time.  This can be used as the vertical coordinate:\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
      PlotGenealogy[tr, 
        NodeFunction \[Rule] 
          \(({#2\[LeftDoubleBracket]\(-1\), 1\[RightDoubleBracket], 
                2  #2\[LeftDoubleBracket]1\[RightDoubleBracket]}&)\)]]; 
    \)\)], "Input",
  CellLabel->"In[150]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .18541 m
.11111 .10301 L
s
.16667 .18541 m
.22222 .10301 L
s
.38889 .30902 m
.33333 .10301 L
s
.38889 .30902 m
.44444 .10301 L
s
.66667 .41202 m
.55556 .10301 L
s
.66667 .41202 m
.66667 .10301 L
s
.66667 .41202 m
.77778 .10301 L
s
.72222 .45322 m
.66667 .41202 L
s
.72222 .45322 m
.88889 .10301 L
s
.61111 .47383 m
.38889 .30902 L
s
.61111 .47383 m
.72222 .45322 L
s
.5 .57683 m
.16667 .18541 L
s
.5 .57683 m
.61111 .47383 L
s
gsave
.14444 .20601 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.36667 .32962 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.64444 .43262 -90.5625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
112.125000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.7 .47383 -98.3438 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
112.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
127.687500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.58889 .49443 -113.906 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
143.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
158.812500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.47778 .59743 -129.469 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
162.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
174.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
183.937500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
189.937500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -75 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[150]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0AOol01000Oomoogoo0`00
0goo0`000Woo00<007ooOol047oo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08
Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0B
Ool00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08
Ool00`00Oomoo`0?Ool00`00Oomoo`05Ool00`00Oomoo`03Ool01000Oomoo`0047oo00<007ooOol0
27oo00<007ooOol06Woo000JOol01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@0
00=oo`03001oogoo015oo`03001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D0
0003Ool007oo01=oo`03001oogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool0
0`00Oomoo`0?Ool00`00Oomoo`02Ool40002Ool40002Ool00`00Oomoo`0>Ool01000Oomoogoo0P00
00=oo`0000000Woo00<007ooOol06Woo000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Ao
o`05001oogooOol00003Ool01000Oomoo`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol0
1@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00
Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool01@00Oomoogoo00000goo00<007oo00000goo
00@007ooOol0011oo`05001oogooOol00002Ool01@00Oomoogoo000077oo000IOol00`00Oomoo`02
Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol03goo
00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo00<007ooOol00Woo00D007ooOomoo`00
00=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03001oogoo011oo`03001oogoo00=oo`03
001oogoo00Aoo`03001oogoo00eoo`03001oogoo009oo`07001oogooOol007oo00000goo00D007oo
Oomoo`0000ioo`03001oogoo009oo`04001oogoo0004Ool00`00Oomoo`0IOol001Yoo`03001oogoo
00Aoo`05001oogooOol0000DOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol0
0003Ool01000Oomoo`0057oo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo0000
0goo00@007ooOol001Aoo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00moo`05001oogoo
Ool00003Ool00`00Ool00003Ool01000Oomoo`0047oo00D007ooOomoo`00009oo`05001oogooOol0
000LOol001Yoo`03001oogoo009oo`<000=oo`03001oogoo019oo`04001oogooOol40003Ool00`00
Oomoo`0AOol00`00Oomoo`02Ool40002Ool00`00Oomoo`0BOol00`00Oomoo`02Ool40002Ool00`00
Oomoo`0BOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo00<007oo
Ool03goo00<007ooOol00Woo1@0000=oo`0000000`0000=oo`00Ool03goo00@007ooOomoo`@000=o
o`03001oogoo01Yoo`006goo00<007ooOol01Woo00<007ooOol057oo00@007ooOol000Eoo`03001o
ogoo01=oo`03001oogoo00Ioo`03001oogoo01Aoo`03001oogoo00Aoo`03001oo`0001Ioo`03001o
ogoo00Ioo`03001oogoo01Aoo`05001oogooOol00004Ool00`00Oomoo`0AOol00`00Oomoo`0<Ool0
0`00Oomoo`0@Ool01000Oomoo`001Goo00<007ooOol06goo000mOol20011Ool2000lOol3000jOol2
000SOol00?moob5oo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007oo
Ool07Goo00<007ooOol07Goo00<007ooOol07Goo00<007ooOol077oo00<007ooOol07goo000POol0
0`00Oomoo`0LOol00`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0MOol0
0`00Oomoo`0MOol00`00Oomoo`0LOol00`00Oomoo`0OOol0025oo`03001oogoo01Yoo`03001oogoo
01ioo`03001oogoo01eoo`03001oogoo01ioo`03001oogoo01aoo`03001oogoo01aoo`03001oogoo
01aoo`03001oogoo021oo`008Woo00<007ooOol067oo00<007ooOol087oo00<007ooOol06goo00<0
07ooOol07goo00<007ooOol077oo00<007ooOol077oo00<007ooOol077oo00<007ooOol087oo000R
Ool00`00Oomoo`0HOol00`00Oomoo`0POol00`00Oomoo`0KOol00`00Oomoo`0OOol00`00Oomoo`0L
Ool00`00Oomoo`0LOol00`00Oomoo`0KOol00`00Oomoo`0QOol002=oo`03001oogoo01Ioo`03001o
ogoo025oo`03001oogoo01]oo`03001oogoo021oo`03001oogoo01]oo`03001oogoo01]oo`03001o
ogoo01aoo`03001oogoo025oo`0097oo00<007ooOol05Goo00<007ooOol08Goo00<007ooOol06goo
00<007ooOol087oo00<007ooOol06goo00<007ooOol06goo00<007ooOol06goo00<007ooOol08Woo
000TOol00`00Oomoo`0DOol00`00Oomoo`0SOol00`00Oomoo`0IOol00`00Oomoo`0QOol00`00Oomo
o`0KOol00`00Oomoo`0KOol00`00Oomoo`0KOol00`00Oomoo`0ROol002Eoo`03001oogoo019oo`03
001oogoo02Aoo`03001oogoo01Uoo`03001oogoo029oo`03001oogoo01Yoo`03001oogoo01Yoo`03
001oogoo01]oo`03001oogoo02=oo`009Woo00<007ooOol04Goo00<007ooOol097oo00<007ooOol0
6Goo00<007ooOol08Woo00<007ooOol06Woo00<007ooOol06Woo00<007ooOol06goo00<007ooOol0
8goo000VOol00`00Oomoo`0@Ool00`00Oomoo`0VOol00`00Oomoo`0GOol00`00Oomoo`0SOol00`00
Oomoo`0JOol00`00Oomoo`0JOol00`00Oomoo`0KOol00`00Oomoo`0SOol002Moo`03001oogoo00io
o`03001oogoo02Moo`03001oogoo01Moo`03001oogoo02Aoo`03001oogoo01Uoo`03001oogoo01Uo
o`03001oogoo01]oo`03001oogoo02Aoo`00:7oo00<007ooOol03Goo00<007ooOol09goo00<007oo
Ool05goo00<007ooOol097oo00<007ooOol06Goo00<007ooOol06Goo00<007ooOol06goo00<007oo
Ool097oo000XOol00`00Oomoo`0<Ool00`00Oomoo`0XOol00`00Oomoo`0GOol00`00Oomoo`0TOol0
0`00Oomoo`0IOol00`00Oomoo`0IOol00`00Oomoo`0JOol00`00Oomoo`0UOol002Uoo`03001oogoo
00]oo`03001oogoo02Uoo`03001oogoo01Eoo`03001oogoo02Ioo`03001oogoo01Qoo`03001oogoo
01Qoo`03001oogoo01]oo`03001oogoo02Eoo`00:Woo00<007ooOol02Goo00<007ooOol0:Woo00<0
07ooOol05Goo00<007ooOol09Woo00<007ooOol067oo00<007ooOol067oo00<007ooOol06Woo00<0
07ooOol09Woo000ZOol00`00Oomoo`08Ool00`00Oomoo`0[Ool00`00Oomoo`0EOol00`00Oomoo`0W
Ool00`00Oomoo`0GOol00`00Oomoo`0GOol00`00Oomoo`0KOol00`00Oomoo`0VOol002]oo`03001o
ogoo00Moo`03001oogoo02]oo`03001oogoo01Eoo`03001oogoo02Moo`03001oogoo01Moo`03001o
ogoo01Moo`03001oogoo01Yoo`03001oogoo02Moo`00;7oo00<007ooOol01Goo00<007ooOol0;Goo
00<007ooOol04goo00<007ooOol0:7oo00<007ooOol05goo00<007ooOol05goo00<007ooOol06Woo
00<007ooOol09goo000/Ool00`00Oomoo`04Ool00`00Oomoo`0^Ool00`00Oomoo`0COol00`00Oomo
o`0YOol00`00Oomoo`0FOol00`00Oomoo`0FOol00`00Oomoo`0JOol00`00Oomoo`0XOol002eoo`03
001oogoo00=oo`03001oogoo02ioo`03001oogoo01=oo`03001oogoo02Uoo`03001oogoo01Ioo`03
001oogoo01Ioo`03001oogoo01Yoo`03001oogoo02Qoo`00;Woo00D007ooOomoo`00039oo`03001o
ogoo015oo`03001oogoo02Yoo`03001oogoo01Ioo`03001oogoo01Ioo`03001oogoo01Uoo`03001o
ogoo02Uoo`00;Woo00D007ooOomoo`00039oo`03001oogoo015oo`03001oogoo02]oo`03001oogoo
01Eoo`03001oogoo01Eoo`03001oogoo01Yoo`03001oogoo02Uoo`00;goo00<007oo0000<goo00<0
07ooOol04Goo00<007ooOol0:goo00<007ooOol05Goo00<007ooOol05Goo00<007ooOol06Goo00<0
07ooOol0:Woo000`Ool00`00Oomoo`0bOol00`00Oomoo`0AOol00`00Oomoo`0[Ool00`00Oomoo`0E
Ool00`00Oomoo`0EOol00`00Oomoo`0IOol00`00Oomoo`0ZOol0031oo`03001oogoo03=oo`03001o
ogoo00moo`03001oogoo02eoo`03001oogoo01Aoo`03001oogoo01Aoo`03001oogoo01Uoo`03001o
ogoo02]oo`0077oo00<007ooOol04Woo00D007ooOomoo`00031oo`03001oogoo00moo`03001oogoo
02eoo`03001oogoo01Aoo`03001oogoo01Aoo`03001oogoo01Uoo`03001oogoo02]oo`006goo00<0
07ooOol027oo00<007ooOol02Goo00D007ooOomoo`0002moo`03001oogoo00moo`03001oogoo02io
o`03001oogoo01=oo`03001oogoo01=oo`03001oogoo01Yoo`03001oogoo02]oo`006goo00@007oo
Oomoo`D0009oo`03001oogoo00Ioo`D0009oo`03001oogoo02eoo`03001oogoo00moo`03001oogoo
02ioo`03001oogoo01=oo`03001oogoo01=oo`03001oogoo01Uoo`03001oogoo02aoo`006goo00D0
07ooOomoo`00009oo`03001oogoo009oo`03001oogoo00Eoo`04001oogooOol200000goo001oo`0_
Ool00`00Oomoo`0=Ool00`00Oomoo`0_Ool00`00Oomoo`0COol00`00Oomoo`0COol00`00Oomoo`0I
Ool00`00Oomoo`0/Ool001Yoo`03001oogoo009oo`@000aoo`09001oogooOol007oo001oo`0002mo
o`03001oogoo00eoo`03001oogoo031oo`03001oogoo019oo`03001oogoo019oo`03001oogoo01Uo
o`03001oogoo02eoo`006goo00<007ooOol017oo00<007ooOol02Woo00D007ooOomoo`00009oo`03
001oogoo02ioo`03001oogoo00eoo`03001oogoo031oo`03001oogoo019oo`03001oogoo019oo`03
001oogoo01Uoo`03001oogoo02eoo`006goo00<007ooOol00Woo0`0037oo10000goo00<007ooOol0
;goo00<007ooOol02goo00<007ooOol0<Goo00<007ooOol04Woo00<007ooOol04Woo00<007ooOol0
67oo00<007ooOol0;Woo000LOol00`00Oomoo`0@Ool00`00Oomoo`03Ool00`00Ool0000`Ool00`00
Oomoo`0;Ool00`00Oomoo`0bOol00`00Oomoo`0AOol00`00Oomoo`0AOol00`00Oomoo`0IOol00`00
Oomoo`0^Ool002ioo`8000Qoo`03001oogoo02eoo`03001oogoo00]oo`03001oogoo039oo`03001o
ogoo015oo`03001oogoo015oo`03001oogoo01Qoo`03001oogoo02moo`00>Goo00<007ooOol0;7oo
00<007ooOol02goo00<007ooOol0<Woo00<007ooOol04Goo00<007ooOol04Goo00<007ooOol067oo
00<007ooOol0;goo000jOol00`00Oomoo`0/Ool00`00Oomoo`09Ool00`00Oomoo`0dOol00`00Oomo
o`0@Ool00`00Oomoo`0@Ool00`00Oomoo`0HOol00`00Oomoo`0`Ool003]oo`03001oogoo02]oo`03
001oogoo00Uoo`03001oogoo03Aoo`03001oogoo011oo`03001oogoo011oo`03001oogoo01Qoo`03
001oogoo031oo`00>goo00<007ooOol0:goo00<007ooOol02Goo00<007ooOol0=7oo00<007ooOol0
47oo00<007ooOol047oo00<007ooOol05goo00<007ooOol0<Goo000lOol00`00Oomoo`0ZOol00`00
Oomoo`09Ool00`00Oomoo`0eOol00`00Oomoo`0?Ool00`00Oomoo`0?Ool00`00Oomoo`0HOol00`00
Oomoo`0aOol003eoo`03001oogoo02Yoo`03001oogoo00Moo`03001oogoo03Ioo`03001oogoo00mo
o`03001oogoo00moo`03001oogoo01Moo`03001oogoo039oo`00?Woo00<007ooOol0:Goo00<007oo
Ool01goo00<007ooOol0=goo00<007ooOol03Woo00<007ooOol03Woo00<007ooOol067oo00<007oo
Ool0<Woo000oOol00`00Oomoo`0XOol00`00Oomoo`07Ool00`00Oomoo`0gOol00`00Oomoo`0>Ool0
0`00Oomoo`0>Ool00`00Oomoo`0GOol00`00Oomoo`0cOol0041oo`03001oogoo02Qoo`03001oogoo
00Eoo`03001oogoo03Qoo`03001oogoo00ioo`03001oogoo00ioo`03001oogoo01Moo`03001oogoo
03=oo`00@Goo00<007ooOol09goo00<007ooOol01Goo00<007ooOol0>Goo00<007ooOol03Goo00<0
07ooOol03Goo00<007ooOol067oo00<007ooOol0<goo0011Ool00`00Oomoo`0WOol00`00Oomoo`05
Ool00`00Oomoo`0iOol00`00Oomoo`0=Ool00`00Oomoo`0=Ool00`00Oomoo`0GOol00`00Oomoo`0d
Ool0049oo`03001oogoo02Ioo`03001oogoo00Eoo`03001oogoo03Uoo`03001oogoo00eoo`03001o
ogoo00eoo`03001oogoo01Moo`03001oogoo03Aoo`00@goo00<007ooOol09Woo00<007ooOol00goo
00<007ooOol0>goo00<007ooOol037oo00<007ooOol037oo00<007ooOol05goo00<007ooOol0=Goo
0014Ool00`00Oomoo`0UOol00`00Oomoo`03Ool00`00Oomoo`0kOol00`00Oomoo`0<Ool00`00Oomo
o`0<Ool00`00Oomoo`0GOol00`00Oomoo`0eOol004Eoo`03001oogoo02Aoo`03001oogoo00=oo`03
001oogoo03]oo`03001oogoo00aoo`03001oogoo00aoo`03001oogoo01Ioo`03001oogoo03Ioo`00
AWoo00<007ooOol08goo00<007ooOol00goo00<007ooOol0?7oo00<007ooOol02goo00<007ooOol0
2goo00<007ooOol05goo00<007ooOol0=Woo0016Ool00`00Oomoo`0TOol01@00Oomoogoo0000?goo
00<007ooOol02goo00<007ooOol02goo00<007ooOol05Woo00<007ooOol0=goo0017Ool00`00Oomo
o`0SOol01@00Oomoogoo0000@7oo00<007ooOol02Woo00<007ooOol02Woo00<007ooOol05goo00<0
07ooOol0=goo0018Ool00`00Oomoo`0ROol01@00Oomoogoo0000@7oo00<007ooOol02Woo00<007oo
Ool02Woo00<007ooOol05Woo00<007ooOol0>7oo0019Ool00`00Oomoo`0ROol00`00Ool00011Ool0
0`00Oomoo`0:Ool00`00Oomoo`0:Ool00`00Oomoo`0FOol00`00Oomoo`0hOol004Yoo`03001oogoo
025oo`03001oo`00049oo`03001oogoo00Uoo`03001oogoo00Uoo`03001oogoo01Ioo`03001oogoo
03Uoo`00Bgoo00<007ooOol087oo00<007oo0000@Woo00<007ooOol02Goo00<007ooOol02Goo00<0
07ooOol05Woo00<007ooOol0>Goo001<Ool00`00Oomoo`0OOol00`00Ool00012Ool00`00Oomoo`09
Ool00`00Oomoo`09Ool00`00Oomoo`0EOol00`00Oomoo`0jOol004aoo`03001oogoo021oo`03001o
ogoo049oo`03001oogoo00Qoo`03001oogoo00Qoo`03001oogoo01Ioo`03001oogoo03Yoo`00CGoo
00<007ooOol07goo0P00@goo00<007ooOol027oo00<007ooOol027oo00<007ooOol05Woo00<007oo
Ool0>Woo001>Ool00`00Oomoo`0POol00`00Oomoo`10Ool00`00Oomoo`08Ool00`00Oomoo`08Ool0
0`00Oomoo`0EOol00`00Oomoo`0kOol004moo`03001oogoo00Yoo`03001oogoo01=oo`04001oogoo
000oOol00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Oomoo`0FOol00`00Oomoo`0kOol0051oo`03
001oogoo00Qoo`03001oogoo00Qoo`03001oogoo00Yoo`800003Ool007oo03eoo`03001oogoo00Mo
o`03001oogoo00Moo`03001oogoo01Eoo`03001oogoo03aoo`00DGoo00<007ooOol01goo00<007oo
Ool00Woo0`000goo00<007ooOol01goo1`00?Woo00<007ooOol01goo00<007ooOol01goo00<007oo
Ool05Goo00<007ooOol0?7oo001BOol00`00Oomoo`06Ool01@00Oomoogoo00000goo00D007ooOomo
o`0000Moo`05001oogooOol00002Ool00`00Oomoo`0mOol00`00Oomoo`06Ool00`00Oomoo`06Ool0
0`00Oomoo`0EOol00`00Oomoo`0mOol0059oo`03001oogoo00Eoo`03001oogoo009oo`03001oogoo
00eoo`05001oogooOol00003Ool2000mOol00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`0E
Ool00`00Oomoo`0mOol005=oo`03001oogoo00Eoo`05001oogooOol00003Ool00`00Oomoo`09Ool0
1@00Oomoogoo00000Woo00@007ooOol003eoo`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo
01Eoo`03001oogoo03ioo`00E7oo00<007ooOol017oo00<007ooOol00Woo100037oo10000Woo00@0
07ooOomoo`8003]oo`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo01Eoo`03001oogoo03io
o`00EGoo00<007ooOol017oo00<007ooOol057oo00<007oo00001Woo00<007ooOol0>7oo00<007oo
Ool01Goo00<007ooOol01Goo00<007ooOol057oo00<007ooOol0?goo001FOol00`00Oomoo`0IOol2
0009Ool00`00Oomoo`0hOol00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`0EOol00`00Oomo
o`0oOol005Moo`03001oogoo02Aoo`8003Qoo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo
01Aoo`03001oogoo041oo`00Egoo00<007ooOol09Woo00<007ooOol0=Goo00<007ooOol017oo00<0
07ooOol017oo00<007ooOol057oo00<007ooOol0@7oo001HOol00`00Oomoo`0VOol00`00Oomoo`0e
Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`0DOol00`00Oomoo`11Ool005Uoo`03001o
ogoo02Ioo`8003Eoo`03001oogoo00=oo`03001oogoo00=oo`03001oogoo01Aoo`03001oogoo045o
o`00FWoo00<007ooOol09goo00<007ooOol0<Woo00<007ooOol00goo00<007ooOol00goo00<007oo
Ool04goo00<007ooOol0@Woo001KOol00`00Oomoo`0WOol00`00Oomoo`0bOol00`00Oomoo`02Ool0
0`00Oomoo`02Ool00`00Oomoo`0DOol00`00Oomoo`12Ool005aoo`03001oogoo02Moo`80039oo`03
001oogoo009oo`03001oogoo009oo`03001oogoo01Aoo`03001oogoo049oo`00GGoo00<007ooOol0
:7oo00<007ooOol0<7oo00D007ooOomoo`0000=oo`03001oogoo01Aoo`03001oogoo04=oo`00GGoo
00<007ooOol0:Goo0P00<7oo00D007ooOomoo`0000=oo`03001oogoo01Aoo`03001oogoo04=oo`00
GWoo00<007ooOol0:Woo00<007ooOol0;Goo00D007ooOomoo`0000=oo`03001oogoo01=oo`03001o
ogoo04Aoo`00Ggoo00<007ooOol0:Woo00<007ooOol0;Goo00@007ooOol0009oo`03001oogoo01Ao
o`03001oogoo04Aoo`00H7oo00<007ooOol0:Woo0P00;Goo00@007ooOol0009oo`03001oogoo01=o
o`03001oogoo04Eoo`00HGoo00<007ooOol0:goo00<007ooOol0:Woo00@007ooOol0009oo`03001o
ogoo01=oo`03001oogoo04Eoo`00HWoo00<007ooOol0:goo00<007ooOol0:Woo00D007oo001oo`00
01Eoo`03001oogoo04Ioo`00HWoo00<007ooOol0;7oo0P00:Woo00D007oo001oo`0001Eoo`03001o
ogoo04Ioo`00Hgoo00<007ooOol0;Goo00<007ooOol09goo00D007oo001oo`0001Aoo`03001oogoo
04Moo`00I7oo00<007ooOol0;Goo00<007ooOol09goo0`005Goo00<007ooOol0Agoo001UOol00`00
Oomoo`0]Ool2000WOol3000DOol00`00Oomoo`18Ool006Ioo`03001oogoo02ioo`03001oogoo02Ao
o`<001Aoo`03001oogoo04Qoo`00Igoo00<007ooOol0;Woo0P009Goo0P004goo00<007ooOol0BGoo
001XOol00`00Oomoo`0_Ool00`00Oomoo`04Ool00`00Oomoo`0MOol00`00Oomoo`030003Ool30002
Ool00`00Oomoo`02Ool00`00Oomoo`19Ool006Qoo`03001oogoo031oo`03001oogoo009oo`03001o
ogoo00Qoo`03001oogoo00aoo`03001oogoo00Eoo`8000=oo`03001oogoo00=oo`04001oogoo0002
Ool00`00Oomoo`1:Ool006Uoo`03001oogoo031oo`80009oo`03001oogoo009oo`@0009oo`03001o
ogoo00Eoo`@000=oo`03001oogoo00Moo`@0009oo`@0009oo`04001oogoo001<Ool006Yoo`03001o
ogoo035oo`03001oo`0000=oo`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo00Aoo`03001o
ogoo00Eoo`03001oo`0000800003Ool007oo009oo`04001oogoo0002Ool00`00Oomoo`1:Ool006]o
o`03001oogoo035oo`03001oogoo009oo`D000]oo`03001oogoo00aoo`07001oogooOol007oo0000
0goo00@007ooOomoo`8004eoo`00K7oo00<007ooOol0<Goo0P000Woo00D007ooOomoo`0000]oo`03
001oogoo00aoo`04001oogooOol30003Ool01P00Oomoo`00Ool004eoo`00KGoo00<007ooOol0<7oo
00<007oo00000Woo0`002goo10003Goo2`0000=oo`000000CWoo001]Ool00`00Oomoo`0aOol00`00
Ool0000@Ool00`00Oomoo`0DOol01`00Oomoogoo001oo`0004ioo`00KWoo00<007ooOol0<goo0P00
3Woo0`005Goo0P000Woo00<007ooOol0CGoo001_Ool00`00Oomoo`0dOol00`00Oomoo`0UOol00`00
Ool0001?Ool0071oo`03001oogoo03Aoo`8002=oo`@0051oo`00LGoo00<007ooOol0=Goo00<007oo
Ool06goo1@00E7oo001bOol00`00Oomoo`0dOol2000GOol50005Ool30003Ool3000BOol00`00Oomo
o`0fOol007=oo`03001oogoo039oo`03001oogoo008000Ioo`03001oogoo00Ioo`L000aoo`03001o
ogoo00=oo`04001oogoo000?Ool00`00Oomoo`0eOol007=oo`03001oogoo039oo`03001oogoo009o
o`@0009oo`04001oogooOol80003Ool00`00Oomoo`07Ool40002Ool40002Ool00`00Oomoo`06Ool2
00000goo00000002Ool00`00Oomoo`0eOol007Aoo`03001oogoo035oo`07001oogooOol007oo0000
0goo1@001Goo00<007ooOol017oo00<007ooOol01Goo00L007ooOomoo`00Ool00003Ool01@00Oomo
ogoo00001goo00@007ooOol000=oo`03001oogoo03Eoo`00MGoo00<007ooOol0;goo00<007ooOol0
0Woo1P002Woo00<007ooOol037oo00L007ooOomoo`00Ool00003Ool00`00Oomoo`09Ool01000Oomo
o`0017oo00<007ooOol0=7oo001fOol00`00Oomoo`0_Ool01000Oomoogoo0P000Woo00<007ooOol0
2Goo00<007ooOol037oo00L007ooOomoo`00Ool00003Ool00`00Oomoo`09Ool01000Oomoo`000goo
00<007ooOol0=Goo001gOol01000Oomoo`00;Goo00@007ooOomoo`@000]oo`@000=oo`<000Moo`D0
0003Ool0000000<000Yoo`@000=oo`03001oogoo03Eoo`00N7oo0P002Woo00<007ooOol037oo00<0
07ooOol03Goo00<007ooOol00goo00<007oo00001Woo00<007ooOol01goo00@007ooOol000Eoo`04
001oogoo000>Ool00`00Oomoo`07Ool00`00Oomoo`03Ool00`00Oomoo`0fOol007Uoo`03001oogoo
009oo`<000=oo`03001oogoo00Ioo`D00003Ool007oo00Qoo`@0009oo`03001oogoo00Aoo`D000=o
o`03001oogoo00Moo`@0009oo`@0009oo`03001oogoo00Eoo`800003Ool00000009oo`03001oogoo
00Ioo`8003ioo`00NGoo00D007ooOomoo`0000=oo`05001oogooOol00006Ool01@00Oomoogoo0000
0goo00<007ooOol01Goo00<007ooOol01Goo00<007ooOol00Woo00@007ooOol000Ioo`03001oogoo
00Eoo`07001oogooOol007oo00000goo00D007ooOomoo`0000Ioo`04001oogoo0003Ool00`00Oomo
o`16Ool007Qoo`03001oo`00009oo`03001oogoo00aoo`05001oogooOol0000;Ool50007Ool01@00
Oomoogoo00003Woo00L007ooOomoo`00Ool00003Ool00`00Oomoo`08Ool01000Oomoo`0017oo00<0
07ooOol0AGoo001iOol01@00Ool007oo00000goo00<007ooOol027oo00D007ooOomoo`0000]oo`05
001oogooOol00006Ool00`00Oomoo`02Ool00`00Oomoo`0<Ool01`00Oomoogoo001oo`0000=oo`03
001oogoo00Qoo`04001oogoo0003Ool00`00Oomoo`16Ool007Uoo`05001oogoo001oo`04000;Ool4
000<Ool30006Ool00`00Oomoo`02Ool4000=Ool500000goo000000030009Ool40003Ool00`00Oomo
o`16Ool007Yoo`04001oogoo000BOol00`00Oomoo`0BOol00`00Oomoo`04Ool00`00Oomoo`0QOol0
0`00Oomoo`03Ool00`00Oomoo`17Ool007ioo`03001oogoo00ioo`8001=oo`03001oogoo00Eoo`<0
021oo`8004moo`00OWoo00<007ooOol08Woo00<007ooOol0NWoo001oOol00`00Oomoo`0POol00`00
Oomoo`1kOol0081oo`03001oogoo01ioo`03001oogoo07aoo`00PGoo00<007ooOol077oo00<007oo
Ool0OGoo0022Ool00`00Oomoo`0IOol20020Ool008=oo`03001oogoo01Moo`03001oogoo081oo`00
Q7oo00<007ooOol05Goo00<007ooOol0PGoo0024Ool00`00Oomoo`0DOol00`00Oomoo`22Ool008Eo
o`03001oogoo019oo`03001oogoo08=oo`00QWoo00<007ooOol047oo00<007ooOol0Q7oo0027Ool0
0`00Oomoo`0>Ool00`00Oomoo`25Ool008Qoo`03001oogoo00aoo`03001oogoo08Ioo`00RGoo00<0
07ooOol02Woo00<007ooOol0Qgoo0029Ool00`00Oomoo`09Ool00`00Oomoo`28Ool008Yoo`03001o
ogoo00Moo`03001oogoo08Uoo`00Rgoo00<007ooOol01Goo00<007ooOol0RWoo002<Ool00`00Oomo
o`03Ool00`00Oomoo`2;Ool008eoo`05001oogooOol0002>Ool008ioo`03001oo`0008moo`00Sgoo
00<007ooOol0SWoo003oOolQOol004Yoo`03001oogoo05moo`<000=oo`<0015oo`03001oogoo05Mo
o`00BGoo00<007ooOol027oo00<007ooOol03Goo00<007ooOol037oo00<007ooOol03Goo00<007oo
Ool037oo00<007ooOol03Goo00<007ooOol02Woo00<007ooOol00goo00@007ooOol000ioo`03001o
ogoo05Ioo`00BGoo00@007ooOomoo`D0009oo`03001oogoo00Ioo`@000=oo`03001oogoo00Ioo`<0
00=oo`03001oogoo00Moo`D00003Ool007oo00Moo`@0009oo`03001oogoo00Ioo`@000=oo`03001o
ogoo00Moo`@0009oo`@0009oo`03001oogoo00Eoo`800003Ool00000009oo`03001oogoo05Ioo`00
BGoo00D007ooOomoo`00009oo`03001oogoo009oo`03001oogoo00Eoo`05001oogooOol00003Ool0
0`00Oomoo`04Ool01@00Oomoogoo00000goo00<007ooOol01Goo00D007ooOomoo`0000=oo`03001o
ogoo00Aoo`03001oogoo00Eoo`03001oogoo00Ioo`03001oogoo00Aoo`03001oogoo00Eoo`07001o
ogooOol007oo00000goo00D007ooOomoo`0000Ioo`04001oogoo0003Ool00`00Oomoo`1FOol004Qo
o`03001oogoo009oo`@000aoo`05001oogooOol0000:Ool00`00Oomoo`0=Ool01@00Oomoogoo0000
2Woo1@0037oo00<007ooOol037oo00L007ooOomoo`00Ool00003Ool00`00Oomoo`08Ool01000Oomo
o`0017oo00<007ooOol0EGoo0019Ool00`00Oomoo`04Ool00`00Oomoo`0:Ool01@00Oomoogoo0000
2Woo00D007ooOomoo`0000]oo`05001oogooOol0000:Ool01@00Oomoogoo000037oo00<007ooOol0
37oo00L007ooOomoo`00Ool00003Ool00`00Oomoo`08Ool01000Oomoo`000goo00<007ooOol0EWoo
0019Ool00`00Oomoo`02Ool3000<Ool4000<Ool4000<Ool4000;Ool3000<Ool4000=Ool500000goo
000000030009Ool40003Ool00`00Oomoo`1FOol004Yoo`03001oogoo011oo`03001oogoo021oo`03
001oogoo01Uoo`03001oogoo025oo`03001oogoo00=oo`03001oogoo05Moo`00G7oo0P008Goo0P00
6goo0`0087oo0P00Ggoo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[TextData[{
  "The function {#2\[LeftDoubleBracket]-1,1\[RightDoubleBracket],2#2\
\[LeftDoubleBracket]1\[RightDoubleBracket]}& takes the ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " coordinate from the last element of the information list (which was \
constructed internally by MakeGenealogyPlot[]), and the ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " coordinate from the first element, which gives the coalescence time.  The \
scale is such that leaves are separated by 1 unit horizontally; coalescence \
time is doubled to give an appropriate scale."
}], "Text"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(PlotGenealogy[g, 
              NodeOffset \[Rule] {\[Delta]x, \[Delta]y}]\), \(offsets\ the\ \
internal\ node\ labels\ by\ {\[Delta]x, \[Delta]y} 
              from\ the\ \(\(nodes\)\(.\)\)\)},
          {\(PlotGenealogy[g, 
              LeafOffset \[Rule] {\[Delta]x, \[Delta]y}]\), \(offsets\ the\ \
leaf\ labels\ by\ {\[Delta]x, \[Delta]y} from\ the\ \(\(nodes\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->{"NodeOffset", "LeafOffset"}],

Cell["\<\
This shifts the node labels to the left.  The scale is set by unit \
horzontal  intervals between leaves.\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
      PlotGenealogy[tr, NodeOffset \[Rule] {\(-1\), 0}, 
        NodeFunction \[Rule] 
          \(({#2\[LeftDoubleBracket]\(-1\), 1\[RightDoubleBracket], 
                2  #2\[LeftDoubleBracket]1\[RightDoubleBracket]}&)\)]]; 
    \)\)], "Input",
  CellLabel->"In[151]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .18541 m
.11111 .10301 L
s
.16667 .18541 m
.22222 .10301 L
s
.38889 .30902 m
.33333 .10301 L
s
.38889 .30902 m
.44444 .10301 L
s
.66667 .41202 m
.55556 .10301 L
s
.66667 .41202 m
.66667 .10301 L
s
.66667 .41202 m
.77778 .10301 L
s
.72222 .45322 m
.66667 .41202 L
s
.72222 .45322 m
.88889 .10301 L
s
.61111 .47383 m
.38889 .30902 L
s
.61111 .47383 m
.72222 .45322 L
s
.5 .57683 m
.16667 .18541 L
s
.5 .57683 m
.61111 .47383 L
s
gsave
.05556 .18541 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.27778 .30902 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .41202 -90.5625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
112.125000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.61111 .45322 -98.3438 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
112.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
127.687500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.5 .47383 -113.906 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
143.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
158.812500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.38889 .57683 -129.469 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
162.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
174.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
183.937500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
189.937500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -75 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[151]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0AOol01000Oomoogoo0`00
0goo0`000Woo00<007ooOol047oo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08
Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0B
Ool00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08
Ool00`00Oomoo`0?Ool00`00Oomoo`05Ool00`00Oomoo`03Ool01000Oomoo`0047oo00<007ooOol0
27oo00<007ooOol06Woo000JOol01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@0
00=oo`03001oogoo015oo`03001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D0
0003Ool007oo01=oo`03001oogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool0
0`00Oomoo`0?Ool00`00Oomoo`02Ool40002Ool40002Ool00`00Oomoo`0>Ool01000Oomoogoo0P00
00=oo`0000000Woo00<007ooOol06Woo000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Ao
o`05001oogooOol00003Ool01000Oomoo`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol0
1@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00
Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool01@00Oomoogoo00000goo00<007oo00000goo
00@007ooOol0011oo`05001oogooOol00002Ool01@00Oomoogoo000077oo000IOol00`00Oomoo`02
Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol03goo
00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo00<007ooOol00Woo00D007ooOomoo`00
00=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03001oogoo011oo`03001oogoo00=oo`03
001oogoo00Aoo`03001oogoo00eoo`03001oogoo009oo`07001oogooOol007oo00000goo00D007oo
Oomoo`0000ioo`03001oogoo009oo`04001oogoo0004Ool00`00Oomoo`0IOol001Yoo`03001oogoo
00Aoo`05001oogooOol0000DOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol0
0003Ool01000Oomoo`0057oo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo0000
0goo00@007ooOol001Aoo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00moo`05001oogoo
Ool00003Ool00`00Ool00003Ool01000Oomoo`0047oo00D007ooOomoo`00009oo`05001oogooOol0
000LOol001Yoo`03001oogoo009oo`<000=oo`03001oogoo019oo`04001oogooOol40003Ool00`00
Oomoo`0AOol00`00Oomoo`02Ool40002Ool00`00Oomoo`0BOol00`00Oomoo`02Ool40002Ool00`00
Oomoo`0BOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo00<007oo
Ool03goo00<007ooOol00Woo1@0000=oo`0000000`0000=oo`00Ool03goo00@007ooOomoo`@000=o
o`03001oogoo01Yoo`006goo00<007ooOol01Woo00<007ooOol057oo00@007ooOol000Eoo`03001o
ogoo01=oo`03001oogoo00Ioo`03001oogoo01Aoo`03001oogoo00Aoo`03001oo`0001Ioo`03001o
ogoo00Ioo`03001oogoo01Aoo`05001oogooOol00004Ool00`00Oomoo`0AOol00`00Oomoo`0<Ool0
0`00Oomoo`0@Ool01000Oomoo`001Goo00<007ooOol06goo000mOol20011Ool2000lOol3000jOol2
000SOol00?moob5oo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007oo
Ool07Goo00<007ooOol07Goo00<007ooOol07Goo00<007ooOol077oo00<007ooOol07goo000POol0
0`00Oomoo`0LOol00`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0MOol0
0`00Oomoo`0MOol00`00Oomoo`0LOol00`00Oomoo`0OOol0025oo`03001oogoo01Yoo`03001oogoo
01ioo`03001oogoo01eoo`03001oogoo01ioo`03001oogoo01aoo`03001oogoo01aoo`03001oogoo
01aoo`03001oogoo021oo`008Woo00<007ooOol067oo00<007ooOol087oo00<007ooOol06goo00<0
07ooOol07goo00<007ooOol077oo00<007ooOol077oo00<007ooOol077oo00<007ooOol087oo000R
Ool00`00Oomoo`0HOol00`00Oomoo`0POol00`00Oomoo`0KOol00`00Oomoo`0OOol00`00Oomoo`0L
Ool00`00Oomoo`0LOol00`00Oomoo`0KOol00`00Oomoo`0QOol002=oo`03001oogoo01Ioo`03001o
ogoo025oo`03001oogoo01]oo`03001oogoo021oo`03001oogoo01]oo`03001oogoo01]oo`03001o
ogoo01aoo`03001oogoo025oo`0097oo00<007ooOol05Goo00<007ooOol08Goo00<007ooOol06goo
00<007ooOol087oo00<007ooOol06goo00<007ooOol06goo00<007ooOol06goo00<007ooOol08Woo
000TOol00`00Oomoo`0DOol00`00Oomoo`0SOol00`00Oomoo`0IOol00`00Oomoo`0QOol00`00Oomo
o`0KOol00`00Oomoo`0KOol00`00Oomoo`0KOol00`00Oomoo`0ROol002Eoo`03001oogoo019oo`03
001oogoo02Aoo`03001oogoo01Uoo`03001oogoo029oo`03001oogoo01Yoo`03001oogoo01Yoo`03
001oogoo01]oo`03001oogoo02=oo`009Woo00<007ooOol04Goo00<007ooOol097oo00<007ooOol0
6Goo00<007ooOol08Woo00<007ooOol06Woo00<007ooOol06Woo00<007ooOol06goo00<007ooOol0
8goo000VOol00`00Oomoo`0@Ool00`00Oomoo`0VOol00`00Oomoo`0GOol00`00Oomoo`0SOol00`00
Oomoo`0JOol00`00Oomoo`0JOol00`00Oomoo`0KOol00`00Oomoo`0SOol002Moo`03001oogoo00io
o`03001oogoo02Moo`03001oogoo01Moo`03001oogoo02Aoo`03001oogoo01Uoo`03001oogoo01Uo
o`03001oogoo01]oo`03001oogoo02Aoo`00:7oo00<007ooOol03Goo00<007ooOol09goo00<007oo
Ool05goo00<007ooOol097oo00<007ooOol06Goo00<007ooOol06Goo00<007ooOol06goo00<007oo
Ool097oo000XOol00`00Oomoo`0<Ool00`00Oomoo`0XOol00`00Oomoo`0GOol00`00Oomoo`0TOol0
0`00Oomoo`0IOol00`00Oomoo`0IOol00`00Oomoo`0JOol00`00Oomoo`0UOol002Uoo`03001oogoo
00]oo`03001oogoo02Uoo`03001oogoo01Eoo`03001oogoo02Ioo`03001oogoo01Qoo`03001oogoo
01Qoo`03001oogoo01]oo`03001oogoo02Eoo`00:Woo00<007ooOol02Goo00<007ooOol0:Woo00<0
07ooOol05Goo00<007ooOol09Woo00<007ooOol067oo00<007ooOol067oo00<007ooOol06Woo00<0
07ooOol09Woo000ZOol00`00Oomoo`08Ool00`00Oomoo`0[Ool00`00Oomoo`0EOol00`00Oomoo`0W
Ool00`00Oomoo`0GOol00`00Oomoo`0GOol00`00Oomoo`0KOol00`00Oomoo`0VOol002]oo`03001o
ogoo00Moo`03001oogoo02]oo`03001oogoo01Eoo`03001oogoo02Moo`03001oogoo01Moo`03001o
ogoo01Moo`03001oogoo01Yoo`03001oogoo02Moo`00;7oo00<007ooOol01Goo00<007ooOol0;Goo
00<007ooOol04goo00<007ooOol0:7oo00<007ooOol05goo00<007ooOol05goo00<007ooOol06Woo
00<007ooOol09goo000/Ool00`00Oomoo`04Ool00`00Oomoo`0^Ool00`00Oomoo`0COol00`00Oomo
o`0YOol00`00Oomoo`0FOol00`00Oomoo`0FOol00`00Oomoo`0JOol00`00Oomoo`0XOol000=oo`03
001oogoo01Ioo`03001oogoo00ioo`03001oogoo00=oo`03001oogoo02ioo`03001oogoo01=oo`03
001oogoo02Uoo`03001oogoo01Ioo`03001oogoo01Ioo`03001oogoo01Yoo`03001oogoo02Qoo`00
0Woo00<007ooOol027oo00<007ooOol03Goo00<007ooOol03Woo00D007ooOomoo`00039oo`03001o
ogoo015oo`03001oogoo02Yoo`03001oogoo01Ioo`03001oogoo01Ioo`03001oogoo01Uoo`03001o
ogoo02Uoo`000Woo00@007ooOomoo`D0009oo`03001oogoo00Ioo`@000=oo`03001oogoo00ioo`05
001oogooOol0000bOol00`00Oomoo`0AOol00`00Oomoo`0[Ool00`00Oomoo`0EOol00`00Oomoo`0E
Ool00`00Oomoo`0JOol00`00Oomoo`0YOol0009oo`05001oogooOol00002Ool00`00Oomoo`02Ool0
0`00Oomoo`05Ool01@00Oomoogoo00000Woo00<007ooOol03goo00<007oo0000<goo00<007ooOol0
4Goo00<007ooOol0:goo00<007ooOol05Goo00<007ooOol05Goo00<007ooOol06Goo00<007ooOol0
:Woo00000goo001oo`03Ool4000<Ool01@00Oomoogoo00000goo00<007ooOol03goo00<007ooOol0
<Woo00<007ooOol04Goo00<007ooOol0:goo00<007ooOol05Goo00<007ooOol05Goo00<007ooOol0
6Goo00<007ooOol0:Woo0002Ool00`00Oomoo`04Ool00`00Oomoo`0:Ool01@00Oomoogoo00000Woo
00<007ooOol047oo00<007ooOol0<goo00<007ooOol03goo00<007ooOol0;Goo00<007ooOol057oo
00<007ooOol057oo00<007ooOol06Goo00<007ooOol0:goo0002Ool00`00Oomoo`02Ool3000<Ool4
0003Ool00`00Oomoo`0AOol00`00Oomoo`0bOol00`00Oomoo`0?Ool00`00Oomoo`0]Ool00`00Oomo
o`0DOol00`00Oomoo`0DOol00`00Oomoo`0IOol00`00Oomoo`0[Ool000=oo`03001oogoo011oo`03
001oogoo00=oo`03001oogoo01=oo`03001oogoo035oo`03001oogoo00moo`03001oogoo02ioo`03
001oogoo01=oo`03001oogoo01=oo`03001oogoo01Yoo`03001oogoo02]oo`005Goo0P0077oo00<0
07ooOol0<7oo00<007ooOol03goo00<007ooOol0;Woo00<007ooOol04goo00<007ooOol04goo00<0
07ooOol06Goo00<007ooOol0;7oo000dOol00`00Oomoo`0`Ool00`00Oomoo`0=Ool00`00Oomoo`0_
Ool00`00Oomoo`0COol00`00Oomoo`0COol00`00Oomoo`0IOol00`00Oomoo`0/Ool003Eoo`03001o
ogoo02moo`03001oogoo00eoo`03001oogoo031oo`03001oogoo019oo`03001oogoo019oo`03001o
ogoo01Uoo`03001oogoo02eoo`00=Woo00<007ooOol0;Woo00<007ooOol03Goo00<007ooOol0<7oo
00<007ooOol04Woo00<007ooOol04Woo00<007ooOol06Goo00<007ooOol0;Goo000fOol00`00Oomo
o`0_Ool00`00Oomoo`0;Ool00`00Oomoo`0aOol00`00Oomoo`0BOol00`00Oomoo`0BOol00`00Oomo
o`0HOol00`00Oomoo`0^Ool003Moo`03001oogoo02ioo`03001oogoo00]oo`03001oogoo039oo`03
001oogoo015oo`03001oogoo015oo`03001oogoo01Uoo`03001oogoo02ioo`00>7oo00<007ooOol0
;Goo00<007ooOol02goo00<007ooOol0<Woo00<007ooOol04Goo00<007ooOol04Goo00<007ooOol0
67oo00<007ooOol0;goo000iOol00`00Oomoo`0/Ool00`00Oomoo`0;Ool00`00Oomoo`0bOol00`00
Oomoo`0AOol00`00Oomoo`0AOol00`00Oomoo`0HOol00`00Oomoo`0_Ool003Yoo`03001oogoo02ao
o`03001oogoo00Uoo`03001oogoo03Aoo`03001oogoo011oo`03001oogoo011oo`03001oogoo01Qo
o`03001oogoo031oo`00>goo00<007ooOol0:goo00<007ooOol02Goo00<007ooOol0=7oo00<007oo
Ool047oo00<007ooOol047oo00<007ooOol067oo00<007ooOol0<7oo000kOol00`00Oomoo`0[Ool0
0`00Oomoo`09Ool00`00Oomoo`0dOol00`00Oomoo`0@Ool00`00Oomoo`0@Ool00`00Oomoo`0GOol0
0`00Oomoo`0aOol003aoo`03001oogoo02Yoo`03001oogoo00Uoo`03001oogoo03Eoo`03001oogoo
00moo`03001oogoo00moo`03001oogoo01Qoo`03001oogoo035oo`00?Goo00<007ooOol0:Woo00<0
07ooOol01goo00<007ooOol0=Woo00<007ooOol03goo00<007ooOol03goo00<007ooOol05goo00<0
07ooOol0<Woo000nOol00`00Oomoo`0YOol00`00Oomoo`07Ool00`00Oomoo`0gOol00`00Oomoo`0>
Ool00`00Oomoo`0>Ool00`00Oomoo`0HOol00`00Oomoo`0bOol003moo`03001oogoo02Qoo`03001o
ogoo00Moo`03001oogoo03Moo`03001oogoo00ioo`03001oogoo00ioo`03001oogoo01Moo`03001o
ogoo03=oo`00@7oo00<007ooOol0:7oo00<007ooOol01Goo00<007ooOol0>7oo00<007ooOol03Woo
00<007ooOol03Woo00<007ooOol05goo00<007ooOol0<goo0011Ool00`00Oomoo`0WOol00`00Oomo
o`05Ool00`00Oomoo`0iOol00`00Oomoo`0=Ool00`00Oomoo`0=Ool00`00Oomoo`0HOol00`00Oomo
o`0cOol0045oo`03001oogoo02Moo`03001oogoo00Eoo`03001oogoo03Uoo`03001oogoo00eoo`03
001oogoo00eoo`03001oogoo01Moo`03001oogoo03Aoo`00@Woo00<007ooOol09Woo00<007ooOol0
1Goo00<007ooOol0>Goo00<007ooOol03Goo00<007ooOol03Goo00<007ooOol05goo00<007ooOol0
=7oo0013Ool00`00Oomoo`0VOol00`00Oomoo`03Ool00`00Oomoo`0kOol00`00Oomoo`0<Ool00`00
Oomoo`0<Ool00`00Oomoo`0GOol00`00Oomoo`0eOol004Aoo`03001oogoo02Eoo`03001oogoo00=o
o`03001oogoo03]oo`03001oogoo00aoo`03001oogoo00aoo`03001oogoo01Moo`03001oogoo03Eo
o`00AGoo00<007ooOol097oo00<007ooOol00goo00<007ooOol0>goo00<007ooOol037oo00<007oo
Ool037oo00<007ooOol05Woo00<007ooOol0=Woo0016Ool00`00Oomoo`0SOol00`00Oomoo`03Ool0
0`00Oomoo`0lOol00`00Oomoo`0;Ool00`00Oomoo`0;Ool00`00Oomoo`0GOol00`00Oomoo`0fOol0
04Ioo`03001oogoo02Aoo`05001oogooOol0000oOol00`00Oomoo`0;Ool00`00Oomoo`0;Ool00`00
Oomoo`0FOol00`00Oomoo`0gOol004Moo`03001oogoo02=oo`05001oogooOol00010Ool00`00Oomo
o`0:Ool00`00Oomoo`0:Ool00`00Oomoo`0GOol00`00Oomoo`0gOol004Qoo`03001oogoo029oo`05
001oogooOol00010Ool00`00Oomoo`0:Ool00`00Oomoo`0:Ool00`00Oomoo`0FOol00`00Oomoo`0h
Ool004Uoo`03001oogoo029oo`03001oo`00045oo`03001oogoo00Yoo`03001oogoo00Yoo`03001o
ogoo01Ioo`03001oogoo03Qoo`00@goo00<007ooOol017oo00<007ooOol03Woo00<007ooOol047oo
00<007oo0000@Woo00<007ooOol02Goo00<007ooOol02Goo00<007ooOol05Woo00<007ooOol0>Goo
0012Ool00`00Oomoo`06Ool00`00Ool0000>Ool00`00Oomoo`0?Ool00`00Ool00012Ool00`00Oomo
o`09Ool00`00Oomoo`09Ool00`00Oomoo`0FOol00`00Oomoo`0iOol0049oo`03001oogoo009oo`<0
009oo`8000Qoo`D00003Ool007oo011oo`03001oo`00049oo`03001oogoo00Uoo`03001oogoo00Uo
o`03001oogoo01Eoo`03001oogoo03Yoo`00@Woo00D007ooOomoo`0000=oo`05001oo`00Ool00006
Ool01@00Oomoogoo00000Woo00<007ooOol047oo00<007ooOol0@Woo00<007ooOol027oo00<007oo
Ool027oo00<007ooOol05Woo00<007ooOol0>Woo0011Ool00`00Oomoo`02Ool00`00Oomoo`04Ool0
0`00Oomoo`05Ool01@00Oomoogoo00000goo00<007ooOol03goo0P00@goo00<007ooOol027oo00<0
07ooOol027oo00<007ooOol05Woo00<007ooOol0>Woo0012Ool01@00Oomoogoo00000goo00D007oo
Oomoo`0000Ioo`05001oogooOol00002Ool00`00Oomoo`0BOol00`00Oomoo`10Ool00`00Oomoo`08
Ool00`00Oomoo`08Ool00`00Oomoo`0EOol00`00Oomoo`0kOol0049oo`03001oogoo009oo`@000Ao
o`03001oogoo00Aoo`@0009oo`03001oogoo01=oo`03001oogoo041oo`03001oogoo00Moo`03001o
ogoo00Moo`03001oogoo01Ioo`03001oogoo03]oo`00@goo00<007ooOol02Woo00<007ooOol01Woo
00<007oo00005goo0P00@7oo00<007ooOol01goo00<007ooOol01goo00<007ooOol05Goo00<007oo
Ool0?7oo001AOol00`00Oomoo`04Ool2000KOol00`00Oomoo`0mOol00`00Oomoo`07Ool00`00Oomo
o`07Ool00`00Oomoo`0EOol00`00Oomoo`0lOol0059oo`03001oogoo025oo`03001oogoo03eoo`03
001oogoo00Ioo`03001oogoo00Ioo`03001oogoo01Eoo`03001oogoo03eoo`00DWoo00<007ooOol0
8Woo0P00?Goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol05Goo00<007ooOol0?Goo001C
Ool00`00Oomoo`0SOol00`00Oomoo`0kOol00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`0E
Ool00`00Oomoo`0nOol005Aoo`03001oogoo02=oo`8003]oo`03001oogoo00Eoo`03001oogoo00Eo
o`03001oogoo01Eoo`03001oogoo03ioo`00EGoo00<007ooOol097oo00<007ooOol0>7oo00<007oo
Ool01Goo00<007ooOol01Goo00<007ooOol057oo00<007ooOol0?goo001FOol00`00Oomoo`0TOol0
0`00Oomoo`0hOol00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`0EOol00`00Oomoo`0oOol0
05Moo`03001oogoo02Aoo`8003Qoo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo01Aoo`03
001oogoo041oo`00Egoo00<007ooOol09Woo00<007ooOol0=Goo00<007ooOol017oo00<007ooOol0
17oo00<007ooOol057oo00<007ooOol0@7oo001HOol00`00Oomoo`0VOol00`00Oomoo`0eOol00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`0DOol00`00Oomoo`11Ool005Uoo`03001oogoo02Io
o`8003Eoo`03001oogoo00=oo`03001oogoo00=oo`03001oogoo01Aoo`03001oogoo045oo`00FWoo
00<007ooOol09goo00<007ooOol0<Woo00<007ooOol00goo00<007ooOol00goo00<007ooOol04goo
00<007ooOol0@Woo001KOol00`00Oomoo`0WOol00`00Oomoo`0bOol00`00Oomoo`02Ool00`00Oomo
o`02Ool00`00Oomoo`0DOol00`00Oomoo`12Ool005aoo`03001oogoo02Moo`80039oo`03001oogoo
009oo`03001oogoo009oo`03001oogoo01Aoo`03001oogoo049oo`00GGoo00<007ooOol0:7oo00<0
07ooOol0<7oo00D007ooOomoo`0000=oo`03001oogoo01Aoo`03001oogoo04=oo`00GGoo00<007oo
Ool0:Goo0P00<7oo00D007ooOomoo`0000=oo`03001oogoo01Aoo`03001oogoo04=oo`00GWoo00<0
07ooOol0:Woo00<007ooOol0;Goo00D007ooOomoo`0000=oo`03001oogoo01=oo`03001oogoo04Ao
o`00Ggoo00<007ooOol0:Woo00<007ooOol0;Goo00@007ooOol0009oo`03001oogoo01Aoo`03001o
ogoo04Aoo`00H7oo00<007ooOol0:Woo0P00;Goo00@007ooOol0009oo`03001oogoo01=oo`03001o
ogoo04Eoo`00HGoo00<007ooOol0:goo00<007ooOol0:Woo00@007ooOol0009oo`03001oogoo01=o
o`03001oogoo04Eoo`00HWoo00<007ooOol0:goo00<007ooOol0:Woo00D007oo001oo`0001Eoo`03
001oogoo04Ioo`00HWoo00<007ooOol0;7oo0P00:Woo00D007oo001oo`0001Eoo`03001oogoo04Io
o`00Hgoo00<007ooOol08Goo00<007ooOol02Goo00<007ooOol057oo0`000goo0`000Woo00<007oo
Ool01Goo00D007oo001oo`0001Aoo`03001oogoo04Moo`00I7oo00<007ooOol07goo00<007ooOol0
27oo00@007ooOol000aoo`03001oogoo00Uoo`03001oogoo00=oo`04001oogoo0007Ool3000EOol0
0`00Oomoo`17Ool006Eoo`03001oogoo01ioo`03001oogoo009oo`@0009oo`04001oogooOol20003
Ool40003Ool00`00Oomoo`06Ool40002Ool40002Ool00`00Oomoo`05Ool3000DOol00`00Oomoo`18
Ool006Ioo`03001oogoo01eoo`05001oogooOol00007Ool00`00Oomoo`02Ool01@00Oomoogoo0000
1Woo00<007ooOol017oo00L007ooOomoo`00Ool00003Ool01000Oomoo`001goo0`0057oo00<007oo
Ool0B7oo001WOol00`00Oomoo`0KOol00`00Oomoo`02Ool50009Ool200000goo001oo`0<Ool01`00
Oomoogoo001oo`0000=oo`05001oogooOol00007Ool2000COol00`00Oomoo`19Ool006Qoo`03001o
ogoo01]oo`05001oogooOol00003Ool00`00Oomoo`09Ool2000=Ool01`00Oomoogoo001oo`0000=o
o`04001oogoo000:Ool00`00Oomoo`0@Ool00`00Oomoo`19Ool006Qoo`03001oogoo01]oo`03001o
ogoo009oo`<000aoo`@000aoo`D00003Ool0000000<00003Ool007oo00Yoo`8000moo`03001oogoo
04Yoo`00JGoo00<007ooOol06goo00<007ooOol04Goo0`005goo00<007ooOol037oo00<007ooOol0
37oo00<007ooOol0BWoo001ZOol00`00Oomoo`0^Ool4000VOol2000<Ool00`00Oomoo`1:Ool006]o
o`03001oogoo035oo`03001oogoo02Eoo`03001oogoo00Qoo`03001oogoo04]oo`00K7oo00<007oo
Ool0<Goo0P009Woo00<007ooOol01goo00<007ooOol0Bgoo001]Ool00`00Oomoo`0OOol00`00Oomo
o`0@Ool00`00Oomoo`0>Ool30003Ool3000=Ool20002Ool01@00Oomoogoo0000CWoo001]Ool00`00
Oomoo`0NOol00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`03Ool00`00Oomoo`0:Ool00`00
Oomoo`03Ool01000Oomoo`002goo00@007ooOol0009oo`03001oogoo04aoo`00KWoo00<007ooOol0
7Goo00<007ooOol00Woo10000Woo00<007ooOol01Woo10000goo00<007ooOol01goo10000Woo1000
0Woo00<007ooOol01Goo0P0000=oo`0000000`0000=oo`00Ool0CWoo001_Ool00`00Oomoo`0LOol0
1@00Oomoogoo00001goo00<007ooOol01Woo00@007ooOol000=oo`03001oogoo00Eoo`07001oogoo
Ool007oo00000goo00D007ooOomoo`0000Ioo`04001oogoo0003Ool00`00Ool0001?Ool0071oo`03
001oogoo01Yoo`03001oogoo009oo`D000aoo`04001oogooOol20009Ool01`00Oomoogoo001oo`00
00=oo`03001oogoo00Qoo`05001oogoo001oo`04001@Ool0075oo`03001oogoo01Yoo`05001oogoo
Ool00003Ool00`00Oomoo`0:Ool00`00Oomoo`03Ool00`00Oomoo`06Ool01`00Oomoogoo001oo`00
00=oo`03001oogoo00Qoo`D0009oo`03001oogoo04moo`00H7oo00<007ooOol03goo00<007ooOol0
6Goo00<007ooOol00Woo0`0037oo10000Woo0`0027oo1@0000=oo`0000000`0017oo2@000goo00<0
07ooOol0Cgoo001OOol00`00Oomoo`08Ool00`00Oomoo`06Ool00`00Oomoo`04Ool00`00Oomoo`0<
Ool00`00Oomoo`03Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00Ool00005Ool200000goo001o
o`0<Ool60005Ool00`00Oomoo`03Ool00`00Oomoo`1@Ool005moo`03001oogoo009oo`<000=oo`03
001oogoo00Ioo`H00003Ool007oo00Moo`@0009oo`03001oogoo00Ioo`@000=oo`03001oogoo00Io
o`@0009oo`@00003Ool0000000Qoo`D0009oo`03001oogoo00Eoo`8005Qoo`00Ggoo00D007ooOomo
o`0000=oo`05001oogooOol00007Ool20002Ool01@00Oomoogoo00001Woo00<007ooOol01Goo00<0
07ooOol01Woo00<007ooOol017oo00<007ooOol017oo00L007ooOomoo`00Ool00003Ool00`00Oomo
o`020002Ool60002Ool01@00Oomoogoo0000HGoo001NOol00`00Oomoo`02Ool00`00Oomoo`0=Ool0
1@00Ool007oo00002Woo1@0037oo00<007ooOol02goo00L007ooOomoo`00Ool00003Ool00`00Oomo
o`040005Ool01000Oomoo`0017oo00<007ooOol0GWoo001OOol01@00Oomoogoo00000goo00<007oo
Ool02Goo00<007ooOol00P002Woo00D007ooOomoo`0000aoo`03001oogoo00]oo`07001oogooOol0
07oo00000goo00<007oo00002Goo00@007ooOol000=oo`03001oogoo05moo`00Ggoo00<007ooOol0
0Woo100037oo10002goo0`0037oo100037oo1@0000=oo`0000000`002Woo10000goo00<007ooOol0
Ggoo001POol00`00Oomoo`0DOol2000JOol00`00Oomoo`0EOol00`00Oomoo`09Ool00`00Oomoo`03
Ool00`00Oomoo`1POol007Ioo`800003Ool007oo01Qoo`<001Aoo`03001oogoo00Uoo`8006Qoo`00
NGoo00<007ooOol0;Goo00<007ooOol0M7oo001jOol00`00Oomoo`0[Ool00`00Oomoo`1eOol007]o
o`03001oogoo02Uoo`03001oogoo07Ioo`00O7oo00<007ooOol09goo00<007ooOol0Mgoo001mOol0
0`00Oomoo`0UOol00`00Oomoo`1hOol007ioo`03001oogoo02=oo`03001oogoo07Uoo`00OWoo00<0
07ooOol08Woo00<007ooOol0NWoo001oOol00`00Oomoo`0POol00`00Oomoo`1kOol0081oo`03001o
ogoo01ioo`03001oogoo07aoo`00PGoo00<007ooOol077oo00<007ooOol0OGoo0022Ool00`00Oomo
o`0IOol20020Ool008=oo`03001oogoo01Moo`03001oogoo081oo`00Q7oo00<007ooOol05Goo00<0
07ooOol0PGoo0024Ool00`00Oomoo`0DOol00`00Oomoo`22Ool008Eoo`03001oogoo019oo`03001o
ogoo08=oo`00QWoo00<007ooOol047oo00<007ooOol0Q7oo0027Ool00`00Oomoo`0>Ool00`00Oomo
o`25Ool008Qoo`03001oogoo00aoo`03001oogoo08Ioo`00RGoo00<007ooOol02Woo00<007ooOol0
Qgoo0029Ool00`00Oomoo`09Ool00`00Oomoo`28Ool008Yoo`03001oogoo00Moo`03001oogoo08Uo
o`00<Goo00<007ooOol0Egoo00<007ooOol017oo0`000goo0`004Woo00<007ooOol0L7oo000`Ool0
0`00Oomoo`08Ool00`00Oomoo`0<Ool00`00Oomoo`0=Ool00`00Oomoo`0<Ool00`00Oomoo`0=Ool0
0`00Oomoo`0=Ool01000Oomoo`001Goo00@007ooOol000Eoo`04001oogoo000?Ool00`00Oomoo`1_
Ool0031oo`04001oogooOol50002Ool00`00Oomoo`05Ool40003Ool00`00Oomoo`07Ool30003Ool0
0`00Oomoo`06Ool500000goo001oo`08Ool40002Ool00`00Oomoo`06Ool40003Ool01@00Oomoogoo
00000goo1@000Woo10000Woo00<007ooOol01Woo0P0000=oo`0000000Woo00<007ooOol0Kgoo000`
Ool01@00Oomoogoo00000Woo00<007ooOol00Woo00<007ooOol017oo00D007ooOomoo`0000=oo`03
001oogoo00Eoo`05001oogooOol00003Ool00`00Oomoo`04Ool01@00Oomoogoo00000goo00<007oo
Ool01Goo00<007ooOol01Goo00<007ooOol01Woo00<007ooOol017oo00H007ooOomoo`00Ool20003
Ool00`00Ool00003Ool01@00Oomoogoo00001goo00@007ooOol000=oo`03001oogoo06moo`00;goo
00<007ooOol00Woo10002goo00D007ooOomoo`0000]oo`03001oogoo00aoo`05001oogooOol0000;
Ool5000<Ool00`00Oomoo`09Ool00`00Ool00003Ool00`00Ool00003Ool00`00Oomoo`09Ool01000
Oomoo`0017oo00<007ooOol0KWoo000`Ool00`00Oomoo`04Ool00`00Oomoo`09Ool01@00Oomoogoo
00002goo00D007ooOomoo`0000Yoo`05001oogooOol0000;Ool01@00Oomoogoo000037oo00<007oo
Ool02goo00L007ooOomoo`00Ool00003Ool00`00Oomoo`09Ool01000Oomoo`000goo00<007ooOol0
Kgoo000`Ool00`00Oomoo`02Ool3000;Ool4000=Ool4000;Ool4000<Ool3000<Ool4000<Ool50000
0goo00000003000:Ool40003Ool00`00Oomoo`1_Ool0035oo`03001oogoo00moo`03001oogoo021o
o`03001oogoo01Yoo`03001oogoo025oo`03001oogoo00=oo`03001oogoo071oo`00@Woo0P008Goo
0P0077oo0`0087oo0P00N7oo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {\(MakeGenealogyPlot[
              g]\), \(appends\ coordinates\ to\ the\ information\ lists; \ 
            these\ are\ used\ by\ \(\(PlotGenealogy[]\)\(.\)\)\)},
          {\(\(\ \)\(PlotGenealogy[g, 
              MakeGenealogyPlot \[Rule] 
                False]\)\), \(takes\ coordinates\ directly\ from\ the\ last\ \
element\ of\ the\ information\ lists, \ 
            rather\ than\ constructing\ them\ with\ \
\(\(MakeGenealogyPlot\)\(.\)\)\)},
          {\(SizeOfGenealogyPlot[
              g]\), \(gives\ the\ minimum\ and\ maximum\ coordinates, \ 
            held\ as\ the\ last\ element\ of\ the\ information\ lists\ in\ g, \
\ in\ the\ form\ \(\({{x\_min, x\_max}, {y\_min, y\_max}}\)\(.\)\)\)}
          }], TraditionalForm]]]], "DefinitionBox",
  CellTags->{"MakeGenealogyPlot", "SizeOfGenealogyPlot"}],

Cell["\<\
PlotGenealogy[] works by calling MakeGenealogyPlot[] to construct a \
tree with the coordinates held as the last element of the information \
lists:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ptr = MakeGenealogyPlot[tr]\)], "Input",
  CellLabel->"In[152]:="],

Cell[BoxData[
    RowBox[{"Node", "[", 
      RowBox[{\({a, b, c, d, e, f, gg, h}\), ",", 
        RowBox[{"{", 
          RowBox[{
            StyleBox["2.29999999999999982`",
              StyleBoxAutoDelete->True,
              PrintPrecision->2], ",", \({7\/2, 4}\)}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{"Node", "[", 
              RowBox[{\({a, b}\), ",", 
                RowBox[{"{", 
                  RowBox[{
                    StyleBox["0.4`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->1], ",", \({1\/2, 1}\)}], "}"}], ",", 
                \({Node[{a}, {0, {0, 0}}, {}], Node[{b}, {0, {1, 0}}, {}]}
                  \)}], "]"}], ",", 
            RowBox[{"Node", "[", 
              RowBox[{\({c, d, e, f, gg, h}\), ",", 
                RowBox[{"{", 
                  RowBox[{
                    StyleBox["1.8`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", \({9\/2, 3}\)}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{
                  \(Node[{c, d}, {1, {5\/2, 1}}, {Node[{c}, {0, {2, 0}}, {}], 
                        Node[{d}, {0, {3, 0}}, {}]}]\), ",", 
                    RowBox[{"Node", "[", 
                      RowBox[{\({e, f, gg, h}\), ",", 
                        RowBox[{"{", 
                          RowBox[{
                            StyleBox["1.7`",
                              StyleBoxAutoDelete->True,
                              PrintPrecision->2], ",", \({11\/2, 2}\)}], 
                          "}"}], ",", 
                        RowBox[{"{", 
                          RowBox[{
                            RowBox[{"Node", "[", 
                              RowBox[{\({e, f, gg}\), ",", 
                                RowBox[{"{", 
                                  RowBox[{
                                    StyleBox["1.5`",
                                      StyleBoxAutoDelete->True,
                                      PrintPrecision->2], ",", \({5, 1}\)}], 
                                  "}"}], ",", 
                                \({Node[{e}, {0, {4, 0}}, {}], 
                                  Node[{f}, {0, {5, 0}}, {}], 
                                  Node[{gg}, {0, {6, 0}}, {}]}\)}], "]"}], 
                            ",", \(Node[{h}, {0, {7, 0}}, {}]\)}], "}"}]}], 
                      "]"}]}], "}"}]}], "]"}]}], "}"}]}], "]"}]], "Output",
  CellLabel->"Out[152]="]
}, Closed]],

Cell["\<\
This displays the liat, taking coordinates directly from the last \
element, rather than calling MakeGenealogyPlot[] internally:\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[PlotGenealogy[ptr, MakeGenealogyPlot \[Rule] False]]; \)\)], 
  "Input",
  CellLabel->"In[153]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.111111 0.111111 0.103006 0.103006 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.16667 .20601 m
.11111 .10301 L
s
.16667 .20601 m
.22222 .10301 L
s
.38889 .20601 m
.33333 .10301 L
s
.38889 .20601 m
.44444 .10301 L
s
.66667 .20601 m
.55556 .10301 L
s
.66667 .20601 m
.66667 .10301 L
s
.66667 .20601 m
.77778 .10301 L
s
.72222 .30902 m
.66667 .20601 L
s
.72222 .30902 m
.88889 .10301 L
s
.61111 .41202 m
.38889 .20601 L
s
.61111 .41202 m
.72222 .30902 L
s
.5 .51503 m
.16667 .20601 L
s
.5 .51503 m
.61111 .41202 L
s
gsave
.14444 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.36667 .22661 -79.7812 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
90.562500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.64444 .22661 -90.5625 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
112.125000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.7 .32962 -98.3438 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
112.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
127.687500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.58889 .43262 -113.906 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
143.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
158.812500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.47778 .53563 -129.469 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
75.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
84.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
90.562500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
100.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
106.125000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
115.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
121.687500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
131.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
137.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
146.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
152.812500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
162.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
174.375000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(,) show
183.937500 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
189.937500 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.11111 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(a) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.22222 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(b) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.33333 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(c) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.44444 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(d) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.55556 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(e) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.66667 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(f) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.77778 .0824 -75 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(gg) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
gsave
.88889 .0824 -72 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.000000 moveto
 558.000000 16.000000 lineto
 558.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.000000 lineto
closepath
clip newpath
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
63.000000 13.000000 moveto
(8) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(h) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(<) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[153]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo000KOol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool0
0`00Oomoo`0COol00`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0DOol0
0`00Oomoo`06Ool00`00Oomoo`0DOol00`00Oomoo`06Ool00`00Oomoo`0AOol01000Oomoogoo0`00
0goo0`000Woo00<007ooOol047oo00<007ooOol01Woo00<007ooOol06goo000JOol00`00Oomoo`08
Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0AOol00`00Oomoo`08Ool00`00Oomoo`0B
Ool00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08Ool00`00Oomoo`0BOol00`00Oomoo`08
Ool00`00Oomoo`0?Ool00`00Oomoo`05Ool00`00Oomoo`03Ool01000Oomoo`0047oo00<007ooOol0
27oo00<007ooOol06Woo000JOol01000Oomoogoo1@000Woo00<007ooOol04Woo00@007ooOomoo`@0
00=oo`03001oogoo015oo`03001oogoo009oo`<000=oo`03001oogoo019oo`03001oogoo009oo`D0
0003Ool007oo01=oo`03001oogoo009oo`@0009oo`03001oogoo019oo`04001oogooOol40003Ool0
0`00Oomoo`0?Ool00`00Oomoo`02Ool40002Ool40002Ool00`00Oomoo`0>Ool01000Oomoogoo0P00
00=oo`0000000Woo00<007ooOol06Woo000JOol01@00Oomoogoo00000Woo00D007ooOomoo`0001Ao
o`05001oogooOol00003Ool01000Oomoo`004goo00D007ooOomoo`0000=oo`04001oogoo000DOol0
1@00Oomoogoo00000goo00@007ooOol001Aoo`05001oogooOol00006Ool00`00Oomoo`0BOol00`00
Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`0?Ool01@00Oomoogoo00000goo00<007oo00000goo
00@007ooOol0011oo`05001oogooOol00002Ool01@00Oomoogoo000077oo000IOol00`00Oomoo`02
Ool40004Ool00`00Oomoo`0@Ool00`00Oomoo`02Ool01@00Oomoogoo00000goo00<007ooOol03goo
00<007ooOol00Woo00<007ooOol01Goo00<007ooOol047oo00<007ooOol00Woo00D007ooOomoo`00
00=oo`03001oogoo011oo`03001oogoo009oo`D000=oo`03001oogoo011oo`03001oogoo00=oo`03
001oogoo00Aoo`03001oogoo00eoo`03001oogoo009oo`07001oogooOol007oo00000goo00D007oo
Oomoo`0000ioo`03001oogoo009oo`04001oogoo0004Ool00`00Oomoo`0IOol001Yoo`03001oogoo
00Aoo`05001oogooOol0000DOol01@00Oomoogoo00000goo00@007ooOol001=oo`05001oogooOol0
0003Ool01000Oomoo`0057oo00D007ooOomoo`0000=oo`04001oogoo000DOol01@00Oomoogoo0000
0goo00@007ooOol001Aoo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00moo`05001oogoo
Ool00003Ool00`00Ool00003Ool01000Oomoo`0047oo00D007ooOomoo`00009oo`05001oogooOol0
000LOol001Yoo`03001oogoo009oo`<000=oo`03001oogoo019oo`04001oogooOol40003Ool00`00
Oomoo`0AOol00`00Oomoo`02Ool40002Ool00`00Oomoo`0BOol00`00Oomoo`02Ool40002Ool00`00
Oomoo`0BOol00`00Oomoo`02Ool30003Ool00`00Oomoo`0BOol01000Oomoogoo10000goo00<007oo
Ool03goo00<007ooOol00Woo1@0000=oo`0000000`0000=oo`00Ool03goo00@007ooOomoo`@000=o
o`03001oogoo01Yoo`006goo00<007ooOol01Woo00<007ooOol057oo00@007ooOol000Eoo`03001o
ogoo01=oo`03001oogoo00Ioo`03001oogoo01Aoo`03001oogoo00Aoo`03001oo`0001Ioo`03001o
ogoo00Ioo`03001oogoo01Aoo`05001oogooOol00004Ool00`00Oomoo`0AOol00`00Oomoo`0<Ool0
0`00Oomoo`0@Ool01000Oomoo`001Goo00<007ooOol06goo000mOol20011Ool2000lOol3000jOol2
000SOol00?moob5oo`0087oo00<007ooOol077oo00<007ooOol07Goo00<007ooOol07Goo00<007oo
Ool07Goo0P007Woo00<007ooOol077oo0P007Woo00<007ooOol07goo000POol00`00Oomoo`0LOol0
0`00Oomoo`0MOol00`00Oomoo`0MOol00`00Oomoo`0OOol00`00Oomoo`0KOol00`00Oomoo`0KOol0
0`00Oomoo`0NOol00`00Oomoo`0OOol0025oo`03001oogoo01Yoo`03001oogoo01moo`03001oogoo
01]oo`03001oogoo025oo`03001oogoo01Yoo`03001oogoo01Yoo`03001oogoo01ioo`03001oogoo
021oo`008Goo00<007ooOol06Woo00<007ooOol07goo00<007ooOol06goo00<007ooOol08Woo00<0
07ooOol06Goo00<007ooOol06Goo00<007ooOol07Woo00<007ooOol08Goo000ROol00`00Oomoo`0H
Ool00`00Oomoo`0QOol00`00Oomoo`0IOol00`00Oomoo`0TOol00`00Oomoo`0HOol00`00Oomoo`0H
Ool00`00Oomoo`0NOol00`00Oomoo`0ROol0029oo`03001oogoo01Qoo`03001oogoo025oo`03001o
ogoo01Uoo`03001oogoo02Eoo`03001oogoo01Moo`03001oogoo01Moo`03001oogoo01ioo`03001o
ogoo02=oo`008goo00<007ooOol05Woo00<007ooOol08goo00<007ooOol05goo00<007ooOol09goo
00<007ooOol05Woo00<007ooOol05Woo00<007ooOol07goo00<007ooOol08goo000SOol00`00Oomo
o`0FOol00`00Oomoo`0SOol00`00Oomoo`0GOol00`00Oomoo`0XOol00`00Oomoo`0EOol00`00Oomo
o`0EOol00`00Oomoo`0OOol00`00Oomoo`0TOol002Aoo`03001oogoo01Aoo`03001oogoo02Eoo`03
001oogoo01Eoo`03001oogoo02Yoo`03001oogoo01Aoo`03001oogoo01Aoo`03001oogoo01moo`03
001oogoo02Eoo`009Goo00<007ooOol04goo00<007ooOol09Woo00<007ooOol04goo00<007ooOol0
;7oo00<007ooOol04goo00<007ooOol04goo00<007ooOol07goo00<007ooOol09Woo000UOol00`00
Oomoo`0BOol00`00Oomoo`0WOol00`00Oomoo`0COol00`00Oomoo`0]Ool00`00Oomoo`0BOol00`00
Oomoo`0BOol00`00Oomoo`0OOol00`00Oomoo`0WOol002Ioo`03001oogoo015oo`03001oogoo02Qo
o`03001oogoo015oo`03001oogoo02moo`03001oogoo015oo`03001oogoo015oo`03001oogoo021o
o`03001oogoo02Moo`009Woo00<007ooOol047oo00<007ooOol0:Goo00<007ooOol04Goo00<007oo
Ool0<7oo00<007ooOol047oo00<007ooOol047oo00<007ooOol087oo00<007ooOol0:7oo000WOol0
0`00Oomoo`0?Ool00`00Oomoo`0ZOol00`00Oomoo`0?Ool00`00Oomoo`0bOol00`00Oomoo`0?Ool0
0`00Oomoo`0?Ool00`00Oomoo`0POol00`00Oomoo`0YOol002Moo`03001oogoo00ioo`03001oogoo
02]oo`03001oogoo00moo`03001oogoo03=oo`03001oogoo00ioo`03001oogoo00ioo`03001oogoo
021oo`03001oogoo02Yoo`00:7oo00<007ooOol03Goo00<007ooOol0;7oo00<007ooOol03Goo00<0
07ooOol0=Goo0P003Woo00<007ooOol037oo0P008Woo00<007ooOol0:goo000XOol00`00Oomoo`0<
Ool00`00Oomoo`0]Ool00`00Oomoo`0=Ool00`00Oomoo`0gOol00`00Oomoo`0;Ool00`00Oomoo`0;
Ool00`00Oomoo`0ROol00`00Oomoo`0[Ool002Uoo`03001oogoo00]oo`03001oogoo02ioo`03001o
ogoo00]oo`03001oogoo03Uoo`03001oogoo00Yoo`03001oogoo00Yoo`03001oogoo029oo`03001o
ogoo02aoo`00:Goo00<007ooOol02Woo00<007ooOol0;goo00<007ooOol02goo00<007ooOol0>Woo
00<007ooOol02Goo00<007ooOol02Goo00<007ooOol08Woo00<007ooOol0;Goo000ZOol00`00Oomo
o`09Ool00`00Oomoo`0`Ool00`00Oomoo`09Ool00`00Oomoo`0lOol00`00Oomoo`08Ool00`00Oomo
o`08Ool00`00Oomoo`0ROol00`00Oomoo`0^Ool002Yoo`03001oogoo00Qoo`03001oogoo035oo`03
001oogoo00Uoo`03001oogoo03eoo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo029oo`03
001oogoo02moo`00:goo00<007ooOol01goo00<007ooOol0<Woo00<007ooOol01goo00<007ooOol0
?goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol08goo00<007ooOol0;goo000[Ool00`00
Oomoo`06Ool00`00Oomoo`0cOol00`00Oomoo`07Ool00`00Oomoo`10Ool00`00Oomoo`05Ool00`00
Oomoo`05Ool00`00Oomoo`0SOol00`00Oomoo`0`Ool002aoo`03001oogoo00Eoo`03001oogoo03Ao
o`03001oogoo00Eoo`03001oogoo049oo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo02=o
o`03001oogoo035oo`00;Goo00<007ooOol00goo00<007ooOol0=Woo00<007ooOol00goo00<007oo
Ool0A7oo00<007ooOol00goo00<007ooOol00goo00<007ooOol08goo00<007ooOol0<Woo000]Ool0
0`00Oomoo`03Ool00`00Oomoo`0fOol00`00Oomoo`03Ool00`00Oomoo`15Ool00`00Oomoo`02Ool0
0`00Oomoo`02Ool00`00Oomoo`0SOol00`00Oomoo`0cOol002ioo`05001oogooOol0000jOol01@00
Oomoogoo0000BGoo00D007ooOomoo`0000=oo`03001oogoo02Aoo`03001oogoo03=oo`00;Woo00D0
07ooOomoo`0003Yoo`05001oogooOol0001:Ool01000Oomoo`000Woo00<007ooOol097oo00<007oo
Ool0=7oo000_Ool00`00Ool0000lOol00`00Ool0001<Ool01@00Ool007oo00009Woo00<007ooOol0
=Goo000_Ool00`00Ool0000lOol00`00Ool0001=Ool3000VOol00`00Oomoo`0fOol0031oo`8003eo
o`8004ioo`03001oogoo02Aoo`03001oogoo03Moo`0077oo00<007ooOol04goo00@007ooOol002Io
o`03001oogoo019oo`05001oogooOol0000[Ool00`00Oomoo`0KOol00`00Oomoo`02Ool30003Ool3
0002Ool00`00Oomoo`0DOol00`00Oomoo`0gOol001]oo`03001oogoo00Qoo`03001oogoo00Yoo`04
001oogoo000TOol00`00Oomoo`08Ool00`00Oomoo`09Ool01@00Oomoogoo0000:Goo00<007ooOol0
27oo00<007ooOol037oo00<007ooOol00goo00<007ooOol017oo00<007ooOol00goo00@007ooOol0
01Aoo`03001oogoo03Qoo`006goo00@007ooOomoo`D0009oo`03001oogoo00Ioo`@00004Ool007oo
000TOol00`00Oomoo`02Ool30003Ool00`00Oomoo`07Ool500000goo001oo`0XOol00`00Oomoo`02
Ool40002Ool00`00Oomoo`05Ool40003Ool00`00Oomoo`03Ool01000Oomoogoo10000Woo10000Woo
00<007ooOol04Goo00<007ooOol0>Goo000KOol01@00Oomoogoo00000Woo00<007ooOol00Woo00<0
07ooOol01Goo00H007ooOomoo`00Ool2000TOol01@00Oomoogoo00000goo00D007ooOomoo`0000Mo
o`04001oogooOol200000goo001oo`0XOol01@00Oomoogoo00001goo00<007ooOol01Goo00<007oo
Ool017oo00<007ooOol00goo00<007oo00000goo00<007oo00000goo00@007ooOol0019oo`03001o
ogoo03Yoo`006Woo00<007ooOol00Woo100037oo00D007ooOomoo`00009oo`80029oo`03001oogoo
009oo`03001oogoo00eoo`09001oogooOol007oo001oo`0002Moo`03001oogoo009oo`D000]oo`03
001oogoo00Yoo`03001oo`0000=oo`03001oo`0000=oo`05001oogooOol0000AOol00`00Oomoo`0j
Ool001]oo`03001oogoo00Aoo`03001oogoo00Yoo`05001oogooOol00002Ool2000SOol01@00Oomo
ogoo00000goo00<007ooOol02Goo00D007ooOomoo`00009oo`03001oogoo02Moo`05001oogooOol0
0003Ool00`00Oomoo`09Ool00`00Oomoo`0;Ool20003Ool00`00Ool00003Ool01000Oomoo`004Goo
00<007ooOol0>goo000KOol00`00Oomoo`02Ool3000<Ool40003Ool00`00Ool0000ROol00`00Oomo
o`02Ool4000<Ool40002Ool2000XOol00`00Oomoo`02Ool3000;Ool4000<Ool600000goo00000003
00000goo001oo`0?Ool00`00Oomoo`0lOol001aoo`03001oogoo011oo`03001oogoo00=oo`05001o
ogooOol0000ROol00`00Oomoo`0DOol00`00Ool00002Ool00`00Oomoo`0VOol00`00Oomoo`0@Ool0
0`00Oomoo`0<Ool00`00Oomoo`09Ool00`00Oomoo`0>Ool00`00Oomoo`0mOol002ioo`8000Yoo`03
001oogoo03Eoo`8000Eoo`03001oogoo03Qoo`<000eoo`03001oogoo01Qoo`03001oogoo03ioo`00
>goo00<007ooOol0?7oo00<007ooOol0Agoo00<007ooOol067oo00<007ooOol0?Woo000lOol00`00
Oomoo`0lOol00`00Oomoo`17Ool00`00Oomoo`0FOol00`00Oomoo`0oOol003eoo`03001oogoo03ao
o`8004Moo`03001oogoo01Eoo`03001oogoo041oo`00?Woo0P00?Woo00<007ooOol0AGoo00<007oo
Ool04goo00<007ooOol0@Goo0010Ool00`00Oomoo`0lOol00`00Oomoo`14Ool00`00Oomoo`0BOol0
0`00Oomoo`12Ool0045oo`03001oogoo03aoo`03001oogoo04Aoo`03001oogoo015oo`03001oogoo
049oo`00@Woo00<007ooOol0?7oo00<007ooOol0A7oo00<007ooOol03goo00<007ooOol0@goo0013
Ool00`00Oomoo`0lOol00`00Oomoo`13Ool00`00Oomoo`0>Ool00`00Oomoo`14Ool004Aoo`03001o
ogoo03aoo`03001oogoo04=oo`03001oogoo00aoo`03001oogoo04Eoo`00AGoo00<007ooOol0?7oo
00<007ooOol0@Woo00<007ooOol02goo00<007ooOol0AWoo0016Ool00`00Oomoo`0lOol00`00Oomo
o`12Ool00`00Oomoo`0:Ool00`00Oomoo`16Ool004Moo`03001oogoo03aoo`03001oogoo045oo`03
001oogoo00Uoo`03001oogoo04Moo`00B7oo00<007ooOol0?7oo00<007ooOol0@Goo00<007ooOol0
1goo00<007ooOol0B7oo0019Ool00`00Oomoo`0lOol00`00Oomoo`10Ool00`00Oomoo`06Ool00`00
Oomoo`19Ool004Yoo`03001oogoo03aoo`80045oo`03001oogoo00Aoo`03001oogoo04Yoo`00Bgoo
0P00?Woo00<007ooOol0?goo00<007ooOol00goo00<007ooOol0BWoo001=Ool00`00Oomoo`0lOol0
0`00Oomoo`0nOol00`00Oomoo`02Ool00`00Oomoo`1;Ool004ioo`03001oogoo03aoo`03001oogoo
03ioo`04001oogoo001>Ool004moo`03001oogoo03aoo`03001oogoo03eoo`03001oo`0004moo`00
D7oo00<007ooOol0?7oo00<007ooOol0?7oo0P00D7oo001AOol00`00Oomoo`0lOol00`00Oomoo`0j
Ool00`00Oomoo`1@Ool0059oo`03001oogoo03aoo`03001oogoo01Eoo`03001oogoo021oo`<000=o
o`<0019oo`03001oogoo03Ioo`00Dgoo00<007ooOol0?7oo00<007ooOol04goo00<007ooOol027oo
00<007ooOol037oo00<007ooOol01Woo00D007ooOomoo`0000Eoo`04001oogoo000?Ool00`00Oomo
o`0eOol005Aoo`03001oogoo03aoo`03001oogoo019oo`03001oogoo009oo`@0009oo`03001oogoo
00Eoo`@000=oo`03001oogoo00Eoo`03001oo`0000<0009oo`@0009oo`03001oogoo00Ioo`800003
Ool00000009oo`03001oogoo03Eoo`00EGoo00<007ooOol0?7oo00<007ooOol04Goo00D007ooOomo
o`0000Moo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00=oo`03001oo`0000=oo`03001o
o`0000=oo`05001oogooOol00007Ool01000Oomoo`000goo00<007ooOol0=Goo001FOol00`00Oomo
o`0lOol2000@Ool00`00Oomoo`02Ool5000;Ool00`00Oomoo`09Ool01000Oomoo`000goo00<007oo
00000goo00<007ooOol02Goo00@007ooOol000Aoo`03001oogoo03Aoo`00Egoo00<007ooOol0?Goo
00<007ooOol03Woo00D007ooOomoo`0000=oo`03001oogoo00Uoo`03001oogoo00Qoo`05001oogoo
Ool00003Ool00`00Ool00003Ool00`00Oomoo`09Ool01000Oomoo`000goo00<007ooOol0=Goo001H
Ool00`00Oomoo`0mOol00`00Oomoo`0=Ool00`00Oomoo`02Ool3000;Ool40007Ool00`00Oomoo`03
Ool500000goo00000003000:Ool40003Ool00`00Oomoo`0eOol005Uoo`8003ioo`03001oogoo00eo
o`03001oogoo011oo`03001oogoo00Ioo`03001oogoo01Uoo`03001oogoo00=oo`03001oogoo03Io
o`00Fgoo00<007ooOol0?7oo00<007ooOol07goo0`001Goo00<007ooOol06Goo0P00?Woo001LOol0
0`00Oomoo`0lOol00`00Oomoo`0UOol00`00Oomoo`1JOol005eoo`03001oogoo03aoo`03001oogoo
02=oo`03001oogoo05]oo`00GWoo00<007ooOol0?7oo00<007ooOol08Goo00<007ooOol0G7oo001O
Ool00`00Oomoo`0lOol00`00Oomoo`0OOol00`00Oomoo`1MOol0061oo`03001oogoo03aoo`03001o
ogoo01aoo`80061oo`00HGoo00<007ooOol0?7oo00<007ooOol06Woo00<007ooOol0H7oo001ROol0
0`00Oomoo`0lOol00`00Oomoo`0HOol00`00Oomoo`1QOol006=oo`03001oogoo03aoo`8001Moo`03
001oogoo069oo`00I7oo00<007ooOol0?Goo00<007ooOol04goo00<007ooOol0Hgoo001UOol00`00
Oomoo`0mOol00`00Oomoo`0AOol00`00Oomoo`1TOol006Ioo`8003ioo`03001oogoo00moo`03001o
ogoo06Eoo`00J7oo00<007ooOol0?7oo00<007ooOol03Goo00<007ooOol0IWoo001YOol00`00Oomo
o`0lOol00`00Oomoo`0;Ool00`00Oomoo`1WOol006Yoo`03001oogoo03aoo`03001oogoo00Uoo`03
001oogoo06Qoo`00Jgoo00<007ooOol0?7oo00<007ooOol01goo00<007ooOol0JGoo001/Ool00`00
Oomoo`0lOol00`00Oomoo`05Ool00`00Oomoo`1ZOol006eoo`03001oogoo03aoo`03001oogoo00=o
o`03001oogoo06]oo`00KWoo00<007ooOol0?7oo00D007ooOomoo`0006ioo`00Kgoo00<007ooOol0
?7oo00<007oo0000Kgoo001`Ool00`00Oomoo`0kOol2001`Ool0075oo`03001oogoo00Ioo`03001o
ogoo031oo`03001oogoo00aoo`<000=oo`<0015oo`03001oogoo04Moo`00LWoo00<007ooOol017oo
00<007ooOol027oo00<007ooOol037oo00<007ooOol03Goo00<007ooOol01Woo00<007ooOol00goo
00<007ooOol02Woo00<007ooOol00goo00@007ooOol000ioo`03001oogoo04Ioo`00Lgoo00<007oo
Ool00goo00<007ooOol00Woo0`000goo00<007ooOol01Woo1@0000=oo`00Ool027oo10000Woo00<0
07ooOol01Goo10000goo00<007ooOol01goo10000Woo10000Woo00<007ooOol01Goo0P0000=oo`00
00000Woo00<007ooOol0AWoo001dOol20003Ool01@00Oomoogoo00000goo00D007ooOomoo`0000Io
o`05001oogooOol00003Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Ool0
0006Ool00`00Oomoo`05Ool01`00Oomoogoo001oo`0000=oo`05001oogooOol00006Ool01000Oomo
o`000goo00<007ooOol0AWoo001fOol00`00Ool00004Ool00`00Oomoo`0<Ool01@00Oomoogoo0000
2goo1@0027oo00@007ooOol000ioo`07001oogooOol007oo00000goo00<007ooOol027oo00@007oo
Ool000Aoo`03001oogoo04Eoo`00Mgoo00<007oo00000goo00D007ooOomoo`0000Yoo`05001oogoo
Ool0000;Ool01@00Oomoogoo00001goo00D007ooOomoo`0000ioo`07001oogooOol007oo00000goo
00<007ooOol027oo00@007ooOol000=oo`03001oogoo04Ioo`00N7oo0P0017oo10002goo100037oo
0`001goo00@007ooOomoo`@000eoo`D00003Ool0000000<000Uoo`@000=oo`03001oogoo04Ioo`00
NGoo0P005Goo00<007ooOol04goo00<007ooOol00goo00<007ooOol08Goo00<007ooOol00goo00<0
07ooOol0Agoo001jOol00`00Oomoo`0BOol2000DOol00`00Oomoo`04Ool3000POol2001?Ool007]o
o`03001oogoo02Eoo`8007]oo`00O7oo00<007ooOol08goo00<007ooOol0Ngoo001mOol00`00Oomo
o`0QOol00`00Oomoo`1lOol007ioo`03001oogoo01moo`03001oogoo07eoo`00Ogoo00<007ooOol0
7Goo00<007ooOol0OWoo0020Ool00`00Oomoo`0KOol00`00Oomoo`1oOol0085oo`8001Yoo`03001o
ogoo081oo`00Pgoo00<007ooOol05Woo00<007ooOol0PGoo0024Ool00`00Oomoo`0DOol00`00Oomo
o`22Ool008Eoo`03001oogoo015oo`8008Eoo`00QWoo00<007ooOol03goo00<007ooOol0QGoo0027
Ool00`00Oomoo`0=Ool00`00Oomoo`26Ool008Qoo`03001oogoo00]oo`03001oogoo08Moo`00RGoo
00<007ooOol02Goo00<007ooOol0R7oo002:Ool00`00Oomoo`07Ool00`00Oomoo`29Ool008]oo`03
001oogoo00Eoo`03001oogoo08Yoo`00S7oo00<007ooOol00goo00<007ooOol0Rgoo002=Ool01@00
Oomoogoo0000SWoo002>Ool00`00Ool0002?Ool008moo`03001oogoo08ioo`00ogoo8Goo001:Ool0
0`00Oomoo`1OOol30003Ool3000AOol00`00Oomoo`1GOol004Uoo`03001oogoo00Qoo`03001oogoo
00eoo`03001oogoo00aoo`03001oogoo00eoo`03001oogoo00aoo`03001oogoo00eoo`03001oogoo
00Yoo`03001oogoo00=oo`04001oogoo000>Ool00`00Oomoo`1FOol004Uoo`04001oogooOol50002
Ool00`00Oomoo`06Ool40003Ool00`00Oomoo`06Ool30003Ool00`00Oomoo`07Ool500000goo001o
o`07Ool40002Ool00`00Oomoo`06Ool40003Ool00`00Oomoo`07Ool40002Ool40002Ool00`00Oomo
o`05Ool200000goo00000002Ool00`00Oomoo`1FOol004Uoo`05001oogooOol00002Ool00`00Oomo
o`02Ool00`00Oomoo`05Ool01@00Oomoogoo00000goo00<007ooOol017oo00D007ooOomoo`0000=o
o`03001oogoo00Eoo`05001oogooOol00003Ool00`00Oomoo`04Ool00`00Oomoo`05Ool00`00Oomo
o`06Ool00`00Oomoo`04Ool00`00Oomoo`05Ool01`00Oomoogoo001oo`0000=oo`05001oogooOol0
0006Ool01000Oomoo`000goo00<007ooOol0EWoo0018Ool00`00Oomoo`02Ool4000<Ool01@00Oomo
ogoo00002Woo00<007ooOol03Goo00D007ooOomoo`0000Yoo`D000aoo`03001oogoo00aoo`07001o
ogooOol007oo00000goo00<007ooOol027oo00@007ooOol000Aoo`03001oogoo05Eoo`00BGoo00<0
07ooOol017oo00<007ooOol02Woo00D007ooOomoo`0000Yoo`05001oogooOol0000;Ool01@00Oomo
ogoo00002Woo00D007ooOomoo`0000aoo`03001oogoo00aoo`07001oogooOol007oo00000goo00<0
07ooOol027oo00@007ooOol000=oo`03001oogoo05Ioo`00BGoo00<007ooOol00Woo0`0037oo1000
37oo100037oo10002goo0`0037oo10003Goo1@0000=oo`0000000`002Goo10000goo00<007ooOol0
EWoo001:Ool00`00Oomoo`0@Ool00`00Oomoo`0POol00`00Oomoo`0IOol00`00Oomoo`0QOol00`00
Oomoo`03Ool00`00Oomoo`1GOol005aoo`80025oo`8001]oo`<0021oo`8005moo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5o
o`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003o
OolQOol00?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.01116, -1.00003, 
  0.0314367, 0.0339103}}]
}, Closed]],

Cell["This gives the size of the plot:", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SizeOfGenealogyPlot[ptr]\)], "Input",
  CellLabel->"In[154]:="],

Cell[BoxData[
    \({{0, 0}, {7, 4}}\)], "Output",
  CellLabel->"Out[154]="]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{509, 693},
WindowMargins->{{Automatic, -3}, {Automatic, 0}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00`0001804P000000_02@?o/onh3109BI085:0?l0@00005X0FP000003[0;@001
0000I00100000@0000000BL?0040000000000000000000000000000000000?nL
ojH?50^J00P100000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "PlotGenealogy"->{
    Cell[1788, 53, 240, 6, 37, "DefinitionBox",
      CellTags->"PlotGenealogy"]},
  "NodeLabels"->{
    Cell[44554, 1329, 471, 11, 80, "DefinitionBox",
      CellTags->{"NodeLabels", "LeafLabels"}]},
  "LeafLabels"->{
    Cell[44554, 1329, 471, 11, 80, "DefinitionBox",
      CellTags->{"NodeLabels", "LeafLabels"}]},
  "NodeFunction"->{
    Cell[80369, 2227, 401, 8, 60, "DefinitionBox",
      CellTags->"NodeFunction"]},
  "NodeOffset"->{
    Cell[127205, 3562, 535, 10, 84, "DefinitionBox",
      CellTags->{"NodeOffset", "LeafOffset"}]},
  "LeafOffset"->{
    Cell[127205, 3562, 535, 10, 84, "DefinitionBox",
      CellTags->{"NodeOffset", "LeafOffset"}]},
  "MakeGenealogyPlot"->{
    Cell[173745, 4886, 880, 16, 140, "DefinitionBox",
      CellTags->{"MakeGenealogyPlot", "SizeOfGenealogyPlot"}]},
  "SizeOfGenealogyPlot"->{
    Cell[173745, 4886, 880, 16, 140, "DefinitionBox",
      CellTags->{"MakeGenealogyPlot", "SizeOfGenealogyPlot"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"PlotGenealogy", 221094, 6275},
  {"NodeLabels", 221195, 6278},
  {"LeafLabels", 221313, 6281},
  {"NodeFunction", 221433, 6284},
  {"NodeOffset", 221536, 6287},
  {"LeafOffset", 221655, 6290},
  {"MakeGenealogyPlot", 221781, 6293},
  {"SizeOfGenealogyPlot", 221926, 6296}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 46, 0, 36, "SubsectionIcon"],
Cell[1788, 53, 240, 6, 37, "DefinitionBox",
  CellTags->"PlotGenealogy"],
Cell[2031, 61, 123, 3, 22, "Text"],
Cell[2157, 66, 58, 0, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[2240, 70, 88, 2, 27, "Input"],
Cell[2331, 74, 42208, 1252, 184, 25784, 1044, "GraphicsData", "PostScript", \
"Graphics"]
}, Closed]],
Cell[44554, 1329, 471, 11, 80, "DefinitionBox",
  CellTags->{"NodeLabels", "LeafLabels"}],

Cell[CellGroupData[{
Cell[45050, 1344, 150, 4, 27, "Input"],
Cell[45203, 1350, 10553, 200, 184, 1059, 78, "GraphicsData", "PostScript", \
"Graphics"]
}, Closed]],
Cell[55771, 1553, 390, 7, 50, "DefinitionBox"],
Cell[56164, 1562, 83, 1, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[56272, 1567, 190, 6, 27, "Input"],
Cell[56465, 1575, 23889, 649, 184, 10980, 484, "GraphicsData", "PostScript", \
"Graphics"]
}, Closed]],
Cell[80369, 2227, 401, 8, 60, "DefinitionBox",
  CellTags->"NodeFunction"],
Cell[80773, 2237, 156, 4, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[80954, 2245, 270, 7, 27, "Input"],
Cell[81227, 2254, 45371, 1291, 184, 25784, 1044, "GraphicsData", \
"PostScript", "Graphics"]
}, Closed]],
Cell[126613, 3548, 589, 12, 60, "Text"],
Cell[127205, 3562, 535, 10, 84, "DefinitionBox",
  CellTags->{"NodeOffset", "LeafOffset"}],
Cell[127743, 3574, 136, 3, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[127904, 3581, 302, 7, 42, "Input"],
Cell[128209, 3590, 45521, 1293, 184, 25784, 1044, "GraphicsData", \
"PostScript", "Graphics"]
}, Closed]],
Cell[173745, 4886, 880, 16, 140, "DefinitionBox",
  CellTags->{"MakeGenealogyPlot", "SizeOfGenealogyPlot"}],
Cell[174628, 4904, 179, 4, 42, "MathCaption"],

Cell[CellGroupData[{
Cell[174832, 4912, 86, 2, 27, "Input"],
Cell[174921, 4916, 2515, 53, 144, "Output"]
}, Closed]],
Cell[177451, 4972, 161, 4, 32, "MathCaption"],

Cell[CellGroupData[{
Cell[177637, 4980, 125, 3, 27, "Input"],
Cell[177765, 4985, 42208, 1252, 184, 25784, 1044, "GraphicsData", \
"PostScript", "Graphics"]
}, Closed]],
Cell[219988, 6240, 55, 0, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[220068, 6244, 83, 2, 27, "Input"],
Cell[220154, 6248, 76, 2, 20, "Output"]
}, Closed]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

