(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3408,        100]*)
(*NotebookOutlinePosition[      4292,        128]*)
(*  CellTagsIndexPosition[      4248,        124]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Caution!", "SubsectionIcon"],

Cell["\<\
Some care is needed in building up sets of rules that describe the \
full life cycle:\
\>", "Text"],

Cell[TextData[{
  "//. applies each item in the list of rules in turn, and stops at the first \
rule that applies.  It is therefore important that each rule applies to a \
distinct expression.  For example, ",
  Cell[BoxData[
      \(TraditionalForm\`\((Recombination[{\[GothicCapitalA], \(\
\[GothicCapitalG]\^*\)}, 
            r]\[Vee]Recombination[{\[GothicCapitalA], \
\(\[GothicCapitalG]\^*\)}, \[Rho]])\)\)]],
  " is a pair of rules that both transform ",
  Cell[BoxData[
      \(TraditionalForm\`\[GothicCapitalD]\_{\(i\_{\(\[GothicCapitalG]\^*\), \
\[Ellipsis]}\) \[Ellipsis]}\)]],
  ", but in different ways.  Only the first will be used: it would make no \
sense to use both."
}], "Text",
  CellDingbat->"\[GrayCircle]"],

Cell[TextData[{
  "In the example above, the default stages \[GothicCapitalG], \
\[GothicCapitalZ], \[GothicCapitalA], ",
  Cell[BoxData[
      \(TraditionalForm\`\(\[GothicCapitalZ]\^*\)\)]],
  " are used.  However, these ",
  StyleBox["must",
    FontWeight->"Bold"],
  " be defined explicitly using DefineContext[].  Different stage names could \
be specified if necessary."
}], "Text",
  CellDingbat->"\[GrayCircle]"],

Cell[TextData[{
  "Similarly, either the default set of selected loci ",
  Cell[BoxData[
      \(TraditionalForm\`\[DoubleStruckCapitalW]\_sex_\)]],
  " must be defined, or some other set must be named using Selection[{\
\[GothicCapitalZ],\[GothicCapitalA]},\[GothicA],\[DoubleStruckCapitalW],{Sex}]\
"
}], "Text",
  CellDingbat->"\[GrayCircle]"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{520, 626},
WindowMargins->{{Automatic, 174}, {Automatic, 42}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000]P2:?oQon82n@960dL5:0?l0080001804P000000]P2:001
0000I00000400`<300000BL?00400@0000000000000006P801T1T00000000000
00000000000000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 34, 0, 36, "SubsectionIcon"],
Cell[1776, 53, 109, 3, 22, "Text"],
Cell[1888, 58, 731, 16, 76, "Text"],
Cell[2622, 76, 421, 11, 38, "Text"],
Cell[3046, 89, 346, 8, 36, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

