(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3271,         80]*)
(*NotebookOutlinePosition[      4155,        108]*)
(*  CellTagsIndexPosition[      4111,        104]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Summary", "SubsectionIcon"],

Cell["\<\
\tThe package is described in five sections.  First, models of \
admixture, involving both short- and long-range migration, are described.  \
These lead to lead to associations among genes which depend on the number of \
genes involved, and on how many come from each parent. Associations involving \
particular loci are proportional to the divergence in allele frequency for \
that locus; this makes it simple to rescale, so as to allow for variation in \
associations across loci.  Second, algorithms for calculating genotype \
frequencies from  mmoments are described; the simple method of estimating the \
matrix of moments is also described here, with its extension to families.  \
The third section methods for making maximum likelihood estimates of the \
within- and between-genome associations, and for testing hypotheses as to \
their magnitude. This uses the Metropolis algorithm.  Methods for finding the \
constraints on moments are then given: these are needed to determine the size \
of trial changes to parameter values.  Finally, methods for generating random \
samples, and testing the algorithms against these, are described.  Obsolete \
functions (which use a different, and less satisfactory description of \
linkage disequilibria) are also documented.\
\>", "Text"],

Cell[TextData[{
  "\tThe algorithms are described more fully in Barton (",
  ButtonBox["2000",
    ButtonData:>{"References", "Barton 2000"},
    ButtonStyle->"AddOnsLink",
    ButtonNote->"2000"],
  ")"
}], "Text"]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{520, 626},
WindowMargins->{{245, Automatic}, {Automatic, 46}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 33, 0, 36, "SubsectionIcon"],
Cell[1753, 51, 1296, 18, 190, "Text"],
Cell[3052, 71, 215, 7, 23, "Text"]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

