(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    108332,       1720]*)
(*NotebookOutlinePosition[    109214,       1748]*)
(*  CellTagsIndexPosition[    109170,       1744]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Explaining the rules", "SubsectionIcon"],

Cell["\<\
This section explains how the full set of rules is built up, and \
why it is necessary to apply rules repeatedly, rather than just once.\
\>", \
"Text"],

Cell["\<\
These are the linkage disequilibria in the new gametes, in terms of \
the adult genotypes:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\[GothicCapitalD]\_{i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}, \
k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}} /. Recombination[]\) /. 
      SymmetricRecombination[]\)], "Input",
  CellLabel->"In[144]:="],

Cell[BoxData[
    \(\[GothicR]\_\({}, {i, k}\)\ \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}}\ \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}}\ \((\(-\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\))\) + \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}\))\)\ \((\(-\
\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \
\[WeierstrassP]\_\(k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}\))\))\) + \[GothicR]\_\({i}, {k}\)\ \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}}\ \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}}\ \((\(-\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\))\) + \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}\))\)\ \((\(-\
\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \
\[WeierstrassP]\_\(k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}\))\))\) + \[GothicR]\_\({i}, {k}\)\ \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}}\ \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}}\ \((\(-\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\(-\[WeierstrassP]\_\(i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}\))\)\ \((\(-\
\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \
\[WeierstrassP]\_\(k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}\))\))\) + \[GothicR]\_\({}, {i, k}\)\ \((\[GothicCapitalD]\
\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}}\ \((\(-\
\[WeierstrassP]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \
\[WeierstrassP]\_\(i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}\))\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}}\ \((\(-\[WeierstrassP]\_\(k\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \[WeierstrassP]\_\(k\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\(-\
\[WeierstrassP]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) + \
\[WeierstrassP]\_\(i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}\))\)\ \
\((\(-\[WeierstrassP]\_\(k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\) \
+ \[WeierstrassP]\_\(k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}\))\))\)\)], "Output",
  CellLabel->"Out[144]="]
}, Open  ]],

Cell[TextData[{
  "Reciprocal recombinations are assumed equally frequent (",
  ButtonBox["SymmetricRecombination",
    ButtonData:>{"Recombination", "SymmetricRecombination"},
    ButtonStyle->"AddOnsLink"],
  "[])."
}], "Text"],

Cell[TextData[{
  "This involves changes in reference point, \[WeierstrassP].  Assume that \
the reference point in the gamete pools is equal to the mean within each sex, \
so that single-locus ",
  Cell[BoxData[
      \(TraditionalForm\`\[GothicCapitalD]\_{\[DoubleStruckI]} = 0\)]],
  " (",
  Cell[BoxData[
      RowBox[{
        ButtonBox["ReferencePointZero",
          ButtonData:>{"Reference points", "ReferencePointZero"},
          ButtonStyle->"AddOnsLink"], 
        "[", \({\(\[GothicCapitalG]\^*\), \[GothicCapitalG]}\), "]"}]]],
  ").  The reference points in the adults and zygotes are assumed the same as \
in the gametes (",
  ButtonBox["ReferencePointSame",
    ButtonData:>{"Reference points", "ReferencePointSame"},
    ButtonStyle->"AddOnsLink"],
  "[\[GothicCapitalG],{\[GothicCapitalA],\[GothicCapitalZ]}])."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(\[GothicCapitalD]\_{i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}, k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}} /. 
            Recombination[]\) /. SymmetricRecombination[]\) /. 
        ReferencePointSame[\[GothicCapitalG], {\[GothicCapitalA], \
\[GothicCapitalZ]}]\) /. 
      ReferencePointZero[{\(\[GothicCapitalG]\^*\), \[GothicCapitalG]}]\)], \
"Input",
  CellLabel->"In[84]:=  (9:28:34 on 3/4/01)"],

Cell[BoxData[
    \(\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\) - \
\[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}}\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\))\)\ \[GothicR]\_\({}, {i, k}\) + \((\[GothicCapitalD]\
\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}}\ \((\
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\) - \
\[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}}\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\))\)\ \[GothicR]\_\({}, {i, k}\) + \((\[GothicCapitalD]\
\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}}\ \((\
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\) - \
\[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}}\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\))\)\ \[GothicR]\_\({i}, {k}\) + \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\) - \
\[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\))\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}}\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) - \[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) - \[GothicM]\_\(k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}\))\))\)\ \[GothicR]\_\({i}, {k}\)\)], "Output",
  CellLabel->"Out[84]=  (9:28:34 on 3/4/01)"]
}, Open  ]],

Cell[TextData[{
  "In order to express the ",
  Cell[BoxData[
      \(\[GothicM]\_\(i\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}\)\)]],
  "in terms of the adult ",
  Cell[BoxData[
      \(TraditionalForm\`\[GothicM]\)]],
  ", we must apply the recombination rules ",
  StyleBox["again",
    FontSlant->"Italic"],
  ":"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(\(\(\(\(\[GothicCapitalD]\_{i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}, k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}} /. 
                    Recombination[]\) /. SymmetricRecombination[]\) /. 
                ReferencePointSame[\[GothicCapitalG], {\[GothicCapitalA], \
\[GothicCapitalZ]}]\) /. 
              ReferencePointZero[{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalG]}]\) /. Recombination[]\) /. SymmetricRecombination[]\) /. 
        ReferencePointSame[\[GothicCapitalG], {\[GothicCapitalA], \
\[GothicCapitalZ]}]\) /. 
      ReferencePointZero[{\(\[GothicCapitalG]\^*\), \[GothicCapitalG]}]\)], \
"Input",
  CellLabel->"In[85]:=  (9:28:49 on 3/4/01)"],

Cell[BoxData[
    \(\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}}\ \((\[GothicM]\_\(k\
\_{\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\[GothicM]\_\(i\_{\
\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\)\ \((\[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\))\)\ \[GothicR]\_\({}, {i, k}\) + \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}}\ \((\[GothicM]\_\(k\
\_{\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\[GothicM]\_\(i\_{\
\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\)\ \((\[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\))\)\ \[GothicR]\_\({}, {i, k}\) + \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalM]}}\ \((\[GothicM]\_\(k\
\_{\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\[GothicM]\_\(i\_{\
\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\)\ \((\[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\))\)\ \[GothicR]\_\({i}, {k}\) + \((\
\[GothicCapitalD]\_{i\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalA], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}}\ \
\((\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalA], \[GothicCapitalF], \[GothicCapitalF]}}\ \((\[GothicM]\_\(k\
\_{\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\) + \((\[GothicM]\_\(i\_{\
\[GothicCapitalG], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(i\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\)\ \((\[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalF]}\) - 
                  1\/2\ \[GothicM]\_\(k\_{\[GothicCapitalA], \
\[GothicCapitalF], \[GothicCapitalM]}\))\))\)\ \[GothicR]\_\({i}, {k}\)\)], \
"Output",
  CellLabel->"Out[85]=  (9:28:49 on 3/4/01)"]
}, Open  ]],

Cell[TextData[{
  "Note that the order of application of the rules is important: \
ReferencePointSame[\[GothicCapitalG],{\[GothicCapitalA],\[GothicCapitalZ]}] \
is applied first, and generates terms involving ",
  Cell[BoxData[
      \(TraditionalForm\`\[WeierstrassP]\_\(i\_{\[GothicCapitalG], \
\[Ellipsis]}\)\)]],
  ", and these are then simplified by ",
  Cell[BoxData[
      \(ReferencePointZero[{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalG]}]\)]],
  "."
}], "Text"],

Cell[TextData[{
  "Next, we express the adult \[GothicCapitalD] and \[GothicM] after \
selection in terms of those in zygotes.  Selection acts on locus ",
  Cell[BoxData[
      \(TraditionalForm\`i\)]],
  ":"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(FitnessSet[sex_] := {i\_{\[GothicCapitalZ], sex, \[GothicCapitalM]}, 
          i\_{\[GothicCapitalZ], sex, \[GothicCapitalF]}};\)\), "\
\[IndentingNewLine]", 
    \(\(\(\(\(\(\(\(\(\(\[GothicCapitalD]\_{i\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}, k\_{\(\[GothicCapitalG]\^*\), \[GothicCapitalF]}} /. 
                        Recombination[]\) /. SymmetricRecombination[]\) /. 
                    ReferencePointSame[\[GothicCapitalG], {\[GothicCapitalA], \
\[GothicCapitalZ]}]\) /. 
                  ReferencePointZero[{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalG]}]\) /. Recombination[]\) /. SymmetricRecombination[]\) /. 
            ReferencePointSame[\[GothicCapitalG], {\[GothicCapitalA], \
\[GothicCapitalZ]}]\) /. 
          ReferencePointZero[{\(\[GothicCapitalG]\^*\), \[GothicCapitalG]}]\) \
/. Recombination[]\) /. Selection[{Sex}]\)}], "Input",
  CellLabel->"In[86]:=  (9:29:09 on 3/4/01)"],

Cell[BoxData[
    \(\[GothicR]\_\({}, {i, k}\)\ \
\((\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\%2\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\))\) + \[GothicR]\_\({i}, {k}\)\ \((\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}, k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\))\) + \[GothicR]\_\({i}, {k}\)\ \((\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\%2\) + \
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalF]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\))\) + \[GothicR]\_\({}, {i, k}\)\ \((\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}, k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \((\(-\[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\)\ \
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) + \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\) + \((\[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\%2\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}, i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\%2\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\)\ \((\[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\) + 
                  1\/2\ \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[WeierstrassP]\_\(k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}\) - \((\(-\
\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \((\(-\[GothicCapitalD]\_{i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \((\(-\[GothicCapitalD]\_{k\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\)\ \[GothicCapitalD]\_{i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}} + \[GothicCapitalD]\
\_{k\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalF]}, i\_{\
\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}})\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\))\))\)\)], "Output",
  CellLabel->"Out[87]=  (9:29:11 on 3/4/01)"]
}, Closed]],

Cell["\<\
Finally, this expression involving zygote genotypes is expressed in \
terms of gametic associations:\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(expr = \(\(\((\((\(\(\(\(\(\(\(\(\(\[GothicCapitalD]\_{i\_{\(\
\[GothicCapitalG]\^*\), \[GothicCapitalF]}, k\_{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalF]}} /. Recombination[]\) /. SymmetricRecombination[]\) /. 
                                    ReferencePointSame[\[GothicCapitalG], {\
\[GothicCapitalA], \[GothicCapitalZ]}]\) /. 
                                  ReferencePointZero[{\(\[GothicCapitalG]\^*\)\
, \[GothicCapitalG]}]\) /. Recombination[]\) /. SymmetricRecombination[]\) /. 
                            ReferencePointSame[\[GothicCapitalG], {\
\[GothicCapitalA], \[GothicCapitalZ]}]\) /. 
                          ReferencePointZero[{\(\[GothicCapitalG]\^*\), \
\[GothicCapitalG]}]\) /. Recombination[]\) /. Selection[{Sex}])\) /. 
                  UnionOfGametes[])\) /. 
              RandomUnion[\[GothicCapitalG]]\) \
/. \[IndentingNewLine]ReferencePointSame[\[GothicCapitalG], \
{\[GothicCapitalA], \[GothicCapitalZ]}]\) /. 
          ReferencePointZero[\[GothicCapitalG]] // Simplify\)], "Input",
  CellLabel->"In[89]:=  (9:30:13 on 3/4/01)"],

Cell[BoxData[
    \(1\/2\ \((2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalF]}, k\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicR]\_\({}, {i, k}\) + 
          2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalM]}, k\
\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \[GothicR]\_\({}, {i, k}\) + \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, {i, k}\) - \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, {i, k}\) - \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\) + \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\) - \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, {k}\) + \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, {k}\) + \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\) - \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicM]\_\(k\_{\
\[GothicCapitalG], \[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\) + 
          2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalF]}, k\
\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \[GothicCapitalD]\_{k\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, \
{i, k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicM]\_\(k\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, \
{i, k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) - \[GothicCapitalD]\_{i\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \[GothicCapitalD]\_{k\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, \
{k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicM]\_\(k\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, \
{k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalF]}}\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\) - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\
\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicR]\_\({}, {i, k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\%2 - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalF]}, i\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\
\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\%2 + 
          2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalM]}, k\
\_{\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \[GothicCapitalD]\_{k\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, \
{i, k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) + \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicM]\_\(k\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({}, \
{i, k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) + \[GothicCapitalD]\_{i\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \[GothicCapitalD]\_{k\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicM]\_\(i\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, \
{k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicM]\_\(i\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicM]\_\(k\_{\[GothicCapitalG], \[GothicCapitalF]}\)\ \[GothicR]\_\({i}, \
{k}\)\ \[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \
\[GothicCapitalF], \[GothicCapitalM]}}\) - \[GothicCapitalD]\_{i\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicM]\_\(k\_{\[GothicCapitalG], \
\[GothicCapitalM]}\)\ \[GothicR]\_\({i}, {k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\
\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicR]\_\({}, {i, k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) - \
\[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\
\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) - \
\[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalM]}, i\_{\
\[GothicCapitalG], \[GothicCapitalM]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) - \
\[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalF]}, i\_{\
\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}}\)\ \[GothicA]\_\(\[GothicCapitalF], \
{i\_{\[GothicCapitalZ], \[GothicCapitalF], \[GothicCapitalM]}}\) - \
\[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalM]}, i\_{\
\[GothicCapitalG], \[GothicCapitalM]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicR]\_\({}, {i, k}\)\ \[GothicA]\_\(\
\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\%2 - \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \
\[GothicCapitalM]}, i\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \
\[GothicCapitalD]\_{k\_{\[GothicCapitalG], \[GothicCapitalM]}, i\_{\
\[GothicCapitalG], \[GothicCapitalM]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\)\%2 + 
          2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalM]}, i\
\_{\[GothicCapitalG], \[GothicCapitalM]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalF]}, i\_{\[GothicCapitalG], \
\[GothicCapitalF]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\) + 
          2\ \[GothicCapitalD]\_{i\_{\[GothicCapitalG], \[GothicCapitalF]}, i\
\_{\[GothicCapitalG], \[GothicCapitalF]}}\ \[GothicCapitalD]\_{k\_{\
\[GothicCapitalG], \[GothicCapitalM]}, i\_{\[GothicCapitalG], \
\[GothicCapitalM]}}\ \[GothicR]\_\({i}, {k}\)\ \
\[GothicA]\_\(\[GothicCapitalF], {i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalF]}, i\_{\[GothicCapitalZ], \[GothicCapitalF], \
\[GothicCapitalM]}}\))\)\)], "Output",
  CellLabel->"Out[89]=  (9:30:20 on 3/4/01)"]
}, Open  ]],

Cell["\<\
The repeated application of rules can be avoided by applying all \
the rules repeatedly, until there is no further change (see above).  The \
clumsier scheme was used here to show how the expression is built up.\
\>", \
"Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1024}, {0, 748}},
WindowSize->{860, 676},
WindowMargins->{{Automatic, 9}, {21, Automatic}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000]P2:?oQon82n@960dL5:0?l0080001804P000000]P2:001
0000I00000400`<300000BL?00400@0000000000000006P801T1T00000000000
00000000000000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 46, 0, 36, "SubsectionIcon"],
Cell[1788, 53, 162, 4, 22, "Text"],
Cell[1953, 59, 121, 3, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[2099, 66, 238, 4, 34, "Input"],
Cell[2340, 72, 4225, 62, 132, "Output"]
}, Open  ]],
Cell[6580, 137, 229, 6, 23, "Text"],
Cell[6812, 145, 842, 19, 37, "Text"],

Cell[CellGroupData[{
Cell[7679, 168, 442, 8, 34, "Input"],
Cell[8124, 178, 3687, 55, 96, "Output"]
}, Open  ]],
Cell[11826, 236, 341, 11, 34, "MathCaption"],

Cell[CellGroupData[{
Cell[12192, 251, 699, 12, 48, "Input"],
Cell[12894, 265, 5992, 103, 232, "Output"]
}, Open  ]],
Cell[18901, 371, 472, 12, 39, "Text"],
Cell[19376, 385, 227, 6, 28, "MathCaption"],

Cell[CellGroupData[{
Cell[19628, 395, 936, 15, 79, "Input"],
Cell[20567, 412, 75129, 1102, 2278, "Output"]
}, Closed]],
Cell[95711, 1517, 131, 3, 18, "MathCaption"],

Cell[CellGroupData[{
Cell[95867, 1524, 1090, 17, 86, "Input"],
Cell[96960, 1543, 11104, 166, 262, "Output"]
}, Open  ]],
Cell[108079, 1712, 237, 5, 36, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

