(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      5259,        194]*)
(*NotebookOutlinePosition[      7886,        272]*)
(*  CellTagsIndexPosition[      7388,        255]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["References", "SubsectionIcon"],

Cell[TextData[{
  "Asmussen, M.A. and Orive, M.E.  (2000)  The effects of pollen and seed \
migration on nuclear-dicytoplasmic systems I  ",
  StyleBox["Genetics",
    FontSlant->"Italic"],
  " ",
  StyleBox["155",
    FontWeight->"Bold"],
  ", 813-831"
}], "Text",
  CellTags->"Asmussen and Orive 2000"],

Cell[TextData[{
  "Baake, E. (2001) Mutation and recombination with tight linkage. ",
  StyleBox["Journal of Mathematical Biology",
    FontSlant->"Italic"],
  " ",
  StyleBox["42:",
    FontWeight->"Bold"],
  " 455-488."
}], "Text",
  CellTags->"Baake 2001"],

Cell[TextData[{
  "Barton, N.H. (1995).  A general model for the evolution of recombination.  \
",
  StyleBox["Genet. Res. (Camb.) ",
    FontSlant->"Italic"],
  StyleBox["65",
    FontWeight->"Bold"],
  ", 123-144."
}], "Text",
  CellTags->"Barton 1995"],

Cell[TextData[{
  "Barton, N.H. and M. Turelli. (1991).  Natural and sexual selection on many \
loci.  ",
  StyleBox["Genetics",
    FontSlant->"Italic"],
  " ",
  StyleBox["127",
    FontWeight->"Bold"],
  ", 229-255."
}], "Text",
  CellTags->"Barton and Turelli 1991"],

Cell[TextData[{
  "Bennett, J. H. (1954).  On the theory of random mating. ",
  StyleBox["Annals of Eugenics",
    FontSlant->"Italic"],
  " ",
  StyleBox["18:",
    FontWeight->"Bold"],
  " 311-317."
}], "Text",
  CellTags->"Bennett 1954"],

Cell[TextData[{
  "Burger, R. (2000)",
  StyleBox["The mathematical theory of selection, recombination, and \
mutation",
    FontSlant->"Italic"],
  ".  Wiley, Chichester."
}], "Text"],

Cell[TextData[{
  "Christiansen, F.B. (1998)  ",
  StyleBox["Population genetics of multiple loci",
    FontSlant->"Italic"],
  ".  ",
  " Wiley, Chichester."
}], "Text",
  CellTags->"Christiansen 1998"],

Cell[TextData[{
  "Crow, J. and Kimura, M. (1970).  ",
  StyleBox["Introduction to population genetics theory",
    FontSlant->"Italic"],
  ".  "
}], "Text",
  CellTags->"Crow and Kimura 1970"],

Cell[TextData[{
  "Dawson, K.J. (2000).  ",
  "The decay of linkage disequilibrium under random union of gametes: how to \
calculate Bennett's principal components. ",
  StyleBox["Theoretical Population Biology ",
    FontSlant->"Italic"],
  StyleBox["58:",
    FontWeight->"Bold"],
  " 1-20."
}], "Text",
  CellTags->"Dawson 2000"],

Cell[TextData[{
  "Kirkpatrick, M., T. Johnson  and N.H. Barton. (",
  ButtonBox["in prep.",
    ButtonData:>{"Multilocus MS", None},
    ButtonStyle->"AddOnsLink"],
  ").  General models of multilocus evolution."
}], "Text",
  CellTags->"Kirkpatrick et al."],

Cell[TextData[{
  "Kirkpatrick, M. and N.H. Barton. (1997).  The strength of indirect \
selection on female mating prefrences.  ",
  StyleBox["Proc. Natl. Acad. Sci. (USA)",
    FontSlant->"Italic"],
  " ",
  StyleBox["94",
    FontWeight->"Bold"],
  ", 1282-1286."
}], "Text",
  CellTags->"Kirkpatrick and Barton 1997"],

Cell[TextData[{
  "Kirkpatrick, M. and M.R. Servedio. (1999).  The reinforcement of mating \
preferences on an island.  ",
  StyleBox["Genetics",
    FontSlant->"Italic"],
  " ",
  StyleBox["151",
    FontWeight->"Bold"],
  ", ",
  "865-884."
}], "Text",
  CellTags->"Kirkpatrick and Servedio 1998"],

Cell[TextData[{
  "Turelli,M.and N.H.Barton.(1994).  Genetic and statistical analyses of \
strong selection on polygenic traits:what, me normal? ",
  StyleBox["Genetics",
    FontSlant->"Italic"],
  " ",
  StyleBox["138",
    FontWeight->"Bold"],
  ",913-941."
}], "Text",
  CellTags->"Turelli and Barton 1994"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{865, 619},
WindowMargins->{{14, Automatic}, {Automatic, 1}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000]P2:?oQon82n@960dL5:0?l0080001804P000000]P2:001
0000I00000400`<300000BL?00400@0000000000000006P801T1T00000000000
00000000000000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Asmussen and Orive 2000"->{
    Cell[1778, 53, 304, 10, 24, "Text",
      CellTags->"Asmussen and Orive 2000"]},
  "Baake 2001"->{
    Cell[2085, 65, 259, 9, 24, "Text",
      CellTags->"Baake 2001"]},
  "Barton 1995"->{
    Cell[2347, 76, 255, 9, 24, "Text",
      CellTags->"Barton 1995"]},
  "Barton and Turelli 1991"->{
    Cell[2605, 87, 270, 10, 24, "Text",
      CellTags->"Barton and Turelli 1991"]},
  "Bennett 1954"->{
    Cell[2878, 99, 240, 9, 24, "Text",
      CellTags->"Bennett 1954"]},
  "Christiansen 1998"->{
    Cell[3308, 118, 203, 7, 24, "Text",
      CellTags->"Christiansen 1998"]},
  "Crow and Kimura 1970"->{
    Cell[3514, 127, 193, 6, 24, "Text",
      CellTags->"Crow and Kimura 1970"]},
  "Dawson 2000"->{
    Cell[3710, 135, 332, 10, 40, "Text",
      CellTags->"Dawson 2000"]},
  "Kirkpatrick et al."->{
    Cell[4045, 147, 259, 7, 23, "Text",
      CellTags->"Kirkpatrick et al."]},
  "Kirkpatrick and Barton 1997"->{
    Cell[4307, 156, 320, 10, 24, "Text",
      CellTags->"Kirkpatrick and Barton 1997"]},
  "Kirkpatrick and Servedio 1998"->{
    Cell[4630, 168, 299, 11, 24, "Text",
      CellTags->"Kirkpatrick and Servedio 1998"]},
  "Turelli and Barton 1994"->{
    Cell[4932, 181, 311, 10, 24, "Text",
      CellTags->"Turelli and Barton 1994"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Asmussen and Orive 2000", 6105, 215},
  {"Baake 2001", 6208, 218},
  {"Barton 1995", 6298, 221},
  {"Barton and Turelli 1991", 6401, 224},
  {"Bennett 1954", 6506, 227},
  {"Christiansen 1998", 6604, 230},
  {"Crow and Kimura 1970", 6711, 233},
  {"Dawson 2000", 6812, 236},
  {"Kirkpatrick et al.", 6912, 239},
  {"Kirkpatrick and Barton 1997", 7027, 242},
  {"Kirkpatrick and Servedio 1998", 7154, 245},
  {"Turelli and Barton 1994", 7277, 248}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 36, 0, 36, "SubsectionIcon"],
Cell[1778, 53, 304, 10, 24, "Text",
  CellTags->"Asmussen and Orive 2000"],
Cell[2085, 65, 259, 9, 24, "Text",
  CellTags->"Baake 2001"],
Cell[2347, 76, 255, 9, 24, "Text",
  CellTags->"Barton 1995"],
Cell[2605, 87, 270, 10, 24, "Text",
  CellTags->"Barton and Turelli 1991"],
Cell[2878, 99, 240, 9, 24, "Text",
  CellTags->"Bennett 1954"],
Cell[3121, 110, 184, 6, 24, "Text"],
Cell[3308, 118, 203, 7, 24, "Text",
  CellTags->"Christiansen 1998"],
Cell[3514, 127, 193, 6, 24, "Text",
  CellTags->"Crow and Kimura 1970"],
Cell[3710, 135, 332, 10, 40, "Text",
  CellTags->"Dawson 2000"],
Cell[4045, 147, 259, 7, 23, "Text",
  CellTags->"Kirkpatrick et al."],
Cell[4307, 156, 320, 10, 24, "Text",
  CellTags->"Kirkpatrick and Barton 1997"],
Cell[4630, 168, 299, 11, 24, "Text",
  CellTags->"Kirkpatrick and Servedio 1998"],
Cell[4932, 181, 311, 10, 24, "Text",
  CellTags->"Turelli and Barton 1994"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

