(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3626,        100]*)
(*NotebookOutlinePosition[      4536,        129]*)
(*  CellTagsIndexPosition[      4492,        125]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Limitations", "SubsectionIcon"],

Cell[TextData[{
  "\t",
  ButtonBox["IterateExact",
    ButtonData:>{"Symmetric Model: iterating one deme", "IterateExact"},
    ButtonStyle->"AddOnsLink"],
  " follows selection and migration on a set of n selected loci, plus a \
single unlinked neutral marker with two alleles.  This is done by following \
the frequencies of each of the selected classes ",
  Cell[BoxData[
      \(TraditionalForm\`\((\[Psi]\_i\)\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`i = 0  \[Ellipsis]n\)]],
  "), and the frequencies of the neutral allele within each class ",
  Cell[BoxData[
      \(TraditionalForm\`\((u\_i)\)\)]],
  ".  This scheme could be extended in various ways.  One could follow \
selection on two sets of unlinked loci, with exchangeability within each set; \
this would require following a matrix( ",
  Cell[BoxData[
      \(TraditionalForm\`\[Psi]\_\(i, j\)\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`i = 0  \[Ellipsis]n\_1, \ 
      j = 0  \[Ellipsis]n\_2\)]],
  ") (see Kondrashov and Kondrashov, ",
  ButtonBox["2000",
    ButtonData:>{"Symmetric model: references", 
      "Kondrashov & Kondrashov 1999"},
    ButtonStyle->"AddOnsLink"],
  ").  A single neutral marker is a special case with ",
  Cell[BoxData[
      \(TraditionalForm\`n\_2 = 1\)]],
  ".  A model with epistasis acting on pairs of loci would require following \
the frequency of genotypes carrying various numbers of pairs in the four \
possible states {0,0},{0,1},{1,0},{1,1}"
}], "Text"],

Cell["\<\
\tThe results from HeterozygoteB[] are stored, which greatly speeds \
up calculations.  However, this does limit the number of loci that can be \
simulated to 50 or so.  It would be better to make storing results optional.  \
This limitation is avoided in IterateExact[] and IterateNeutral[] if Compiled\
\[Rule]True.\
\>", "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
AutoGeneratedPackage->None,
WindowSize->{632, 517},
WindowMargins->{{Automatic, 42}, {Automatic, 8}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oRon@3:`8f0dL5N`?N0080001804P000000`d26P01
0000I00000400@410?l00BL?00400@00000000000000000201T1T0000000@000
00000000004000000000000000010000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 37, 0, 36, "SubsectionIcon"],
Cell[1779, 53, 1487, 36, 108, "Text"],
Cell[3269, 91, 341, 6, 50, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

