(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3657,        112]*)
(*NotebookOutlinePosition[      4539,        140]*)
(*  CellTagsIndexPosition[      4495,        136]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  "Compatibility with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 3.0"
}], "SubsectionIcon"],

Cell[TextData[{
  "These packages were written and tested using ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.0.  According to the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " ",
  ButtonBox["documentation",
    ButtonData:>{"A.13.4", "4.1"},
    ButtonStyle->"MainBookLink"],
  ", they should be compatible with Mathematica 3.0.  However, there are some \
problems, which lead to error messages when the packages are loaded under ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 3.0.  Nevertheless, most of the functions do work correctly, despite \
these error messages: as a first step, just try pressing on regardless."
}], "Text"],

Cell["Two specific problems that may arise:", "Text"],

Cell[TextData[{
  " The correct version of the Notation Package should be used.  For details, \
see ",
  ButtonBox["http://resources.wolfram.com/packages/notation/",
    ButtonData:>{
      URL[ "http://resources.wolfram.com/packages/notation/"], None},
    ButtonStyle->"Hyperlink"],
  "."
}], "Text",
  CellDingbat->"\[GrayCircle]"],

Cell[TextData[{
  "Compile[] has a different definition under ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.0, and so the option Compiled->True may not work when running under ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 3.0.  This is mainly a problem for the NumericalModels packages, which \
use Compile[] to speed execution."
}], "Text",
  CellDingbat->"\[GrayCircle]"],

Cell[TextData[{
  "Please email any other specific incompatibilities that you find to \
n.barton@ed.ac.uk, so that they can be documented, or even, fixed. However, \
an upgrade to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.0 or later versions is the recommended solution."
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{854, 636},
WindowMargins->{{8, Automatic}, {Automatic, 11}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00<0001804P000000`d26_oQon@3:`8g0dL5N`?P0080001804P000000]P2:001
0000I00000400`<30?l00BL?00400@0000000000000006P801T1T00000000000
00000000004000000000000000000000\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 123, 5, 36, "SubsectionIcon"],
Cell[1865, 58, 674, 17, 54, "Text"],
Cell[2542, 77, 53, 0, 22, "Text"],
Cell[2598, 79, 334, 9, 22, "Text"],
Cell[2935, 90, 401, 10, 38, "Text"],
Cell[3339, 102, 302, 7, 38, "Text"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

