(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      3873,        118]*)
(*NotebookOutlinePosition[      4893,        152]*)
(*  CellTagsIndexPosition[      4816,        146]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Version 1.02", "SubsectionIcon",
  CellTags->"Version 1.00"],

Cell[CellGroupData[{

Cell["1.03 Current", "SubsubsectionIcon"],

Cell["\<\
-Altered ProductSum in SetManipulation so that the compiled version \
ProductSum[k] is built for arbitrary k.  However, it is extremely slow to \
compile for k>8. A much faster scheme is to use CoefficientList[Times@@(1+z\
\[VeryThinSpace]p),z]\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["1.02\t26th September 2002", "SubsubsectionIcon",
  CellDingbat->"\[GrayCircle]"],

Cell["\<\
- Inference of allele frequencies with null alleles implemented in \
DataManipulation`.  New functions GenotypeFrequency and AlleleFrequency \
facilitate calculation of the probability of a given genotype, assuming Hardy \
Weinberg and linkage equilibrium.\
\>", "Text"],

Cell["\<\
- Option InferParentalGenotypes added to EstimatingD`, which allows \
parental genotypes to be inferred fromthe class of segregation, rather than \
frommoments of offspring scores.  ParentalGenotypes uses a simple rule to \
make this inference.
- Bug fixed in Subsets, so that Subsets[U,0] gives 1.  This fixes problems \
ProductSum and FamilyM, for example.\
\>", "Text"],

Cell[TextData[{
  "- ",
  ButtonBox["DiscreteMath`Combinatorica`",
    ButtonData:>{"DiscreteMath`Combinatorica`", None},
    ButtonStyle->"AddOnsLink"],
  "is now loaded by Utilities`SetManipulation`, and provides the function \
Subsets[]; Compositions[] is also used by ConfigurationSet[].  This change \
brings a",
  ButtonBox[" minor problem",
    ButtonData:>{"Bugs", "Clashes between packages"},
    ButtonStyle->"AddOnsLink"],
  ": Combinatorica` clashes with other packages, generating an error message \
when it is loaded.  This can be ignored."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["1.01\t28th December 2001", "SubsubsectionIcon",
  CellDingbat->"\[GrayCircle]"],

Cell["\<\
- AncestralGraphs defined, and several functions for dealing with \
coalescence and recombination implemented.\
\>", "Text"]
}, Open  ]],

Cell["1.00\t5th March 2000", "SubsubsectionIcon",
  CellDingbat->"\[GrayCircle]"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 748}},
WindowSize->{852, 472},
WindowMargins->{{65, Automatic}, {Automatic, 61}},
StyleDefinitions -> "HelpBrowser.nb",
MacintoshSystemPageSetup->"\<\
00h0001804P000000b02<?oaonl3>@91H`85N0?N0@00005X0FP000003j0:l001
0@00I00100000@0200000BL?00400000000000000000010000000000000@0?ne
oj/@7@]500P1000000000000000001T1\>"
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Version 1.00"->{
    Cell[1739, 51, 66, 1, 36, "SubsectionIcon",
      CellTags->"Version 1.00"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Version 1.00", 4709, 139}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 66, 1, 36, "SubsectionIcon",
  CellTags->"Version 1.00"],

Cell[CellGroupData[{
Cell[1830, 56, 41, 0, 24, "SubsubsectionIcon"],
Cell[1874, 58, 268, 5, 36, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2179, 68, 86, 1, 24, "SubsubsectionIcon"],
Cell[2268, 71, 280, 5, 36, "Text"],
Cell[2551, 78, 382, 7, 58, "Text"],
Cell[2936, 87, 566, 13, 38, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3539, 105, 85, 1, 24, "SubsubsectionIcon"],
Cell[3627, 108, 134, 3, 22, "Text"]
}, Open  ]],
Cell[3776, 114, 81, 1, 24, "SubsubsectionIcon"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

